pragma Warnings (Off);
pragma Ada_95;
with System;
with System.Parameters;
with System.Secondary_Stack;
package ada_main is

   gnat_argc : Integer;
   gnat_argv : System.Address;
   gnat_envp : System.Address;

   pragma Import (C, gnat_argc);
   pragma Import (C, gnat_argv);
   pragma Import (C, gnat_envp);

   gnat_exit_status : Integer;
   pragma Import (C, gnat_exit_status);

   GNAT_Version : constant String :=
                    "GNAT Version: 13.2.1 20230728 (Red Hat 13.2.1-1)" & ASCII.NUL;
   pragma Export (C, GNAT_Version, "__gnat_version");

   GNAT_Version_Address : constant System.Address := GNAT_Version'Address;
   pragma Export (C, GNAT_Version_Address, "__gnat_version_address");

   Ada_Main_Program_Name : constant String := "_ada_gnatbind" & ASCII.NUL;
   pragma Export (C, Ada_Main_Program_Name, "__gnat_ada_main_program_name");

   procedure adainit;
   pragma Export (C, adainit, "adainit");

   function main
     (argc : Integer;
      argv : System.Address;
      envp : System.Address)
      return Integer;
   pragma Export (C, main, "main");

   type Version_32 is mod 2 ** 32;
   u00001 : constant Version_32 := 16#3379b04e#;
   pragma Export (C, u00001, "gnatbindB");
   u00002 : constant Version_32 := 16#d6787f71#;
   pragma Export (C, u00002, "gnatbindS");
   u00003 : constant Version_32 := 16#7320ff5f#;
   pragma Export (C, u00003, "system__standard_libraryB");
   u00004 : constant Version_32 := 16#708b39be#;
   pragma Export (C, u00004, "system__standard_libraryS");
   u00005 : constant Version_32 := 16#c93f4dca#;
   pragma Export (C, u00005, "ada__exceptionsB");
   u00006 : constant Version_32 := 16#3e9d152a#;
   pragma Export (C, u00006, "ada__exceptionsS");
   u00007 : constant Version_32 := 16#76789da1#;
   pragma Export (C, u00007, "adaS");
   u00008 : constant Version_32 := 16#0740df23#;
   pragma Export (C, u00008, "ada__exceptions__last_chance_handlerB");
   u00009 : constant Version_32 := 16#6dc27684#;
   pragma Export (C, u00009, "ada__exceptions__last_chance_handlerS");
   u00010 : constant Version_32 := 16#62859e27#;
   pragma Export (C, u00010, "systemS");
   u00011 : constant Version_32 := 16#fd5f5f4c#;
   pragma Export (C, u00011, "system__soft_linksB");
   u00012 : constant Version_32 := 16#1f1808c4#;
   pragma Export (C, u00012, "system__soft_linksS");
   u00013 : constant Version_32 := 16#d4c699bf#;
   pragma Export (C, u00013, "system__secondary_stackB");
   u00014 : constant Version_32 := 16#4ac72b90#;
   pragma Export (C, u00014, "system__secondary_stackS");
   u00015 : constant Version_32 := 16#821dff88#;
   pragma Export (C, u00015, "system__parametersB");
   u00016 : constant Version_32 := 16#b6113a81#;
   pragma Export (C, u00016, "system__parametersS");
   u00017 : constant Version_32 := 16#2a95d23d#;
   pragma Export (C, u00017, "system__storage_elementsB");
   u00018 : constant Version_32 := 16#c9d1f6c3#;
   pragma Export (C, u00018, "system__storage_elementsS");
   u00019 : constant Version_32 := 16#0286ce9f#;
   pragma Export (C, u00019, "system__soft_links__initializeB");
   u00020 : constant Version_32 := 16#2ed17187#;
   pragma Export (C, u00020, "system__soft_links__initializeS");
   u00021 : constant Version_32 := 16#8599b27b#;
   pragma Export (C, u00021, "system__stack_checkingB");
   u00022 : constant Version_32 := 16#c250373d#;
   pragma Export (C, u00022, "system__stack_checkingS");
   u00023 : constant Version_32 := 16#c71e6c8a#;
   pragma Export (C, u00023, "system__exception_tableB");
   u00024 : constant Version_32 := 16#efaee83e#;
   pragma Export (C, u00024, "system__exception_tableS");
   u00025 : constant Version_32 := 16#50202115#;
   pragma Export (C, u00025, "system__exceptionsS");
   u00026 : constant Version_32 := 16#69416224#;
   pragma Export (C, u00026, "system__exceptions__machineB");
   u00027 : constant Version_32 := 16#8bdfdbe3#;
   pragma Export (C, u00027, "system__exceptions__machineS");
   u00028 : constant Version_32 := 16#7706238d#;
   pragma Export (C, u00028, "system__exceptions_debugB");
   u00029 : constant Version_32 := 16#528bc674#;
   pragma Export (C, u00029, "system__exceptions_debugS");
   u00030 : constant Version_32 := 16#1206414f#;
   pragma Export (C, u00030, "system__img_intS");
   u00031 : constant Version_32 := 16#f2c63a02#;
   pragma Export (C, u00031, "ada__numericsS");
   u00032 : constant Version_32 := 16#174f5472#;
   pragma Export (C, u00032, "ada__numerics__big_numbersS");
   u00033 : constant Version_32 := 16#98afe17e#;
   pragma Export (C, u00033, "system__unsigned_typesS");
   u00034 : constant Version_32 := 16#7e670629#;
   pragma Export (C, u00034, "system__val_intS");
   u00035 : constant Version_32 := 16#6879161d#;
   pragma Export (C, u00035, "system__val_unsS");
   u00036 : constant Version_32 := 16#96e09402#;
   pragma Export (C, u00036, "system__val_utilB");
   u00037 : constant Version_32 := 16#51404aaa#;
   pragma Export (C, u00037, "system__val_utilS");
   u00038 : constant Version_32 := 16#b98923bf#;
   pragma Export (C, u00038, "system__case_utilB");
   u00039 : constant Version_32 := 16#ad964972#;
   pragma Export (C, u00039, "system__case_utilS");
   u00040 : constant Version_32 := 16#adeaac9c#;
   pragma Export (C, u00040, "system__wid_unsS");
   u00041 : constant Version_32 := 16#5c7d9c20#;
   pragma Export (C, u00041, "system__tracebackB");
   u00042 : constant Version_32 := 16#e41f6a9a#;
   pragma Export (C, u00042, "system__tracebackS");
   u00043 : constant Version_32 := 16#5f6b6486#;
   pragma Export (C, u00043, "system__traceback_entriesB");
   u00044 : constant Version_32 := 16#aa9921ab#;
   pragma Export (C, u00044, "system__traceback_entriesS");
   u00045 : constant Version_32 := 16#a0281f47#;
   pragma Export (C, u00045, "system__traceback__symbolicB");
   u00046 : constant Version_32 := 16#d9e66ad1#;
   pragma Export (C, u00046, "system__traceback__symbolicS");
   u00047 : constant Version_32 := 16#701f9d88#;
   pragma Export (C, u00047, "ada__exceptions__tracebackB");
   u00048 : constant Version_32 := 16#eb07882c#;
   pragma Export (C, u00048, "ada__exceptions__tracebackS");
   u00049 : constant Version_32 := 16#a0d3d22b#;
   pragma Export (C, u00049, "system__address_imageB");
   u00050 : constant Version_32 := 16#c369031d#;
   pragma Export (C, u00050, "system__address_imageS");
   u00051 : constant Version_32 := 16#fd158a37#;
   pragma Export (C, u00051, "system__wch_conB");
   u00052 : constant Version_32 := 16#bb86bd44#;
   pragma Export (C, u00052, "system__wch_conS");
   u00053 : constant Version_32 := 16#5c289972#;
   pragma Export (C, u00053, "system__wch_stwB");
   u00054 : constant Version_32 := 16#96979145#;
   pragma Export (C, u00054, "system__wch_stwS");
   u00055 : constant Version_32 := 16#23eeabc5#;
   pragma Export (C, u00055, "system__wch_cnvB");
   u00056 : constant Version_32 := 16#bd467734#;
   pragma Export (C, u00056, "system__wch_cnvS");
   u00057 : constant Version_32 := 16#ce296fe1#;
   pragma Export (C, u00057, "interfacesS");
   u00058 : constant Version_32 := 16#e538de43#;
   pragma Export (C, u00058, "system__wch_jisB");
   u00059 : constant Version_32 := 16#08f1151e#;
   pragma Export (C, u00059, "system__wch_jisS");
   u00060 : constant Version_32 := 16#d3b322b3#;
   pragma Export (C, u00060, "aliB");
   u00061 : constant Version_32 := 16#f5f3f6bf#;
   pragma Export (C, u00061, "aliS");
   u00062 : constant Version_32 := 16#5a52105d#;
   pragma Export (C, u00062, "butilB");
   u00063 : constant Version_32 := 16#02d57147#;
   pragma Export (C, u00063, "butilS");
   u00064 : constant Version_32 := 16#b5988c27#;
   pragma Export (C, u00064, "gnatS");
   u00065 : constant Version_32 := 16#2be8d8e8#;
   pragma Export (C, u00065, "optB");
   u00066 : constant Version_32 := 16#d17abec5#;
   pragma Export (C, u00066, "optS");
   u00067 : constant Version_32 := 16#f8d3608b#;
   pragma Export (C, u00067, "csetsB");
   u00068 : constant Version_32 := 16#e948558f#;
   pragma Export (C, u00068, "csetsS");
   u00069 : constant Version_32 := 16#3b0dbbfa#;
   pragma Export (C, u00069, "hostparmS");
   u00070 : constant Version_32 := 16#ca878138#;
   pragma Export (C, u00070, "system__concat_2B");
   u00071 : constant Version_32 := 16#d77eedd0#;
   pragma Export (C, u00071, "system__concat_2S");
   u00072 : constant Version_32 := 16#d4e0603b#;
   pragma Export (C, u00072, "typesB");
   u00073 : constant Version_32 := 16#fc9c2399#;
   pragma Export (C, u00073, "typesS");
   u00074 : constant Version_32 := 16#190570e0#;
   pragma Export (C, u00074, "system__compare_array_unsigned_8B");
   u00075 : constant Version_32 := 16#f2630044#;
   pragma Export (C, u00075, "system__compare_array_unsigned_8S");
   u00076 : constant Version_32 := 16#74e358eb#;
   pragma Export (C, u00076, "system__address_operationsB");
   u00077 : constant Version_32 := 16#1cb1b287#;
   pragma Export (C, u00077, "system__address_operationsS");
   u00078 : constant Version_32 := 16#256dbbe5#;
   pragma Export (C, u00078, "system__stringsB");
   u00079 : constant Version_32 := 16#f9079e3f#;
   pragma Export (C, u00079, "system__stringsS");
   u00080 : constant Version_32 := 16#a61ae265#;
   pragma Export (C, u00080, "outputB");
   u00081 : constant Version_32 := 16#dfee97b2#;
   pragma Export (C, u00081, "outputS");
   u00082 : constant Version_32 := 16#1d7382c4#;
   pragma Export (C, u00082, "system__os_libB");
   u00083 : constant Version_32 := 16#98e94e78#;
   pragma Export (C, u00083, "system__os_libS");
   u00084 : constant Version_32 := 16#3c17a879#;
   pragma Export (C, u00084, "system__crtlS");
   u00085 : constant Version_32 := 16#085261e6#;
   pragma Export (C, u00085, "nametB");
   u00086 : constant Version_32 := 16#bc7da6aa#;
   pragma Export (C, u00086, "nametS");
   u00087 : constant Version_32 := 16#91fc5baa#;
   pragma Export (C, u00087, "debugB");
   u00088 : constant Version_32 := 16#1ac546f9#;
   pragma Export (C, u00088, "debugS");
   u00089 : constant Version_32 := 16#160489b6#;
   pragma Export (C, u00089, "widecharB");
   u00090 : constant Version_32 := 16#fc939d63#;
   pragma Export (C, u00090, "widecharS");
   u00091 : constant Version_32 := 16#1b78961f#;
   pragma Export (C, u00091, "allocS");
   u00092 : constant Version_32 := 16#401cdb9b#;
   pragma Export (C, u00092, "tableB");
   u00093 : constant Version_32 := 16#f93c8813#;
   pragma Export (C, u00093, "tableS");
   u00094 : constant Version_32 := 16#1982dcd0#;
   pragma Export (C, u00094, "system__memoryB");
   u00095 : constant Version_32 := 16#3901acf7#;
   pragma Export (C, u00095, "system__memoryS");
   u00096 : constant Version_32 := 16#9b950d9a#;
   pragma Export (C, u00096, "fnameB");
   u00097 : constant Version_32 := 16#cdf3f413#;
   pragma Export (C, u00097, "fnameS");
   u00098 : constant Version_32 := 16#2af1acd3#;
   pragma Export (C, u00098, "gnat__dynamic_htablesB");
   u00099 : constant Version_32 := 16#2317962f#;
   pragma Export (C, u00099, "gnat__dynamic_htablesS");
   u00100 : constant Version_32 := 16#aa491086#;
   pragma Export (C, u00100, "osintB");
   u00101 : constant Version_32 := 16#6e7d7764#;
   pragma Export (C, u00101, "osintS");
   u00102 : constant Version_32 := 16#b23ad542#;
   pragma Export (C, u00102, "fmapB");
   u00103 : constant Version_32 := 16#19fb29a0#;
   pragma Export (C, u00103, "fmapS");
   u00104 : constant Version_32 := 16#9f9cc922#;
   pragma Export (C, u00104, "gnat__htableB");
   u00105 : constant Version_32 := 16#4a45b320#;
   pragma Export (C, u00105, "gnat__htableS");
   u00106 : constant Version_32 := 16#3548d972#;
   pragma Export (C, u00106, "system__htableB");
   u00107 : constant Version_32 := 16#e35cc6cc#;
   pragma Export (C, u00107, "system__htableS");
   u00108 : constant Version_32 := 16#1f1abe38#;
   pragma Export (C, u00108, "system__string_hashB");
   u00109 : constant Version_32 := 16#441946b3#;
   pragma Export (C, u00109, "system__string_hashS");
   u00110 : constant Version_32 := 16#a4b68e67#;
   pragma Export (C, u00110, "gnatvsnB");
   u00111 : constant Version_32 := 16#fdc6387d#;
   pragma Export (C, u00111, "gnatvsnS");
   u00112 : constant Version_32 := 16#23db0006#;
   pragma Export (C, u00112, "sdefaultB");
   u00113 : constant Version_32 := 16#2b49f98f#;
   pragma Export (C, u00113, "sdefaultS");
   u00114 : constant Version_32 := 16#b6ddf4be#;
   pragma Export (C, u00114, "targparmB");
   u00115 : constant Version_32 := 16#c8d35e80#;
   pragma Export (C, u00115, "targparmS");
   u00116 : constant Version_32 := 16#3d90c1c0#;
   pragma Export (C, u00116, "ridentS");
   u00117 : constant Version_32 := 16#c484e6b6#;
   pragma Export (C, u00117, "snamesB");
   u00118 : constant Version_32 := 16#5d7dbf4b#;
   pragma Export (C, u00118, "snamesS");
   u00119 : constant Version_32 := 16#c48b4da9#;
   pragma Export (C, u00119, "casingB");
   u00120 : constant Version_32 := 16#cdd9f882#;
   pragma Export (C, u00120, "casingS");
   u00121 : constant Version_32 := 16#48c739d2#;
   pragma Export (C, u00121, "ali__utilB");
   u00122 : constant Version_32 := 16#f9319136#;
   pragma Export (C, u00122, "ali__utilS");
   u00123 : constant Version_32 := 16#73968e32#;
   pragma Export (C, u00123, "atreeB");
   u00124 : constant Version_32 := 16#08b30e5d#;
   pragma Export (C, u00124, "atreeS");
   u00125 : constant Version_32 := 16#ac5eb766#;
   pragma Export (C, u00125, "aspectsB");
   u00126 : constant Version_32 := 16#6c4155e1#;
   pragma Export (C, u00126, "aspectsS");
   u00127 : constant Version_32 := 16#7f0c2427#;
   pragma Export (C, u00127, "einfoS");
   u00128 : constant Version_32 := 16#6e11a734#;
   pragma Export (C, u00128, "standS");
   u00129 : constant Version_32 := 16#6c3bab0d#;
   pragma Export (C, u00129, "uintpB");
   u00130 : constant Version_32 := 16#c8c1c4a4#;
   pragma Export (C, u00130, "uintpS");
   u00131 : constant Version_32 := 16#e2a447d9#;
   pragma Export (C, u00131, "urealpB");
   u00132 : constant Version_32 := 16#5a74d7ac#;
   pragma Export (C, u00132, "urealpS");
   u00133 : constant Version_32 := 16#2a366f01#;
   pragma Export (C, u00133, "einfo__entitiesB");
   u00134 : constant Version_32 := 16#d22d53f1#;
   pragma Export (C, u00134, "einfo__entitiesS");
   u00135 : constant Version_32 := 16#05a4bfac#;
   pragma Export (C, u00135, "einfo__utilsB");
   u00136 : constant Version_32 := 16#4bafe198#;
   pragma Export (C, u00136, "einfo__utilsS");
   u00137 : constant Version_32 := 16#f5b8535a#;
   pragma Export (C, u00137, "elistsB");
   u00138 : constant Version_32 := 16#9ebd8804#;
   pragma Export (C, u00138, "elistsS");
   u00139 : constant Version_32 := 16#08942e1f#;
   pragma Export (C, u00139, "nlistsB");
   u00140 : constant Version_32 := 16#e95c43d8#;
   pragma Export (C, u00140, "nlistsS");
   u00141 : constant Version_32 := 16#4e4c2b5c#;
   pragma Export (C, u00141, "sinfoS");
   u00142 : constant Version_32 := 16#d93df5c0#;
   pragma Export (C, u00142, "sinfo__nodesB");
   u00143 : constant Version_32 := 16#46d4de05#;
   pragma Export (C, u00143, "sinfo__nodesS");
   u00144 : constant Version_32 := 16#c91ec790#;
   pragma Export (C, u00144, "sinfo__utilsB");
   u00145 : constant Version_32 := 16#53f5e458#;
   pragma Export (C, u00145, "sinfo__utilsS");
   u00146 : constant Version_32 := 16#bdc9a102#;
   pragma Export (C, u00146, "seinfoS");
   u00147 : constant Version_32 := 16#138ce8da#;
   pragma Export (C, u00147, "sinputB");
   u00148 : constant Version_32 := 16#1990175a#;
   pragma Export (C, u00148, "sinputS");
   u00149 : constant Version_32 := 16#641bd22f#;
   pragma Export (C, u00149, "gnat__byte_order_markB");
   u00150 : constant Version_32 := 16#0475df31#;
   pragma Export (C, u00150, "gnat__byte_order_markS");
   u00151 : constant Version_32 := 16#f932b5ec#;
   pragma Export (C, u00151, "scansB");
   u00152 : constant Version_32 := 16#b5b27c47#;
   pragma Export (C, u00152, "scansS");
   u00153 : constant Version_32 := 16#e8c996fc#;
   pragma Export (C, u00153, "binderrB");
   u00154 : constant Version_32 := 16#08adca1b#;
   pragma Export (C, u00154, "binderrS");
   u00155 : constant Version_32 := 16#9c57b5ef#;
   pragma Export (C, u00155, "err_varsS");
   u00156 : constant Version_32 := 16#c313b157#;
   pragma Export (C, u00156, "erroutB");
   u00157 : constant Version_32 := 16#7e9bb0a9#;
   pragma Export (C, u00157, "erroutS");
   u00158 : constant Version_32 := 16#53758945#;
   pragma Export (C, u00158, "erroutcB");
   u00159 : constant Version_32 := 16#25a351e2#;
   pragma Export (C, u00159, "erroutcS");
   u00160 : constant Version_32 := 16#48e1701b#;
   pragma Export (C, u00160, "stringtB");
   u00161 : constant Version_32 := 16#2409adf9#;
   pragma Export (C, u00161, "stringtS");
   u00162 : constant Version_32 := 16#b9ee5b43#;
   pragma Export (C, u00162, "warnswB");
   u00163 : constant Version_32 := 16#4be73eb5#;
   pragma Export (C, u00163, "warnswS");
   u00164 : constant Version_32 := 16#585ea7f7#;
   pragma Export (C, u00164, "libB");
   u00165 : constant Version_32 := 16#181108e0#;
   pragma Export (C, u00165, "libS");
   u00166 : constant Version_32 := 16#130ca291#;
   pragma Export (C, u00166, "unameB");
   u00167 : constant Version_32 := 16#480cff7e#;
   pragma Export (C, u00167, "unameS");
   u00168 : constant Version_32 := 16#4c8f170c#;
   pragma Export (C, u00168, "sem_auxB");
   u00169 : constant Version_32 := 16#f30488d1#;
   pragma Export (C, u00169, "sem_auxS");
   u00170 : constant Version_32 := 16#6c4c6bb5#;
   pragma Export (C, u00170, "styleswB");
   u00171 : constant Version_32 := 16#3079b87e#;
   pragma Export (C, u00171, "styleswS");
   u00172 : constant Version_32 := 16#4515aae6#;
   pragma Export (C, u00172, "scngB");
   u00173 : constant Version_32 := 16#098d1a78#;
   pragma Export (C, u00173, "scngS");
   u00174 : constant Version_32 := 16#1e6e5cd0#;
   pragma Export (C, u00174, "system__crc32B");
   u00175 : constant Version_32 := 16#88644273#;
   pragma Export (C, u00175, "system__crc32S");
   u00176 : constant Version_32 := 16#1f3e80d3#;
   pragma Export (C, u00176, "system__utf_32B");
   u00177 : constant Version_32 := 16#e6e44f98#;
   pragma Export (C, u00177, "system__utf_32S");
   u00178 : constant Version_32 := 16#8eae9e28#;
   pragma Export (C, u00178, "stylegB");
   u00179 : constant Version_32 := 16#fc809ba0#;
   pragma Export (C, u00179, "stylegS");
   u00180 : constant Version_32 := 16#2266bd1c#;
   pragma Export (C, u00180, "sinput__cB");
   u00181 : constant Version_32 := 16#feb16495#;
   pragma Export (C, u00181, "sinput__cS");
   u00182 : constant Version_32 := 16#a6861846#;
   pragma Export (C, u00182, "bcheckB");
   u00183 : constant Version_32 := 16#881dacd4#;
   pragma Export (C, u00183, "bcheckS");
   u00184 : constant Version_32 := 16#864562cf#;
   pragma Export (C, u00184, "bindgenB");
   u00185 : constant Version_32 := 16#cf43ceaf#;
   pragma Export (C, u00185, "bindgenS");
   u00186 : constant Version_32 := 16#89e8bac3#;
   pragma Export (C, u00186, "gnat__heap_sort_aB");
   u00187 : constant Version_32 := 16#a0f346d1#;
   pragma Export (C, u00187, "gnat__heap_sort_aS");
   u00188 : constant Version_32 := 16#afcb99d0#;
   pragma Export (C, u00188, "osint__bB");
   u00189 : constant Version_32 := 16#cc9435e0#;
   pragma Export (C, u00189, "osint__bS");
   u00190 : constant Version_32 := 16#a769f886#;
   pragma Export (C, u00190, "bindoB");
   u00191 : constant Version_32 := 16#980d5858#;
   pragma Export (C, u00191, "bindoS");
   u00192 : constant Version_32 := 16#82e9a2d0#;
   pragma Export (C, u00192, "bindeB");
   u00193 : constant Version_32 := 16#c95f6cfc#;
   pragma Export (C, u00193, "bindeS");
   u00194 : constant Version_32 := 16#52d0e92c#;
   pragma Export (C, u00194, "bindo__elaboratorsB");
   u00195 : constant Version_32 := 16#ba15b383#;
   pragma Export (C, u00195, "bindo__elaboratorsS");
   u00196 : constant Version_32 := 16#8de6a879#;
   pragma Export (C, u00196, "bindo__augmentorsB");
   u00197 : constant Version_32 := 16#4de1d230#;
   pragma Export (C, u00197, "bindo__augmentorsS");
   u00198 : constant Version_32 := 16#3d2ba5c0#;
   pragma Export (C, u00198, "bindo__writersB");
   u00199 : constant Version_32 := 16#f0aa20d5#;
   pragma Export (C, u00199, "bindo__writersS");
   u00200 : constant Version_32 := 16#0426d861#;
   pragma Export (C, u00200, "bindo__unitsB");
   u00201 : constant Version_32 := 16#02f95f8c#;
   pragma Export (C, u00201, "bindo__unitsS");
   u00202 : constant Version_32 := 16#6ffde2e6#;
   pragma Export (C, u00202, "gnat__setsB");
   u00203 : constant Version_32 := 16#f203e24e#;
   pragma Export (C, u00203, "gnat__setsS");
   u00204 : constant Version_32 := 16#18033725#;
   pragma Export (C, u00204, "gnat__graphsB");
   u00205 : constant Version_32 := 16#cb5490cc#;
   pragma Export (C, u00205, "gnat__graphsS");
   u00206 : constant Version_32 := 16#40b0a077#;
   pragma Export (C, u00206, "gnat__listsB");
   u00207 : constant Version_32 := 16#4d95c121#;
   pragma Export (C, u00207, "gnat__listsS");
   u00208 : constant Version_32 := 16#51bd4a32#;
   pragma Export (C, u00208, "bindo__graphsB");
   u00209 : constant Version_32 := 16#adb854b3#;
   pragma Export (C, u00209, "bindo__graphsS");
   u00210 : constant Version_32 := 16#7a6aa76f#;
   pragma Export (C, u00210, "bindo__buildersB");
   u00211 : constant Version_32 := 16#1ff68edf#;
   pragma Export (C, u00211, "bindo__buildersS");
   u00212 : constant Version_32 := 16#60a94aad#;
   pragma Export (C, u00212, "bindo__validatorsB");
   u00213 : constant Version_32 := 16#500a8d28#;
   pragma Export (C, u00213, "bindo__validatorsS");
   u00214 : constant Version_32 := 16#14298719#;
   pragma Export (C, u00214, "bindo__diagnosticsB");
   u00215 : constant Version_32 := 16#0693eff6#;
   pragma Export (C, u00215, "bindo__diagnosticsS");
   u00216 : constant Version_32 := 16#23532055#;
   pragma Export (C, u00216, "bindusgB");
   u00217 : constant Version_32 := 16#12f067e3#;
   pragma Export (C, u00217, "bindusgS");
   u00218 : constant Version_32 := 16#52ebc05d#;
   pragma Export (C, u00218, "switchB");
   u00219 : constant Version_32 := 16#148c9c2f#;
   pragma Export (C, u00219, "switchS");
   u00220 : constant Version_32 := 16#3b90882a#;
   pragma Export (C, u00220, "switch__bB");
   u00221 : constant Version_32 := 16#2c145cac#;
   pragma Export (C, u00221, "switch__bS");
   u00222 : constant Version_32 := 16#4282cd51#;
   pragma Export (C, u00222, "system__response_fileB");
   u00223 : constant Version_32 := 16#dc02831e#;
   pragma Export (C, u00223, "system__response_fileS");

   --  BEGIN ELABORATION ORDER
   --  ada%s
   --  interfaces%s
   --  system%s
   --  system.address_operations%s
   --  system.address_operations%b
   --  system.parameters%s
   --  system.parameters%b
   --  system.crtl%s
   --  system.storage_elements%s
   --  system.storage_elements%b
   --  system.stack_checking%s
   --  system.stack_checking%b
   --  system.string_hash%s
   --  system.string_hash%b
   --  system.htable%s
   --  system.htable%b
   --  system.strings%s
   --  system.strings%b
   --  system.traceback_entries%s
   --  system.traceback_entries%b
   --  system.unsigned_types%s
   --  system.utf_32%s
   --  system.utf_32%b
   --  system.wch_con%s
   --  system.wch_con%b
   --  system.wch_jis%s
   --  system.wch_jis%b
   --  system.wch_cnv%s
   --  system.wch_cnv%b
   --  system.compare_array_unsigned_8%s
   --  system.compare_array_unsigned_8%b
   --  system.concat_2%s
   --  system.concat_2%b
   --  system.crc32%s
   --  system.crc32%b
   --  system.traceback%s
   --  system.traceback%b
   --  system.case_util%s
   --  system.secondary_stack%s
   --  system.standard_library%s
   --  ada.exceptions%s
   --  system.exceptions_debug%s
   --  system.exceptions_debug%b
   --  system.soft_links%s
   --  system.val_uns%s
   --  system.val_int%s
   --  system.val_util%s
   --  system.val_util%b
   --  system.wch_stw%s
   --  system.wch_stw%b
   --  ada.exceptions.last_chance_handler%s
   --  ada.exceptions.last_chance_handler%b
   --  ada.exceptions.traceback%s
   --  ada.exceptions.traceback%b
   --  system.address_image%s
   --  system.address_image%b
   --  system.case_util%b
   --  system.exception_table%s
   --  system.exception_table%b
   --  ada.numerics%s
   --  ada.numerics.big_numbers%s
   --  system.exceptions%s
   --  system.exceptions.machine%s
   --  system.exceptions.machine%b
   --  system.memory%s
   --  system.memory%b
   --  system.secondary_stack%b
   --  system.soft_links.initialize%s
   --  system.soft_links.initialize%b
   --  system.soft_links%b
   --  system.standard_library%b
   --  system.traceback.symbolic%s
   --  system.traceback.symbolic%b
   --  system.wid_uns%s
   --  system.img_int%s
   --  ada.exceptions%b
   --  gnat%s
   --  gnat.heap_sort_a%s
   --  gnat.heap_sort_a%b
   --  gnat.htable%s
   --  gnat.htable%b
   --  system.os_lib%s
   --  system.os_lib%b
   --  gnat.byte_order_mark%s
   --  gnat.byte_order_mark%b
   --  gnat.dynamic_htables%s
   --  gnat.dynamic_htables%b
   --  gnat.lists%s
   --  gnat.lists%b
   --  gnat.sets%s
   --  gnat.sets%b
   --  gnat.graphs%s
   --  gnat.graphs%b
   --  system.response_file%s
   --  system.response_file%b
   --  debug%s
   --  debug%b
   --  types%s
   --  types%b
   --  alloc%s
   --  gnatvsn%s
   --  gnatvsn%b
   --  hostparm%s
   --  opt%s
   --  csets%s
   --  csets%b
   --  opt%b
   --  output%s
   --  output%b
   --  rident%s
   --  seinfo%s
   --  stand%s
   --  stylesw%s
   --  stylesw%b
   --  table%s
   --  table%b
   --  elists%s
   --  elists%b
   --  uintp%s
   --  uintp%b
   --  urealp%s
   --  urealp%b
   --  warnsw%s
   --  warnsw%b
   --  widechar%s
   --  widechar%b
   --  namet%s
   --  namet%b
   --  butil%s
   --  butil%b
   --  binderr%s
   --  binderr%b
   --  casing%s
   --  casing%b
   --  err_vars%s
   --  fmap%s
   --  osint%s
   --  fmap%b
   --  sdefault%s
   --  sdefault%b
   --  targparm%s
   --  targparm%b
   --  osint%b
   --  fname%s
   --  fname%b
   --  osint.b%s
   --  osint.b%b
   --  sinfo%s
   --  snames%s
   --  snames%b
   --  ali%s
   --  ali%b
   --  binde%s
   --  binde%b
   --  bindgen%s
   --  bindgen%b
   --  bindo%s
   --  bindo.units%s
   --  bindo.graphs%s
   --  bindo.augmentors%s
   --  bindo.builders%s
   --  bindo.diagnostics%s
   --  bindo.elaborators%s
   --  bindo%b
   --  bindo.validators%s
   --  bindo.writers%s
   --  bindo.writers%b
   --  bindo.augmentors%b
   --  bindo.builders%b
   --  bindo.diagnostics%b
   --  bindo.elaborators%b
   --  bindo.graphs%b
   --  bindo.units%b
   --  bindo.validators%b
   --  einfo%s
   --  scans%s
   --  scans%b
   --  aspects%s
   --  nlists%s
   --  sinfo.nodes%s
   --  einfo.entities%s
   --  einfo.utils%s
   --  atree%s
   --  einfo.entities%b
   --  nlists%b
   --  sinfo.utils%s
   --  aspects%b
   --  atree%b
   --  einfo.utils%b
   --  sinfo.nodes%b
   --  sinput%s
   --  sinput%b
   --  sinfo.utils%b
   --  sem_aux%s
   --  sem_aux%b
   --  sinput.c%s
   --  sinput.c%b
   --  stringt%s
   --  stringt%b
   --  erroutc%s
   --  erroutc%b
   --  lib%s
   --  uname%s
   --  uname%b
   --  lib%b
   --  errout%s
   --  errout%b
   --  styleg%s
   --  styleg%b
   --  scng%s
   --  scng%b
   --  ali.util%s
   --  ali.util%b
   --  bcheck%s
   --  bcheck%b
   --  switch%s
   --  switch%b
   --  bindusg%s
   --  bindusg%b
   --  switch.b%s
   --  switch.b%b
   --  gnatbind%s
   --  gnatbind%b
   --  END ELABORATION ORDER

end ada_main;
