with Types; use Types;

package Seinfo is

   --  This package is automatically generated.

   --  Common declarations visible in both Sinfo.Nodes and Einfo.Entities.

   type Field_Kind is
     (Flag_Field,
      Node_Id_Field,
      List_Id_Field,
      Elist_Id_Field,
      Name_Id_Field,
      String_Id_Field,
      Uint_Field,
      Valid_Uint_Field,
      Unat_Field,
      Upos_Field,
      Nonzero_Uint_Field,
      Ureal_Field,
      Node_Kind_Type_Field,
      Entity_Kind_Type_Field,
      Source_Ptr_Field,
      Small_Paren_Count_Type_Field,
      Union_Id_Field,
      Convention_Id_Field,
      Component_Alignment_Kind_Field,
      Mechanism_Type_Field);

   Field_Size : constant array (Field_Kind) of Field_Size_In_Bits :=
     (Flag_Field => 1,
      Node_Id_Field => 32,
      List_Id_Field => 32,
      Elist_Id_Field => 32,
      Name_Id_Field => 32,
      String_Id_Field => 32,
      Uint_Field => 32,
      Valid_Uint_Field => 32,
      Unat_Field => 32,
      Upos_Field => 32,
      Nonzero_Uint_Field => 32,
      Ureal_Field => 32,
      Node_Kind_Type_Field => 8,
      Entity_Kind_Type_Field => 8,
      Source_Ptr_Field => 32,
      Small_Paren_Count_Type_Field => 2,
      Union_Id_Field => 32,
      Convention_Id_Field => 8,
      Component_Alignment_Kind_Field => 2,
      Mechanism_Type_Field => 32);

   type Type_Only_Enum is
     (No_Type_Only, Base_Type_Only, Impl_Base_Type_Only, Root_Type_Only);

   type Field_Descriptor is record
      Kind : Field_Kind;
      Offset : Field_Offset;
      Type_Only : Type_Only_Enum;
   end record;

   N_Head : constant Field_Offset := 3;

   Atree_Statistics_Enabled : constant Boolean := False;

end Seinfo;
