pragma Warnings (Off);
pragma Ada_95;
with System;
with System.Parameters;
with System.Secondary_Stack;
package ada_main is

   gnat_argc : Integer;
   gnat_argv : System.Address;
   gnat_envp : System.Address;

   pragma Import (C, gnat_argc);
   pragma Import (C, gnat_argv);
   pragma Import (C, gnat_envp);

   gnat_exit_status : Integer;
   pragma Import (C, gnat_exit_status);

   GNAT_Version : constant String :=
                    "GNAT Version: 13.2.1 20230728 (Red Hat 13.2.1-1)" & ASCII.NUL;
   pragma Export (C, GNAT_Version, "__gnat_version");

   GNAT_Version_Address : constant System.Address := GNAT_Version'Address;
   pragma Export (C, GNAT_Version_Address, "__gnat_version_address");

   Ada_Main_Program_Name : constant String := "_ada_gnatmake" & ASCII.NUL;
   pragma Export (C, Ada_Main_Program_Name, "__gnat_ada_main_program_name");

   procedure adainit;
   pragma Export (C, adainit, "adainit");

   procedure adafinal;
   pragma Export (C, adafinal, "adafinal");

   function main
     (argc : Integer;
      argv : System.Address;
      envp : System.Address)
      return Integer;
   pragma Export (C, main, "main");

   type Version_32 is mod 2 ** 32;
   u00001 : constant Version_32 := 16#665813ff#;
   pragma Export (C, u00001, "gnatmakeB");
   u00002 : constant Version_32 := 16#2f7236c5#;
   pragma Export (C, u00002, "gnatmakeS");
   u00003 : constant Version_32 := 16#7320ff5f#;
   pragma Export (C, u00003, "system__standard_libraryB");
   u00004 : constant Version_32 := 16#e631fedd#;
   pragma Export (C, u00004, "system__standard_libraryS");
   u00005 : constant Version_32 := 16#a4b68e67#;
   pragma Export (C, u00005, "gnatvsnB");
   u00006 : constant Version_32 := 16#fdc6387d#;
   pragma Export (C, u00006, "gnatvsnS");
   u00007 : constant Version_32 := 16#d4c699bf#;
   pragma Export (C, u00007, "system__secondary_stackB");
   u00008 : constant Version_32 := 16#dc7decf3#;
   pragma Export (C, u00008, "system__secondary_stackS");
   u00009 : constant Version_32 := 16#76789da1#;
   pragma Export (C, u00009, "adaS");
   u00010 : constant Version_32 := 16#5f858aa9#;
   pragma Export (C, u00010, "ada__exceptionsB");
   u00011 : constant Version_32 := 16#a827d249#;
   pragma Export (C, u00011, "ada__exceptionsS");
   u00012 : constant Version_32 := 16#0740df23#;
   pragma Export (C, u00012, "ada__exceptions__last_chance_handlerB");
   u00013 : constant Version_32 := 16#6dc27684#;
   pragma Export (C, u00013, "ada__exceptions__last_chance_handlerS");
   u00014 : constant Version_32 := 16#f43f5944#;
   pragma Export (C, u00014, "systemS");
   u00015 : constant Version_32 := 16#fd5f5f4c#;
   pragma Export (C, u00015, "system__soft_linksB");
   u00016 : constant Version_32 := 16#89a2cfa7#;
   pragma Export (C, u00016, "system__soft_linksS");
   u00017 : constant Version_32 := 16#0286ce9f#;
   pragma Export (C, u00017, "system__soft_links__initializeB");
   u00018 : constant Version_32 := 16#2ed17187#;
   pragma Export (C, u00018, "system__soft_links__initializeS");
   u00019 : constant Version_32 := 16#821dff88#;
   pragma Export (C, u00019, "system__parametersB");
   u00020 : constant Version_32 := 16#20abfde2#;
   pragma Export (C, u00020, "system__parametersS");
   u00021 : constant Version_32 := 16#8599b27b#;
   pragma Export (C, u00021, "system__stack_checkingB");
   u00022 : constant Version_32 := 16#54eaf05e#;
   pragma Export (C, u00022, "system__stack_checkingS");
   u00023 : constant Version_32 := 16#2a95d23d#;
   pragma Export (C, u00023, "system__storage_elementsB");
   u00024 : constant Version_32 := 16#5f6b31a0#;
   pragma Export (C, u00024, "system__storage_elementsS");
   u00025 : constant Version_32 := 16#c71e6c8a#;
   pragma Export (C, u00025, "system__exception_tableB");
   u00026 : constant Version_32 := 16#79142f5d#;
   pragma Export (C, u00026, "system__exception_tableS");
   u00027 : constant Version_32 := 16#c69ae676#;
   pragma Export (C, u00027, "system__exceptionsS");
   u00028 : constant Version_32 := 16#69416224#;
   pragma Export (C, u00028, "system__exceptions__machineB");
   u00029 : constant Version_32 := 16#8bdfdbe3#;
   pragma Export (C, u00029, "system__exceptions__machineS");
   u00030 : constant Version_32 := 16#7706238d#;
   pragma Export (C, u00030, "system__exceptions_debugB");
   u00031 : constant Version_32 := 16#c4310117#;
   pragma Export (C, u00031, "system__exceptions_debugS");
   u00032 : constant Version_32 := 16#84bc862c#;
   pragma Export (C, u00032, "system__img_intS");
   u00033 : constant Version_32 := 16#f2c63a02#;
   pragma Export (C, u00033, "ada__numericsS");
   u00034 : constant Version_32 := 16#174f5472#;
   pragma Export (C, u00034, "ada__numerics__big_numbersS");
   u00035 : constant Version_32 := 16#0e15261d#;
   pragma Export (C, u00035, "system__unsigned_typesS");
   u00036 : constant Version_32 := 16#e8ddc14a#;
   pragma Export (C, u00036, "system__val_intS");
   u00037 : constant Version_32 := 16#fec3d17e#;
   pragma Export (C, u00037, "system__val_unsS");
   u00038 : constant Version_32 := 16#96e09402#;
   pragma Export (C, u00038, "system__val_utilB");
   u00039 : constant Version_32 := 16#c7fa8dc9#;
   pragma Export (C, u00039, "system__val_utilS");
   u00040 : constant Version_32 := 16#b98923bf#;
   pragma Export (C, u00040, "system__case_utilB");
   u00041 : constant Version_32 := 16#3b2c8e11#;
   pragma Export (C, u00041, "system__case_utilS");
   u00042 : constant Version_32 := 16#3b506bff#;
   pragma Export (C, u00042, "system__wid_unsS");
   u00043 : constant Version_32 := 16#5c7d9c20#;
   pragma Export (C, u00043, "system__tracebackB");
   u00044 : constant Version_32 := 16#72a5adf9#;
   pragma Export (C, u00044, "system__tracebackS");
   u00045 : constant Version_32 := 16#5f6b6486#;
   pragma Export (C, u00045, "system__traceback_entriesB");
   u00046 : constant Version_32 := 16#3c23e6c8#;
   pragma Export (C, u00046, "system__traceback_entriesS");
   u00047 : constant Version_32 := 16#a0281f47#;
   pragma Export (C, u00047, "system__traceback__symbolicB");
   u00048 : constant Version_32 := 16#d9e66ad1#;
   pragma Export (C, u00048, "system__traceback__symbolicS");
   u00049 : constant Version_32 := 16#701f9d88#;
   pragma Export (C, u00049, "ada__exceptions__tracebackB");
   u00050 : constant Version_32 := 16#eb07882c#;
   pragma Export (C, u00050, "ada__exceptions__tracebackS");
   u00051 : constant Version_32 := 16#a0d3d22b#;
   pragma Export (C, u00051, "system__address_imageB");
   u00052 : constant Version_32 := 16#55d3c47e#;
   pragma Export (C, u00052, "system__address_imageS");
   u00053 : constant Version_32 := 16#fd158a37#;
   pragma Export (C, u00053, "system__wch_conB");
   u00054 : constant Version_32 := 16#2d3c7a27#;
   pragma Export (C, u00054, "system__wch_conS");
   u00055 : constant Version_32 := 16#5c289972#;
   pragma Export (C, u00055, "system__wch_stwB");
   u00056 : constant Version_32 := 16#002d5626#;
   pragma Export (C, u00056, "system__wch_stwS");
   u00057 : constant Version_32 := 16#f8305de6#;
   pragma Export (C, u00057, "system__wch_cnvB");
   u00058 : constant Version_32 := 16#2bfcb057#;
   pragma Export (C, u00058, "system__wch_cnvS");
   u00059 : constant Version_32 := 16#15f799c2#;
   pragma Export (C, u00059, "interfacesS");
   u00060 : constant Version_32 := 16#e538de43#;
   pragma Export (C, u00060, "system__wch_jisB");
   u00061 : constant Version_32 := 16#9e4bd27d#;
   pragma Export (C, u00061, "system__wch_jisS");
   u00062 : constant Version_32 := 16#2e9be1fc#;
   pragma Export (C, u00062, "makeB");
   u00063 : constant Version_32 := 16#f8ac97ed#;
   pragma Export (C, u00063, "makeS");
   u00064 : constant Version_32 := 16#fdc30936#;
   pragma Export (C, u00064, "ada__command_lineB");
   u00065 : constant Version_32 := 16#3cdef8c9#;
   pragma Export (C, u00065, "ada__command_lineS");
   u00066 : constant Version_32 := 16#414349e5#;
   pragma Export (C, u00066, "ada__directoriesB");
   u00067 : constant Version_32 := 16#65bd6f7f#;
   pragma Export (C, u00067, "ada__directoriesS");
   u00068 : constant Version_32 := 16#37ff5dbb#;
   pragma Export (C, u00068, "ada__calendarB");
   u00069 : constant Version_32 := 16#8324cd02#;
   pragma Export (C, u00069, "ada__calendarS");
   u00070 : constant Version_32 := 16#545fe66d#;
   pragma Export (C, u00070, "interfaces__cB");
   u00071 : constant Version_32 := 16#9d395173#;
   pragma Export (C, u00071, "interfaces__cS");
   u00072 : constant Version_32 := 16#1d7382c4#;
   pragma Export (C, u00072, "system__os_libB");
   u00073 : constant Version_32 := 16#0e53891b#;
   pragma Export (C, u00073, "system__os_libS");
   u00074 : constant Version_32 := 16#6e5d049a#;
   pragma Export (C, u00074, "system__atomic_operations__test_and_setB");
   u00075 : constant Version_32 := 16#57acee8e#;
   pragma Export (C, u00075, "system__atomic_operations__test_and_setS");
   u00076 : constant Version_32 := 16#335c2361#;
   pragma Export (C, u00076, "system__atomic_operationsS");
   u00077 : constant Version_32 := 16#29cc6115#;
   pragma Export (C, u00077, "system__atomic_primitivesB");
   u00078 : constant Version_32 := 16#b3761165#;
   pragma Export (C, u00078, "system__atomic_primitivesS");
   u00079 : constant Version_32 := 16#aaad6f1a#;
   pragma Export (C, u00079, "system__crtlS");
   u00080 : constant Version_32 := 16#256dbbe5#;
   pragma Export (C, u00080, "system__stringsB");
   u00081 : constant Version_32 := 16#6fbd595c#;
   pragma Export (C, u00081, "system__stringsS");
   u00082 : constant Version_32 := 16#307180be#;
   pragma Export (C, u00082, "system__os_primitivesB");
   u00083 : constant Version_32 := 16#f3c23cb2#;
   pragma Export (C, u00083, "system__os_primitivesS");
   u00084 : constant Version_32 := 16#5b4659fa#;
   pragma Export (C, u00084, "ada__charactersS");
   u00085 : constant Version_32 := 16#f70a517e#;
   pragma Export (C, u00085, "ada__characters__handlingB");
   u00086 : constant Version_32 := 16#ea6baced#;
   pragma Export (C, u00086, "ada__characters__handlingS");
   u00087 : constant Version_32 := 16#cde9ea2d#;
   pragma Export (C, u00087, "ada__characters__latin_1S");
   u00088 : constant Version_32 := 16#e6d4fa36#;
   pragma Export (C, u00088, "ada__stringsS");
   u00089 : constant Version_32 := 16#16f45e54#;
   pragma Export (C, u00089, "ada__strings__mapsB");
   u00090 : constant Version_32 := 16#9df1863a#;
   pragma Export (C, u00090, "ada__strings__mapsS");
   u00091 : constant Version_32 := 16#96b40646#;
   pragma Export (C, u00091, "system__bit_opsB");
   u00092 : constant Version_32 := 16#39ccf578#;
   pragma Export (C, u00092, "system__bit_opsS");
   u00093 : constant Version_32 := 16#4642cba6#;
   pragma Export (C, u00093, "ada__strings__maps__constantsS");
   u00094 : constant Version_32 := 16#179d7d28#;
   pragma Export (C, u00094, "ada__containersS");
   u00095 : constant Version_32 := 16#c3b32edd#;
   pragma Export (C, u00095, "ada__containers__helpersB");
   u00096 : constant Version_32 := 16#444c93c2#;
   pragma Export (C, u00096, "ada__containers__helpersS");
   u00097 : constant Version_32 := 16#86c56e5a#;
   pragma Export (C, u00097, "ada__finalizationS");
   u00098 : constant Version_32 := 16#b4f41810#;
   pragma Export (C, u00098, "ada__streamsB");
   u00099 : constant Version_32 := 16#67e31212#;
   pragma Export (C, u00099, "ada__streamsS");
   u00100 : constant Version_32 := 16#367911c4#;
   pragma Export (C, u00100, "ada__io_exceptionsS");
   u00101 : constant Version_32 := 16#a201b8c5#;
   pragma Export (C, u00101, "ada__strings__text_buffersB");
   u00102 : constant Version_32 := 16#a7cfd09b#;
   pragma Export (C, u00102, "ada__strings__text_buffersS");
   u00103 : constant Version_32 := 16#8b7604c4#;
   pragma Export (C, u00103, "ada__strings__utf_encodingB");
   u00104 : constant Version_32 := 16#4d0e0994#;
   pragma Export (C, u00104, "ada__strings__utf_encodingS");
   u00105 : constant Version_32 := 16#bb780f45#;
   pragma Export (C, u00105, "ada__strings__utf_encoding__stringsB");
   u00106 : constant Version_32 := 16#b85ff4b6#;
   pragma Export (C, u00106, "ada__strings__utf_encoding__stringsS");
   u00107 : constant Version_32 := 16#d1d1ed0b#;
   pragma Export (C, u00107, "ada__strings__utf_encoding__wide_stringsB");
   u00108 : constant Version_32 := 16#5678478f#;
   pragma Export (C, u00108, "ada__strings__utf_encoding__wide_stringsS");
   u00109 : constant Version_32 := 16#c2b98963#;
   pragma Export (C, u00109, "ada__strings__utf_encoding__wide_wide_stringsB");
   u00110 : constant Version_32 := 16#d7af3358#;
   pragma Export (C, u00110, "ada__strings__utf_encoding__wide_wide_stringsS");
   u00111 : constant Version_32 := 16#f38d604a#;
   pragma Export (C, u00111, "ada__tagsB");
   u00112 : constant Version_32 := 16#4d1deaec#;
   pragma Export (C, u00112, "ada__tagsS");
   u00113 : constant Version_32 := 16#3548d972#;
   pragma Export (C, u00113, "system__htableB");
   u00114 : constant Version_32 := 16#75e601af#;
   pragma Export (C, u00114, "system__htableS");
   u00115 : constant Version_32 := 16#1f1abe38#;
   pragma Export (C, u00115, "system__string_hashB");
   u00116 : constant Version_32 := 16#d2a381d0#;
   pragma Export (C, u00116, "system__string_hashS");
   u00117 : constant Version_32 := 16#dc0c0394#;
   pragma Export (C, u00117, "system__val_lluS");
   u00118 : constant Version_32 := 16#abd3c34b#;
   pragma Export (C, u00118, "system__put_imagesB");
   u00119 : constant Version_32 := 16#e8915e5b#;
   pragma Export (C, u00119, "system__put_imagesS");
   u00120 : constant Version_32 := 16#22b9eb9f#;
   pragma Export (C, u00120, "ada__strings__text_buffers__utilsB");
   u00121 : constant Version_32 := 16#89062ac3#;
   pragma Export (C, u00121, "ada__strings__text_buffers__utilsS");
   u00122 : constant Version_32 := 16#95817ed8#;
   pragma Export (C, u00122, "system__finalization_rootB");
   u00123 : constant Version_32 := 16#bbcd2ad4#;
   pragma Export (C, u00123, "system__finalization_rootS");
   u00124 : constant Version_32 := 16#ea191d9a#;
   pragma Export (C, u00124, "system__atomic_countersB");
   u00125 : constant Version_32 := 16#2827b687#;
   pragma Export (C, u00125, "system__atomic_countersS");
   u00126 : constant Version_32 := 16#443c5e57#;
   pragma Export (C, u00126, "ada__directories__hierarchical_file_namesB");
   u00127 : constant Version_32 := 16#34d5eeb2#;
   pragma Export (C, u00127, "ada__directories__hierarchical_file_namesS");
   u00128 : constant Version_32 := 16#ab4ad33a#;
   pragma Export (C, u00128, "ada__directories__validityB");
   u00129 : constant Version_32 := 16#0877bcae#;
   pragma Export (C, u00129, "ada__directories__validityS");
   u00130 : constant Version_32 := 16#bc39daba#;
   pragma Export (C, u00130, "ada__strings__fixedB");
   u00131 : constant Version_32 := 16#889cc4e3#;
   pragma Export (C, u00131, "ada__strings__fixedS");
   u00132 : constant Version_32 := 16#24432fa0#;
   pragma Export (C, u00132, "ada__strings__searchB");
   u00133 : constant Version_32 := 16#501fe7a7#;
   pragma Export (C, u00133, "ada__strings__searchS");
   u00134 : constant Version_32 := 16#ce46ef46#;
   pragma Export (C, u00134, "ada__strings__unboundedB");
   u00135 : constant Version_32 := 16#6c6d6657#;
   pragma Export (C, u00135, "ada__strings__unboundedS");
   u00136 : constant Version_32 := 16#190570e0#;
   pragma Export (C, u00136, "system__compare_array_unsigned_8B");
   u00137 : constant Version_32 := 16#64d9c727#;
   pragma Export (C, u00137, "system__compare_array_unsigned_8S");
   u00138 : constant Version_32 := 16#74e358eb#;
   pragma Export (C, u00138, "system__address_operationsB");
   u00139 : constant Version_32 := 16#8a0b75e4#;
   pragma Export (C, u00139, "system__address_operationsS");
   u00140 : constant Version_32 := 16#5000376b#;
   pragma Export (C, u00140, "system__return_stackS");
   u00141 : constant Version_32 := 16#d50f3cfb#;
   pragma Export (C, u00141, "system__stream_attributesB");
   u00142 : constant Version_32 := 16#e8517e28#;
   pragma Export (C, u00142, "system__stream_attributesS");
   u00143 : constant Version_32 := 16#3aecdcda#;
   pragma Export (C, u00143, "system__stream_attributes__xdrB");
   u00144 : constant Version_32 := 16#42985e70#;
   pragma Export (C, u00144, "system__stream_attributes__xdrS");
   u00145 : constant Version_32 := 16#370d8628#;
   pragma Export (C, u00145, "system__fat_fltS");
   u00146 : constant Version_32 := 16#113f8f25#;
   pragma Export (C, u00146, "system__fat_lfltS");
   u00147 : constant Version_32 := 16#6bef21cf#;
   pragma Export (C, u00147, "system__fat_llfS");
   u00148 : constant Version_32 := 16#f4efa93a#;
   pragma Export (C, u00148, "system__file_attributesS");
   u00149 : constant Version_32 := 16#776f8952#;
   pragma Export (C, u00149, "system__os_constantsS");
   u00150 : constant Version_32 := 16#1aa716c1#;
   pragma Export (C, u00150, "system__file_ioB");
   u00151 : constant Version_32 := 16#889d9c11#;
   pragma Export (C, u00151, "system__file_ioS");
   u00152 : constant Version_32 := 16#73d2d764#;
   pragma Export (C, u00152, "interfaces__c_streamsB");
   u00153 : constant Version_32 := 16#7acc80b4#;
   pragma Export (C, u00153, "interfaces__c_streamsS");
   u00154 : constant Version_32 := 16#56ceae55#;
   pragma Export (C, u00154, "system__file_control_blockS");
   u00155 : constant Version_32 := 16#28888d98#;
   pragma Export (C, u00155, "system__finalization_mastersB");
   u00156 : constant Version_32 := 16#b4b61b27#;
   pragma Export (C, u00156, "system__finalization_mastersS");
   u00157 : constant Version_32 := 16#20ec7aa3#;
   pragma Export (C, u00157, "system__ioB");
   u00158 : constant Version_32 := 16#6a7dae0b#;
   pragma Export (C, u00158, "system__ioS");
   u00159 : constant Version_32 := 16#35d6ef80#;
   pragma Export (C, u00159, "system__storage_poolsB");
   u00160 : constant Version_32 := 16#09de9c13#;
   pragma Export (C, u00160, "system__storage_poolsS");
   u00161 : constant Version_32 := 16#8f8e85c2#;
   pragma Export (C, u00161, "system__regexpB");
   u00162 : constant Version_32 := 16#d70dfe88#;
   pragma Export (C, u00162, "system__regexpS");
   u00163 : constant Version_32 := 16#d3b322b3#;
   pragma Export (C, u00163, "aliB");
   u00164 : constant Version_32 := 16#f5f3f6bf#;
   pragma Export (C, u00164, "aliS");
   u00165 : constant Version_32 := 16#5a52105d#;
   pragma Export (C, u00165, "butilB");
   u00166 : constant Version_32 := 16#02d57147#;
   pragma Export (C, u00166, "butilS");
   u00167 : constant Version_32 := 16#b5988c27#;
   pragma Export (C, u00167, "gnatS");
   u00168 : constant Version_32 := 16#2be8d8e8#;
   pragma Export (C, u00168, "optB");
   u00169 : constant Version_32 := 16#d17abec5#;
   pragma Export (C, u00169, "optS");
   u00170 : constant Version_32 := 16#f8d3608b#;
   pragma Export (C, u00170, "csetsB");
   u00171 : constant Version_32 := 16#e948558f#;
   pragma Export (C, u00171, "csetsS");
   u00172 : constant Version_32 := 16#2fb34529#;
   pragma Export (C, u00172, "system__assertionsB");
   u00173 : constant Version_32 := 16#d23c26df#;
   pragma Export (C, u00173, "system__assertionsS");
   u00174 : constant Version_32 := 16#8b2c6428#;
   pragma Export (C, u00174, "ada__assertionsB");
   u00175 : constant Version_32 := 16#cc3ec2fd#;
   pragma Export (C, u00175, "ada__assertionsS");
   u00176 : constant Version_32 := 16#3b0dbbfa#;
   pragma Export (C, u00176, "hostparmS");
   u00177 : constant Version_32 := 16#ca878138#;
   pragma Export (C, u00177, "system__concat_2B");
   u00178 : constant Version_32 := 16#41c42ab3#;
   pragma Export (C, u00178, "system__concat_2S");
   u00179 : constant Version_32 := 16#d4e0603b#;
   pragma Export (C, u00179, "typesB");
   u00180 : constant Version_32 := 16#6a26e4fa#;
   pragma Export (C, u00180, "typesS");
   u00181 : constant Version_32 := 16#a61ae265#;
   pragma Export (C, u00181, "outputB");
   u00182 : constant Version_32 := 16#dfee97b2#;
   pragma Export (C, u00182, "outputS");
   u00183 : constant Version_32 := 16#d38c97c5#;
   pragma Export (C, u00183, "nametB");
   u00184 : constant Version_32 := 16#bc7da6aa#;
   pragma Export (C, u00184, "nametS");
   u00185 : constant Version_32 := 16#91fc5baa#;
   pragma Export (C, u00185, "debugB");
   u00186 : constant Version_32 := 16#1ac546f9#;
   pragma Export (C, u00186, "debugS");
   u00187 : constant Version_32 := 16#160489b6#;
   pragma Export (C, u00187, "widecharB");
   u00188 : constant Version_32 := 16#fc939d63#;
   pragma Export (C, u00188, "widecharS");
   u00189 : constant Version_32 := 16#1b78961f#;
   pragma Export (C, u00189, "allocS");
   u00190 : constant Version_32 := 16#d6a61cf8#;
   pragma Export (C, u00190, "tableB");
   u00191 : constant Version_32 := 16#f93c8813#;
   pragma Export (C, u00191, "tableS");
   u00192 : constant Version_32 := 16#1982dcd0#;
   pragma Export (C, u00192, "system__memoryB");
   u00193 : constant Version_32 := 16#afbb6b94#;
   pragma Export (C, u00193, "system__memoryS");
   u00194 : constant Version_32 := 16#9b950d9a#;
   pragma Export (C, u00194, "fnameB");
   u00195 : constant Version_32 := 16#cdf3f413#;
   pragma Export (C, u00195, "fnameS");
   u00196 : constant Version_32 := 16#2af1acd3#;
   pragma Export (C, u00196, "gnat__dynamic_htablesB");
   u00197 : constant Version_32 := 16#2317962f#;
   pragma Export (C, u00197, "gnat__dynamic_htablesS");
   u00198 : constant Version_32 := 16#aa491086#;
   pragma Export (C, u00198, "osintB");
   u00199 : constant Version_32 := 16#f8c7b007#;
   pragma Export (C, u00199, "osintS");
   u00200 : constant Version_32 := 16#b23ad542#;
   pragma Export (C, u00200, "fmapB");
   u00201 : constant Version_32 := 16#19fb29a0#;
   pragma Export (C, u00201, "fmapS");
   u00202 : constant Version_32 := 16#9f9cc922#;
   pragma Export (C, u00202, "gnat__htableB");
   u00203 : constant Version_32 := 16#4a45b320#;
   pragma Export (C, u00203, "gnat__htableS");
   u00204 : constant Version_32 := 16#23db0006#;
   pragma Export (C, u00204, "sdefaultB");
   u00205 : constant Version_32 := 16#2b49f98f#;
   pragma Export (C, u00205, "sdefaultS");
   u00206 : constant Version_32 := 16#b6ddf4be#;
   pragma Export (C, u00206, "targparmB");
   u00207 : constant Version_32 := 16#c8d35e80#;
   pragma Export (C, u00207, "targparmS");
   u00208 : constant Version_32 := 16#3d90c1c0#;
   pragma Export (C, u00208, "ridentS");
   u00209 : constant Version_32 := 16#c484e6b6#;
   pragma Export (C, u00209, "snamesB");
   u00210 : constant Version_32 := 16#5d7dbf4b#;
   pragma Export (C, u00210, "snamesS");
   u00211 : constant Version_32 := 16#c48b4da9#;
   pragma Export (C, u00211, "casingB");
   u00212 : constant Version_32 := 16#cdd9f882#;
   pragma Export (C, u00212, "casingS");
   u00213 : constant Version_32 := 16#48c739d2#;
   pragma Export (C, u00213, "ali__utilB");
   u00214 : constant Version_32 := 16#f9319136#;
   pragma Export (C, u00214, "ali__utilS");
   u00215 : constant Version_32 := 16#73968e32#;
   pragma Export (C, u00215, "atreeB");
   u00216 : constant Version_32 := 16#9e09c93e#;
   pragma Export (C, u00216, "atreeS");
   u00217 : constant Version_32 := 16#ac5eb766#;
   pragma Export (C, u00217, "aspectsB");
   u00218 : constant Version_32 := 16#6c4155e1#;
   pragma Export (C, u00218, "aspectsS");
   u00219 : constant Version_32 := 16#7f0c2427#;
   pragma Export (C, u00219, "einfoS");
   u00220 : constant Version_32 := 16#6e11a734#;
   pragma Export (C, u00220, "standS");
   u00221 : constant Version_32 := 16#6c3bab0d#;
   pragma Export (C, u00221, "uintpB");
   u00222 : constant Version_32 := 16#c8c1c4a4#;
   pragma Export (C, u00222, "uintpS");
   u00223 : constant Version_32 := 16#e2a447d9#;
   pragma Export (C, u00223, "urealpB");
   u00224 : constant Version_32 := 16#5a74d7ac#;
   pragma Export (C, u00224, "urealpS");
   u00225 : constant Version_32 := 16#2a366f01#;
   pragma Export (C, u00225, "einfo__entitiesB");
   u00226 : constant Version_32 := 16#d22d53f1#;
   pragma Export (C, u00226, "einfo__entitiesS");
   u00227 : constant Version_32 := 16#05a4bfac#;
   pragma Export (C, u00227, "einfo__utilsB");
   u00228 : constant Version_32 := 16#4bafe198#;
   pragma Export (C, u00228, "einfo__utilsS");
   u00229 : constant Version_32 := 16#f5b8535a#;
   pragma Export (C, u00229, "elistsB");
   u00230 : constant Version_32 := 16#08074f67#;
   pragma Export (C, u00230, "elistsS");
   u00231 : constant Version_32 := 16#08942e1f#;
   pragma Export (C, u00231, "nlistsB");
   u00232 : constant Version_32 := 16#7fe684bb#;
   pragma Export (C, u00232, "nlistsS");
   u00233 : constant Version_32 := 16#4e4c2b5c#;
   pragma Export (C, u00233, "sinfoS");
   u00234 : constant Version_32 := 16#d93df5c0#;
   pragma Export (C, u00234, "sinfo__nodesB");
   u00235 : constant Version_32 := 16#46d4de05#;
   pragma Export (C, u00235, "sinfo__nodesS");
   u00236 : constant Version_32 := 16#c91ec790#;
   pragma Export (C, u00236, "sinfo__utilsB");
   u00237 : constant Version_32 := 16#53f5e458#;
   pragma Export (C, u00237, "sinfo__utilsS");
   u00238 : constant Version_32 := 16#bdc9a102#;
   pragma Export (C, u00238, "seinfoS");
   u00239 : constant Version_32 := 16#138ce8da#;
   pragma Export (C, u00239, "sinputB");
   u00240 : constant Version_32 := 16#8f2ad039#;
   pragma Export (C, u00240, "sinputS");
   u00241 : constant Version_32 := 16#641bd22f#;
   pragma Export (C, u00241, "gnat__byte_order_markB");
   u00242 : constant Version_32 := 16#0475df31#;
   pragma Export (C, u00242, "gnat__byte_order_markS");
   u00243 : constant Version_32 := 16#f932b5ec#;
   pragma Export (C, u00243, "scansB");
   u00244 : constant Version_32 := 16#b5b27c47#;
   pragma Export (C, u00244, "scansS");
   u00245 : constant Version_32 := 16#e8c996fc#;
   pragma Export (C, u00245, "binderrB");
   u00246 : constant Version_32 := 16#08adca1b#;
   pragma Export (C, u00246, "binderrS");
   u00247 : constant Version_32 := 16#9c57b5ef#;
   pragma Export (C, u00247, "err_varsS");
   u00248 : constant Version_32 := 16#c313b157#;
   pragma Export (C, u00248, "erroutB");
   u00249 : constant Version_32 := 16#e82177ca#;
   pragma Export (C, u00249, "erroutS");
   u00250 : constant Version_32 := 16#53758945#;
   pragma Export (C, u00250, "erroutcB");
   u00251 : constant Version_32 := 16#25a351e2#;
   pragma Export (C, u00251, "erroutcS");
   u00252 : constant Version_32 := 16#48e1701b#;
   pragma Export (C, u00252, "stringtB");
   u00253 : constant Version_32 := 16#b2b36a9a#;
   pragma Export (C, u00253, "stringtS");
   u00254 : constant Version_32 := 16#b9ee5b43#;
   pragma Export (C, u00254, "warnswB");
   u00255 : constant Version_32 := 16#4be73eb5#;
   pragma Export (C, u00255, "warnswS");
   u00256 : constant Version_32 := 16#585ea7f7#;
   pragma Export (C, u00256, "libB");
   u00257 : constant Version_32 := 16#181108e0#;
   pragma Export (C, u00257, "libS");
   u00258 : constant Version_32 := 16#130ca291#;
   pragma Export (C, u00258, "unameB");
   u00259 : constant Version_32 := 16#480cff7e#;
   pragma Export (C, u00259, "unameS");
   u00260 : constant Version_32 := 16#4c8f170c#;
   pragma Export (C, u00260, "sem_auxB");
   u00261 : constant Version_32 := 16#f30488d1#;
   pragma Export (C, u00261, "sem_auxS");
   u00262 : constant Version_32 := 16#6c4c6bb5#;
   pragma Export (C, u00262, "styleswB");
   u00263 : constant Version_32 := 16#3079b87e#;
   pragma Export (C, u00263, "styleswS");
   u00264 : constant Version_32 := 16#4515aae6#;
   pragma Export (C, u00264, "scngB");
   u00265 : constant Version_32 := 16#098d1a78#;
   pragma Export (C, u00265, "scngS");
   u00266 : constant Version_32 := 16#1e6e5cd0#;
   pragma Export (C, u00266, "system__crc32B");
   u00267 : constant Version_32 := 16#c5007333#;
   pragma Export (C, u00267, "system__crc32S");
   u00268 : constant Version_32 := 16#1f3e80d3#;
   pragma Export (C, u00268, "system__utf_32B");
   u00269 : constant Version_32 := 16#705e88fb#;
   pragma Export (C, u00269, "system__utf_32S");
   u00270 : constant Version_32 := 16#8eae9e28#;
   pragma Export (C, u00270, "stylegB");
   u00271 : constant Version_32 := 16#fc809ba0#;
   pragma Export (C, u00271, "stylegS");
   u00272 : constant Version_32 := 16#b4dc7a7f#;
   pragma Export (C, u00272, "sinput__cB");
   u00273 : constant Version_32 := 16#feb16495#;
   pragma Export (C, u00273, "sinput__cS");
   u00274 : constant Version_32 := 16#4937563f#;
   pragma Export (C, u00274, "fname__sfB");
   u00275 : constant Version_32 := 16#a6838c5d#;
   pragma Export (C, u00275, "fname__sfS");
   u00276 : constant Version_32 := 16#0be3bcc2#;
   pragma Export (C, u00276, "fname__ufB");
   u00277 : constant Version_32 := 16#814be417#;
   pragma Export (C, u00277, "fname__ufS");
   u00278 : constant Version_32 := 16#55ac2fc9#;
   pragma Export (C, u00278, "krunchB");
   u00279 : constant Version_32 := 16#c0b4ff65#;
   pragma Export (C, u00279, "krunchS");
   u00280 : constant Version_32 := 16#68fe5eaf#;
   pragma Export (C, u00280, "sfn_scanB");
   u00281 : constant Version_32 := 16#fb1d0fa7#;
   pragma Export (C, u00281, "sfn_scanS");
   u00282 : constant Version_32 := 16#ece328dc#;
   pragma Export (C, u00282, "gnat__command_lineB");
   u00283 : constant Version_32 := 16#556a5ffb#;
   pragma Export (C, u00283, "gnat__command_lineS");
   u00284 : constant Version_32 := 16#67eb6d5a#;
   pragma Export (C, u00284, "ada__text_ioB");
   u00285 : constant Version_32 := 16#8aa3e4d7#;
   pragma Export (C, u00285, "ada__text_ioS");
   u00286 : constant Version_32 := 16#2af91ee3#;
   pragma Export (C, u00286, "gnat__directory_operationsB");
   u00287 : constant Version_32 := 16#38215e80#;
   pragma Export (C, u00287, "gnat__directory_operationsS");
   u00288 : constant Version_32 := 16#1a69b526#;
   pragma Export (C, u00288, "gnat__os_libS");
   u00289 : constant Version_32 := 16#7c78c3c5#;
   pragma Export (C, u00289, "system__pool_globalB");
   u00290 : constant Version_32 := 16#27e19159#;
   pragma Export (C, u00290, "system__pool_globalS");
   u00291 : constant Version_32 := 16#b49a0e5d#;
   pragma Export (C, u00291, "system__storage_pools__subpoolsB");
   u00292 : constant Version_32 := 16#a2d8d50c#;
   pragma Export (C, u00292, "system__storage_pools__subpoolsS");
   u00293 : constant Version_32 := 16#b0df1928#;
   pragma Export (C, u00293, "system__storage_pools__subpools__finalizationB");
   u00294 : constant Version_32 := 16#562129f7#;
   pragma Export (C, u00294, "system__storage_pools__subpools__finalizationS");
   u00295 : constant Version_32 := 16#40fe4806#;
   pragma Export (C, u00295, "gnat__regexpS");
   u00296 : constant Version_32 := 16#2b19e51a#;
   pragma Export (C, u00296, "gnat__stringsS");
   u00297 : constant Version_32 := 16#6ad8d3ae#;
   pragma Export (C, u00297, "gnat__ctrl_cB");
   u00298 : constant Version_32 := 16#ca91985c#;
   pragma Export (C, u00298, "gnat__ctrl_cS");
   u00299 : constant Version_32 := 16#19856117#;
   pragma Export (C, u00299, "make_utilB");
   u00300 : constant Version_32 := 16#f1a0ce26#;
   pragma Export (C, u00300, "make_utilS");
   u00301 : constant Version_32 := 16#c46db9d7#;
   pragma Export (C, u00301, "errutilB");
   u00302 : constant Version_32 := 16#8842cb8c#;
   pragma Export (C, u00302, "errutilS");
   u00303 : constant Version_32 := 16#f94e6456#;
   pragma Export (C, u00303, "gnat__case_utilS");
   u00304 : constant Version_32 := 16#f24bc691#;
   pragma Export (C, u00304, "makeusgB");
   u00305 : constant Version_32 := 16#d11a0f72#;
   pragma Export (C, u00305, "makeusgS");
   u00306 : constant Version_32 := 16#52ebc05d#;
   pragma Export (C, u00306, "switchB");
   u00307 : constant Version_32 := 16#148c9c2f#;
   pragma Export (C, u00307, "switchS");
   u00308 : constant Version_32 := 16#a6b14290#;
   pragma Export (C, u00308, "usageB");
   u00309 : constant Version_32 := 16#44182068#;
   pragma Export (C, u00309, "usageS");
   u00310 : constant Version_32 := 16#0fe8c51a#;
   pragma Export (C, u00310, "osint__mB");
   u00311 : constant Version_32 := 16#8cda5acc#;
   pragma Export (C, u00311, "osint__mS");
   u00312 : constant Version_32 := 16#0a90f75f#;
   pragma Export (C, u00312, "switch__mB");
   u00313 : constant Version_32 := 16#c3358508#;
   pragma Export (C, u00313, "switch__mS");
   u00314 : constant Version_32 := 16#fe2ee843#;
   pragma Export (C, u00314, "system__multiprocessorsB");
   u00315 : constant Version_32 := 16#cc93c637#;
   pragma Export (C, u00315, "system__multiprocessorsS");
   u00316 : constant Version_32 := 16#a8476e49#;
   pragma Export (C, u00316, "tempdirB");
   u00317 : constant Version_32 := 16#d2dc0918#;
   pragma Export (C, u00317, "tempdirS");

   --  BEGIN ELABORATION ORDER
   --  ada%s
   --  ada.characters%s
   --  ada.characters.latin_1%s
   --  interfaces%s
   --  system%s
   --  system.address_operations%s
   --  system.address_operations%b
   --  system.atomic_counters%s
   --  system.atomic_counters%b
   --  system.atomic_operations%s
   --  system.io%s
   --  system.io%b
   --  system.parameters%s
   --  system.parameters%b
   --  system.crtl%s
   --  interfaces.c_streams%s
   --  interfaces.c_streams%b
   --  system.os_primitives%s
   --  system.os_primitives%b
   --  system.storage_elements%s
   --  system.storage_elements%b
   --  system.return_stack%s
   --  system.stack_checking%s
   --  system.stack_checking%b
   --  system.string_hash%s
   --  system.string_hash%b
   --  system.htable%s
   --  system.htable%b
   --  system.strings%s
   --  system.strings%b
   --  system.traceback_entries%s
   --  system.traceback_entries%b
   --  system.unsigned_types%s
   --  system.utf_32%s
   --  system.utf_32%b
   --  system.wch_con%s
   --  system.wch_con%b
   --  system.wch_jis%s
   --  system.wch_jis%b
   --  system.wch_cnv%s
   --  system.wch_cnv%b
   --  system.compare_array_unsigned_8%s
   --  system.compare_array_unsigned_8%b
   --  system.concat_2%s
   --  system.concat_2%b
   --  system.crc32%s
   --  system.crc32%b
   --  system.traceback%s
   --  system.traceback%b
   --  system.case_util%s
   --  system.secondary_stack%s
   --  system.standard_library%s
   --  ada.exceptions%s
   --  system.exceptions_debug%s
   --  system.exceptions_debug%b
   --  system.soft_links%s
   --  system.val_uns%s
   --  system.val_int%s
   --  system.val_util%s
   --  system.val_util%b
   --  system.wch_stw%s
   --  system.wch_stw%b
   --  ada.exceptions.last_chance_handler%s
   --  ada.exceptions.last_chance_handler%b
   --  ada.exceptions.traceback%s
   --  ada.exceptions.traceback%b
   --  system.address_image%s
   --  system.address_image%b
   --  system.case_util%b
   --  system.exception_table%s
   --  system.exception_table%b
   --  ada.numerics%s
   --  ada.numerics.big_numbers%s
   --  system.exceptions%s
   --  system.exceptions.machine%s
   --  system.exceptions.machine%b
   --  system.memory%s
   --  system.memory%b
   --  system.secondary_stack%b
   --  system.soft_links.initialize%s
   --  system.soft_links.initialize%b
   --  system.soft_links%b
   --  system.standard_library%b
   --  system.traceback.symbolic%s
   --  system.traceback.symbolic%b
   --  system.wid_uns%s
   --  system.img_int%s
   --  ada.exceptions%b
   --  ada.assertions%s
   --  ada.assertions%b
   --  ada.command_line%s
   --  ada.command_line%b
   --  ada.containers%s
   --  ada.io_exceptions%s
   --  ada.strings%s
   --  ada.strings.utf_encoding%s
   --  ada.strings.utf_encoding%b
   --  ada.strings.utf_encoding.strings%s
   --  ada.strings.utf_encoding.strings%b
   --  ada.strings.utf_encoding.wide_strings%s
   --  ada.strings.utf_encoding.wide_strings%b
   --  ada.strings.utf_encoding.wide_wide_strings%s
   --  ada.strings.utf_encoding.wide_wide_strings%b
   --  gnat%s
   --  gnat.case_util%s
   --  gnat.htable%s
   --  gnat.htable%b
   --  gnat.strings%s
   --  interfaces.c%s
   --  interfaces.c%b
   --  system.atomic_primitives%s
   --  system.atomic_primitives%b
   --  system.atomic_operations.test_and_set%s
   --  system.atomic_operations.test_and_set%b
   --  system.fat_flt%s
   --  system.fat_lflt%s
   --  system.fat_llf%s
   --  system.multiprocessors%s
   --  system.multiprocessors%b
   --  system.os_constants%s
   --  system.os_lib%s
   --  system.os_lib%b
   --  gnat.os_lib%s
   --  system.val_llu%s
   --  ada.tags%s
   --  ada.tags%b
   --  ada.strings.text_buffers%s
   --  ada.strings.text_buffers%b
   --  ada.strings.text_buffers.utils%s
   --  ada.strings.text_buffers.utils%b
   --  system.put_images%s
   --  system.put_images%b
   --  ada.streams%s
   --  ada.streams%b
   --  system.file_control_block%s
   --  system.finalization_root%s
   --  system.finalization_root%b
   --  ada.finalization%s
   --  ada.containers.helpers%s
   --  ada.containers.helpers%b
   --  system.file_io%s
   --  system.file_io%b
   --  system.storage_pools%s
   --  system.storage_pools%b
   --  system.finalization_masters%s
   --  system.finalization_masters%b
   --  system.storage_pools.subpools%s
   --  system.storage_pools.subpools.finalization%s
   --  system.storage_pools.subpools.finalization%b
   --  system.storage_pools.subpools%b
   --  system.stream_attributes%s
   --  system.stream_attributes.xdr%s
   --  system.stream_attributes.xdr%b
   --  system.stream_attributes%b
   --  ada.calendar%s
   --  ada.calendar%b
   --  ada.text_io%s
   --  ada.text_io%b
   --  gnat.byte_order_mark%s
   --  gnat.byte_order_mark%b
   --  gnat.ctrl_c%s
   --  gnat.ctrl_c%b
   --  gnat.dynamic_htables%s
   --  gnat.dynamic_htables%b
   --  system.assertions%s
   --  system.assertions%b
   --  system.bit_ops%s
   --  system.bit_ops%b
   --  ada.strings.maps%s
   --  ada.strings.maps%b
   --  ada.strings.maps.constants%s
   --  ada.characters.handling%s
   --  ada.characters.handling%b
   --  ada.strings.search%s
   --  ada.strings.search%b
   --  ada.strings.fixed%s
   --  ada.strings.fixed%b
   --  ada.strings.unbounded%s
   --  ada.strings.unbounded%b
   --  gnat.directory_operations%s
   --  gnat.directory_operations%b
   --  system.file_attributes%s
   --  system.pool_global%s
   --  system.pool_global%b
   --  system.regexp%s
   --  system.regexp%b
   --  ada.directories%s
   --  ada.directories.hierarchical_file_names%s
   --  ada.directories.validity%s
   --  ada.directories.validity%b
   --  ada.directories%b
   --  ada.directories.hierarchical_file_names%b
   --  gnat.regexp%s
   --  gnat.command_line%s
   --  gnat.command_line%b
   --  debug%s
   --  debug%b
   --  types%s
   --  types%b
   --  alloc%s
   --  gnatvsn%s
   --  gnatvsn%b
   --  hostparm%s
   --  krunch%s
   --  krunch%b
   --  opt%s
   --  csets%s
   --  csets%b
   --  opt%b
   --  output%s
   --  output%b
   --  rident%s
   --  seinfo%s
   --  sfn_scan%s
   --  sfn_scan%b
   --  stand%s
   --  stylesw%s
   --  stylesw%b
   --  table%s
   --  table%b
   --  elists%s
   --  elists%b
   --  uintp%s
   --  uintp%b
   --  urealp%s
   --  urealp%b
   --  warnsw%s
   --  warnsw%b
   --  widechar%s
   --  widechar%b
   --  namet%s
   --  namet%b
   --  butil%s
   --  butil%b
   --  binderr%s
   --  binderr%b
   --  casing%s
   --  casing%b
   --  err_vars%s
   --  fmap%s
   --  osint%s
   --  fmap%b
   --  sdefault%s
   --  sdefault%b
   --  targparm%s
   --  targparm%b
   --  osint%b
   --  fname%s
   --  fname%b
   --  osint.m%s
   --  osint.m%b
   --  sinfo%s
   --  snames%s
   --  snames%b
   --  ali%s
   --  ali%b
   --  einfo%s
   --  scans%s
   --  scans%b
   --  aspects%s
   --  nlists%s
   --  sinfo.nodes%s
   --  einfo.entities%s
   --  einfo.utils%s
   --  atree%s
   --  einfo.entities%b
   --  nlists%b
   --  sinfo.utils%s
   --  aspects%b
   --  atree%b
   --  einfo.utils%b
   --  sinfo.nodes%b
   --  sinput%s
   --  sinput%b
   --  sinfo.utils%b
   --  sem_aux%s
   --  sem_aux%b
   --  sinput.c%s
   --  sinput.c%b
   --  stringt%s
   --  stringt%b
   --  erroutc%s
   --  erroutc%b
   --  lib%s
   --  uname%s
   --  uname%b
   --  lib%b
   --  errout%s
   --  errout%b
   --  fname.uf%s
   --  fname.uf%b
   --  fname.sf%s
   --  fname.sf%b
   --  styleg%s
   --  styleg%b
   --  errutil%s
   --  errutil%b
   --  make_util%s
   --  make_util%b
   --  scng%s
   --  scng%b
   --  ali.util%s
   --  ali.util%b
   --  switch%s
   --  switch%b
   --  switch.m%s
   --  switch.m%b
   --  tempdir%s
   --  tempdir%b
   --  usage%s
   --  usage%b
   --  makeusg%s
   --  makeusg%b
   --  make%s
   --  make%b
   --  gnatmake%s
   --  gnatmake%b
   --  END ELABORATION ORDER

end ada_main;
