/* do not edit automatically generated by mc from M2Comp.  */
/* M2Comp.mod continually calls the compiler for every source file.

Copyright (C) 2001-2023 Free Software Foundation, Inc.
Contributed by Gaius Mulley <gaius.mulley@southwales.ac.uk>.

This file is part of GNU Modula-2.

GNU Modula-2 is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 3, or (at your option)
any later version.

GNU Modula-2 is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with GNU Modula-2; see the file COPYING3.  If not see
<http://www.gnu.org/licenses/>.  */

#include "config.h"
#include "system.h"
#include <stdbool.h>
#   if !defined (PROC_D)
#      define PROC_D
       typedef void (*PROC_t) (void);
       typedef struct { PROC_t proc; } PROC;
#   endif

#   if !defined (TRUE)
#      define TRUE (1==1)
#   endif

#   if !defined (FALSE)
#      define FALSE (1==0)
#   endif

#if defined(__cplusplus)
#   undef NULL
#   define NULL 0
#endif
#define _M2Comp_H
#define _M2Comp_C

#   include "GM2Options.h"
#   include "GM2Pass.h"
#   include "GM2Reserved.h"
#   include "GM2Search.h"
#   include "GM2Code.h"
#   include "GM2LexBuf.h"
#   include "GM2FileName.h"
#   include "GM2Preprocess.h"
#   include "Glibc.h"
#   include "GM2Error.h"
#   include "GM2MetaError.h"
#   include "GFormatStrings.h"
#   include "GP0SymBuild.h"
#   include "Gm2flex.h"
#   include "GP0SyntaxCheck.h"
#   include "GP1Build.h"
#   include "GP2Build.h"
#   include "GPCBuild.h"
#   include "GP3Build.h"
#   include "GPHBuild.h"
#   include "GPCSymBuild.h"
#   include "GM2Batch.h"
#   include "GSymbolTable.h"
#   include "GFIO.h"
#   include "GNameKey.h"
#   include "GM2Printf.h"
#   include "GM2Quiet.h"
#   include "GDynamicStrings.h"
#   include "GPathName.h"

#   define Debugging false
static enum {M2Comp_None, M2Comp_Definition, M2Comp_Implementation, M2Comp_Program} ModuleType;

/*
   compile - compile the filename.
*/

extern "C" void M2Comp_compile (void * filename);

/*
   CompilingDefinitionModule - returns true if the current module being
                               compiled is a definition module.
*/

extern "C" bool M2Comp_CompilingDefinitionModule (void);

/*
   CompilingImplementationModule - returns true if the current module being
                                   compiled is an implementation module.
*/

extern "C" bool M2Comp_CompilingImplementationModule (void);

/*
   CompilingProgramModule - returns true if the current module being
                            compiled is a program module.
*/

extern "C" bool M2Comp_CompilingProgramModule (void);

/*
   NeedToParseImplementation -
*/

static bool NeedToParseImplementation (unsigned int sym);

/*
   Compile - compile file, s, using a 5 pass technique.
*/

static void Compile (DynamicStrings_String s);

/*
   ExamineCompilationUnit - opens the source file to obtain the module name and kind of module.
*/

static void ExamineCompilationUnit (void * *name, bool *isdefimp);

/*
   PeepInto - peeps into source, s, and initializes a definition/implementation or
              program module accordingly.
*/

static void PeepInto (DynamicStrings_String s);

/*
   qprintLibName - print the libname
*/

static void qprintLibName (DynamicStrings_String LibName);

/*
   DoPass0 -
*/

static void DoPass0 (DynamicStrings_String s);

/*
   DoPass1 - parses the sources of all modules necessary to compile
             the required module, Main.
*/

static void DoPass1 (void);

/*
   DoPass2 - parses the sources of all modules necessary to compile
             the required module, Main.
*/

static void DoPass2 (void);

/*
   DoPassC - parses the sources of all modules necessary to compile
             the required module, Main.
*/

static void DoPassC (void);

/*
   DoPass3 - parses the sources of all modules necessary to compile
             the required module, Main.
*/

static void DoPass3 (void);


/*
   NeedToParseImplementation -
*/

static bool NeedToParseImplementation (unsigned int sym)
{
  return ((((SymbolTable_IsDefImp (sym)) && (SymbolTable_IsHiddenTypeDeclared (sym))) && M2Options_ExtendedOpaque) || ((SymbolTable_IsDefImp (sym)) && (SymbolTable_IsBuiltinInModule (sym)))) || (M2Options_WholeProgram && (! (SymbolTable_IsDefinitionForC (sym))));
  /* static analysis guarentees a RETURN statement will be used before here.  */
  __builtin_unreachable ();
}


/*
   Compile - compile file, s, using a 5 pass technique.
*/

static void Compile (DynamicStrings_String s)
{
  DoPass0 (s);
  M2Error_FlushWarnings ();
  M2Error_FlushErrors ();
  if (M2Options_PPonly)
    {
      return ;
    }
  M2LexBuf_ResetForNewPass ();
  M2Error_ResetErrorScope ();
  M2Quiet_qprintf0 ((const char *) "Pass 1: scopes, enumerated types, imports and exports\\n", 55);
  DoPass1 ();
  M2Error_FlushWarnings ();
  M2Error_FlushErrors ();
  M2Quiet_qprintf0 ((const char *) "Pass 2: constants and types\\n", 29);
  M2LexBuf_ResetForNewPass ();
  M2Error_ResetErrorScope ();
  DoPass2 ();
  M2Error_FlushWarnings ();
  M2Error_FlushErrors ();
  M2Quiet_qprintf0 ((const char *) "Pass C: aggregate constants\\n", 29);
  M2LexBuf_ResetForNewPass ();
  M2Error_ResetErrorScope ();
  DoPassC ();
  M2Error_FlushWarnings ();
  M2Error_FlushErrors ();
  M2Quiet_qprintf0 ((const char *) "Pass 3: quadruple generation\\n", 30);
  M2LexBuf_ResetForNewPass ();
  M2Error_ResetErrorScope ();
  DoPass3 ();
  M2Error_FlushWarnings ();
  M2Error_FlushErrors ();
  M2Quiet_qprintf0 ((const char *) "Pass 4: gcc tree generation\\n", 29);
  M2Code_Code ();
  M2Error_FlushWarnings ();
  M2Error_FlushErrors ();
}


/*
   ExamineCompilationUnit - opens the source file to obtain the module name and kind of module.
*/

static void ExamineCompilationUnit (void * *name, bool *isdefimp)
{
  DynamicStrings_String Message;

  (*isdefimp) = false;  /* default to program module  */
  /* stop if we see eof, ';' or '['  */
  while (((M2LexBuf_currenttoken != M2Reserved_eoftok) && (M2LexBuf_currenttoken != M2Reserved_semicolontok)) && (M2LexBuf_currenttoken != M2Reserved_lsbratok))
    {
      if ((M2LexBuf_currenttoken == M2Reserved_implementationtok) || (M2LexBuf_currenttoken == M2Reserved_definitiontok))
        {
          (*isdefimp) = true;
          M2LexBuf_GetToken ();
        }
      if (M2LexBuf_currenttoken == M2Reserved_identtok)
        {
          (*name) = M2LexBuf_currentstring;
          return ;
        }
      M2LexBuf_GetToken ();
    }
  Message = M2MetaError_MetaString0 (DynamicStrings_InitString ((const char *) "no {%kMODULE} name found", 24));
  m2flex_M2Error (DynamicStrings_string (Message));
  libc_exit (1);
}


/*
   PeepInto - peeps into source, s, and initializes a definition/implementation or
              program module accordingly.
*/

static void PeepInto (DynamicStrings_String s)
{
  void * name;
  bool isdefimp;

  if (M2LexBuf_OpenSource (s))
    {
      ExamineCompilationUnit (&name, &isdefimp);
      if (isdefimp)
        {
          SymbolTable_SetMainModule (M2Batch_MakeImplementationSource (M2LexBuf_GetTokenNo (), NameKey_makekey (name)));
        }
      else
        {
          SymbolTable_SetMainModule (M2Batch_MakeProgramSource (M2LexBuf_GetTokenNo (), NameKey_makekey (name)));
        }
      M2LexBuf_CloseSource ();
      M2LexBuf_ReInitialize ();
    }
  else
    {
      M2Printf_fprintf1 (FIO_StdErr, (const char *) "failed to open %s\\n", 19, (const unsigned char *) &s, (sizeof (s)-1));
      libc_exit (1);
    }
}


/*
   qprintLibName - print the libname
*/

static void qprintLibName (DynamicStrings_String LibName)
{
  if ((LibName != NULL) && (! (DynamicStrings_EqualArray (LibName, (const char *) "", 0))))
    {
      M2Quiet_qprintf1 ((const char *) " [%s]", 5, (const unsigned char *) &LibName, (sizeof (LibName)-1));
    }
}


/*
   DoPass0 -
*/

static void DoPass0 (DynamicStrings_String s)
{
  unsigned int Main;
  unsigned int Sym;
  unsigned int i;
  DynamicStrings_String SymName;
  DynamicStrings_String FileName;
  DynamicStrings_String LibName;
  DynamicStrings_String PPSource;

  P0SymBuild_P0Init ();
  M2Pass_SetPassToPass0 ();
  /* Maybe preprocess the main file.  */
  PPSource = M2Preprocess_PreprocessModule (s, true);
  if (M2Options_PPonly)
    {
      return ;
    }
  PeepInto (PPSource);
  Main = SymbolTable_GetMainModule ();
  i = 1;
  Sym = M2Batch_GetModuleNo (i);
  M2Quiet_qprintf1 ((const char *) "Compiling: %s\\n", 15, (const unsigned char *) &PPSource, (sizeof (PPSource)-1));
  if (Debugging)
    {
      PathName_DumpPathName ((const char *) "DoPass0", 7);
    }
  if (M2Options_Verbose)
    {
      M2Printf_fprintf1 (FIO_StdOut, (const char *) "Compiling: %s\\n", 15, (const unsigned char *) &PPSource, (sizeof (PPSource)-1));
    }
  M2Quiet_qprintf0 ((const char *) "Pass 0: lexical analysis, parsing, modules and associated filenames\\n", 69);
  while (Sym != SymbolTable_NulSym)
    {
      SymName = DynamicStrings_InitStringCharStar (NameKey_KeyToCharStar (SymbolTable_GetSymName (Sym)));
      if (SymbolTable_IsDefImp (Sym))
        {
          LibName = static_cast<DynamicStrings_String> (NULL);
          if (M2Search_FindSourceDefFile (SymName, &FileName, &LibName))
            {
              ModuleType = M2Comp_Definition;
              if (M2LexBuf_OpenSource (M2Batch_AssociateDefinition (M2Preprocess_PreprocessModule (FileName, false), Sym)))
                {
                  if (! (P0SyntaxCheck_CompilationUnit ()))
                    {
                      M2Error_WriteFormat0 ((const char *) "compilation failed", 18);
                      M2LexBuf_CloseSource ();
                      return ;
                    }
                  M2Quiet_qprintf2 ((const char *) "   Module %-20s : %s", 20, (const unsigned char *) &SymName, (sizeof (SymName)-1), (const unsigned char *) &FileName, (sizeof (FileName)-1));
                  qprintLibName (LibName);
                  SymbolTable_PutLibName (Sym, NameKey_makekey (DynamicStrings_string (LibName)));
                  if (SymbolTable_IsDefinitionForC (Sym))
                    {
                      M2Quiet_qprintf0 ((const char *) " (for C)", 8);
                    }
                  if (SymbolTable_IsDefLink (Sym))
                    {
                      M2Quiet_qprintf0 ((const char *) " (linking)", 10);
                    }
                  M2Quiet_qprintf0 ((const char *) "\\n", 2);
                  M2LexBuf_CloseSource ();
                }
              else
                {
                  /* Unrecoverable error.  */
                  M2MetaError_MetaErrorString1 (FormatStrings_Sprintf1 (DynamicStrings_InitString ((const char *) "file {%%1EUAF%s} containing module {%%1a} cannot be found", 57), (const unsigned char *) &FileName, (sizeof (FileName)-1)), Sym);
                }
            }
          else
            {
              /* Unrecoverable error.  */
              M2MetaError_MetaError1 ((const char *) "the file containing the definition module {%1EMAa} cannot be found", 66, Sym);
            }
          ModuleType = M2Comp_Implementation;
        }
      else
        {
          ModuleType = M2Comp_Program;
        }
      if ((Main == Sym) || (NeedToParseImplementation (Sym)))
        {
          /* avoid dangling else.  */
          /* Only need to read implementation module if hidden types are declared or it is the main module  */
          LibName = static_cast<DynamicStrings_String> (NULL);
          if (Main == Sym)
            {
              FileName = DynamicStrings_Dup (PPSource);
              LibName = DynamicStrings_InitStringCharStar (M2Options_GetM2Prefix ());
              SymbolTable_PutLibName (Sym, NameKey_makekey (DynamicStrings_string (LibName)));
            }
          else
            {
              if (M2Search_FindSourceModFile (SymName, &FileName, &LibName))
                {
                  FileName = M2Preprocess_PreprocessModule (FileName, false);
                  SymbolTable_PutLibName (Sym, NameKey_makekey (DynamicStrings_string (LibName)));
                }
              else
                {
                  M2Quiet_qprintf1 ((const char *) "   Module %-20s : implementation source file not found\\n", 56, (const unsigned char *) &SymName, (sizeof (SymName)-1));
                }
            }
          if (FileName != NULL)
            {
              /* avoid gcc warning by using compound statement even if not strictly necessary.  */
              if (M2LexBuf_OpenSource (M2Batch_AssociateModule (DynamicStrings_Dup (FileName), Sym)))
                {
                  if (! (P0SyntaxCheck_CompilationUnit ()))
                    {
                      M2Error_WriteFormat0 ((const char *) "compilation failed", 18);
                      M2LexBuf_CloseSource ();
                      return ;
                    }
                  M2Quiet_qprintf2 ((const char *) "   Module %-20s : %s", 20, (const unsigned char *) &SymName, (sizeof (SymName)-1), (const unsigned char *) &FileName, (sizeof (FileName)-1));
                  qprintLibName (LibName);
                  if (SymbolTable_IsModLink (Sym))
                    {
                      M2Quiet_qprintf0 ((const char *) " (linking)", 10);
                    }
                  M2Quiet_qprintf0 ((const char *) "\\n", 2);
                  M2LexBuf_CloseSource ();
                }
              else
                {
                  /* It is quite legitimate to implement a module in C (and pretend it was a M2
                  implementation) providing that it is not the main program module and the
                  definition module does not declare a hidden type when -fextended-opaque
                  is used.  */
                  if ((! M2Options_WholeProgram || (Sym == Main)) || (SymbolTable_IsHiddenTypeDeclared (Sym)))
                    {
                      /* Unrecoverable error.  */
                      M2MetaError_MetaErrorString1 (FormatStrings_Sprintf1 (DynamicStrings_InitString ((const char *) "file {%%1EUAF%s} containing module {%%1a} cannot be found", 57), (const unsigned char *) &FileName, (sizeof (FileName)-1)), Sym);
                    }
                }
            }
        }
      else if (M2Options_GenModuleList)
        {
          /* avoid dangling else.  */
          if (! (SymbolTable_IsDefinitionForC (Sym)))
            {
              /* The implementation is only useful if -fgen-module-list= is
               used and we do not insist upon it.  */
              LibName = static_cast<DynamicStrings_String> (NULL);
              if (M2Search_FindSourceModFile (SymName, &FileName, &LibName))
                {
                  SymbolTable_PutLibName (Sym, NameKey_makekey (DynamicStrings_string (LibName)));
                  M2Quiet_qprintf2 ((const char *) "   Module %-20s : %s", 20, (const unsigned char *) &SymName, (sizeof (SymName)-1), (const unsigned char *) &FileName, (sizeof (FileName)-1));
                  qprintLibName (LibName);
                  M2Quiet_qprintf0 ((const char *) " (linking)\\n", 12);
                  if (M2LexBuf_OpenSource (M2Batch_AssociateModule (M2Preprocess_PreprocessModule (FileName, false), Sym)))
                    {
                      SymbolTable_PutModLink (Sym, true);  /* This source is only used to determine link time info.  */
                      if (! (P0SyntaxCheck_CompilationUnit ()))  /* This source is only used to determine link time info.  */
                        {
                          M2Error_WriteFormat0 ((const char *) "compilation failed", 18);
                          M2LexBuf_CloseSource ();
                          return ;
                        }
                      M2LexBuf_CloseSource ();
                    }
                }
            }
        }
      SymName = DynamicStrings_KillString (SymName);
      FileName = DynamicStrings_KillString (FileName);
      LibName = DynamicStrings_KillString (LibName);
      i += 1;
      Sym = M2Batch_GetModuleNo (i);
    }
  M2Pass_SetPassToNoPass ();
}


/*
   DoPass1 - parses the sources of all modules necessary to compile
             the required module, Main.
*/

static void DoPass1 (void)
{
  NameKey_Name name;
  unsigned int Sym;
  unsigned int i;
  DynamicStrings_String FileName;

  P0SymBuild_P1Init ();
  M2Pass_SetPassToPass1 ();
  i = 1;
  Sym = M2Batch_GetModuleNo (i);
  while (Sym != SymbolTable_NulSym)
    {
      FileName = M2Batch_GetDefinitionModuleFile (Sym);
      if (FileName != NULL)
        {
          if (Debugging)
            {
              name = SymbolTable_GetSymName (Sym);
              M2Quiet_qprintf1 ((const char *) "   Module %a\\n", 14, (const unsigned char *) &name, (sizeof (name)-1));
            }
          if (M2LexBuf_OpenSource (FileName))
            {
              ModuleType = M2Comp_Definition;
              if (! (P1Build_CompilationUnit ()))
                {
                  M2MetaError_MetaError0 ((const char *) "compilation failed", 18);
                  M2LexBuf_CloseSource ();
                  return ;
                }
              M2LexBuf_CloseSource ();
            }
          else
            {
              M2Printf_fprintf1 (FIO_StdErr, (const char *) "failed to open %s\\n", 19, (const unsigned char *) &FileName, (sizeof (FileName)-1));
              libc_exit (1);
            }
          ModuleType = M2Comp_Implementation;
        }
      else
        {
          ModuleType = M2Comp_Program;
        }
      FileName = M2Batch_GetModuleFile (Sym);
      if (FileName != NULL)
        {
          if (Debugging)
            {
              name = SymbolTable_GetSymName (Sym);
              M2Quiet_qprintf1 ((const char *) "   Module %a\\n", 14, (const unsigned char *) &name, (sizeof (name)-1));
            }
          if (M2LexBuf_OpenSource (FileName))
            {
              if (! (P1Build_CompilationUnit ()))
                {
                  M2MetaError_MetaError0 ((const char *) "compilation failed", 18);
                  M2LexBuf_CloseSource ();
                  return ;
                }
              M2LexBuf_CloseSource ();
            }
          else
            {
              M2Printf_fprintf1 (FIO_StdErr, (const char *) "failed to open %s\\n", 19, (const unsigned char *) &FileName, (sizeof (FileName)-1));
              libc_exit (1);
            }
        }
      i += 1;
      Sym = M2Batch_GetModuleNo (i);
    }
  M2Pass_SetPassToNoPass ();
}


/*
   DoPass2 - parses the sources of all modules necessary to compile
             the required module, Main.
*/

static void DoPass2 (void)
{
  NameKey_Name name;
  unsigned int Sym;
  unsigned int i;
  DynamicStrings_String FileName;

  M2Pass_SetPassToPass2 ();
  i = 1;
  Sym = M2Batch_GetModuleNo (i);
  while (Sym != SymbolTable_NulSym)
    {
      FileName = M2Batch_GetDefinitionModuleFile (Sym);
      if (FileName != NULL)
        {
          if (Debugging)
            {
              name = SymbolTable_GetSymName (Sym);
              M2Quiet_qprintf1 ((const char *) "   Module %a\\n", 14, (const unsigned char *) &name, (sizeof (name)-1));
            }
          if (M2LexBuf_OpenSource (FileName))
            {
              ModuleType = M2Comp_Definition;
              if (! (P2Build_CompilationUnit ()))
                {
                  M2MetaError_MetaError0 ((const char *) "compilation failed", 18);
                  M2LexBuf_CloseSource ();
                  return ;
                }
              M2LexBuf_CloseSource ();
            }
          else
            {
              M2Printf_fprintf1 (FIO_StdErr, (const char *) "failed to open %s\\n", 19, (const unsigned char *) &FileName, (sizeof (FileName)-1));
              libc_exit (1);
            }
          ModuleType = M2Comp_Implementation;
        }
      else
        {
          ModuleType = M2Comp_Program;
        }
      FileName = M2Batch_GetModuleFile (Sym);
      if (FileName != NULL)
        {
          if (Debugging)
            {
              name = SymbolTable_GetSymName (Sym);
              M2Quiet_qprintf1 ((const char *) "   Module %a\\n", 14, (const unsigned char *) &name, (sizeof (name)-1));
            }
          if (M2LexBuf_OpenSource (FileName))
            {
              if (! (P2Build_CompilationUnit ()))
                {
                  M2MetaError_MetaError0 ((const char *) "compilation failed", 18);
                  M2LexBuf_CloseSource ();
                  return ;
                }
              M2LexBuf_CloseSource ();
            }
          else
            {
              M2Printf_fprintf1 (FIO_StdErr, (const char *) "failed to open %s\\n", 19, (const unsigned char *) &FileName, (sizeof (FileName)-1));
              libc_exit (1);
            }
        }
      i += 1;
      Sym = M2Batch_GetModuleNo (i);
    }
  M2Pass_SetPassToNoPass ();
}


/*
   DoPassC - parses the sources of all modules necessary to compile
             the required module, Main.
*/

static void DoPassC (void)
{
  NameKey_Name name;
  unsigned int Sym;
  unsigned int i;
  DynamicStrings_String FileName;

  M2Pass_SetPassToPassC ();
  i = 1;
  Sym = M2Batch_GetModuleNo (i);
  while (Sym != SymbolTable_NulSym)
    {
      FileName = M2Batch_GetDefinitionModuleFile (Sym);
      if (FileName != NULL)
        {
          if (Debugging)
            {
              name = SymbolTable_GetSymName (Sym);
              M2Quiet_qprintf1 ((const char *) "   Module %a\\n", 14, (const unsigned char *) &name, (sizeof (name)-1));
            }
          if (M2LexBuf_OpenSource (FileName))
            {
              ModuleType = M2Comp_Definition;
              if (! (PCBuild_CompilationUnit ()))
                {
                  M2MetaError_MetaError0 ((const char *) "compilation failed", 18);
                  M2LexBuf_CloseSource ();
                  return ;
                }
              M2LexBuf_CloseSource ();
            }
          else
            {
              M2Printf_fprintf1 (FIO_StdErr, (const char *) "failed to open %s\\n", 19, (const unsigned char *) &FileName, (sizeof (FileName)-1));
              libc_exit (1);
            }
          ModuleType = M2Comp_Implementation;
        }
      else
        {
          ModuleType = M2Comp_Program;
        }
      FileName = M2Batch_GetModuleFile (Sym);
      if (FileName != NULL)
        {
          if (Debugging)
            {
              name = SymbolTable_GetSymName (Sym);
              M2Quiet_qprintf1 ((const char *) "   Module %a\\n", 14, (const unsigned char *) &name, (sizeof (name)-1));
            }
          if (M2LexBuf_OpenSource (FileName))
            {
              if (! (PCBuild_CompilationUnit ()))
                {
                  M2MetaError_MetaError0 ((const char *) "compilation failed", 18);
                  M2LexBuf_CloseSource ();
                  return ;
                }
              M2LexBuf_CloseSource ();
            }
          else
            {
              M2Printf_fprintf1 (FIO_StdErr, (const char *) "failed to open %s\\n", 19, (const unsigned char *) &FileName, (sizeof (FileName)-1));
              libc_exit (1);
            }
        }
      i += 1;
      Sym = M2Batch_GetModuleNo (i);
    }
  PCSymBuild_ResolveConstTypes ();
  SymbolTable_ResolveConstructorTypes ();
  SymbolTable_SanityCheckConstants ();
  M2Pass_SetPassToNoPass ();
}


/*
   DoPass3 - parses the sources of all modules necessary to compile
             the required module, Main.
*/

static void DoPass3 (void)
{
  unsigned int Main;
  unsigned int Sym;
  unsigned int i;
  DynamicStrings_String FileName;

  M2Pass_SetPassToPass3 ();
  Main = SymbolTable_GetMainModule ();
  i = 1;
  Sym = M2Batch_GetModuleNo (i);
  while (Sym != SymbolTable_NulSym)
    {
      FileName = M2Batch_GetDefinitionModuleFile (Sym);
      if (FileName != NULL)
        {
          if (M2LexBuf_OpenSource (FileName))
            {
              ModuleType = M2Comp_Definition;
              if (! (P3Build_CompilationUnit ()))
                {
                  M2MetaError_MetaError0 ((const char *) "compilation failed", 18);
                  M2LexBuf_CloseSource ();
                  return ;
                }
              M2LexBuf_CloseSource ();
            }
          else
            {
              M2Printf_fprintf1 (FIO_StdErr, (const char *) "failed to open %s\\n", 19, (const unsigned char *) &FileName, (sizeof (FileName)-1));
              libc_exit (1);
            }
          ModuleType = M2Comp_Implementation;
        }
      else
        {
          ModuleType = M2Comp_Program;
        }
      FileName = M2Batch_GetModuleFile (Sym);
      if (FileName != NULL)
        {
          /* avoid gcc warning by using compound statement even if not strictly necessary.  */
          if (M2LexBuf_OpenSource (FileName))
            {
              if ((Main == Sym) || M2Options_WholeProgram)
                {
                  /* avoid dangling else.  */
                  if (! (P3Build_CompilationUnit ()))
                    {
                      M2MetaError_MetaError0 ((const char *) "compilation failed", 18);
                      M2LexBuf_CloseSource ();
                      return ;
                    }
                }
              else
                {
                  /* 
                  not the main module .mod therefore must be implementing
                  a hidden type - we dont want to generate any
                  StatementSequence quadrupes but we do want to build TYPEs
                  and ConstExpressions.
  */
                  M2Pass_SetPassToNoPass ();
                  M2Pass_SetPassToPassHidden ();
                  if (! (PHBuild_CompilationUnit ()))
                    {
                      M2MetaError_MetaError0 ((const char *) "compilation failed", 18);
                      M2LexBuf_CloseSource ();
                      return ;
                    }
                  M2Pass_SetPassToNoPass ();
                  M2Pass_SetPassToPass3 ();
                }
              M2LexBuf_CloseSource ();
            }
          else
            {
              M2Printf_fprintf1 (FIO_StdErr, (const char *) "failed to open %s\\n", 19, (const unsigned char *) &FileName, (sizeof (FileName)-1));
              libc_exit (1);
            }
        }
      i += 1;
      Sym = M2Batch_GetModuleNo (i);
    }
  M2Pass_SetPassToNoPass ();
}


/*
   compile - compile the filename.
*/

extern "C" void M2Comp_compile (void * filename)
{
  DynamicStrings_String f;

  f = DynamicStrings_InitStringCharStar (filename);
  Compile (f);
  f = DynamicStrings_KillString (f);
}


/*
   CompilingDefinitionModule - returns true if the current module being
                               compiled is a definition module.
*/

extern "C" bool M2Comp_CompilingDefinitionModule (void)
{
  return ModuleType == M2Comp_Definition;
  /* static analysis guarentees a RETURN statement will be used before here.  */
  __builtin_unreachable ();
}


/*
   CompilingImplementationModule - returns true if the current module being
                                   compiled is an implementation module.
*/

extern "C" bool M2Comp_CompilingImplementationModule (void)
{
  return ModuleType == M2Comp_Implementation;
  /* static analysis guarentees a RETURN statement will be used before here.  */
  __builtin_unreachable ();
}


/*
   CompilingProgramModule - returns true if the current module being
                            compiled is a program module.
*/

extern "C" bool M2Comp_CompilingProgramModule (void)
{
  return ModuleType == M2Comp_Program;
  /* static analysis guarentees a RETURN statement will be used before here.  */
  __builtin_unreachable ();
}

extern "C" void _M2_M2Comp_init (__attribute__((unused)) int argc,__attribute__((unused)) char *argv[],__attribute__((unused)) char *envp[])
{
  ModuleType = M2Comp_None;
}

extern "C" void _M2_M2Comp_fini (__attribute__((unused)) int argc,__attribute__((unused)) char *argv[],__attribute__((unused)) char *envp[])
{
}
