/* do not edit automatically generated by mc from M2LexBuf.  */
/* M2LexBuf.mod provides a buffer for m2.lex.

Copyright (C) 2001-2023 Free Software Foundation, Inc.
Contributed by Gaius Mulley <gaius.mulley@southwales.ac.uk>.

This file is part of GNU Modula-2.

GNU Modula-2 is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 3, or (at your option)
any later version.

GNU Modula-2 is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with GNU Modula-2; see the file COPYING3.  If not see
<http://www.gnu.org/licenses/>.  */

#include "config.h"
#include "system.h"
#include <stdbool.h>
#   if !defined (PROC_D)
#      define PROC_D
       typedef void (*PROC_t) (void);
       typedef struct { PROC_t proc; } PROC;
#   endif

#   if !defined (TRUE)
#      define TRUE (1==1)
#   endif

#   if !defined (FALSE)
#      define FALSE (1==0)
#   endif

#   include "GStorage.h"
#if defined(__cplusplus)
#   undef NULL
#   define NULL 0
#endif
#define _M2LexBuf_H
#define _M2LexBuf_C

#   include "Gm2flex.h"
#   include "Glibc.h"
#   include "GSYSTEM.h"
#   include "GStorage.h"
#   include "GDynamicStrings.h"
#   include "GFormatStrings.h"
#   include "GNameKey.h"
#   include "GM2Reserved.h"
#   include "GM2Printf.h"
#   include "GM2Debug.h"
#   include "Gm2linemap.h"
#   include "GM2Emit.h"
#   include "GM2Error.h"
#   include "GM2RTS.h"

#   define M2LexBuf_UnknownTokenNo 0
#   define M2LexBuf_BuiltinTokenNo 1
unsigned int M2LexBuf_currentcolumn;
int M2LexBuf_currentinteger;
void * M2LexBuf_currentstring;
M2Reserved_toktype M2LexBuf_currenttoken;
#   define MaxBucketSize 100
#   define Debugging false
#   define DebugRecover false
#   define InitialSourceToken 2
typedef struct M2LexBuf_TokenDesc_r M2LexBuf_TokenDesc;

typedef struct M2LexBuf_ListDesc_r M2LexBuf_ListDesc;

typedef struct M2LexBuf__T1_r M2LexBuf__T1;

typedef M2LexBuf__T1 *M2LexBuf_SourceList;

typedef struct M2LexBuf__T2_r M2LexBuf__T2;

typedef M2LexBuf__T2 *M2LexBuf_TokenBucket;

typedef struct M2LexBuf__T3_a M2LexBuf__T3;

struct M2LexBuf_TokenDesc_r {
                              M2Reserved_toktype token;
                              NameKey_Name str;
                              int int_;
                              unsigned int line;
                              unsigned int col;
                              M2LexBuf_SourceList file;
                              m2linemap_location_t loc;
                              M2LexBuf_TokenBucket insert;
                            };

struct M2LexBuf_ListDesc_r {
                             M2LexBuf_TokenBucket head;
                             M2LexBuf_TokenBucket tail;
                             unsigned int LastBucketOffset;
                           };

struct M2LexBuf__T1_r {
                        M2LexBuf_SourceList left;
                        M2LexBuf_SourceList right;
                        DynamicStrings_String name;
                        unsigned int line;
                        unsigned int col;
                      };

struct M2LexBuf__T3_a { M2LexBuf_TokenDesc array[MaxBucketSize+1]; };
struct M2LexBuf__T2_r {
                        M2LexBuf__T3 buf;
                        unsigned int len;
                        M2LexBuf_TokenBucket next;
                      };

static M2LexBuf_SourceList CurrentSource;
static bool UseBufferedTokens;
static bool CurrentUsed;
static M2LexBuf_ListDesc ListOfTokens;
static unsigned int CurrentTokNo;
static unsigned int InsertionIndex;
static bool SeenEof;

/*
   OpenSource - Attempts to open the source file, s.
                The success of the operation is returned.
*/

extern "C" bool M2LexBuf_OpenSource (DynamicStrings_String s);

/*
   CloseSource - closes the current open file.
*/

extern "C" void M2LexBuf_CloseSource (void);

/*
   ReInitialize - re-initialize the all the data structures.
*/

extern "C" void M2LexBuf_ReInitialize (void);

/*
   ResetForNewPass - reset the buffer pointers to the beginning ready for
                     a new pass
*/

extern "C" void M2LexBuf_ResetForNewPass (void);

/*
   GetToken - gets the next token into currenttoken.
*/

extern "C" void M2LexBuf_GetToken (void);

/*
   InsertToken - inserts a symbol, token, infront of the current token
                 ready for the next pass.
*/

extern "C" void M2LexBuf_InsertToken (M2Reserved_toktype token);

/*
   InsertTokenAndRewind - inserts a symbol, token, infront of the current token
                          and then moves the token stream back onto the inserted token.
*/

extern "C" void M2LexBuf_InsertTokenAndRewind (M2Reserved_toktype token);

/*
   GetPreviousTokenLineNo - returns the line number of the previous token.
*/

extern "C" unsigned int M2LexBuf_GetPreviousTokenLineNo (void);

/*
   GetLineNo - returns the current line number where the symbol occurs in
               the source file.
*/

extern "C" unsigned int M2LexBuf_GetLineNo (void);

/*
   GetTokenNo - returns the current token number.
*/

extern "C" unsigned int M2LexBuf_GetTokenNo (void);

/*
   GetTokenName - returns the token name given the tokenno.
*/

extern "C" NameKey_Name M2LexBuf_GetTokenName (unsigned int tokenno);

/*
   TokenToLineNo - returns the line number of the current file for the
                   TokenNo. The depth refers to the include depth.
                   A depth of 0 is the current file, depth of 1 is the file
                   which included the current file. Zero is returned if the
                   depth exceeds the file nesting level.
*/

extern "C" unsigned int M2LexBuf_TokenToLineNo (unsigned int TokenNo, unsigned int depth);

/*
   GetColumnNo - returns the current column where the symbol occurs in
                 the source file.
*/

extern "C" unsigned int M2LexBuf_GetColumnNo (void);

/*
   TokenToColumnNo - returns the column number of the current file for the
                     TokenNo. The depth refers to the include depth.
                     A depth of 0 is the current file, depth of 1 is the file
                     which included the current file. Zero is returned if the
                     depth exceeds the file nesting level.
*/

extern "C" unsigned int M2LexBuf_TokenToColumnNo (unsigned int TokenNo, unsigned int depth);

/*
   TokenToLocation - returns the location_t corresponding to, TokenNo.
*/

extern "C" m2linemap_location_t M2LexBuf_TokenToLocation (unsigned int TokenNo);

/*
   FindFileNameFromToken - returns the complete FileName for the appropriate
                           source file yields the token number, TokenNo.
                           The, Depth, indicates the include level: 0..n
                           Level 0 is the current. NIL is returned if n+1
                           is requested.
*/

extern "C" DynamicStrings_String M2LexBuf_FindFileNameFromToken (unsigned int TokenNo, unsigned int depth);

/*
   GetFileName - returns a String defining the current file.
*/

extern "C" DynamicStrings_String M2LexBuf_GetFileName (void);

/*
   MakeVirtualTok - providing caret, left, right are associated with a source file
                    and exist on the same src line then
                    create and return a new tokenno which is created from
                    tokenno range1 and range2.  Otherwise return caret.
*/

extern "C" unsigned int M2LexBuf_MakeVirtualTok (unsigned int caret, unsigned int left, unsigned int right);

/*
   AddTok - adds a token to the buffer.
*/

extern "C" void M2LexBuf_AddTok (M2Reserved_toktype t);

/*
   AddTokCharStar - adds a token to the buffer and an additional string, s.
                    A copy of string, s, is made.
*/

extern "C" void M2LexBuf_AddTokCharStar (M2Reserved_toktype t, void * s);

/*
   AddTokInteger - adds a token and an integer to the buffer.
*/

extern "C" void M2LexBuf_AddTokInteger (M2Reserved_toktype t, int i);

/*
   SetFile - sets the current filename to, filename.
*/

extern "C" void M2LexBuf_SetFile (void * filename);

/*
   PushFile - indicates that, filename, has just been included.
*/

extern "C" void M2LexBuf_PushFile (void * filename);

/*
   PopFile - indicates that we are returning to, filename, having finished
             an include.
*/

extern "C" void M2LexBuf_PopFile (void * filename);

/*
   PrintTokenNo - displays token and the location of the token.
*/

extern "C" void M2LexBuf_PrintTokenNo (unsigned int tokenno);

/*
   DisplayToken - display the token name using printf0 no newline is emitted.
*/

extern "C" void M2LexBuf_DisplayToken (M2Reserved_toktype tok);

/*
   DumpTokens - developer debugging aid.
*/

extern "C" void M2LexBuf_DumpTokens (void);

/*
   InitTokenList - creates an empty token list, which starts the first source token
                   at position 2.  This allows position 0 to be for unknown location
                   and position 1 for builtin token.
*/

static void InitTokenList (void);

/*
   Init - initializes the token list and source list.
*/

static void Init (void);

/*
   AddTo - adds a new element to the end of SourceList, CurrentSource.
*/

static void AddTo (M2LexBuf_SourceList l);

/*
   SubFrom - subtracts, l, from the source list.
*/

static void SubFrom (M2LexBuf_SourceList l);

/*
   NewElement - returns a new SourceList
*/

static M2LexBuf_SourceList NewElement (void * s);

/*
   NewList - initializes an empty list with the classic dummy header element.
*/

static M2LexBuf_SourceList NewList (void);

/*
   CheckIfNeedToDuplicate - checks to see whether the CurrentSource has
                            been used, if it has then duplicate the list.
*/

static void CheckIfNeedToDuplicate (void);

/*
   KillList - kills the SourceList providing that it has not been used.
*/

static void KillList (void);

/*
   UpdateFromBucket - updates the global variables:  currenttoken,
                      currentstring, currentcolumn and currentinteger
                      from TokenBucket, b, and, offset.
*/

static void UpdateFromBucket (M2LexBuf_TokenBucket b, unsigned int offset);

/*
   DisplayTokenEntry -
*/

static void DisplayTokenEntry (M2LexBuf_TokenBucket topBucket, unsigned int index, unsigned int total);

/*
   GetNonEofToken - providing that we have not already seen an eof for this source
                    file call m2flex.GetToken and GetToken if requested.
*/

static void GetNonEofToken (bool callGetToken);

/*
   SyncOpenWithBuffer - synchronise the buffer with the start of a file.
                        Skips all the tokens to do with the previous file.
*/

static void SyncOpenWithBuffer (void);

/*
   GetInsertBucket - returns the insertion bucket associated with token count
                     and the topBucket.  It creates a new TokenBucket if necessary.
*/

static M2LexBuf_TokenBucket GetInsertBucket (M2LexBuf_TokenBucket topBucket, unsigned int count);

/*
   AppendToken - appends desc to the end of the insertionBucket.
*/

static void AppendToken (M2LexBuf_TokenBucket insertionBucket, M2LexBuf_TokenDesc desc);

/*
   FindTokenBucket - returns the TokenBucket corresponding to the TokenNo.
*/

static M2LexBuf_TokenBucket FindTokenBucket (unsigned int *TokenNo);

/*
   AddTokToList - adds a token to a dynamic list.
*/

static void AddTokToList (M2Reserved_toktype t, NameKey_Name n, int i, unsigned int l, unsigned int c, M2LexBuf_SourceList f, m2linemap_location_t location);

/*
   IsLastTokenEof - returns TRUE if the last token was an eoftok
*/

static bool IsLastTokenEof (void);

/*
   isSrcToken - returns TRUE if tokenno is associated with
                program source code.
*/

static bool isSrcToken (unsigned int tokenno);


/*
   InitTokenList - creates an empty token list, which starts the first source token
                   at position 2.  This allows position 0 to be for unknown location
                   and position 1 for builtin token.
*/

static void InitTokenList (void)
{
  Storage_ALLOCATE ((void **) &ListOfTokens.head, sizeof (M2LexBuf__T2));
  ListOfTokens.tail = ListOfTokens.head;
  ListOfTokens.tail->buf.array[0].token = M2Reserved_eoftok;
  ListOfTokens.tail->buf.array[0].str = NameKey_NulName;
  ListOfTokens.tail->buf.array[0].int_ = 0;
  ListOfTokens.tail->buf.array[0].line = 0;
  ListOfTokens.tail->buf.array[0].col = 0;
  ListOfTokens.tail->buf.array[0].file = NULL;
  ListOfTokens.tail->buf.array[0].loc = M2Emit_UnknownLocation ();
  ListOfTokens.tail->buf.array[1].token = M2Reserved_eoftok;
  ListOfTokens.tail->buf.array[1].str = NameKey_NulName;
  ListOfTokens.tail->buf.array[1].int_ = 0;
  ListOfTokens.tail->buf.array[1].line = 0;
  ListOfTokens.tail->buf.array[1].col = 0;
  ListOfTokens.tail->buf.array[1].file = NULL;
  ListOfTokens.tail->buf.array[1].loc = M2Emit_BuiltinsLocation ();
  ListOfTokens.tail->len = InitialSourceToken;
}


/*
   Init - initializes the token list and source list.
*/

static void Init (void)
{
  SeenEof = false;
  InsertionIndex = 0;
  M2LexBuf_currenttoken = M2Reserved_eoftok;
  CurrentTokNo = InitialSourceToken;
  CurrentSource = NULL;
  ListOfTokens.head = NULL;
  ListOfTokens.tail = NULL;
  UseBufferedTokens = false;
  InitTokenList ();
}


/*
   AddTo - adds a new element to the end of SourceList, CurrentSource.
*/

static void AddTo (M2LexBuf_SourceList l)
{
  l->right = CurrentSource;
  l->left = CurrentSource->left;
  CurrentSource->left->right = l;
  CurrentSource->left = l;
  l->left->line = m2flex_GetLineNo ();
  l->left->col = m2flex_GetColumnNo ();
}


/*
   SubFrom - subtracts, l, from the source list.
*/

static void SubFrom (M2LexBuf_SourceList l)
{
  l->left->right = l->right;
  l->right->left = l->left;
}


/*
   NewElement - returns a new SourceList
*/

static M2LexBuf_SourceList NewElement (void * s)
{
  M2LexBuf_SourceList l;

  Storage_ALLOCATE ((void **) &l, sizeof (M2LexBuf__T1));
  if (l == NULL)
    {
      M2RTS_HALT (-1);
      __builtin_unreachable ();
    }
  else
    {
      l->name = DynamicStrings_InitStringCharStar (s);
      l->left = NULL;
      l->right = NULL;
    }
  return l;
  /* static analysis guarentees a RETURN statement will be used before here.  */
  __builtin_unreachable ();
}


/*
   NewList - initializes an empty list with the classic dummy header element.
*/

static M2LexBuf_SourceList NewList (void)
{
  M2LexBuf_SourceList l;

  Storage_ALLOCATE ((void **) &l, sizeof (M2LexBuf__T1));
  l->left = l;
  l->right = l;
  l->name = static_cast<DynamicStrings_String> (NULL);
  return l;
  /* static analysis guarentees a RETURN statement will be used before here.  */
  __builtin_unreachable ();
}


/*
   CheckIfNeedToDuplicate - checks to see whether the CurrentSource has
                            been used, if it has then duplicate the list.
*/

static void CheckIfNeedToDuplicate (void)
{
  M2LexBuf_SourceList l;
  M2LexBuf_SourceList h;

  if (CurrentUsed)
    {
      l = CurrentSource->right;
      h = CurrentSource;
      CurrentSource = NewList ();
      while (l != h)
        {
          AddTo (NewElement (reinterpret_cast<void *> (l->name)));
          l = l->right;
        }
    }
}


/*
   KillList - kills the SourceList providing that it has not been used.
*/

static void KillList (void)
{
  M2LexBuf_SourceList l;
  M2LexBuf_SourceList k;

  if (! CurrentUsed && (CurrentSource != NULL))
    {
      l = CurrentSource;
      do {
        k = l;
        l = l->right;
        Storage_DEALLOCATE ((void **) &k, sizeof (M2LexBuf__T1));
      } while (! (l == CurrentSource));
    }
}


/*
   UpdateFromBucket - updates the global variables:  currenttoken,
                      currentstring, currentcolumn and currentinteger
                      from TokenBucket, b, and, offset.
*/

static void UpdateFromBucket (M2LexBuf_TokenBucket b, unsigned int offset)
{
  if (InsertionIndex > 0)
    {
      /* avoid dangling else.  */
      /* we have an inserted token to use.  */
      M2Debug_Assert (b->buf.array[offset].insert != NULL);
      M2LexBuf_currenttoken = b->buf.array[offset].insert->buf.array[InsertionIndex].token;
      M2LexBuf_currentstring = NameKey_KeyToCharStar (b->buf.array[offset].insert->buf.array[InsertionIndex].str);
      M2LexBuf_currentcolumn = b->buf.array[offset].insert->buf.array[InsertionIndex].col;
      M2LexBuf_currentinteger = b->buf.array[offset].insert->buf.array[InsertionIndex].int_;
      if (Debugging)
        {
          M2Printf_printf3 ((const char *) "line %d (# %d  %d) ", 19, (const unsigned char *) &b->buf.array[offset].insert->buf.array[InsertionIndex].line, (sizeof (b->buf.array[offset].insert->buf.array[InsertionIndex].line)-1), (const unsigned char *) &offset, (sizeof (offset)-1), (const unsigned char *) &CurrentTokNo, (sizeof (CurrentTokNo)-1));
        }
      InsertionIndex += 1;
      if (InsertionIndex == b->buf.array[offset].insert->len)
        {
          InsertionIndex = 0;  /* finished consuming the inserted tokens.  */
          CurrentTokNo += 1;  /* finished consuming the inserted tokens.  */
        }
    }
  else if ((b->buf.array[offset].insert != NULL) && (InsertionIndex == 0))
    {
      /* avoid dangling else.  */
      /* this source token has extra tokens appended after it by the error recovery.  */
      M2Debug_Assert (b->buf.array[offset].insert->len > 0);  /* we must have at least one token.  */
      InsertionIndex = 1;  /* so set the index ready for the next UpdateFromBucket.  */
      /* and read the original token.  */
      M2LexBuf_currenttoken = b->buf.array[offset].token;
      M2LexBuf_currentstring = NameKey_KeyToCharStar (b->buf.array[offset].str);
      M2LexBuf_currentcolumn = b->buf.array[offset].col;
      M2LexBuf_currentinteger = b->buf.array[offset].int_;
      if (Debugging)
        {
          M2Printf_printf3 ((const char *) "line %d (# %d  %d) ", 19, (const unsigned char *) &b->buf.array[offset].line, (sizeof (b->buf.array[offset].line)-1), (const unsigned char *) &offset, (sizeof (offset)-1), (const unsigned char *) &CurrentTokNo, (sizeof (CurrentTokNo)-1));
        }
    }
  else
    {
      /* avoid dangling else.  */
      /* no inserted tokens after this token so read it and move on.  */
      M2LexBuf_currenttoken = b->buf.array[offset].token;
      M2LexBuf_currentstring = NameKey_KeyToCharStar (b->buf.array[offset].str);
      M2LexBuf_currentcolumn = b->buf.array[offset].col;
      M2LexBuf_currentinteger = b->buf.array[offset].int_;
      if (Debugging)
        {
          M2Printf_printf3 ((const char *) "line %d (# %d  %d) ", 19, (const unsigned char *) &b->buf.array[offset].line, (sizeof (b->buf.array[offset].line)-1), (const unsigned char *) &offset, (sizeof (offset)-1), (const unsigned char *) &CurrentTokNo, (sizeof (CurrentTokNo)-1));
        }
      CurrentTokNo += 1;
    }
}


/*
   DisplayTokenEntry -
*/

static void DisplayTokenEntry (M2LexBuf_TokenBucket topBucket, unsigned int index, unsigned int total)
{
  unsigned int i;

  M2Printf_printf1 ((const char *) "%d: ", 4, (const unsigned char *) &total, (sizeof (total)-1));
  M2LexBuf_DisplayToken (topBucket->buf.array[index].token);
  M2Printf_printf1 ((const char *) " %a ", 4, (const unsigned char *) &topBucket->buf.array[index].str, (sizeof (topBucket->buf.array[index].str)-1));
  if (total == (M2LexBuf_GetTokenNo ()))
    {
      M2Printf_printf0 ((const char *) " <- current token", 17);
    }
  M2Printf_printf0 ((const char *) "\\n", 2);
  /* now check for inserted tokens.  */
  if (topBucket->buf.array[index].insert != NULL)
    {
      i = 1;
      while (i < topBucket->buf.array[index].insert->len)
        {
          M2Printf_printf1 ((const char *) "   %d: ", 7, (const unsigned char *) &i, (sizeof (i)-1));
          M2LexBuf_DisplayToken (topBucket->buf.array[index].insert->buf.array[i].token);
          M2Printf_printf1 ((const char *) " %a\\n", 5, (const unsigned char *) &topBucket->buf.array[index].insert->buf.array[i].str, (sizeof (topBucket->buf.array[index].insert->buf.array[i].str)-1));
          i += 1;
        }
    }
}


/*
   GetNonEofToken - providing that we have not already seen an eof for this source
                    file call m2flex.GetToken and GetToken if requested.
*/

static void GetNonEofToken (bool callGetToken)
{
  if (SeenEof)
    {
      M2LexBuf_currenttoken = M2Reserved_eoftok;
    }
  else
    {
      /* Call the lexical phase to place a new token into the last bucket.  */
      m2flex_GetToken ();
      if (callGetToken)
        {
          M2LexBuf_GetToken ();
        }
    }
}


/*
   SyncOpenWithBuffer - synchronise the buffer with the start of a file.
                        Skips all the tokens to do with the previous file.
*/

static void SyncOpenWithBuffer (void)
{
  if (ListOfTokens.tail != NULL)
    {
      CurrentTokNo = ListOfTokens.LastBucketOffset+ListOfTokens.tail->len;
    }
}


/*
   GetInsertBucket - returns the insertion bucket associated with token count
                     and the topBucket.  It creates a new TokenBucket if necessary.
*/

static M2LexBuf_TokenBucket GetInsertBucket (M2LexBuf_TokenBucket topBucket, unsigned int count)
{
  if (topBucket->buf.array[count].insert == NULL)
    {
      Storage_ALLOCATE ((void **) &topBucket->buf.array[count].insert, sizeof (M2LexBuf__T2));
      topBucket->buf.array[count].insert->buf.array[0] = topBucket->buf.array[count];
      topBucket->buf.array[count].insert->buf.array[0].insert = NULL;
      topBucket->buf.array[count].insert->len = 1;  /* empty, slot 0 contains the original token for ease.  */
    }
  return topBucket->buf.array[count].insert;
  /* static analysis guarentees a RETURN statement will be used before here.  */
  __builtin_unreachable ();
}


/*
   AppendToken - appends desc to the end of the insertionBucket.
*/

static void AppendToken (M2LexBuf_TokenBucket insertionBucket, M2LexBuf_TokenDesc desc)
{
  if (insertionBucket->len < MaxBucketSize)
    {
      insertionBucket->buf.array[insertionBucket->len] = desc;
      insertionBucket->len += 1;
    }
}


/*
   FindTokenBucket - returns the TokenBucket corresponding to the TokenNo.
*/

static M2LexBuf_TokenBucket FindTokenBucket (unsigned int *TokenNo)
{
  M2LexBuf_TokenBucket b;

  b = ListOfTokens.head;
  while (b != NULL)
    {
      if ((*TokenNo) < b->len)
        {
          return b;
        }
      else
        {
          (*TokenNo) -= b->len;
        }
      b = b->next;
    }
  return NULL;
  /* static analysis guarentees a RETURN statement will be used before here.  */
  __builtin_unreachable ();
}


/*
   AddTokToList - adds a token to a dynamic list.
*/

static void AddTokToList (M2Reserved_toktype t, NameKey_Name n, int i, unsigned int l, unsigned int c, M2LexBuf_SourceList f, m2linemap_location_t location)
{
  if (ListOfTokens.head == NULL)
    {
      Storage_ALLOCATE ((void **) &ListOfTokens.head, sizeof (M2LexBuf__T2));
      if (ListOfTokens.head == NULL)
        {}  /* empty.  */
      /* list error  */
      ListOfTokens.tail = ListOfTokens.head;
      ListOfTokens.tail->len = 0;
    }
  else if (ListOfTokens.tail->len == MaxBucketSize)
    {
      /* avoid dangling else.  */
      M2Debug_Assert (ListOfTokens.tail->next == NULL);
      Storage_ALLOCATE ((void **) &ListOfTokens.tail->next, sizeof (M2LexBuf__T2));
      if (ListOfTokens.tail->next == NULL)
        {}  /* empty.  */
      else
        {
          /* list error  */
          ListOfTokens.tail = ListOfTokens.tail->next;
          ListOfTokens.tail->len = 0;
        }
      ListOfTokens.LastBucketOffset += MaxBucketSize;
    }
  ListOfTokens.tail->next = NULL;
  ListOfTokens.tail->buf.array[ListOfTokens.tail->len].token = t;
  ListOfTokens.tail->buf.array[ListOfTokens.tail->len].str = n;
  ListOfTokens.tail->buf.array[ListOfTokens.tail->len].int_ = i;
  ListOfTokens.tail->buf.array[ListOfTokens.tail->len].line = l;
  ListOfTokens.tail->buf.array[ListOfTokens.tail->len].col = c;
  ListOfTokens.tail->buf.array[ListOfTokens.tail->len].file = f;
  ListOfTokens.tail->buf.array[ListOfTokens.tail->len].loc = location;
  ListOfTokens.tail->buf.array[ListOfTokens.tail->len].insert = NULL;
  ListOfTokens.tail->len += 1;
}


/*
   IsLastTokenEof - returns TRUE if the last token was an eoftok
*/

static bool IsLastTokenEof (void)
{
  M2LexBuf_TokenBucket b;

  if (ListOfTokens.tail != NULL)
    {
      if (ListOfTokens.tail->len == 0)
        {
          b = ListOfTokens.head;
          if (b == ListOfTokens.tail)
            {
              return false;
            }
          while (b->next != ListOfTokens.tail)
            {
              b = b->next;
            }
        }
      else
        {
          b = ListOfTokens.tail;
        }
      M2Debug_Assert (b->len > 0);  /* len should always be >0  */
      return b->buf.array[b->len-1].token == M2Reserved_eoftok;  /* len should always be >0  */
    }
  return false;
  /* static analysis guarentees a RETURN statement will be used before here.  */
  __builtin_unreachable ();
}


/*
   isSrcToken - returns TRUE if tokenno is associated with
                program source code.
*/

static bool isSrcToken (unsigned int tokenno)
{
  return (tokenno != M2LexBuf_UnknownTokenNo) && (tokenno != M2LexBuf_BuiltinTokenNo);
  /* static analysis guarentees a RETURN statement will be used before here.  */
  __builtin_unreachable ();
}


/*
   OpenSource - Attempts to open the source file, s.
                The success of the operation is returned.
*/

extern "C" bool M2LexBuf_OpenSource (DynamicStrings_String s)
{
  SeenEof = false;
  if (UseBufferedTokens)
    {
      M2LexBuf_GetToken ();
      return true;
    }
  else
    {
      if (m2flex_OpenSource (DynamicStrings_string (s)))
        {
          M2LexBuf_SetFile (DynamicStrings_string (s));
          SyncOpenWithBuffer ();
          M2LexBuf_GetToken ();
          return true;
        }
      else
        {
          return false;
        }
    }
  /* static analysis guarentees a RETURN statement will be used before here.  */
  __builtin_unreachable ();
}


/*
   CloseSource - closes the current open file.
*/

extern "C" void M2LexBuf_CloseSource (void)
{
  if (UseBufferedTokens)
    {
      while (M2LexBuf_currenttoken != M2Reserved_eoftok)
        {
          M2LexBuf_GetToken ();
        }
    }
  /* a subsequent call to m2flex.OpenSource will really close the file  */
}


/*
   ReInitialize - re-initialize the all the data structures.
*/

extern "C" void M2LexBuf_ReInitialize (void)
{
  M2LexBuf_TokenBucket s;
  M2LexBuf_TokenBucket t;

  if (ListOfTokens.head != NULL)
    {
      t = ListOfTokens.head;
      do {
        s = t;
        t = t->next;
        Storage_DEALLOCATE ((void **) &s, sizeof (M2LexBuf__T2));
      } while (! (t == NULL));
      CurrentUsed = false;
      KillList ();
    }
  Init ();
}


/*
   ResetForNewPass - reset the buffer pointers to the beginning ready for
                     a new pass
*/

extern "C" void M2LexBuf_ResetForNewPass (void)
{
  InsertionIndex = 0;
  CurrentTokNo = InitialSourceToken;
  UseBufferedTokens = true;
}


/*
   GetToken - gets the next token into currenttoken.
*/

extern "C" void M2LexBuf_GetToken (void)
{
  unsigned int t;
  M2LexBuf_TokenBucket b;

  if (UseBufferedTokens)
    {
      t = CurrentTokNo;
      b = FindTokenBucket (&t);
      UpdateFromBucket (b, t);
    }
  else
    {
      if (ListOfTokens.tail == NULL)
        {
          GetNonEofToken (false);
          if (ListOfTokens.tail == NULL)
            {
              M2RTS_HALT (-1);
              __builtin_unreachable ();
            }
        }
      if (CurrentTokNo >= ListOfTokens.LastBucketOffset)
        {
          /* CurrentTokNo is in the last bucket or needs to be read.  */
          if ((CurrentTokNo-ListOfTokens.LastBucketOffset) < ListOfTokens.tail->len)
            {
              UpdateFromBucket (ListOfTokens.tail, CurrentTokNo-ListOfTokens.LastBucketOffset);
            }
          else
            {
              /* and call ourselves again to collect the token from bucket  */
              GetNonEofToken (true);
            }
        }
      else
        {
          t = CurrentTokNo;
          b = FindTokenBucket (&t);
          UpdateFromBucket (b, t);
        }
    }
}


/*
   InsertToken - inserts a symbol, token, infront of the current token
                 ready for the next pass.
*/

extern "C" void M2LexBuf_InsertToken (M2Reserved_toktype token)
{
  M2LexBuf_TokenBucket topBucket;
  M2LexBuf_TokenBucket insertionBucket;
  unsigned int count;
  M2LexBuf_TokenDesc desc;

  M2Debug_Assert (ListOfTokens.tail != NULL);
  count = (M2LexBuf_GetTokenNo ())-1;
  topBucket = FindTokenBucket (&count);
  insertionBucket = GetInsertBucket (topBucket, count);
  desc = topBucket->buf.array[count];
  desc.token = token;
  desc.insert = NULL;
  AppendToken (insertionBucket, desc);
  if (DebugRecover)
    {
      M2LexBuf_DumpTokens ();
    }
}


/*
   InsertTokenAndRewind - inserts a symbol, token, infront of the current token
                          and then moves the token stream back onto the inserted token.
*/

extern "C" void M2LexBuf_InsertTokenAndRewind (M2Reserved_toktype token)
{
  unsigned int offset;
  M2LexBuf_TokenBucket topBucket;

  if ((M2LexBuf_GetTokenNo ()) > 0)
    {
      M2LexBuf_InsertToken (token);
      offset = CurrentTokNo-2;
      topBucket = FindTokenBucket (&offset);
      InsertionIndex = topBucket->buf.array[offset].insert->len-1;
      CurrentTokNo -= 2;
      M2LexBuf_GetToken ();
    }
}


/*
   GetPreviousTokenLineNo - returns the line number of the previous token.
*/

extern "C" unsigned int M2LexBuf_GetPreviousTokenLineNo (void)
{
  /* 
   IF GetTokenNo()>0
   THEN
      RETURN( TokenToLineNo(GetTokenNo()-1, 0) )
   ELSE
      RETURN( 0 )
   END
  */
  return M2LexBuf_GetLineNo ();
  /* static analysis guarentees a RETURN statement will be used before here.  */
  __builtin_unreachable ();
}


/*
   GetLineNo - returns the current line number where the symbol occurs in
               the source file.
*/

extern "C" unsigned int M2LexBuf_GetLineNo (void)
{
  if (CurrentTokNo == 0)
    {
      return 0;
    }
  else
    {
      return M2LexBuf_TokenToLineNo (M2LexBuf_GetTokenNo (), 0);
    }
  /* static analysis guarentees a RETURN statement will be used before here.  */
  __builtin_unreachable ();
}


/*
   GetTokenNo - returns the current token number.
*/

extern "C" unsigned int M2LexBuf_GetTokenNo (void)
{
  if (CurrentTokNo == 0)
    {
      return 0;
    }
  else
    {
      return CurrentTokNo-1;
    }
  /* static analysis guarentees a RETURN statement will be used before here.  */
  __builtin_unreachable ();
}


/*
   GetTokenName - returns the token name given the tokenno.
*/

extern "C" NameKey_Name M2LexBuf_GetTokenName (unsigned int tokenno)
{
  M2LexBuf_TokenBucket b;
  NameKey_Name n;

  b = FindTokenBucket (&tokenno);
  if (b == NULL)
    {
      return NameKey_NulName;
    }
  else
    {
      n = M2Reserved_tokToTok (b->buf.array[tokenno].token);
      if (n == NameKey_NulName)
        {
          return b->buf.array[tokenno].str;
        }
      else
        {
          return n;
        }
    }
  /* static analysis guarentees a RETURN statement will be used before here.  */
  __builtin_unreachable ();
}


/*
   TokenToLineNo - returns the line number of the current file for the
                   TokenNo. The depth refers to the include depth.
                   A depth of 0 is the current file, depth of 1 is the file
                   which included the current file. Zero is returned if the
                   depth exceeds the file nesting level.
*/

extern "C" unsigned int M2LexBuf_TokenToLineNo (unsigned int TokenNo, unsigned int depth)
{
  M2LexBuf_TokenBucket b;
  M2LexBuf_SourceList l;

  if ((TokenNo == M2LexBuf_UnknownTokenNo) || (TokenNo == M2LexBuf_BuiltinTokenNo))
    {
      return 0;
    }
  else
    {
      b = FindTokenBucket (&TokenNo);
      if (b == NULL)
        {
          return 0;
        }
      else
        {
          if (depth == 0)
            {
              return b->buf.array[TokenNo].line;
            }
          else
            {
              l = b->buf.array[TokenNo].file->left;
              while (depth > 0)
                {
                  l = l->left;
                  if (l == b->buf.array[TokenNo].file->left)
                    {
                      return 0;
                    }
                  depth -= 1;
                }
              return l->line;
            }
        }
    }
  /* static analysis guarentees a RETURN statement will be used before here.  */
  __builtin_unreachable ();
}


/*
   GetColumnNo - returns the current column where the symbol occurs in
                 the source file.
*/

extern "C" unsigned int M2LexBuf_GetColumnNo (void)
{
  if (CurrentTokNo == 0)
    {
      return 0;
    }
  else
    {
      return M2LexBuf_TokenToColumnNo (M2LexBuf_GetTokenNo (), 0);
    }
  /* static analysis guarentees a RETURN statement will be used before here.  */
  __builtin_unreachable ();
}


/*
   TokenToColumnNo - returns the column number of the current file for the
                     TokenNo. The depth refers to the include depth.
                     A depth of 0 is the current file, depth of 1 is the file
                     which included the current file. Zero is returned if the
                     depth exceeds the file nesting level.
*/

extern "C" unsigned int M2LexBuf_TokenToColumnNo (unsigned int TokenNo, unsigned int depth)
{
  M2LexBuf_TokenBucket b;
  M2LexBuf_SourceList l;

  if ((TokenNo == M2LexBuf_UnknownTokenNo) || (TokenNo == M2LexBuf_BuiltinTokenNo))
    {
      return 0;
    }
  else
    {
      b = FindTokenBucket (&TokenNo);
      if (b == NULL)
        {
          return 0;
        }
      else
        {
          if (depth == 0)
            {
              return b->buf.array[TokenNo].col;
            }
          else
            {
              l = b->buf.array[TokenNo].file->left;
              while (depth > 0)
                {
                  l = l->left;
                  if (l == b->buf.array[TokenNo].file->left)
                    {
                      return 0;
                    }
                  depth -= 1;
                }
              return l->col;
            }
        }
    }
  /* static analysis guarentees a RETURN statement will be used before here.  */
  __builtin_unreachable ();
}


/*
   TokenToLocation - returns the location_t corresponding to, TokenNo.
*/

extern "C" m2linemap_location_t M2LexBuf_TokenToLocation (unsigned int TokenNo)
{
  M2LexBuf_TokenBucket b;

  if (TokenNo == M2LexBuf_UnknownTokenNo)
    {
      return M2Emit_UnknownLocation ();
    }
  else if (TokenNo == M2LexBuf_BuiltinTokenNo)
    {
      /* avoid dangling else.  */
      return M2Emit_BuiltinsLocation ();
    }
  else
    {
      /* avoid dangling else.  */
      b = FindTokenBucket (&TokenNo);
      if (b == NULL)
        {
          return M2Emit_UnknownLocation ();
        }
      else
        {
          return b->buf.array[TokenNo].loc;
        }
    }
  /* static analysis guarentees a RETURN statement will be used before here.  */
  __builtin_unreachable ();
}


/*
   FindFileNameFromToken - returns the complete FileName for the appropriate
                           source file yields the token number, TokenNo.
                           The, Depth, indicates the include level: 0..n
                           Level 0 is the current. NIL is returned if n+1
                           is requested.
*/

extern "C" DynamicStrings_String M2LexBuf_FindFileNameFromToken (unsigned int TokenNo, unsigned int depth)
{
  M2LexBuf_TokenBucket b;
  M2LexBuf_SourceList l;

  b = FindTokenBucket (&TokenNo);
  if (b == NULL)
    {
      return static_cast<DynamicStrings_String> (NULL);
    }
  else
    {
      if (TokenNo == M2LexBuf_UnknownTokenNo)
        {
          return static_cast<DynamicStrings_String> (NULL);
        }
      else if (TokenNo == M2LexBuf_BuiltinTokenNo)
        {
          /* avoid dangling else.  */
          return static_cast<DynamicStrings_String> (NULL);
        }
      else
        {
          /* avoid dangling else.  */
          l = b->buf.array[TokenNo].file->left;
          while (depth > 0)
            {
              l = l->left;
              if (l == b->buf.array[TokenNo].file->left)
                {
                  return static_cast<DynamicStrings_String> (NULL);
                }
              depth -= 1;
            }
          return l->name;
        }
    }
  /* static analysis guarentees a RETURN statement will be used before here.  */
  __builtin_unreachable ();
}


/*
   GetFileName - returns a String defining the current file.
*/

extern "C" DynamicStrings_String M2LexBuf_GetFileName (void)
{
  return M2LexBuf_FindFileNameFromToken (M2LexBuf_GetTokenNo (), 0);
  /* static analysis guarentees a RETURN statement will be used before here.  */
  __builtin_unreachable ();
}


/*
   MakeVirtualTok - providing caret, left, right are associated with a source file
                    and exist on the same src line then
                    create and return a new tokenno which is created from
                    tokenno range1 and range2.  Otherwise return caret.
*/

extern "C" unsigned int M2LexBuf_MakeVirtualTok (unsigned int caret, unsigned int left, unsigned int right)
{
  M2LexBuf_TokenBucket bufLeft;
  M2LexBuf_TokenBucket bufRight;
  m2linemap_location_t lc;
  m2linemap_location_t ll;
  m2linemap_location_t lr;

  if (((isSrcToken (caret)) && (isSrcToken (left))) && (isSrcToken (right)))
    {
      lc = M2LexBuf_TokenToLocation (caret);
      ll = M2LexBuf_TokenToLocation (left);
      lr = M2LexBuf_TokenToLocation (right);
      bufLeft = FindTokenBucket (&left);  /* left maybe changed now.  */
      bufRight = FindTokenBucket (&right);  /* right maybe changed now.  */
      if ((bufLeft->buf.array[left].line == bufRight->buf.array[right].line) && (bufLeft->buf.array[left].file == bufRight->buf.array[right].file))
        {
          /* on the same line, create a new token and location.  */
          AddTokToList (M2Reserved_virtualrangetok, NameKey_NulName, 0, bufLeft->buf.array[left].line, bufLeft->buf.array[left].col, bufLeft->buf.array[left].file, m2linemap_GetLocationBinary (lc, ll, lr));
          return (ListOfTokens.LastBucketOffset+ListOfTokens.tail->len)-1;
        }
    }
  return caret;
  /* static analysis guarentees a RETURN statement will be used before here.  */
  __builtin_unreachable ();
}


/*
   AddTok - adds a token to the buffer.
*/

extern "C" void M2LexBuf_AddTok (M2Reserved_toktype t)
{
  DynamicStrings_String s;

  if (t == M2Reserved_eoftok)
    {
      SeenEof = true;
    }
  if (! ((t == M2Reserved_eoftok) && (IsLastTokenEof ())))
    {
      AddTokToList (t, NameKey_NulName, 0, m2flex_GetLineNo (), m2flex_GetColumnNo (), CurrentSource, m2flex_GetLocation ());
      CurrentUsed = true;
      if (Debugging)
        {
          /* display each token as a warning.  */
          s = DynamicStrings_InitStringCharStar (NameKey_KeyToCharStar (M2LexBuf_GetTokenName (M2LexBuf_GetTokenNo ())));
          M2Error_WarnStringAt (s, M2LexBuf_GetTokenNo ());
        }
    }
}


/*
   AddTokCharStar - adds a token to the buffer and an additional string, s.
                    A copy of string, s, is made.
*/

extern "C" void M2LexBuf_AddTokCharStar (M2Reserved_toktype t, void * s)
{
  AddTokToList (t, NameKey_makekey (s), 0, m2flex_GetLineNo (), m2flex_GetColumnNo (), CurrentSource, m2flex_GetLocation ());
  CurrentUsed = true;
}


/*
   AddTokInteger - adds a token and an integer to the buffer.
*/

extern "C" void M2LexBuf_AddTokInteger (M2Reserved_toktype t, int i)
{
  DynamicStrings_String s;
  unsigned int c;
  unsigned int l;

  l = m2flex_GetLineNo ();
  c = m2flex_GetColumnNo ();
  s = FormatStrings_Sprintf1 (DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "%d", 2)), (const unsigned char *) &i, (sizeof (i)-1));
  AddTokToList (t, NameKey_makekey (DynamicStrings_string (s)), i, l, c, CurrentSource, m2flex_GetLocation ());
  s = DynamicStrings_KillString (s);
  CurrentUsed = true;
}


/*
   SetFile - sets the current filename to, filename.
*/

extern "C" void M2LexBuf_SetFile (void * filename)
{
  KillList ();
  CurrentUsed = false;
  CurrentSource = NewList ();
  AddTo (NewElement (filename));
}


/*
   PushFile - indicates that, filename, has just been included.
*/

extern "C" void M2LexBuf_PushFile (void * filename)
{
  M2LexBuf_SourceList l;

  CheckIfNeedToDuplicate ();
  AddTo (NewElement (filename));
  if (Debugging)
    {
      if (CurrentSource->right != CurrentSource)
        {
          l = CurrentSource;
          do {
            M2Printf_printf3 ((const char *) "name = %s, line = %d, col = %d\\n", 32, (const unsigned char *) &l->name, (sizeof (l->name)-1), (const unsigned char *) &l->line, (sizeof (l->line)-1), (const unsigned char *) &l->col, (sizeof (l->col)-1));
            l = l->right;
          } while (! (l == CurrentSource));
        }
    }
}


/*
   PopFile - indicates that we are returning to, filename, having finished
             an include.
*/

extern "C" void M2LexBuf_PopFile (void * filename)
{
  M2LexBuf_SourceList l;

  CheckIfNeedToDuplicate ();
  if ((CurrentSource != NULL) && (CurrentSource->left != CurrentSource))
    {
      /* avoid dangling else.  */
      l = CurrentSource->left;  /* last element  */
      SubFrom (l);  /* last element  */
      Storage_DEALLOCATE ((void **) &l, sizeof (M2LexBuf__T1));
      if ((CurrentSource->left != CurrentSource) && (! (DynamicStrings_Equal (CurrentSource->name, DynamicStrings_Mark (DynamicStrings_InitStringCharStar (filename))))))
        {}  /* empty.  */
      /* mismatch in source file names after preprocessing files  */
    }
  /* source file list is empty, cannot pop an include..  */
}


/*
   PrintTokenNo - displays token and the location of the token.
*/

extern "C" void M2LexBuf_PrintTokenNo (unsigned int tokenno)
{
  DynamicStrings_String s;

  M2Printf_printf1 ((const char *) "tokenno = %d, ", 14, (const unsigned char *) &tokenno, (sizeof (tokenno)-1));
  s = DynamicStrings_InitStringCharStar (NameKey_KeyToCharStar (M2LexBuf_GetTokenName (tokenno)));
  M2Printf_printf1 ((const char *) "%s\\n", 4, (const unsigned char *) &s, (sizeof (s)-1));
  s = DynamicStrings_KillString (s);
}


/*
   DisplayToken - display the token name using printf0 no newline is emitted.
*/

extern "C" void M2LexBuf_DisplayToken (M2Reserved_toktype tok)
{
  switch (tok)
    {
      case M2Reserved_eoftok:
        M2Printf_printf0 ((const char *) "eoftok", 6);
        break;

      case M2Reserved_plustok:
        M2Printf_printf0 ((const char *) "plustok", 7);
        break;

      case M2Reserved_minustok:
        M2Printf_printf0 ((const char *) "minustok", 8);
        break;

      case M2Reserved_timestok:
        M2Printf_printf0 ((const char *) "timestok", 8);
        break;

      case M2Reserved_dividetok:
        M2Printf_printf0 ((const char *) "dividetok", 9);
        break;

      case M2Reserved_becomestok:
        M2Printf_printf0 ((const char *) "becomestok", 10);
        break;

      case M2Reserved_ambersandtok:
        M2Printf_printf0 ((const char *) "ambersandtok", 12);
        break;

      case M2Reserved_periodtok:
        M2Printf_printf0 ((const char *) "periodtok", 9);
        break;

      case M2Reserved_commatok:
        M2Printf_printf0 ((const char *) "commatok", 8);
        break;

      case M2Reserved_semicolontok:
        M2Printf_printf0 ((const char *) "semicolontok", 12);
        break;

      case M2Reserved_lparatok:
        M2Printf_printf0 ((const char *) "lparatok", 8);
        break;

      case M2Reserved_rparatok:
        M2Printf_printf0 ((const char *) "rparatok", 8);
        break;

      case M2Reserved_lsbratok:
        M2Printf_printf0 ((const char *) "lsbratok", 8);
        break;

      case M2Reserved_rsbratok:
        M2Printf_printf0 ((const char *) "rsbratok", 8);
        break;

      case M2Reserved_lcbratok:
        M2Printf_printf0 ((const char *) "lcbratok", 8);
        break;

      case M2Reserved_rcbratok:
        M2Printf_printf0 ((const char *) "rcbratok", 8);
        break;

      case M2Reserved_uparrowtok:
        M2Printf_printf0 ((const char *) "uparrowtok", 10);
        break;

      case M2Reserved_singlequotetok:
        M2Printf_printf0 ((const char *) "singlequotetok", 14);
        break;

      case M2Reserved_equaltok:
        M2Printf_printf0 ((const char *) "equaltok", 8);
        break;

      case M2Reserved_hashtok:
        M2Printf_printf0 ((const char *) "hashtok", 7);
        break;

      case M2Reserved_lesstok:
        M2Printf_printf0 ((const char *) "lesstok", 7);
        break;

      case M2Reserved_greatertok:
        M2Printf_printf0 ((const char *) "greatertok", 10);
        break;

      case M2Reserved_lessgreatertok:
        M2Printf_printf0 ((const char *) "lessgreatertok", 14);
        break;

      case M2Reserved_lessequaltok:
        M2Printf_printf0 ((const char *) "lessequaltok", 12);
        break;

      case M2Reserved_greaterequaltok:
        M2Printf_printf0 ((const char *) "greaterequaltok", 15);
        break;

      case M2Reserved_periodperiodtok:
        M2Printf_printf0 ((const char *) "periodperiodtok", 15);
        break;

      case M2Reserved_colontok:
        M2Printf_printf0 ((const char *) "colontok", 8);
        break;

      case M2Reserved_doublequotestok:
        M2Printf_printf0 ((const char *) "doublequotestok", 15);
        break;

      case M2Reserved_bartok:
        M2Printf_printf0 ((const char *) "bartok", 6);
        break;

      case M2Reserved_andtok:
        M2Printf_printf0 ((const char *) "andtok", 6);
        break;

      case M2Reserved_arraytok:
        M2Printf_printf0 ((const char *) "arraytok", 8);
        break;

      case M2Reserved_begintok:
        M2Printf_printf0 ((const char *) "begintok", 8);
        break;

      case M2Reserved_bytok:
        M2Printf_printf0 ((const char *) "bytok", 5);
        break;

      case M2Reserved_casetok:
        M2Printf_printf0 ((const char *) "casetok", 7);
        break;

      case M2Reserved_consttok:
        M2Printf_printf0 ((const char *) "consttok", 8);
        break;

      case M2Reserved_definitiontok:
        M2Printf_printf0 ((const char *) "definitiontok", 13);
        break;

      case M2Reserved_divtok:
        M2Printf_printf0 ((const char *) "divtok", 6);
        break;

      case M2Reserved_dotok:
        M2Printf_printf0 ((const char *) "dotok", 5);
        break;

      case M2Reserved_elsetok:
        M2Printf_printf0 ((const char *) "elsetok", 7);
        break;

      case M2Reserved_elsiftok:
        M2Printf_printf0 ((const char *) "elsiftok", 8);
        break;

      case M2Reserved_endtok:
        M2Printf_printf0 ((const char *) "endtok", 6);
        break;

      case M2Reserved_exittok:
        M2Printf_printf0 ((const char *) "exittok", 7);
        break;

      case M2Reserved_exporttok:
        M2Printf_printf0 ((const char *) "exporttok", 9);
        break;

      case M2Reserved_fortok:
        M2Printf_printf0 ((const char *) "fortok", 6);
        break;

      case M2Reserved_fromtok:
        M2Printf_printf0 ((const char *) "fromtok", 7);
        break;

      case M2Reserved_iftok:
        M2Printf_printf0 ((const char *) "iftok", 5);
        break;

      case M2Reserved_implementationtok:
        M2Printf_printf0 ((const char *) "implementationtok", 17);
        break;

      case M2Reserved_importtok:
        M2Printf_printf0 ((const char *) "importtok", 9);
        break;

      case M2Reserved_intok:
        M2Printf_printf0 ((const char *) "intok", 5);
        break;

      case M2Reserved_looptok:
        M2Printf_printf0 ((const char *) "looptok", 7);
        break;

      case M2Reserved_modtok:
        M2Printf_printf0 ((const char *) "modtok", 6);
        break;

      case M2Reserved_moduletok:
        M2Printf_printf0 ((const char *) "moduletok", 9);
        break;

      case M2Reserved_nottok:
        M2Printf_printf0 ((const char *) "nottok", 6);
        break;

      case M2Reserved_oftok:
        M2Printf_printf0 ((const char *) "oftok", 5);
        break;

      case M2Reserved_ortok:
        M2Printf_printf0 ((const char *) "ortok", 5);
        break;

      case M2Reserved_pointertok:
        M2Printf_printf0 ((const char *) "pointertok", 10);
        break;

      case M2Reserved_proceduretok:
        M2Printf_printf0 ((const char *) "proceduretok", 12);
        break;

      case M2Reserved_qualifiedtok:
        M2Printf_printf0 ((const char *) "qualifiedtok", 12);
        break;

      case M2Reserved_unqualifiedtok:
        M2Printf_printf0 ((const char *) "unqualifiedtok", 14);
        break;

      case M2Reserved_recordtok:
        M2Printf_printf0 ((const char *) "recordtok", 9);
        break;

      case M2Reserved_repeattok:
        M2Printf_printf0 ((const char *) "repeattok", 9);
        break;

      case M2Reserved_returntok:
        M2Printf_printf0 ((const char *) "returntok", 9);
        break;

      case M2Reserved_settok:
        M2Printf_printf0 ((const char *) "settok", 6);
        break;

      case M2Reserved_thentok:
        M2Printf_printf0 ((const char *) "thentok", 7);
        break;

      case M2Reserved_totok:
        M2Printf_printf0 ((const char *) "totok", 5);
        break;

      case M2Reserved_typetok:
        M2Printf_printf0 ((const char *) "typetok", 7);
        break;

      case M2Reserved_untiltok:
        M2Printf_printf0 ((const char *) "untiltok", 8);
        break;

      case M2Reserved_vartok:
        M2Printf_printf0 ((const char *) "vartok", 6);
        break;

      case M2Reserved_whiletok:
        M2Printf_printf0 ((const char *) "whiletok", 8);
        break;

      case M2Reserved_withtok:
        M2Printf_printf0 ((const char *) "withtok", 7);
        break;

      case M2Reserved_asmtok:
        M2Printf_printf0 ((const char *) "asmtok", 6);
        break;

      case M2Reserved_volatiletok:
        M2Printf_printf0 ((const char *) "volatiletok", 11);
        break;

      case M2Reserved_periodperiodperiodtok:
        M2Printf_printf0 ((const char *) "periodperiodperiodtok", 21);
        break;

      case M2Reserved_datetok:
        M2Printf_printf0 ((const char *) "datetok", 7);
        break;

      case M2Reserved_linetok:
        M2Printf_printf0 ((const char *) "linetok", 7);
        break;

      case M2Reserved_filetok:
        M2Printf_printf0 ((const char *) "filetok", 7);
        break;

      case M2Reserved_integertok:
        M2Printf_printf0 ((const char *) "integertok", 10);
        break;

      case M2Reserved_identtok:
        M2Printf_printf0 ((const char *) "identtok", 8);
        break;

      case M2Reserved_realtok:
        M2Printf_printf0 ((const char *) "realtok", 7);
        break;

      case M2Reserved_stringtok:
        M2Printf_printf0 ((const char *) "stringtok", 9);
        break;


      default:
        break;
    }
}


/*
   DumpTokens - developer debugging aid.
*/

extern "C" void M2LexBuf_DumpTokens (void)
{
  M2LexBuf_TokenBucket tb;
  unsigned int i;
  unsigned int tokenNo;
  unsigned int total;
  unsigned int length;

  tokenNo = M2LexBuf_GetTokenNo ();
  tb = ListOfTokens.head;
  total = 0;
  while (tb != NULL)
    {
      length = tb->len;
      i = 0;
      while (i < length)
        {
          DisplayTokenEntry (tb, i, total);
          i += 1;
          total += 1;
        }
      tb = tb->next;
    }
  M2Printf_printf2 ((const char *) "%d: tokenNo,  %d: total\\n", 25, (const unsigned char *) &tokenNo, (sizeof (tokenNo)-1), (const unsigned char *) &total, (sizeof (total)-1));
  if ((total != 0) && (tokenNo == total))
    {
      M2Printf_printf1 ((const char *) "%d: end of buffer ", 18, (const unsigned char *) &total, (sizeof (total)-1));
      M2Printf_printf0 ((const char *) " <- current token", 17);
      M2Printf_printf0 ((const char *) "\\n", 2);
    }
}

extern "C" void _M2_M2LexBuf_init (__attribute__((unused)) int argc,__attribute__((unused)) char *argv[],__attribute__((unused)) char *envp[])
{
  Init ();
}

extern "C" void _M2_M2LexBuf_fini (__attribute__((unused)) int argc,__attribute__((unused)) char *argv[],__attribute__((unused)) char *envp[])
{
}
