/* do not edit automatically generated by mc from M2Preprocess.  */
/* M2Preprocess.mod provides a mechanism to invoke the C preprocessor.

Copyright (C) 2001-2023 Free Software Foundation, Inc.
Contributed by Gaius Mulley <gaius.mulley@southwales.ac.uk>.

This file is part of GNU Modula-2.

GNU Modula-2 is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 3, or (at your option)
any later version.

GNU Modula-2 is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with GNU Modula-2; see the file COPYING3.  If not see
<http://www.gnu.org/licenses/>.  */

#include "config.h"
#include "system.h"
#include <stdbool.h>
#   if !defined (PROC_D)
#      define PROC_D
       typedef void (*PROC_t) (void);
       typedef struct { PROC_t proc; } PROC;
#   endif

#if defined(__cplusplus)
#   undef NULL
#   define NULL 0
#endif
#define _M2Preprocess_H
#define _M2Preprocess_C

#   include "GSYSTEM.h"
#   include "GDynamicStrings.h"
#   include "Gchoosetemp.h"
#   include "Gpexecute.h"
#   include "Glibc.h"
#   include "GLists.h"
#   include "GFIO.h"
#   include "GM2Printf.h"
#   include "GM2Options.h"
#   include "GNameKey.h"
#   include "GM2RTS.h"

static Lists_List ListOfFiles;

/*
   PreprocessModule - preprocess a file, filename, returning the new filename
                      of the preprocessed file.
                      Preprocessing will only occur if requested by the user.
                      If no preprocessing was requested then filename is returned.
                      If preprocessing occurs then a temporary file is created
                      and its name is returned.
                      All temporary files will be deleted when the compiler exits.
*/

extern "C" DynamicStrings_String M2Preprocess_PreprocessModule (DynamicStrings_String filename, bool isMain);

/*
   OnExitDelete -
*/

static DynamicStrings_String OnExitDelete (DynamicStrings_String filename);

/*
   RemoveFile - removes a single file, s.
*/

static void RemoveFile (unsigned int w);

/*
   RemoveFiles -
*/

static int RemoveFiles (void);
static DynamicStrings_String GetFileName (DynamicStrings_String Path);

/*
   MakeSaveTempsFileName - return a temporary file like 
   "./filename.{def,mod}.m2i" in the CWD unless SaveTempsDir = obj,
   when we put it in the dumpdir if that is specified (or fallback to '.'
   if not).
   We have to keep the original extension because that disambiguates .def
   and .mod files (otherwise, we'd need two 'preprocessed' extensions).
*/

static DynamicStrings_String MakeSaveTempsFileName (DynamicStrings_String filename);


/*
   OnExitDelete -
*/

static DynamicStrings_String OnExitDelete (DynamicStrings_String filename)
{
  Lists_IncludeItemIntoList (ListOfFiles, NameKey_makekey (reinterpret_cast<void *> (filename)));
  return filename;
  /* static analysis guarentees a RETURN statement will be used before here.  */
  __builtin_unreachable ();
}


/*
   RemoveFile - removes a single file, s.
*/

static void RemoveFile (unsigned int w)
{
  NameKey_Name n;

  n = static_cast<NameKey_Name> (w);
  if ((libc_unlink (NameKey_KeyToCharStar (n))) != 0)
    {}  /* empty.  */
}


/*
   RemoveFiles -
*/

static int RemoveFiles (void)
{
  Lists_ForeachItemInListDo (ListOfFiles, (SymbolKey_PerformOperation) {(SymbolKey_PerformOperation_t) RemoveFile});
  return 0;
  /* static analysis guarentees a RETURN statement will be used before here.  */
  __builtin_unreachable ();
}

static DynamicStrings_String GetFileName (DynamicStrings_String Path)
{
  int fstart;

  /* 
   Return the filename with no path.
  */
  fstart = DynamicStrings_RIndex (Path, '/', 0);
  if (fstart == -1)
    {
      fstart = 0;
    }
  else
    {
      fstart = fstart+1;
    }
  return DynamicStrings_Dup (DynamicStrings_Slice (Path, fstart, static_cast<int> (DynamicStrings_Length (Path))));
  /* static analysis guarentees a RETURN statement will be used before here.  */
  __builtin_unreachable ();
}


/*
   MakeSaveTempsFileName - return a temporary file like 
   "./filename.{def,mod}.m2i" in the CWD unless SaveTempsDir = obj,
   when we put it in the dumpdir if that is specified (or fallback to '.'
   if not).
   We have to keep the original extension because that disambiguates .def
   and .mod files (otherwise, we'd need two 'preprocessed' extensions).
*/

static DynamicStrings_String MakeSaveTempsFileName (DynamicStrings_String filename)
{
  DynamicStrings_String NewName;
  DynamicStrings_String DumpDir;
  DynamicStrings_String NewDir;

  NewName = DynamicStrings_ConCat (GetFileName (filename), DynamicStrings_InitString ((const char *) ".m2i", 4));
  NewDir = M2Options_GetSaveTempsDir ();
  DumpDir = M2Options_GetDumpDir ();
  /* IF Verbose
   THEN
      fprintf1 (StdOut, "newname: %s", NewName) ;
      fprintf1 (StdOut, " NewDir: %s", NewDir) ;
      fprintf1 (StdOut, " DumpDir: %s
  ", DumpDir)
   END ;
  */
  if (((NewDir != NULL) && (DynamicStrings_EqualArray (NewDir, (const char *) "obj", 3))) && (DumpDir != NULL))
    {
      return DynamicStrings_Dup (DynamicStrings_ConCat (DumpDir, NewName));
    }
  else
    {
      return DynamicStrings_Dup (DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "./", 2), NewName));
    }
  /* static analysis guarentees a RETURN statement will be used before here.  */
  __builtin_unreachable ();
}


/*
   PreprocessModule - preprocess a file, filename, returning the new filename
                      of the preprocessed file.
                      Preprocessing will only occur if requested by the user.
                      If no preprocessing was requested then filename is returned.
                      If preprocessing occurs then a temporary file is created
                      and its name is returned.
                      All temporary files will be deleted when the compiler exits.
*/

extern "C" DynamicStrings_String M2Preprocess_PreprocessModule (DynamicStrings_String filename, bool isMain)
{
  DynamicStrings_String tempfile;
  DynamicStrings_String command;
  DynamicStrings_String commandLine;

  command = M2Options_CppCommandLine ();
  if ((command == NULL) || (DynamicStrings_EqualArray (command, (const char *) "", 0)))
    {
      return DynamicStrings_Dup (filename);
    }
  else
    {
      commandLine = DynamicStrings_Dup (command);
      tempfile = static_cast<DynamicStrings_String> (NULL);
      /* We support MD and MMD for the main file only, at present.  */
      if (isMain || M2Options_PPonly)
        {
          if ((M2Options_GetMD ()) != NULL)
            {
              tempfile = DynamicStrings_ConCat (DynamicStrings_Mark (DynamicStrings_InitString ((const char *) " -MD ", 5)), DynamicStrings_InitStringCharStar (M2Options_GetMD ()));
            }
          else if ((M2Options_GetMMD ()) != NULL)
            {
              /* avoid dangling else.  */
              tempfile = DynamicStrings_ConCat (DynamicStrings_Mark (DynamicStrings_InitString ((const char *) " -MMD ", 6)), DynamicStrings_InitStringCharStar (M2Options_GetMMD ()));
            }
          if (tempfile != NULL)
            {
              commandLine = DynamicStrings_ConCat (DynamicStrings_Dup (commandLine), DynamicStrings_Dup (tempfile));
              /* We can only add MQ if we already have an MD/MMD.  */
              if ((M2Options_GetMQ ()) != NULL)
                {
                  tempfile = DynamicStrings_ConCat (DynamicStrings_Mark (DynamicStrings_InitString ((const char *) " -MQ ", 5)), DynamicStrings_InitStringCharStar (M2Options_GetMQ ()));
                  commandLine = DynamicStrings_ConCat (DynamicStrings_Dup (commandLine), DynamicStrings_Dup (tempfile));
                }
            }
        }
      /* The output file depends on whether we are in stand-alone PP mode, and
         if an output file is specified.  */
      tempfile = static_cast<DynamicStrings_String> (NULL);
      if (M2Options_PPonly)
        {
          /* avoid dangling else.  */
          if ((M2Options_GetObj ()) != NULL)
            {
              tempfile = DynamicStrings_InitStringCharStar (M2Options_GetObj ());
            }
        }
      else if (M2Options_SaveTemps)
        {
          /* avoid dangling else.  */
          tempfile = MakeSaveTempsFileName (filename);
        }
      else
        {
          /* avoid dangling else.  */
          tempfile = DynamicStrings_InitStringCharStar (choosetemp_make_temp_file (NameKey_KeyToCharStar (NameKey_MakeKey ((const char *) ".m2i", 4))));
        }
      commandLine = DynamicStrings_ConCat (DynamicStrings_ConCatChar (DynamicStrings_Dup (commandLine), ' '), filename);
      if (tempfile != NULL)
        {
          commandLine = DynamicStrings_ConCat (DynamicStrings_ConCat (DynamicStrings_Dup (commandLine), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) " -o ", 4))), tempfile);
        }
      /* for now we'll use system  */
      if (M2Options_Verbose)
        {
          M2Printf_fprintf1 (FIO_StdOut, (const char *) "preprocess: %s\\n", 16, (const unsigned char *) &commandLine, (sizeof (commandLine)-1));
        }
      if ((libc_system (DynamicStrings_string (commandLine))) != 0)
        {
          M2Printf_fprintf1 (FIO_StdErr, (const char *) "C preprocessor failed when preprocessing %s\\n", 45, (const unsigned char *) &filename, (sizeof (filename)-1));
          libc_exit (1);
        }
      commandLine = DynamicStrings_KillString (commandLine);
      if (M2Options_SaveTemps)
        {
          return tempfile;
        }
      else
        {
          return OnExitDelete (tempfile);
        }
    }
  /* static analysis guarentees a RETURN statement will be used before here.  */
  __builtin_unreachable ();
}

extern "C" void _M2_M2Preprocess_init (__attribute__((unused)) int argc,__attribute__((unused)) char *argv[],__attribute__((unused)) char *envp[])
{
  Lists_InitList (&ListOfFiles);
  if ((libc_atexit ((libc_exitP_C) RemoveFiles)) != 0)
    {
      M2RTS_HALT (-1);
      __builtin_unreachable ();
    }
}

extern "C" void _M2_M2Preprocess_fini (__attribute__((unused)) int argc,__attribute__((unused)) char *argv[],__attribute__((unused)) char *envp[])
{
}
