/* do not edit automatically generated by mc from P2SymBuild.  */
/* P2SymBuild.mod pass 2 symbol creation.

Copyright (C) 2001-2023 Free Software Foundation, Inc.
Contributed by Gaius Mulley <gaius.mulley@southwales.ac.uk>.

This file is part of GNU Modula-2.

GNU Modula-2 is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 3, or (at your option)
any later version.

GNU Modula-2 is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with GNU Modula-2; see the file COPYING3.  If not see
<http://www.gnu.org/licenses/>.  */

#include "config.h"
#include "system.h"
#include <stdbool.h>
#   if !defined (PROC_D)
#      define PROC_D
       typedef void (*PROC_t) (void);
       typedef struct { PROC_t proc; } PROC;
#   endif

#   if !defined (TRUE)
#      define TRUE (1==1)
#   endif

#   if !defined (FALSE)
#      define FALSE (1==0)
#   endif

#if defined(__cplusplus)
#   undef NULL
#   define NULL 0
#endif
#define _P2SymBuild_H
#define _P2SymBuild_C

#   include "Glibc.h"
#   include "GNameKey.h"
#   include "GStrLib.h"
#   include "GM2Debug.h"
#   include "GM2LexBuf.h"
#   include "GM2Error.h"
#   include "GM2MetaError.h"
#   include "GDynamicStrings.h"
#   include "GFormatStrings.h"
#   include "GM2Printf.h"
#   include "GM2StackWord.h"
#   include "GM2Options.h"
#   include "GStrIO.h"
#   include "GM2Base.h"
#   include "GStorage.h"
#   include "Gm2linemap.h"
#   include "GM2Reserved.h"
#   include "GFifoQueue.h"
#   include "GSymbolTable.h"
#   include "GM2Batch.h"
#   include "GM2Quads.h"
#   include "GM2Comp.h"
#   include "GM2Const.h"
#   include "GM2Students.h"

#   define Debugging false
static unsigned int alignTypeNo;
static unsigned int castType;
static M2Const_constType type;
static unsigned int RememberedConstant;
static M2StackWord_StackOfWord RememberStack;
static M2StackWord_StackOfWord TypeStack;
static unsigned int curModuleSym;
static unsigned int curBeginTok;
static unsigned int curFinallyTok;
static unsigned int curStartTok;
static unsigned int curEndTok;
static M2StackWord_StackOfWord BlockStack;

/*
   BlockStart - tokno is the module/procedure/implementation/definition token
*/

extern "C" void P2SymBuild_BlockStart (unsigned int tokno);

/*
   BlockEnd - declare module ctor/init/fini/dep procedures.
*/

extern "C" void P2SymBuild_BlockEnd (unsigned int tokno);

/*
   BlockBegin - assign curBeginTok to tokno.
*/

extern "C" void P2SymBuild_BlockBegin (unsigned int tokno);

/*
   BlockFinally - assign curFinallyTok to tokno.
*/

extern "C" void P2SymBuild_BlockFinally (unsigned int tokno);
extern "C" void P2SymBuild_P2StartBuildDefModule (void);
extern "C" void P2SymBuild_P2EndBuildDefModule (void);
extern "C" void P2SymBuild_P2StartBuildImplementationModule (void);
extern "C" void P2SymBuild_P2EndBuildImplementationModule (void);
extern "C" void P2SymBuild_P2StartBuildProgramModule (void);
extern "C" void P2SymBuild_P2EndBuildProgramModule (void);

/*
   StartBuildInnerModule - Creates an Inner module and starts
                           a new scope.

                           The Stack is expected:

                           Entry                 Exit

                    Ptr ->                                     <- Ptr
                           +------------+        +-----------+
                           | NameStart  |        | NameStart |
                           |------------|        |-----------|

*/

extern "C" void P2SymBuild_StartBuildInnerModule (void);

/*
   EndBuildInnerModule - Destroys the Inner module scope and
                         checks for correct name.

                         The Stack is expected:

                         Entry                 Exit

                  Ptr ->
                         +------------+        +-----------+
                         | NameEnd    |        |           |
                         |------------|        |-----------|
                         | NameStart  |        |           | <- Ptr
                         |------------|        |-----------|
*/

extern "C" void P2SymBuild_EndBuildInnerModule (void);

/*
   BuildImportOuterModule - Builds imported identifiers into an outer module
                            from a definition module.

                            The Stack is expected:

                            Entry           OR    Entry

                     Ptr ->                Ptr ->
                            +------------+        +-----------+
                            | #          |        | #         |
                            |------------|        |-----------|
                            | Id1        |        | Id1       |
                            |------------|        |-----------|
                            .            .        .           .
                            .            .        .           .
                            .            .        .           .
                            |------------|        |-----------|
                            | Id#        |        | Id#       |
                            |------------|        |-----------|
                            | ImportTok  |        | Ident     |
                            |------------|        |-----------|

                            IMPORT Id1, .. Id# ;  FROM Ident IMPORT Id1 .. Id# ;


                            Exit

                            All above stack discarded
*/

extern "C" void P2SymBuild_BuildImportOuterModule (void);

/*
   BuildExportOuterModule - Builds exported identifiers from an outer module
                            to the outside world of library modules.

                            The Stack is expected:

                            Entry           OR    Entry

                     Ptr ->                Ptr ->
                            +------------+        +--------------+
                            | #          |        | #            |
                            |------------|        |--------------|
                            | Id1        |        | Id1          |
                            |------------|        |--------------|
                            .            .        .              .
                            .            .        .              .
                            .            .        .              .
                            |------------|        |--------------|
                            | Id#        |        | Id#          |
                            |------------|        |--------------|
                            | ExportTok  |        | QualifiedTok |
                            |------------|        |--------------|

                            EXPORT Id1, .. Id# ;  EXPORT QUALIFIED Id1 .. Id# ;

                            Error Condition


                            Exit

                            All above stack discarded
*/

extern "C" void P2SymBuild_BuildExportOuterModule (void);

/*
   BuildImportInnerModule - Builds imported identifiers into an inner module
                            from the last level of module.

                            The Stack is expected:

                            Entry           OR    Entry

                     Ptr ->                Ptr ->
                            +------------+        +-----------+
                            | #          |        | #         |
                            |------------|        |-----------|
                            | Id1        |        | Id1       |
                            |------------|        |-----------|
                            .            .        .           .
                            .            .        .           .
                            .            .        .           .
                            |------------|        |-----------|
                            | Id#        |        | Id#       |
                            |------------|        |-----------|
                            | ImportTok  |        | Ident     |
                            |------------|        |-----------|

                            IMPORT Id1, .. Id# ;  FROM Ident IMPORT Id1 .. Id# ;

                            Exit

                            All above stack discarded
*/

extern "C" void P2SymBuild_BuildImportInnerModule (void);

/*
   BuildExportInnerModule - Builds exported identifiers from an inner module
                            to the next layer module.

                            The Stack is expected:

                            Entry           OR    Entry

                     Ptr ->                Ptr ->
                            +------------+        +--------------+
                            | #          |        | #            |
                            |------------|        |--------------|
                            | Id1        |        | Id1          |
                            |------------|        |--------------|
                            .            .        .              .
                            .            .        .              .
                            .            .        .              .
                            |------------|        |--------------|
                            | Id#        |        | Id#          |
                            |------------|        |--------------|
                            | ExportTok  |        | QualifiedTok |
                            |------------|        |--------------|

                            EXPORT Id1, .. Id# ;  EXPORT QUALIFIED Id1 .. Id# ;


                            Exit

                            All above stack discarded
*/

extern "C" void P2SymBuild_BuildExportInnerModule (void);

/*
   BuildNumber - Converts a number into a symbol.


                 Stack

                 Entry                 Exit

          Ptr ->                                             <- Ptr
                 +------------+        +-------------------+
                 | Name | tok |        | Sym | Type | tok  |
                 |------------+        |-------------------|
*/

extern "C" void P2SymBuild_BuildNumber (void);

/*
   BuildString - Converts a string into a symbol.


                 Stack

                 Entry                 Exit

          Ptr ->                                               <- Ptr
                 +-------------+        +--------------------+
                 | Name | | tok|        | Sym | NulSym | tok |
                 |-------------+        |--------------------|
*/

extern "C" void P2SymBuild_BuildString (void);

/*
   BuildConst - builds a constant.
                Stack

                Entry                 Exit

         Ptr ->
                +------------+
                | Name       |
                |------------+                       <- Ptr
*/

extern "C" void P2SymBuild_BuildConst (void);

/*
   StartBuildEnumeration - Builds an Enumeration type Type.


                           Stack

                           Entry                 Exit

                    Ptr ->
                           +------------+
                           | #          |
                           |------------|
                           | en 1       |
                           |------------|
                           | en 2       |
                           |------------|
                           .            .
                           .            .
                           .            .                       <- Ptr
                           |------------|        +------------+
                           | en #       |        | Type       |
                           |------------|        |------------|
                           | Name       |        | Name       |
                           |------------|        |------------|
*/

extern "C" void P2SymBuild_StartBuildEnumeration (void);

/*
   BuildSubrange - Builds a Subrange type Symbol, the base type can also be
                   supplied if known.

                      Stack

                      Entry                 Exit


                                                           <- Ptr
                                            +------------+
               Ptr ->                       | Type       |
                      +------------+        |------------|
                      | Name       |        | Name       |
                      |------------|        |------------|
*/

extern "C" void P2SymBuild_BuildSubrange (unsigned int Base);

/*
   BuildAligned - builds an alignment constant symbol which is placed onto
                  the stack.  It expects the ident ALIGNED to be on the
                  stack.

                         Stack

                           Entry                 Exit


                  Ptr ->                                            <- Ptr
                         +---------------+      +-----------------+
                         | bytealignment |      | AlignmentConst  |
                         +---------------+      |-----------------|
*/

extern "C" void P2SymBuild_BuildAligned (void);

/*
   BuildVarAlignment - the AlignmentConst is either a temporary or NulSym.
                       A type may only have one alignment value and
                       error checking is performed.

                       Stack

                           Entry                 Exit


                   Ptr ->
                          +-----------------+
                          | AlignmentConst  |                             <- Ptr
                          |-----------------|        +------------------+
                          | Type            |        | Type  | TypeName |
                          |-----------------|        |------------------|
*/

extern "C" void P2SymBuild_BuildVarAlignment (void);

/*
   BuildTypeAlignment - the AlignmentConst is either a temporary or NulSym.
                        In the case of NulSym it is popped from the stack
                        and the procedure returns.  Otherwise the temporary
                        is popped and recorded as the alignment value for this
                        type.  A type may only have one alignment value and
                        error checking is performed.

                        Stack

                            Entry                 Exit


                    Ptr ->
                           +-----------------+
                           | AlignmentConst  |
                           |-----------------|
                           | Type            |    Empty
                           |-----------------|
*/

extern "C" void P2SymBuild_BuildTypeAlignment (void);
extern "C" void P2SymBuild_P2BuildDefaultFieldAlignment (void);

/*
   BuildPragmaConst - pushes a constant to the stack and stores it away into the
                      const fifo queue ready for pass 3.
*/

extern "C" void P2SymBuild_BuildPragmaConst (void);

/*
   BuildVariable - Builds variables listed in an IdentList with a Type.

                   Stack

                   Entry                 Exit

            Ptr ->
                   +------------+        +------------+
                   | Type | Name|        |            |
                   |------------|        |------------|
                   | #          |        |            |
                   |------------|        |------------|
                   | Ident 1    |        |            |
                   |------------|        |------------|
                   | Ident 2    |        |            |
                   |------------|        |------------|
                   .            .        .            .
                   .            .        .            .
                   .            .        .            .
                   |------------|        |------------|
                   | Ident #    |        |            | <- Ptr
                   |------------|        |------------|

                                           Empty
*/

extern "C" void P2SymBuild_BuildVariable (void);

/*
   BuildType - Builds a Type.


               Stack

               Entry                 Exit

        Ptr ->
               +------------+
               | Type       |                          <- Ptr
               |------------|        +---------------+
               | Name       |        | Type  | Name  |
               |------------|        |---------------|

                                     Empty
*/

extern "C" void P2SymBuild_BuildType (void);

/*
   StartBuildFormalParameters - Initialises the quadruple stack for
                                Formal Parameters.

                                The Stack:

                                Entry                Exit

                                                                    <- Ptr
                                                     +------------+
                                Empty                | 0          |
                                                     |------------|
*/

extern "C" void P2SymBuild_StartBuildFormalParameters (void);

/*
   EndBuildFormalParameters - Resets the quadruple stack after building
                              Formal Parameters.

                              The Stack:

                              Entry                    Exit

                       Ptr ->
                              +------------+
                              | NoOfParam  |                          <- Ptr
                              |------------|           +------------+
                              | ProcSym    |           | ProcSym    |
                              |------------|           |------------|
*/

extern "C" void P2SymBuild_EndBuildFormalParameters (void);

/*
   BuildProcedureHeading - Builds a procedure heading for the definition
                           module procedures.

                           Operation only performed if compiling a
                           definition module.

                           The Stack:

                           Entry                       Exit

                    Ptr ->
                           +------------+
                           | ProcSym    |
                           |------------|
                           | NameStart  |
                           |------------|
                                                       Empty

*/

extern "C" void P2SymBuild_BuildProcedureHeading (void);

/*
   BuildFunction - Builds a procedures return type.
                   Procedure becomes a function.

                    The Stack:

                    Entry                 Exit

             Ptr ->
                    +------------+
                    | TypeSym    |                       <- Ptr
                    |------------|        +------------+
                    | ProcSym    |        | ProcSym    |
                    |------------|        |------------|
*/

extern "C" void P2SymBuild_BuildFunction (void);

/*
   BuildOptFunction - Builds a procedures optional return type.
                      Procedure becomes a function and the user
                      can either call it as a function or a procedure.

                      The Stack:

                      Entry                 Exit

               Ptr ->
                      +------------+
                      | TypeSym    |                       <- Ptr
                      |------------|        +------------+
                      | ProcSym    |        | ProcSym    |
                      |------------|        |------------|
*/

extern "C" void P2SymBuild_BuildOptFunction (void);

/*
   BuildFPSection - Builds a Formal Parameter in a procedure.

                    The Stack:

                    Entry                 Exit

             Ptr ->
                    +------------+
                    | ParamTotal |
                    |------------|
                    | TypeSym    |
                    |------------|
                    | Array/Nul  |
                    |------------|
                    | NoOfIds    |
                    |------------|
                    | Id 1       |
                    |------------|
                    .            .
                    .            .
                    .            .
                    |------------|
                    | Id n       |                       <- Ptr
                    |------------|        +------------+
                    | Var / Nul  |        | ParamTotal |
                    |------------|        |------------|
                    | ProcSym    |        | ProcSym    |
                    |------------|        |------------|
*/

extern "C" void P2SymBuild_BuildFPSection (void);

/*
   BuildVarArgs - indicates that the ProcSym takes varargs
                  after ParamTotal.
                                                         <- Ptr
                    +------------+        +------------+
                    | ParamTotal |        | ParamTotal |
                    |------------|        |------------|
                    | ProcSym    |        | ProcSym    |
                    |------------|        |------------|

*/

extern "C" void P2SymBuild_BuildVarArgs (void);

/*
   BuildFormalVarArgs - indicates that the procedure type takes varargs.

                                                             <- Ptr
                        +------------+        +------------+
                        | ProcSym    |        | ProcSym    |
                        |------------|        |------------|

*/

extern "C" void P2SymBuild_BuildFormalVarArgs (void);

/*
   BuildOptArg - indicates that the ProcSym takes a single optarg
                 after ParamTotal.

                                                         <- Ptr
                 +------------+        +------------+
                 | ParamTotal |        | ParamTotal |
                 |------------|        |------------|
                 | ProcSym    |        | ProcSym    |
                 |------------|        |------------|
*/

extern "C" void P2SymBuild_BuildOptArg (void);

/*
   StartBuildProcedure - Builds a Procedure.

                         The Stack:

                         Entry                 Exit

                                                              <- Ptr
                                               +------------+
                  Ptr ->                       | ProcSym    |
                         +------------+        |------------|
                         | Name       |        | Name       |
                         |------------|        |------------|
*/

extern "C" void P2SymBuild_StartBuildProcedure (void);

/*
   EndBuildProcedure - Ends building a Procedure.
                       It checks the start procedure name matches the end
                       procedure name.

                       The Stack:

                       (Procedure Not Defined in definition module)

                       Entry                 Exit

                Ptr ->
                       +------------+
                       | NameEnd    |
                       |------------|
                       | ProcSym    |
                       |------------|
                       | NameStart  |
                       |------------|
                                             Empty
*/

extern "C" void P2SymBuild_EndBuildProcedure (void);

/*
   BuildNoReturnAttribute - provide an interface to the symbol table module.
*/

extern "C" void P2SymBuild_BuildNoReturnAttribute (unsigned int procedureSym);

/*
   BuildPointerType - builds a pointer type.
                      The Stack:

                      Entry                       Exit
                      =====                       ====


               Ptr ->                                             <- Ptr
                      +------------+              +-------------+
                      | Type       |              | PointerType |
                      |------------|              |-------------|
                      | Name       |              | Name        |
                      |------------|              |-------------|
*/

extern "C" void P2SymBuild_BuildPointerType (void);

/*
   BuildSetType - builds a set type.
                  The Stack:

                  Entry                       Exit
                  =====                       ====


           Ptr ->                                             <- Ptr
                  +------------+              +-------------+
                  | Type       |              | SetType     |
                  |------------|              |-------------|
                  | Name       |              | Name        |
                  |------------|              |-------------|
*/

extern "C" void P2SymBuild_BuildSetType (bool ispacked);

/*
   BuildRecord - Builds a record type.
                 The Stack:

                 Entry                              Exit
                 =====                              ====


                                                                  <- Ptr
                                                    +-----------+
          Ptr ->                                    | RecordSym |
                 +------------------+               |-----------|
                 | Name             |               | Name      |
                 |------------------|               |-----------|
*/

extern "C" void P2SymBuild_BuildRecord (void);

/*
   BuildFieldRecord - Builds a field into a record sym.
                      The Stack:


                      Entry                     Exit
                      =====                     ====

               Ptr ->
                      +-------------+
                      | NoOfPragmas |
                      |-------------|
                      | Const1      |
                      |-------------|
                      | PragmaName1 |
                      |-------------|
                      | Type | Name |
                      |-------------|
                      | n           |
                      |-------------|
                      | Id 1        |
                      |-------------|
                      .             .
                      .             .
                      .             .
                      |-------------|
                      | Id n        |                           <- Ptr
                      |-------------|           +-------------+
                      | RecordSym   |           | RecordSym   |
                      |-------------|           |-------------|
                      | RecordName  |           | RecordName  |
                      |-------------|           |-------------|
*/

extern "C" void P2SymBuild_BuildFieldRecord (void);

/*
   StartBuildVarient - Builds a varient symbol on top of a record sym.
                       The Stack:


                       Entry                     Exit
                       =====                     ====

                                                                 <- Ptr
                                                 +-------------+
                Ptr ->                           | VarientSym  |
                       +-------------+           |-------------|
                       | RecordSym   |           | RecordSym   |
                       |-------------|           |-------------|
                       | RecordName  |           | RecordName  |
                       |-------------|           |-------------|
*/

extern "C" void P2SymBuild_StartBuildVarient (void);

/*
   EndBuildVarient - Removes the varient symbol from the stack.
                     The Stack:

                     Entry                     Exit
                     =====                     ====

              Ptr ->
                     +-------------+
                     | VarientSym  |                           <- Ptr
                     |-------------|           +-------------+
                     | RecordSym   |           | RecordSym   |
                     |-------------|           |-------------|
                     | RecordName  |           | RecordName  |
                     |-------------|           |-------------|
*/

extern "C" void P2SymBuild_EndBuildVarient (void);

/*
   BuildVarientSelector - Builds a field into a record sym.
                          The Stack:


                          Entry                     Exit
                          =====                     ====

                   Ptr ->
                          +-------------+
                          | Type        |
                          |-------------|
                          | Tag         |                           <- Ptr
                          |-------------|           +-------------+
                          | RecordSym   |           | RecordSym   |
                          |-------------|           |-------------|
*/

extern "C" void P2SymBuild_BuildVarientSelector (void);

/*
   StartBuildVarientFieldRecord - Builds a varient field into a varient sym.
                                  The Stack:


                                  Entry                     Exit
                                  =====                     ====

                                                                       <- Ptr
                                                       +-------------+
                      Ptr ->                           | VarientField|
                             +-------------+           |-------------|
                             | VarientSym  |           | VarientSym  |
                             |-------------|           |-------------|
*/

extern "C" void P2SymBuild_StartBuildVarientFieldRecord (void);

/*
   EndBuildVarientFieldRecord - Removes a varient field from the stack.
                                The Stack:


                                Entry                     Exit
                                =====                     ====

                         Ptr ->
                                +-------------+
                                | VarientField|                           <- Ptr
                                |-------------|           +-------------+
                                | VarientSym  |           | VarientSym  |
                                |-------------|           |-------------|
*/

extern "C" void P2SymBuild_EndBuildVarientFieldRecord (void);

/*
   BuildNulName - Pushes a NulName onto the top of the stack.
                  The Stack:


                  Entry                    Exit

                                                          <- Ptr
                  Empty                    +------------+
                                           | NulName   |
                                           |------------|
*/

extern "C" void P2SymBuild_BuildNulName (void);

/*
   BuildTypeEnd - Pops the type Type and Name.
                  The Stack:


                  Entry                    Exit


           Ptr ->
                  +-------------+
                  | Type | Name |          Empty
                  |-------------|
*/

extern "C" void P2SymBuild_BuildTypeEnd (void);

/*
   StartBuildArray - Builds an array type.
                     The Stack:

                     Entry                        Exit
                     =====                        ====

                                                                <- Ptr
                                                  +-----------+
              Ptr ->                              | ArraySym  |
                     +------------+               |-----------|
                     | Name       |               | Name      |
                     |------------|               |-----------|
*/

extern "C" void P2SymBuild_StartBuildArray (void);

/*
   EndBuildArray - Builds an array type.
                   The Stack:

                   Entry                        Exit
                   =====                        ====

            Ptr ->
                   +------------+
                   | TypeSym    |                              <- Ptr
                   |------------|               +------------+
                   | ArraySym   |               | ArraySym   |
                   |------------|               |------------|
                   | Name       |               | Name       |
                   |------------|               |------------|
*/

extern "C" void P2SymBuild_EndBuildArray (void);

/*
   BuildFieldArray - Builds a field into an array sym.
                     The Stack:


                     Entry                     Exit
                     =====                     ====

              Ptr ->
                     +-------------+
                     | Type | Name |                           <- Ptr
                     |-------------|           +-------------+
                     | ArraySym    |           | ArraySym    |
                     |-------------|           |-------------|
                     | ArrayName   |           | ArrayName   |
                     |-------------|           |-------------|
*/

extern "C" void P2SymBuild_BuildFieldArray (void);

/*
   BuildArrayComma - converts ARRAY [..], [..] OF into ARRAY [..] OF ARRAY [..]


              Ptr ->                                           <- Ptr
                     +-------------+           +-------------+
                     | ArraySym1   |           | ArraySym2   |
                     |-------------|           |-------------|
                     | ArrayName   |           | ArrayName   |
                     |-------------|           |-------------|
*/

extern "C" void P2SymBuild_BuildArrayComma (void);

/*
   BuildProcedureType - builds a procedure type symbol.
                        The Stack:


                                                               <- Ptr
                                               +-------------+
                 Ptr ->                        | ProcTypeSym |
                        +-------------+        |-------------|
                        | Name        |        | Name        |
                        |-------------|        |-------------|
*/

extern "C" void P2SymBuild_BuildProcedureType (void);

/*
   BuildFormalType - Builds a Formal Parameter in a procedure type.

                     The Stack:

                     Entry                 Exit

              Ptr ->
                     +------------+
                     | TypeSym    |
                     |------------|
                     | Array/Nul  |
                     |------------|
                     | Var / Nul  |                         <- Ptr
                     |------------|        +--------------+
                     | ProcTypeSym|        | ProcTypeSym  |
                     |------------|        |--------------|
*/

extern "C" void P2SymBuild_BuildFormalType (void);

/*
   SeenUnknown - sets the operand type to unknown.
*/

extern "C" void P2SymBuild_SeenUnknown (void);

/*
   SeenCast - sets the operand type to cast.
*/

extern "C" void P2SymBuild_SeenCast (unsigned int sym);

/*
   SeenSet - sets the operand type to set.
*/

extern "C" void P2SymBuild_SeenSet (void);

/*
   SeenConstructor - sets the operand type to constructor.
*/

extern "C" void P2SymBuild_SeenConstructor (void);

/*
   SeenArray - sets the operand type to array.
*/

extern "C" void P2SymBuild_SeenArray (void);

/*
   SeenString - sets the operand type to string.
*/

extern "C" void P2SymBuild_SeenString (void);

/*
   SeenBoolean - sets the operand type to a BOOLEAN.
*/

extern "C" void P2SymBuild_SeenBoolean (void);

/*
   SeenZType - sets the operand type to a Z type.
*/

extern "C" void P2SymBuild_SeenZType (void);

/*
   SeenRType - sets the operand type to a R type.
*/

extern "C" void P2SymBuild_SeenRType (void);

/*
   SeenCType - sets the operand type to a C type.
*/

extern "C" void P2SymBuild_SeenCType (void);

/*
   DetermineType - assigns the top of stack symbol with the type of
                   constant expression, if known.
*/

extern "C" void P2SymBuild_DetermineType (void);

/*
   PushType -
*/

extern "C" void P2SymBuild_PushType (void);

/*
   PopType -
*/

extern "C" void P2SymBuild_PopType (void);

/*
   PushRememberConstant -
*/

extern "C" void P2SymBuild_PushRememberConstant (void);

/*
   PopRememberConstant -
*/

extern "C" void P2SymBuild_PopRememberConstant (void);

/*
   RememberConstant -
*/

extern "C" void P2SymBuild_RememberConstant (unsigned int sym);
static void stop (void);

/*
   propageteTokenPosition - if laterTokPos is unknown then return knownTokPos.
                            else return laterTokPos.
*/

static unsigned int propageteTokenPosition (unsigned int knownTokPos, unsigned int laterTokPos);

/*
   PushBlock - push the block variables to the block stack.
*/

static void PushBlock (unsigned int tokno);

/*
   PopBlock - pop the block variables from the block stack.
*/

static void PopBlock (void);

/*
   BuildFormalParameterSection - Builds a Formal Parameter in a procedure.

                                 The Stack:

                                 Entry                 Exit

                          Ptr ->
                                 +------------+
                                 | ParamTotal |
                                 |------------|
                                 | TypeSym    |
                                 |------------|
                                 | Array/Nul  |
                                 |------------|
                                 | NoOfIds    |
                                 |------------|
                                 | Id 1       |
                                 |------------|
                                 .            .
                                 .            .
                                 .            .
                                 |------------|
                                 | Id n       |                       <- Ptr
                                 |------------|        +------------+
                                 | Var / Nul  |        | ParamTotal |
                                 |------------|        |------------|
                                 | ProcSym    |        | ProcSym    |
                                 |------------|        |------------|
*/

static void BuildFormalParameterSection (void);

/*
   CheckFormalParameterSection - Checks a Formal Parameter in a procedure.

                                 The Stack:

                                 Entry                 Exit

                          Ptr ->
                                 +------------+
                                 | ParamTotal |
                                 |------------|
                                 | TypeSym    |
                                 |------------|
                                 | Array/Nul  |
                                 |------------|
                                 | NoOfIds    |
                                 |------------|
                                 | Id 1       |
                                 |------------|
                                 .            .
                                 .            .
                                 .            .
                                 |------------|
                                 | Id n       |                       <- Ptr
                                 |------------|        +------------+
                                 | Var / Nul  |        | ParamTotal |
                                 |------------|        |------------|
                                 | ProcSym    |        | ProcSym    |
                                 |------------|        |------------|
*/

static void CheckFormalParameterSection (void);

/*
   FailParameter - generates an error message indicating that a parameter
                   declaration has failed.

                   The parameters are:

                   CurrentState  - string describing the current failing state.
                   PreviousState - string describing the old defined state.
                   Given         - token or identifier that was given.
                   ParameterNo   - parameter number that has failed.
                   ProcedureSym  - procedure symbol where parameter has failed.

                   If any parameter is Nul then it is ignored.
*/

static void FailParameter (const char *CurrentState_, unsigned int _CurrentState_high, const char *PreviousState_, unsigned int _PreviousState_high, NameKey_Name Given, unsigned int ParameterNo, unsigned int ProcedureSym);

/*
   HandleRecordFieldPragmas -

                      Entry                     Exit
                      =====                     ====

               Ptr ->                                     <- Ptr

                      |-------------|           |-------------|
                      | Const1      |           | Const1      |
                      |-------------|           |-------------|
                      | PragmaName1 |           | PragmaName1 |
                      |-------------|           |-------------|
*/

static void HandleRecordFieldPragmas (unsigned int record, unsigned int field, unsigned int n);

/*
   SaveRememberedConstructor -
*/

static void SaveRememberedConstructor (void);

/*
   GetSeenString - returns a string corresponding to, s.
*/

static DynamicStrings_String GetSeenString (M2Const_constType s);

/*
   SetTypeTo - attempts to set, type, to, s.
*/

static void SetTypeTo (M2Const_constType s);

static void stop (void)
{
}


/*
   propageteTokenPosition - if laterTokPos is unknown then return knownTokPos.
                            else return laterTokPos.
*/

static unsigned int propageteTokenPosition (unsigned int knownTokPos, unsigned int laterTokPos)
{
  if (laterTokPos == M2LexBuf_UnknownTokenNo)
    {
      return knownTokPos;
    }
  else
    {
      return laterTokPos;
    }
  /* static analysis guarentees a RETURN statement will be used before here.  */
  __builtin_unreachable ();
}


/*
   PushBlock - push the block variables to the block stack.
*/

static void PushBlock (unsigned int tokno)
{
  M2StackWord_PushWord (BlockStack, curStartTok);  /* module/implementation/definition/procedure token pos.  */
  M2StackWord_PushWord (BlockStack, curBeginTok);  /* BEGIN keyword pos.  */
  M2StackWord_PushWord (BlockStack, curEndTok);  /* END keyword pos.  */
  M2StackWord_PushWord (BlockStack, curFinallyTok);  /* FINALLY keyword pos.  */
  M2StackWord_PushWord (BlockStack, curModuleSym);  /* current module.  */
  curStartTok = tokno;  /* current module.  */
  curBeginTok = M2LexBuf_UnknownTokenNo;
  curEndTok = M2LexBuf_UnknownTokenNo;
  curFinallyTok = M2LexBuf_UnknownTokenNo;
  curModuleSym = SymbolTable_NulSym;
}


/*
   PopBlock - pop the block variables from the block stack.
*/

static void PopBlock (void)
{
  curModuleSym = static_cast<unsigned int> (M2StackWord_PopWord (BlockStack));
  curFinallyTok = static_cast<unsigned int> (M2StackWord_PopWord (BlockStack));
  curEndTok = static_cast<unsigned int> (M2StackWord_PopWord (BlockStack));
  curBeginTok = static_cast<unsigned int> (M2StackWord_PopWord (BlockStack));
  curStartTok = static_cast<unsigned int> (M2StackWord_PopWord (BlockStack));
}


/*
   BuildFormalParameterSection - Builds a Formal Parameter in a procedure.

                                 The Stack:

                                 Entry                 Exit

                          Ptr ->
                                 +------------+
                                 | ParamTotal |
                                 |------------|
                                 | TypeSym    |
                                 |------------|
                                 | Array/Nul  |
                                 |------------|
                                 | NoOfIds    |
                                 |------------|
                                 | Id 1       |
                                 |------------|
                                 .            .
                                 .            .
                                 .            .
                                 |------------|
                                 | Id n       |                       <- Ptr
                                 |------------|        +------------+
                                 | Var / Nul  |        | ParamTotal |
                                 |------------|        |------------|
                                 | ProcSym    |        | ProcSym    |
                                 |------------|        |------------|
*/

static void BuildFormalParameterSection (void)
{
  NameKey_Name ParamName;
  NameKey_Name Var;
  NameKey_Name Array;
  unsigned int tok;
  unsigned int ParamTotal;
  unsigned int TypeSym;
  unsigned int UnBoundedSym;
  unsigned int NoOfIds;
  unsigned int ProcSym;
  unsigned int i;
  unsigned int ndim;

  M2Quads_PopT (&ParamTotal);
  M2Quads_PopT (&TypeSym);
  M2Quads_PopTF (&Array, &ndim);
  M2Debug_Assert ((Array == M2Reserved_ArrayTok) || (Array == M2Reserved_NulTok));
  M2Quads_PopT (&NoOfIds);
  ProcSym = static_cast<unsigned int> (M2Quads_OperandT (NoOfIds+2));
  M2Debug_Assert (SymbolTable_IsProcedure (ProcSym));
  Var = static_cast<NameKey_Name> (M2Quads_OperandT (NoOfIds+1));
  tok = static_cast<unsigned int> (M2Quads_OperandTok (NoOfIds+2));
  M2Debug_Assert ((Var == M2Reserved_VarTok) || (Var == M2Reserved_NulTok));
  if (Array == M2Reserved_ArrayTok)
    {
      UnBoundedSym = SymbolTable_MakeUnbounded (tok, TypeSym, ndim);
      TypeSym = UnBoundedSym;
    }
  i = 1;
  /* 
   WriteString('Procedure ') ; WriteKey(GetSymName(ProcSym)) ;
   WriteString(' adding No. of identifiers:') ; WriteCard(NoOfIds, 4) ; WriteLn ;
  */
  while (i <= NoOfIds)
    {
      if (((M2Comp_CompilingDefinitionModule ()) && ! M2Options_PedanticParamNames) && (((SymbolTable_GetMainModule ()) == (SymbolTable_GetCurrentModule ())) || ((SymbolTable_IsHiddenTypeDeclared (SymbolTable_GetCurrentModule ())) && M2Options_ExtendedOpaque)))
        {
          /* we will see the parameters in the implementation module  */
          ParamName = NameKey_NulName;
        }
      else
        {
          ParamName = static_cast<NameKey_Name> (M2Quads_OperandT ((NoOfIds+1)-i));
        }
      tok = static_cast<unsigned int> (M2Quads_OperandTok ((NoOfIds+1)-i));
      if (Var == M2Reserved_VarTok)
        {
          /* avoid dangling else.  */
          /* VAR parameter  */
          if (! (SymbolTable_PutVarParam (tok, ProcSym, ParamTotal+i, ParamName, TypeSym, Array == M2Reserved_ArrayTok)))
            {
              M2Error_InternalError ((const char *) "problems adding a VarParameter - wrong param #?", 47);
            }
        }
      else
        {
          /* Non VAR parameter  */
          if (! (SymbolTable_PutParam (tok, ProcSym, ParamTotal+i, ParamName, TypeSym, Array == M2Reserved_ArrayTok)))
            {
              M2Error_InternalError ((const char *) "problems adding a Parameter - wrong param #?", 44);
            }
        }
      /* 
      WriteString(' parameter') ; WriteCard(ParamTotal+i, 4) ; WriteLn ;
      WriteKey(Operand(Ptr+i+1)) ; WriteString(' is a parameter with type ') ;
      WriteKey(GetSymName(TypeSym)) ; WriteLn ;
  */
      i += 1;
    }
  M2Quads_PopN (NoOfIds+1);
  M2Quads_PushT (ParamTotal+NoOfIds);
  M2Debug_Assert (SymbolTable_IsProcedure (M2Quads_OperandT (2)));
}


/*
   CheckFormalParameterSection - Checks a Formal Parameter in a procedure.

                                 The Stack:

                                 Entry                 Exit

                          Ptr ->
                                 +------------+
                                 | ParamTotal |
                                 |------------|
                                 | TypeSym    |
                                 |------------|
                                 | Array/Nul  |
                                 |------------|
                                 | NoOfIds    |
                                 |------------|
                                 | Id 1       |
                                 |------------|
                                 .            .
                                 .            .
                                 .            .
                                 |------------|
                                 | Id n       |                       <- Ptr
                                 |------------|        +------------+
                                 | Var / Nul  |        | ParamTotal |
                                 |------------|        |------------|
                                 | ProcSym    |        | ProcSym    |
                                 |------------|        |------------|
*/

static void CheckFormalParameterSection (void)
{
  NameKey_Name Array;
  NameKey_Name Var;
  bool Unbounded;
  unsigned int ParamI;
  unsigned int ParamIType;
  unsigned int ParamTotal;
  unsigned int TypeSym;
  unsigned int NoOfIds;
  unsigned int ProcSym;
  unsigned int pi;
  unsigned int i;
  unsigned int ndim;

  M2Quads_PopT (&ParamTotal);
  M2Quads_PopT (&TypeSym);
  M2Quads_PopTF (&Array, &ndim);
  M2Debug_Assert ((Array == M2Reserved_ArrayTok) || (Array == M2Reserved_NulTok));
  M2Quads_PopT (&NoOfIds);
  ProcSym = static_cast<unsigned int> (M2Quads_OperandT (NoOfIds+2));
  M2Debug_Assert (SymbolTable_IsProcedure (ProcSym));
  Var = static_cast<NameKey_Name> (M2Quads_OperandT (NoOfIds+1));
  M2Debug_Assert ((Var == M2Reserved_VarTok) || (Var == M2Reserved_NulTok));
  Unbounded = Array == M2Reserved_ArrayTok;  /* ARRAY OF Type, parameter  */
  i = 1;  /* ARRAY OF Type, parameter  */
  pi = NoOfIds;  /* stack index referencing stacked parameter, i  */
  /* 
   WriteString('No. of identifiers:') ; WriteCard(NoOfIds, 4) ; WriteLn ;
  */
  while (i <= NoOfIds)
    {
      if ((ParamTotal+i) <= (SymbolTable_NoOfParam (ProcSym)))
        {
          /* avoid dangling else.  */
          if (Unbounded && (! (SymbolTable_IsUnboundedParam (ProcSym, ParamTotal+i))))
            {
              FailParameter ((const char *) "the parameter was declared as an ARRAY OF type", 46, (const char *) "the parameter was not declared as an ARRAY OF type", 50, NameKey_NulName, ParamTotal+i, ProcSym);
            }
          else if (! Unbounded && (SymbolTable_IsUnboundedParam (ProcSym, ParamTotal+i)))
            {
              /* avoid dangling else.  */
              FailParameter ((const char *) "the parameter was not declared as an ARRAY OF type", 50, (const char *) "the parameter was declared as an ARRAY OF type", 46, NameKey_NulName, ParamTotal+i, ProcSym);
            }
          if (Unbounded)
            {
              if ((SymbolTable_GetDimension (SymbolTable_GetNthParam (ProcSym, ParamTotal+1))) != ndim)
                {
                  FailParameter ((const char *) "", 0, (const char *) "the dynamic array parameter was declared with different number of dimensions", 76, NameKey_NulName, ParamTotal+i, ProcSym);
                }
            }
          if ((Var == M2Reserved_VarTok) && (! (SymbolTable_IsVarParam (ProcSym, ParamTotal+i))))
            {
              /* expecting non VAR pamarater  */
              FailParameter ((const char *) "the parameter has been declared as a VAR parameter", 50, (const char *) "the parameter was not declared as a VAR parameter", 49, NameKey_NulName, ParamTotal+i, ProcSym);
            }
          else if ((Var == M2Reserved_NulTok) && (SymbolTable_IsVarParam (ProcSym, ParamTotal+i)))
            {
              /* avoid dangling else.  */
              /* expecting VAR pamarater  */
              FailParameter ((const char *) "the parameter was not declared as a VAR parameter", 49, (const char *) "the parameter has been declared as a VAR parameter", 50, NameKey_NulName, ParamTotal+i, ProcSym);
            }
          ParamI = SymbolTable_GetParam (ProcSym, ParamTotal+i);
          if (M2Options_PedanticParamNames)
            {
              /* avoid dangling else.  */
              if ((SymbolTable_GetSymName (ParamI)) != (M2Quads_OperandT (pi)))
                {
                  /* different parameter names  */
                  FailParameter ((const char *) "", 0, (const char *) "the parameter has been declared with a different name", 53, M2Quads_OperandT (pi), ParamTotal+i, ProcSym);
                }
            }
          else
            {
              if ((SymbolTable_GetSymName (ParamI)) == NameKey_NulName)
                {
                  SymbolTable_PutParamName (M2Quads_OperandTok (pi), ProcSym, ParamTotal+i, M2Quads_OperandT (pi));
                }
            }
          if (Unbounded)
            {
              /* GetType(ParamI) yields an UnboundedSym or a PartialUnboundedSym,
               depending whether it has been resolved..  */
              ParamIType = SymbolTable_GetType (SymbolTable_GetType (ParamI));
            }
          else
            {
              ParamIType = SymbolTable_GetType (ParamI);
            }
          if (((((SymbolTable_SkipType (ParamIType)) != (SymbolTable_SkipType (TypeSym))) || (M2Options_PedanticParamNames && (ParamIType != TypeSym))) && (! (SymbolTable_IsUnknown (SymbolTable_SkipType (TypeSym))))) && (! (SymbolTable_IsUnknown (SymbolTable_SkipType (ParamIType)))))
            {
              /* different parameter types  */
              FailParameter ((const char *) "", 0, (const char *) "the parameter has been declared with a different type", 53, M2Quads_OperandT (pi), ParamTotal+i, ProcSym);
            }
        }
      else
        {
          FailParameter ((const char *) "too many parameters", 19, (const char *) "fewer parameters were declared", 30, NameKey_NulName, ParamTotal+i, ProcSym);
        }
      i += 1;
      pi -= 1;
    }
  M2Quads_PopN (NoOfIds+1);  /* +1 for the Var/Nul  */
  M2Quads_PushT (ParamTotal+NoOfIds);  /* +1 for the Var/Nul  */
  M2Debug_Assert (SymbolTable_IsProcedure (M2Quads_OperandT (2)));
}


/*
   FailParameter - generates an error message indicating that a parameter
                   declaration has failed.

                   The parameters are:

                   CurrentState  - string describing the current failing state.
                   PreviousState - string describing the old defined state.
                   Given         - token or identifier that was given.
                   ParameterNo   - parameter number that has failed.
                   ProcedureSym  - procedure symbol where parameter has failed.

                   If any parameter is Nul then it is ignored.
*/

static void FailParameter (const char *CurrentState_, unsigned int _CurrentState_high, const char *PreviousState_, unsigned int _PreviousState_high, NameKey_Name Given, unsigned int ParameterNo, unsigned int ProcedureSym)
{
  unsigned int First;
  DynamicStrings_String FirstModule;
  DynamicStrings_String SecondModule;
  DynamicStrings_String s1;
  DynamicStrings_String s2;
  DynamicStrings_String s3;
  char CurrentState[_CurrentState_high+1];
  char PreviousState[_PreviousState_high+1];

  /* make a local copy of each unbounded array.  */
  memcpy (CurrentState, CurrentState_, _CurrentState_high+1);
  memcpy (PreviousState, PreviousState_, _PreviousState_high+1);

  if ((SymbolTable_NoOfParam (ProcedureSym)) >= ParameterNo)
    {
      if (M2Comp_CompilingDefinitionModule ())
        {
          First = SymbolTable_GetDeclaredDef (SymbolTable_GetNthParam (ProcedureSym, ParameterNo));
        }
      else
        {
          First = SymbolTable_GetDeclaredMod (SymbolTable_GetNthParam (ProcedureSym, ParameterNo));
        }
    }
  else
    {
      /* ParameterNo does not exist - which is probably the reason why this routine was called..  */
      if (M2Comp_CompilingDefinitionModule ())
        {
          First = SymbolTable_GetDeclaredDef (ProcedureSym);
        }
      else
        {
          First = SymbolTable_GetDeclaredMod (ProcedureSym);
        }
    }
  if (M2Comp_CompilingDefinitionModule ())
    {
      FirstModule = DynamicStrings_InitString ((const char *) "definition module", 17);
      SecondModule = DynamicStrings_InitString ((const char *) "implementation module", 21);
    }
  else if (M2Comp_CompilingImplementationModule ())
    {
      /* avoid dangling else.  */
      FirstModule = DynamicStrings_InitString ((const char *) "implementation module", 21);
      SecondModule = DynamicStrings_InitString ((const char *) "definition module", 17);
    }
  else
    {
      /* avoid dangling else.  */
      M2Debug_Assert (M2Comp_CompilingProgramModule ());
      FirstModule = DynamicStrings_InitString ((const char *) "program module", 14);
      SecondModule = DynamicStrings_InitString ((const char *) "definition module", 17);
    }
  s2 = DynamicStrings_Mark (DynamicStrings_InitStringCharStar (NameKey_KeyToCharStar (SymbolTable_GetSymName (ProcedureSym))));
  s3 = DynamicStrings_Mark (FirstModule);
  s1 = FormatStrings_Sprintf4 (DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "declaration of procedure %s in the %s differs from the %s, problem with parameter number %d", 91)), (const unsigned char *) &s2, (sizeof (s2)-1), (const unsigned char *) &s3, (sizeof (s3)-1), (const unsigned char *) &SecondModule, (sizeof (SecondModule)-1), (const unsigned char *) &ParameterNo, (sizeof (ParameterNo)-1));
  if ((SymbolTable_NoOfParam (ProcedureSym)) >= ParameterNo)
    {
      s2 = DynamicStrings_Mark (DynamicStrings_InitStringCharStar (NameKey_KeyToCharStar (SymbolTable_GetSymName (SymbolTable_GetNthParam (ProcedureSym, ParameterNo)))));
      s1 = DynamicStrings_ConCat (s1, DynamicStrings_Mark (FormatStrings_Sprintf1 (DynamicStrings_Mark (DynamicStrings_InitString ((const char *) " (%s)", 5)), (const unsigned char *) &s2, (sizeof (s2)-1))));
    }
  if (! (StrLib_StrEqual ((const char *) CurrentState, _CurrentState_high, (const char *) "", 0)))
    {
      s2 = DynamicStrings_Mark (DynamicStrings_InitString ((const char *) CurrentState, _CurrentState_high));
      s1 = DynamicStrings_ConCat (s1, DynamicStrings_Mark (FormatStrings_Sprintf1 (DynamicStrings_Mark (DynamicStrings_InitString ((const char *) ", %s", 4)), (const unsigned char *) &s2, (sizeof (s2)-1))));
    }
  if (! (StrLib_StrEqual ((const char *) PreviousState, _PreviousState_high, (const char *) "", 0)))
    {
      s2 = DynamicStrings_Mark (SecondModule);
      s3 = DynamicStrings_Mark (DynamicStrings_InitString ((const char *) PreviousState, _PreviousState_high));
      s1 = DynamicStrings_ConCat (s1, DynamicStrings_Mark (FormatStrings_Sprintf2 (DynamicStrings_Mark (DynamicStrings_InitString ((const char *) " in the %s %s", 13)), (const unsigned char *) &s2, (sizeof (s2)-1), (const unsigned char *) &s3, (sizeof (s3)-1))));
    }
  if (Given != NameKey_NulName)
    {
      s2 = DynamicStrings_Mark (DynamicStrings_InitStringCharStar (NameKey_KeyToCharStar (Given)));
      s1 = DynamicStrings_ConCat (s1, DynamicStrings_Mark (FormatStrings_Sprintf1 (DynamicStrings_Mark (DynamicStrings_InitString ((const char *) " (%s)", 5)), (const unsigned char *) &s2, (sizeof (s2)-1))));
    }
  s1 = DynamicStrings_ConCat (s1, DynamicStrings_Mark (FormatStrings_Sprintf0 (DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "\\n", 2)))));
  M2Error_ErrorStringAt2 (s1, M2LexBuf_GetTokenNo (), First);
}


/*
   HandleRecordFieldPragmas -

                      Entry                     Exit
                      =====                     ====

               Ptr ->                                     <- Ptr

                      |-------------|           |-------------|
                      | Const1      |           | Const1      |
                      |-------------|           |-------------|
                      | PragmaName1 |           | PragmaName1 |
                      |-------------|           |-------------|
*/

static void HandleRecordFieldPragmas (unsigned int record, unsigned int field, unsigned int n)
{
  bool seenAlignment;
  unsigned int defaultAlignment;
  unsigned int sym;
  unsigned int i;
  NameKey_Name name;
  DynamicStrings_String s;

  seenAlignment = false;
  defaultAlignment = SymbolTable_GetDefaultRecordFieldAlignment (record);
  i = 1;
  while (i <= n)
    {
      name = static_cast<NameKey_Name> (M2Quads_OperandT (i*2));
      sym = static_cast<unsigned int> (M2Quads_OperandT ((i*2)-1));
      if (name == (NameKey_MakeKey ((const char *) "unused", 6)))
        {
          if (sym == SymbolTable_NulSym)
            {
              SymbolTable_PutUnused (field);
            }
          else
            {
              M2Error_WriteFormat0 ((const char *) "not expecting pragma 'unused' to contain an expression", 54);
            }
        }
      else if (name == (NameKey_MakeKey ((const char *) "bytealignment", 13)))
        {
          /* avoid dangling else.  */
          if (sym == SymbolTable_NulSym)
            {
              M2Error_WriteFormat0 ((const char *) "expecting an expression with the pragma 'bytealignment'", 55);
            }
          else
            {
              SymbolTable_PutAlignment (field, sym);
              seenAlignment = true;
            }
        }
      else
        {
          /* avoid dangling else.  */
          s = DynamicStrings_InitString ((const char *) "cannot use pragma '", 19);
          s = DynamicStrings_ConCat (s, DynamicStrings_Mark (DynamicStrings_InitStringCharStar (NameKey_KeyToCharStar (name))));
          s = DynamicStrings_ConCat (s, DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "' on record field {%1ad}", 24)));
          M2MetaError_MetaErrorString1 (s, field);
        }
      i += 1;
    }
  if (! seenAlignment && (defaultAlignment != SymbolTable_NulSym))
    {
      SymbolTable_PutAlignment (field, defaultAlignment);
    }
}


/*
   SaveRememberedConstructor -
*/

static void SaveRememberedConstructor (void)
{
}


/*
   GetSeenString - returns a string corresponding to, s.
*/

static DynamicStrings_String GetSeenString (M2Const_constType s)
{
  switch (s)
    {
      case M2Const_unknown:
        return DynamicStrings_InitString ((const char *) "unknown", 7);
        break;

      case M2Const_set:
        return DynamicStrings_InitString ((const char *) "SET", 3);
        break;

      case M2Const_str:
        return DynamicStrings_InitString ((const char *) "string", 6);
        break;

      case M2Const_constructor:
        return DynamicStrings_InitString ((const char *) "constructor", 11);
        break;

      case M2Const_array:
        return DynamicStrings_InitString ((const char *) "ARRAY", 5);
        break;

      case M2Const_cast:
        return DynamicStrings_InitStringCharStar (NameKey_KeyToCharStar (SymbolTable_GetSymName (castType)));
        break;

      case M2Const_boolean:
        return DynamicStrings_InitString ((const char *) "BOOLEAN", 7);
        break;

      case M2Const_ztype:
        return DynamicStrings_InitString ((const char *) "Z type", 6);
        break;

      case M2Const_rtype:
        return DynamicStrings_InitString ((const char *) "R type", 6);
        break;

      case M2Const_ctype:
        return DynamicStrings_InitString ((const char *) "C type", 6);
        break;

      case M2Const_procedure:
        return DynamicStrings_InitString ((const char *) "PROCEDURE", 9);
        break;


      default:
        M2Error_InternalError ((const char *) "unexpected value of type", 24);
        break;
    }
  return static_cast<DynamicStrings_String> (NULL);
  /* static analysis guarentees a RETURN statement will be used before here.  */
  __builtin_unreachable ();
}


/*
   SetTypeTo - attempts to set, type, to, s.
*/

static void SetTypeTo (M2Const_constType s)
{
  DynamicStrings_String s1;
  DynamicStrings_String s2;
  DynamicStrings_String s3;

  if (type == M2Const_unknown)
    {
      type = s;
    }
  /* leave it alone  */
  else if ((type == M2Const_constructor) && (s != M2Const_str))
    {
      /* avoid dangling else.  */
      type = s;
    }
  else if ((s == M2Const_constructor) && ((type == M2Const_array) || (type == M2Const_set)))
    {
      /* avoid dangling else.  */
    }
  else if (type != s)
    {
      /* avoid dangling else.  */
      s1 = GetSeenString (type);
      s2 = GetSeenString (s);
      s3 = FormatStrings_Sprintf2 (DynamicStrings_InitString ((const char *) "cannot create a %s constant together with a %s constant", 55), (const unsigned char *) &s1, (sizeof (s1)-1), (const unsigned char *) &s2, (sizeof (s2)-1));
      M2Error_ErrorStringAt (s3, M2LexBuf_GetTokenNo ());
      s1 = DynamicStrings_KillString (s1);
      s2 = DynamicStrings_KillString (s2);
    }
}


/*
   BlockStart - tokno is the module/procedure/implementation/definition token
*/

extern "C" void P2SymBuild_BlockStart (unsigned int tokno)
{
  PushBlock (tokno);
}


/*
   BlockEnd - declare module ctor/init/fini/dep procedures.
*/

extern "C" void P2SymBuild_BlockEnd (unsigned int tokno)
{
  curBeginTok = propageteTokenPosition (curStartTok, curBeginTok);
  curFinallyTok = propageteTokenPosition (tokno, curFinallyTok);
  M2Debug_Assert (curModuleSym != SymbolTable_NulSym);
  SymbolTable_MakeModuleCtor (curStartTok, curBeginTok, curFinallyTok, curModuleSym);
  PopBlock ();
}


/*
   BlockBegin - assign curBeginTok to tokno.
*/

extern "C" void P2SymBuild_BlockBegin (unsigned int tokno)
{
  curBeginTok = tokno;
}


/*
   BlockFinally - assign curFinallyTok to tokno.
*/

extern "C" void P2SymBuild_BlockFinally (unsigned int tokno)
{
  curFinallyTok = tokno;
}

extern "C" void P2SymBuild_P2StartBuildDefModule (void)
{
  NameKey_Name name;
  unsigned int ModuleSym;
  unsigned int tokno;

  /* 
   StartBuildDefinitionModule - Creates a definition module and starts
                                a new scope.

                                he Stack is expected:

                                Entry                 Exit

                         Ptr ->                                     <- Ptr
                                +------------+        +-----------+
                                | NameStart  |        | NameStart |
                                |------------|        |-----------|

  */
  M2Quads_PopTtok (&name, &tokno);
  ModuleSym = M2Batch_MakeDefinitionSource (tokno, name);
  curModuleSym = ModuleSym;
  SymbolTable_SetCurrentModule (ModuleSym);
  SymbolTable_SetFileModule (ModuleSym);
  SymbolTable_StartScope (ModuleSym);
  M2Debug_Assert (SymbolTable_IsDefImp (ModuleSym));
  M2Debug_Assert (M2Comp_CompilingDefinitionModule ());
  M2Quads_PushT (name);
  M2Quads_Annotate ((const char *) "%1n||definition module name", 27);
  M2Error_EnterDefinitionScope (name);
}

extern "C" void P2SymBuild_P2EndBuildDefModule (void)
{
  NameKey_Name NameStart;
  NameKey_Name NameEnd;

  /* 
   EndBuildDefinitionModule - Destroys the definition module scope and
                              checks for correct name.

                              The Stack is expected:

                              Entry                 Exit

                       Ptr ->
                              +------------+        +-----------+
                              | NameEnd    |        |           |
                              |------------|        |-----------|
                              | NameStart  |        |           | <- Ptr
                              |------------|        |-----------|
  */
  M2Debug_Assert (M2Comp_CompilingDefinitionModule ());
  SymbolTable_CheckForUndeclaredExports (SymbolTable_GetCurrentModule ());
  SymbolTable_EndScope ();
  M2Quads_PopT (&NameStart);
  M2Quads_PopT (&NameEnd);
  if (Debugging)
    {
      M2Printf_printf0 ((const char *) "pass 2: ", 8);
      SymbolTable_DisplayTrees (SymbolTable_GetCurrentModule ());
    }
  if (NameStart != NameEnd)
    {
      M2Error_WriteFormat2 ((const char *) "inconsistant definition module name, module began as (%a) and ended with (%a)", 77, (const unsigned char *) &NameStart, (sizeof (NameStart)-1), (const unsigned char *) &NameEnd, (sizeof (NameEnd)-1));
    }
  M2Error_LeaveErrorScope ();
}

extern "C" void P2SymBuild_P2StartBuildImplementationModule (void)
{
  NameKey_Name name;
  unsigned int ModuleSym;
  unsigned int tokno;

  /* 
   StartBuildImplementationModule - Creates an implementation module and starts
                                    a new scope.

                                    The Stack is expected:

                                    Entry                 Exit

                             Ptr ->                                     <- Ptr
                                    +------------+        +-----------+
                                    | NameStart  |        | NameStart |
                                    |------------|        |-----------|

  */
  M2Quads_PopTtok (&name, &tokno);
  ModuleSym = M2Batch_MakeImplementationSource (tokno, name);
  curModuleSym = ModuleSym;
  SymbolTable_SetCurrentModule (ModuleSym);
  SymbolTable_SetFileModule (ModuleSym);
  SymbolTable_StartScope (ModuleSym);
  M2Debug_Assert (SymbolTable_IsDefImp (ModuleSym));
  M2Debug_Assert (M2Comp_CompilingImplementationModule ());
  M2Quads_PushT (name);
  M2Quads_Annotate ((const char *) "%1n||implementation module name", 31);
  M2Error_EnterImplementationScope (name);
}

extern "C" void P2SymBuild_P2EndBuildImplementationModule (void)
{
  NameKey_Name NameStart;
  NameKey_Name NameEnd;

  /* 
   EndBuildImplementationModule - Destroys the implementation module scope and
                                  checks for correct name.

                                  The Stack is expected:

                                  Entry                 Exit

                           Ptr ->
                                  +------------+        +-----------+
                                  | NameEnd    |        |           |
                                  |------------|        |-----------|
                                  | NameStart  |        |           | <- Ptr
                                  |------------|        |-----------|
  */
  M2Debug_Assert (M2Comp_CompilingImplementationModule ());
  SymbolTable_CheckForUnImplementedExports ();
  SymbolTable_EndScope ();
  M2Quads_PopT (&NameStart);
  M2Quads_PopT (&NameEnd);
  if (NameStart != NameEnd)
    {
      M2Error_WriteFormat1 ((const char *) "inconsistant implementation module name %a", 42, (const unsigned char *) &NameStart, (sizeof (NameStart)-1));
    }
  M2Error_LeaveErrorScope ();
}

extern "C" void P2SymBuild_P2StartBuildProgramModule (void)
{
  NameKey_Name name;
  unsigned int ModuleSym;
  unsigned int tokno;

  /* 
   StartBuildProgramModule - Creates a program module and starts
                             a new scope.

                             The Stack is expected:

                             Entry                 Exit

                      Ptr ->                                     <- Ptr
                             +------------+        +-----------+
                             | NameStart  |        | NameStart |
                             |------------|        |-----------|

  */
  M2Quads_PopTtok (&name, &tokno);
  ModuleSym = M2Batch_MakeProgramSource (tokno, name);
  curModuleSym = ModuleSym;
  SymbolTable_SetCurrentModule (ModuleSym);
  SymbolTable_SetFileModule (ModuleSym);
  SymbolTable_StartScope (ModuleSym);
  M2Debug_Assert (M2Comp_CompilingProgramModule ());
  M2Debug_Assert (! (SymbolTable_IsDefImp (ModuleSym)));
  M2Quads_PushT (name);
  M2Quads_Annotate ((const char *) "%1n||program module name", 24);
  M2Error_EnterProgramScope (name);
}

extern "C" void P2SymBuild_P2EndBuildProgramModule (void)
{
  NameKey_Name NameStart;
  NameKey_Name NameEnd;

  /* 
   EndBuildProgramModule - Destroys the program module scope and
                           checks for correct name.

                           The Stack is expected:

                           Entry                 Exit

                    Ptr ->
                           +------------+        +-----------+
                           | NameEnd    |        |           |
                           |------------|        |-----------|
                           | NameStart  |        |           | <- Ptr
                           |------------|        |-----------|
  */
  M2Debug_Assert (M2Comp_CompilingProgramModule ());
  SymbolTable_CheckForUndeclaredExports (SymbolTable_GetCurrentModule ());  /* Not really allowed exports here though!  */
  SymbolTable_EndScope ();  /* Not really allowed exports here though!  */
  M2Quads_PopT (&NameStart);
  M2Quads_PopT (&NameEnd);
  if (Debugging)
    {
      M2Printf_printf0 ((const char *) "pass 2: ", 8);
      SymbolTable_DisplayTrees (SymbolTable_GetCurrentModule ());
    }
  if (NameStart != NameEnd)
    {
      M2Error_WriteFormat2 ((const char *) "inconsistant program module name %a does not match %a", 53, (const unsigned char *) &NameStart, (sizeof (NameStart)-1), (const unsigned char *) &NameEnd, (sizeof (NameEnd)-1));
    }
  M2Error_LeaveErrorScope ();
}


/*
   StartBuildInnerModule - Creates an Inner module and starts
                           a new scope.

                           The Stack is expected:

                           Entry                 Exit

                    Ptr ->                                     <- Ptr
                           +------------+        +-----------+
                           | NameStart  |        | NameStart |
                           |------------|        |-----------|

*/

extern "C" void P2SymBuild_StartBuildInnerModule (void)
{
  NameKey_Name name;
  unsigned int tok;
  unsigned int ModuleSym;

  M2Quads_PopTtok (&name, &tok);
  ModuleSym = SymbolTable_GetDeclareSym (tok, name);
  curModuleSym = ModuleSym;
  SymbolTable_StartScope (ModuleSym);
  M2Debug_Assert (! (SymbolTable_IsDefImp (ModuleSym)));
  M2Quads_PushTtok (name, tok);
  M2Quads_Annotate ((const char *) "%1n||inner module name", 22);
  M2Error_EnterModuleScope (name);
}


/*
   EndBuildInnerModule - Destroys the Inner module scope and
                         checks for correct name.

                         The Stack is expected:

                         Entry                 Exit

                  Ptr ->
                         +------------+        +-----------+
                         | NameEnd    |        |           |
                         |------------|        |-----------|
                         | NameStart  |        |           | <- Ptr
                         |------------|        |-----------|
*/

extern "C" void P2SymBuild_EndBuildInnerModule (void)
{
  NameKey_Name NameStart;
  NameKey_Name NameEnd;

  SymbolTable_CheckForUndeclaredExports (SymbolTable_GetCurrentModule ());
  SymbolTable_EndScope ();
  M2Quads_PopT (&NameStart);
  M2Quads_PopT (&NameEnd);
  if (NameStart != NameEnd)
    {
      M2Error_WriteFormat2 ((const char *) "inconsistant inner module name %a does not match %a", 51, (const unsigned char *) &NameStart, (sizeof (NameStart)-1), (const unsigned char *) &NameEnd, (sizeof (NameEnd)-1));
    }
  M2Error_LeaveErrorScope ();
}


/*
   BuildImportOuterModule - Builds imported identifiers into an outer module
                            from a definition module.

                            The Stack is expected:

                            Entry           OR    Entry

                     Ptr ->                Ptr ->
                            +------------+        +-----------+
                            | #          |        | #         |
                            |------------|        |-----------|
                            | Id1        |        | Id1       |
                            |------------|        |-----------|
                            .            .        .           .
                            .            .        .           .
                            .            .        .           .
                            |------------|        |-----------|
                            | Id#        |        | Id#       |
                            |------------|        |-----------|
                            | ImportTok  |        | Ident     |
                            |------------|        |-----------|

                            IMPORT Id1, .. Id# ;  FROM Ident IMPORT Id1 .. Id# ;


                            Exit

                            All above stack discarded
*/

extern "C" void P2SymBuild_BuildImportOuterModule (void)
{
  unsigned int Sym;
  unsigned int ModSym;
  unsigned int i;
  unsigned int n;

  M2Quads_PopT (&n);  /* n   = # of the Ident List  */
  if ((M2Quads_OperandT (n+1)) != M2Reserved_ImportTok)
    {
      /* Ident List contains list of objects imported from ModSym  */
      ModSym = M2Batch_LookupModule (M2Quads_OperandTok (n+1), M2Quads_OperandT (n+1));
      i = 1;
      while (i <= n)
        {
          Sym = SymbolTable_GetExported (M2Quads_OperandTok (i), ModSym, M2Quads_OperandT (i));
          SymbolTable_CheckForEnumerationInCurrentModule (Sym);
          i += 1;
        }
    }
  M2Quads_PopN (n+1);  /* clear stack  */
}


/*
   BuildExportOuterModule - Builds exported identifiers from an outer module
                            to the outside world of library modules.

                            The Stack is expected:

                            Entry           OR    Entry

                     Ptr ->                Ptr ->
                            +------------+        +--------------+
                            | #          |        | #            |
                            |------------|        |--------------|
                            | Id1        |        | Id1          |
                            |------------|        |--------------|
                            .            .        .              .
                            .            .        .              .
                            .            .        .              .
                            |------------|        |--------------|
                            | Id#        |        | Id#          |
                            |------------|        |--------------|
                            | ExportTok  |        | QualifiedTok |
                            |------------|        |--------------|

                            EXPORT Id1, .. Id# ;  EXPORT QUALIFIED Id1 .. Id# ;

                            Error Condition


                            Exit

                            All above stack discarded
*/

extern "C" void P2SymBuild_BuildExportOuterModule (void)
{
  unsigned int n;

  M2Quads_PopT (&n);  /* n   = # of the Ident List  */
  M2Quads_PopN (n+1);  /* n   = # of the Ident List  */
}


/*
   BuildImportInnerModule - Builds imported identifiers into an inner module
                            from the last level of module.

                            The Stack is expected:

                            Entry           OR    Entry

                     Ptr ->                Ptr ->
                            +------------+        +-----------+
                            | #          |        | #         |
                            |------------|        |-----------|
                            | Id1        |        | Id1       |
                            |------------|        |-----------|
                            .            .        .           .
                            .            .        .           .
                            .            .        .           .
                            |------------|        |-----------|
                            | Id#        |        | Id#       |
                            |------------|        |-----------|
                            | ImportTok  |        | Ident     |
                            |------------|        |-----------|

                            IMPORT Id1, .. Id# ;  FROM Ident IMPORT Id1 .. Id# ;

                            Exit

                            All above stack discarded
*/

extern "C" void P2SymBuild_BuildImportInnerModule (void)
{
  unsigned int Sym;
  unsigned int ModSym;
  unsigned int n;
  unsigned int i;

  M2Quads_PopT (&n);  /* i   = # of the Ident List  */
  if ((M2Quads_OperandT (n+1)) == M2Reserved_ImportTok)
    {
      /* Ident List contains list of objects  */
      i = 1;
      while (i <= n)
        {
          Sym = SymbolTable_GetFromOuterModule (M2Quads_OperandTok (i), M2Quads_OperandT (i));
          SymbolTable_CheckForEnumerationInCurrentModule (Sym);
          i += 1;
        }
    }
  else
    {
      /* Ident List contains list of objects from ModSym  */
      ModSym = M2Batch_LookupOuterModule (M2Quads_OperandTok (n+1), M2Quads_OperandT (n+1));
      i = 1;
      while (i <= n)
        {
          Sym = SymbolTable_GetExported (M2Quads_OperandTok (i), ModSym, M2Quads_OperandT (i));
          SymbolTable_CheckForEnumerationInCurrentModule (Sym);
          i += 1;
        }
    }
  M2Quads_PopN (n+1);  /* Clear Stack  */
}


/*
   BuildExportInnerModule - Builds exported identifiers from an inner module
                            to the next layer module.

                            The Stack is expected:

                            Entry           OR    Entry

                     Ptr ->                Ptr ->
                            +------------+        +--------------+
                            | #          |        | #            |
                            |------------|        |--------------|
                            | Id1        |        | Id1          |
                            |------------|        |--------------|
                            .            .        .              .
                            .            .        .              .
                            .            .        .              .
                            |------------|        |--------------|
                            | Id#        |        | Id#          |
                            |------------|        |--------------|
                            | ExportTok  |        | QualifiedTok |
                            |------------|        |--------------|

                            EXPORT Id1, .. Id# ;  EXPORT QUALIFIED Id1 .. Id# ;


                            Exit

                            All above stack discarded
*/

extern "C" void P2SymBuild_BuildExportInnerModule (void)
{
  unsigned int n;

  M2Quads_PopT (&n);
  M2Quads_PopN (n+1);  /* clear stack  */
}


/*
   BuildNumber - Converts a number into a symbol.


                 Stack

                 Entry                 Exit

          Ptr ->                                             <- Ptr
                 +------------+        +-------------------+
                 | Name | tok |        | Sym | Type | tok  |
                 |------------+        |-------------------|
*/

extern "C" void P2SymBuild_BuildNumber (void)
{
  NameKey_Name name;
  unsigned int Sym;
  unsigned int tok;

  M2Quads_PopTtok (&name, &tok);
  Sym = SymbolTable_MakeConstLit (tok, name, SymbolTable_NulSym);
  M2Quads_PushTFtok (Sym, SymbolTable_GetType (Sym), tok);
  M2Quads_Annotate ((const char *) "%1s(%1d)||constant number", 25);
}


/*
   BuildString - Converts a string into a symbol.


                 Stack

                 Entry                 Exit

          Ptr ->                                               <- Ptr
                 +-------------+        +--------------------+
                 | Name | | tok|        | Sym | NulSym | tok |
                 |-------------+        |--------------------|
*/

extern "C" void P2SymBuild_BuildString (void)
{
  NameKey_Name name;
  unsigned int Sym;
  unsigned int tok;

  M2Quads_PopTtok (&name, &tok);
  /* slice off the leading and trailing quotes  */
  if (name == 1140)
    {
      stop ();
    }
  Sym = SymbolTable_MakeConstLitString (tok, NameKey_makekey (DynamicStrings_string (DynamicStrings_Mark (DynamicStrings_Slice (DynamicStrings_Mark (DynamicStrings_InitStringCharStar (NameKey_KeyToCharStar (name))), 1, -1)))));
  M2Quads_PushTFtok (Sym, static_cast<unsigned int> (SymbolTable_NulSym), tok);
  M2Quads_Annotate ((const char *) "%1s(%1d)|%3d||constant string", 29);
}


/*
   BuildConst - builds a constant.
                Stack

                Entry                 Exit

         Ptr ->
                +------------+
                | Name       |
                |------------+                       <- Ptr
*/

extern "C" void P2SymBuild_BuildConst (void)
{
  NameKey_Name name;
  unsigned int sym;
  unsigned int tok;

  M2Quads_PopTtok (&name, &tok);
  sym = SymbolTable_MakeConstVar (tok, name);
  M2Quads_PushTtok (sym, tok);
  P2SymBuild_RememberConstant (sym);
  M2Quads_Annotate ((const char *) "%1s(%1d)|%3d||remembered constant", 33);
}


/*
   StartBuildEnumeration - Builds an Enumeration type Type.


                           Stack

                           Entry                 Exit

                    Ptr ->
                           +------------+
                           | #          |
                           |------------|
                           | en 1       |
                           |------------|
                           | en 2       |
                           |------------|
                           .            .
                           .            .
                           .            .                       <- Ptr
                           |------------|        +------------+
                           | en #       |        | Type       |
                           |------------|        |------------|
                           | Name       |        | Name       |
                           |------------|        |------------|
*/

extern "C" void P2SymBuild_StartBuildEnumeration (void)
{
  unsigned int n;
  unsigned int Type;
  unsigned int tok;

  M2Quads_PopT (&n);  /* n := #  */
  /* name is in OperandT(n+1) but we dont need it here.  */
  tok = static_cast<unsigned int> (M2Quads_OperandTok (n+1));
  FifoQueue_GetEnumerationFromFifoQueue (&Type);
  SymbolTable_CheckForExportedImplementation (Type);  /* May be an exported hidden type  */
  M2Quads_PopN (n);  /* May be an exported hidden type  */
  M2Quads_PushTtok (Type, tok);
  M2Quads_Annotate ((const char *) "%1s(%1d)|%3d||enumerated type", 29);
}


/*
   BuildSubrange - Builds a Subrange type Symbol, the base type can also be
                   supplied if known.

                      Stack

                      Entry                 Exit


                                                           <- Ptr
                                            +------------+
               Ptr ->                       | Type       |
                      +------------+        |------------|
                      | Name       |        | Name       |
                      |------------|        |------------|
*/

extern "C" void P2SymBuild_BuildSubrange (unsigned int Base)
{
  NameKey_Name name;
  unsigned int Type;
  unsigned int tok;

  M2Quads_PopTtok (&name, &tok);
  Type = SymbolTable_MakeSubrange (tok, name);
  FifoQueue_PutSubrangeIntoFifoQueue (Type);  /* Store Subrange away so that we can fill in  */
  /* its bounds during pass 3.  */
  FifoQueue_PutSubrangeIntoFifoQueue (Base);  /* store Base type of subrange away as well.  */
  SymbolTable_CheckForExportedImplementation (Type);  /* May be an exported hidden type  */
  M2Quads_PushTtok (name, tok);  /* May be an exported hidden type  */
  M2Quads_Annotate ((const char *) "%1n|%3d||subrange name|token no", 31);
  M2Quads_PushTtok (Type, tok);
  M2Quads_Annotate ((const char *) "%1s(%1d)|%3d||subrange type|token no", 36);
}


/*
   BuildAligned - builds an alignment constant symbol which is placed onto
                  the stack.  It expects the ident ALIGNED to be on the
                  stack.

                         Stack

                           Entry                 Exit


                  Ptr ->                                            <- Ptr
                         +---------------+      +-----------------+
                         | bytealignment |      | AlignmentConst  |
                         +---------------+      |-----------------|
*/

extern "C" void P2SymBuild_BuildAligned (void)
{
  unsigned int tok;
  NameKey_Name name;
  unsigned int align;

  M2Quads_PopTtok (&name, &tok);
  if (name == (NameKey_MakeKey ((const char *) "bytealignment", 13)))
    {
      align = SymbolTable_MakeTemporary (tok, SymbolTable_ImmediateValue);
      SymbolTable_PutConst (align, M2Base_ZType);
      FifoQueue_PutConstIntoFifoQueue (align);  /* Store align away so that we can fill in its  */
      M2Quads_PushT (align);  /* value during pass 3.  */
      M2Quads_Annotate ((const char *) "%1s(%1d)|%3d||bytealignment constant generated from <* *>|token no", 66);  /* value during pass 3.  */
      M2Quads_PushTtok (name, tok);
    }
  else
    {
      M2Error_WriteFormat1 ((const char *) "expecting bytealignment identifier, rather than %a", 50, (const unsigned char *) &name, (sizeof (name)-1));
      M2Quads_PushT (static_cast<unsigned int> (SymbolTable_NulSym));
    }
  M2Quads_Annotate ((const char *) "%1n(%1d)||bytealignment constant generated from <* *>", 53);
}


/*
   BuildVarAlignment - the AlignmentConst is either a temporary or NulSym.
                       A type may only have one alignment value and
                       error checking is performed.

                       Stack

                           Entry                 Exit


                   Ptr ->
                          +-----------------+
                          | AlignmentConst  |                             <- Ptr
                          |-----------------|        +------------------+
                          | Type            |        | Type  | TypeName |
                          |-----------------|        |------------------|
*/

extern "C" void P2SymBuild_BuildVarAlignment (void)
{
  unsigned int tokno;
  NameKey_Name alignment;
  NameKey_Name newname;
  unsigned int new_;
  unsigned int type;
  unsigned int align;
  DynamicStrings_String s;

  M2Quads_PopT (&alignment);
  if (alignment == (NameKey_MakeKey ((const char *) "bytealignment", 13)))
    {
      M2Quads_PopT (&align);
      M2Quads_PopTtok (&type, &tokno);
      if (((((SymbolTable_IsRecord (type)) || (SymbolTable_IsRecordField (type))) || (SymbolTable_IsType (type))) || (SymbolTable_IsArray (type))) || (SymbolTable_IsPointer (type)))
        {
          stop ();
          if (SymbolTable_IsNameAnonymous (type))
            {
              SymbolTable_PutAlignment (type, align);
              M2Quads_PushTFtok (type, SymbolTable_GetSymName (type), tokno);
              M2Quads_Annotate ((const char *) "%1s(%1d)|%2n|%3d||aligned type|aligned type name|token no", 57);
            }
          else
            {
              /* create a pseudonym  */
              s = FormatStrings_Sprintf1 (DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "_$A%d", 5)), (const unsigned char *) &alignTypeNo, (sizeof (alignTypeNo)-1));
              alignTypeNo += 1;
              newname = NameKey_makekey (DynamicStrings_string (s));
              if (SymbolTable_IsPointer (type))
                {
                  new_ = SymbolTable_MakePointer (tokno, newname);
                }
              else
                {
                  new_ = SymbolTable_MakeType (tokno, newname);
                }
              s = DynamicStrings_KillString (s);
              SymbolTable_PutType (new_, type);
              SymbolTable_PutAlignment (new_, align);
              M2Quads_PushTFtok (new_, SymbolTable_GetSymName (new_), tokno);
              M2Quads_Annotate ((const char *) "%1s(%1d)|%2n|%3d||aligned type|aligned type name", 48);
            }
        }
      else
        {
          M2MetaError_MetaError1 ((const char *) "not allowed to add an alignment attribute to type {%1ad}", 56, type);
          M2Quads_PushTFtok (type, SymbolTable_GetSymName (type), tokno);
          M2Quads_Annotate ((const char *) "%1s(%1d)|%2n|%3d||error aligned type|error aligned type name", 60);
        }
    }
  else if (alignment != NameKey_NulName)
    {
      /* avoid dangling else.  */
      M2Error_WriteFormat1 ((const char *) "unknown variable alignment attribute, %a", 40, (const unsigned char *) &alignment, (sizeof (alignment)-1));
    }
}


/*
   BuildTypeAlignment - the AlignmentConst is either a temporary or NulSym.
                        In the case of NulSym it is popped from the stack
                        and the procedure returns.  Otherwise the temporary
                        is popped and recorded as the alignment value for this
                        type.  A type may only have one alignment value and
                        error checking is performed.

                        Stack

                            Entry                 Exit


                    Ptr ->
                           +-----------------+
                           | AlignmentConst  |
                           |-----------------|
                           | Type            |    Empty
                           |-----------------|
*/

extern "C" void P2SymBuild_BuildTypeAlignment (void)
{
  NameKey_Name alignment;
  unsigned int type;
  unsigned int align;

  M2Quads_PopT (&alignment);
  if (alignment == (NameKey_MakeKey ((const char *) "bytealignment", 13)))
    {
      /* avoid dangling else.  */
      M2Quads_PopT (&align);
      M2Quads_PopT (&type);
      if (align != SymbolTable_NulSym)
        {
          /* avoid gcc warning by using compound statement even if not strictly necessary.  */
          if (((((SymbolTable_IsRecord (type)) || (SymbolTable_IsRecordField (type))) || (SymbolTable_IsType (type))) || (SymbolTable_IsArray (type))) || (SymbolTable_IsPointer (type)))
            {
              SymbolTable_PutAlignment (type, align);
            }
          else
            {
              M2MetaError_MetaError1 ((const char *) "not allowed to add an alignment attribute to type {%1ad}", 56, type);
            }
        }
    }
  else if (alignment != NameKey_NulName)
    {
      /* avoid dangling else.  */
      M2Error_WriteFormat1 ((const char *) "unknown type alignment attribute, %a", 36, (const unsigned char *) &alignment, (sizeof (alignment)-1));
    }
  else
    {
      /* avoid dangling else.  */
      M2Quads_PopT (&type);
    }
}

extern "C" void P2SymBuild_P2BuildDefaultFieldAlignment (void)
{
  unsigned int tok;
  NameKey_Name alignment;
  unsigned int align;

  /* 
   BuildDefaultFieldAlignment -

                 The Stack:

                 Entry                         Exit
                 =====                         ====


          Ptr ->
                 +-----------+
                 | Alignment |
                 |-----------|                 +-----------+
                 | RecordSym |                 | RecordSym |
                 |-----------|                 |-----------|
                 | Name      |                 | Name      |
                 |-----------|                 |-----------|

  */
  M2Quads_PopTtok (&alignment, &tok);
  align = SymbolTable_MakeTemporary (tok, SymbolTable_ImmediateValue);
  SymbolTable_PutConst (align, M2Base_ZType);
  FifoQueue_PutConstIntoFifoQueue (align);  /* store align away ready for pass 3  */
  SymbolTable_PutDefaultRecordFieldAlignment (M2Quads_OperandT (1), align);  /* store align away ready for pass 3  */
}


/*
   BuildPragmaConst - pushes a constant to the stack and stores it away into the
                      const fifo queue ready for pass 3.
*/

extern "C" void P2SymBuild_BuildPragmaConst (void)
{
  unsigned int value;

  value = SymbolTable_MakeTemporary (M2LexBuf_GetTokenNo (), SymbolTable_ImmediateValue);
  SymbolTable_PutConst (value, M2Base_ZType);
  FifoQueue_PutConstIntoFifoQueue (value);  /* Store value away so that we can fill it in  */
  M2Quads_PushT (value);  /* during pass 3.  */
  M2Quads_Annotate ((const char *) "%1s(%1d)||pragma constant", 25);  /* during pass 3.  */
}


/*
   BuildVariable - Builds variables listed in an IdentList with a Type.

                   Stack

                   Entry                 Exit

            Ptr ->
                   +------------+        +------------+
                   | Type | Name|        |            |
                   |------------|        |------------|
                   | #          |        |            |
                   |------------|        |------------|
                   | Ident 1    |        |            |
                   |------------|        |------------|
                   | Ident 2    |        |            |
                   |------------|        |------------|
                   .            .        .            .
                   .            .        .            .
                   .            .        .            .
                   |------------|        |------------|
                   | Ident #    |        |            | <- Ptr
                   |------------|        |------------|

                                           Empty
*/

extern "C" void P2SymBuild_BuildVariable (void)
{
  NameKey_Name name;
  unsigned int tok;
  unsigned int AtAddress;
  unsigned int Type;
  unsigned int Var;
  unsigned int i;
  unsigned int n;

  M2Quads_PopTF (&Type, &name);
  M2Quads_PopT (&n);
  i = 1;
  while (i <= n)
    {
      M2Students_CheckForVariableThatLooksLikeKeyword (M2Quads_OperandT ((n+1)-i));
      Var = SymbolTable_MakeVar (M2Quads_OperandTok ((n+1)-i), M2Quads_OperandT ((n+1)-i));
      AtAddress = static_cast<unsigned int> (M2Quads_OperandA ((n+1)-i));
      if (AtAddress != SymbolTable_NulSym)
        {
          SymbolTable_PutVariableAtAddress (Var, SymbolTable_NulSym);
          SymbolTable_PutMode (Var, SymbolTable_LeftValue);
        }
      SymbolTable_PutVar (Var, Type);
      tok = static_cast<unsigned int> (M2Quads_OperandTok ((n+1)-i));
      if (tok != M2LexBuf_UnknownTokenNo)
        {
          SymbolTable_PutDeclared (tok, Var);
          name = static_cast<NameKey_Name> (M2Quads_OperandT ((n+1)-i));
        }
      /* 
         l := TokenToLocation (tok) ;
         printf3 ('declaring variable %a at position %d location %d
      ', name, tok, l)
  */
      i += 1;
    }
  M2Quads_PopN (n);
}


/*
   BuildType - Builds a Type.


               Stack

               Entry                 Exit

        Ptr ->
               +------------+
               | Type       |                          <- Ptr
               |------------|        +---------------+
               | Name       |        | Type  | Name  |
               |------------|        |---------------|

                                     Empty
*/

extern "C" void P2SymBuild_BuildType (void)
{
  bool isunknown;
  NameKey_Name n1;
  NameKey_Name n2;
  unsigned int Sym;
  unsigned int Type;
  NameKey_Name name;
  unsigned int tokno;

  /* 
      Two cases

      - the type name the same as Name, or the name is nul. - do nothing.
      - when type with a name that is different to Name. In which case
        we create a new type.
  */
  M2Quads_PopTtok (&Type, &tokno);
  M2Quads_PopT (&name);
  if (Debugging)
    {
      n1 = SymbolTable_GetSymName (SymbolTable_GetCurrentModule ());
      M2Printf_printf2 ((const char *) "inside module %a declaring type name %a\\n", 41, (const unsigned char *) &n1, (sizeof (n1)-1), (const unsigned char *) &name, (sizeof (name)-1));
      if (! (SymbolTable_IsUnknown (Type)))
        {
          n1 = SymbolTable_GetSymName (SymbolTable_GetScope (Type));
          n2 = SymbolTable_GetSymName (Type);
          M2Printf_printf2 ((const char *) "type was created inside scope %a as name %a\\n", 45, (const unsigned char *) &n1, (sizeof (n1)-1), (const unsigned char *) &n2, (sizeof (n2)-1));
        }
    }
  if (name == NameKey_NulName)
    {
      /* WriteString('Blank name type') ; WriteLn ;  */
      M2Quads_PushTFtok (Type, name, tokno);
      M2Quads_Annotate ((const char *) "%1s(%1d)|%2n|%3d||type|type name|token no", 41);
    }
  else if (SymbolTable_IsError (Type))
    {
      /* avoid dangling else.  */
      M2Quads_PushTFtok (Type, name, tokno);
      M2Quads_Annotate ((const char *) "%1s(%1d)|%2n|%3d||error type|error type name|token no", 53);
    }
  else if ((SymbolTable_GetSymName (Type)) == name)
    {
      /* avoid dangling else.  */
      isunknown = SymbolTable_IsUnknown (Type);
      if (isunknown || (! (SymbolTable_IsDeclaredIn (SymbolTable_GetCurrentScope (), Type))))
        {
          Sym = SymbolTable_MakeType (tokno, name);
          if (! (SymbolTable_IsError (Sym)))
            {
              /* avoid gcc warning by using compound statement even if not strictly necessary.  */
              if (Sym == Type)
                {
                  if (isunknown)
                    {
                      M2MetaError_MetaError2 ((const char *) "attempting to declare a type {%1ad} to a type which is itself unknown {%2ad}", 76, Sym, Type);
                    }
                  else
                    {
                      M2MetaError_MetaError1 ((const char *) "attempting to declare a type {%1ad} as itself", 45, Sym);
                    }
                }
              else
                {
                  SymbolTable_PutType (Sym, Type);
                  SymbolTable_CheckForExportedImplementation (Sym);  /* May be an exported hidden type  */
                  /* if Type is an enumerated type then add its contents to the pseudo scope  */
                  SymbolTable_CheckForEnumerationInCurrentModule (Type);
                }
            }
          M2Quads_PushTFtok (Sym, name, tokno);
          M2Quads_Annotate ((const char *) "%1s(%1d)|%2n|%3d||type|type name|token no", 41);
        }
      else
        {
          M2Quads_PushTFtok (Type, name, tokno);
          M2Quads_Annotate ((const char *) "%1s(%1d)|%2n|%3d||type|type name|token no", 41);
        }
    }
  else
    {
      /* avoid dangling else.  */
      /* example   TYPE a = CARDINAL  */
      Sym = SymbolTable_MakeType (tokno, name);
      SymbolTable_PutType (Sym, Type);
      SymbolTable_CheckForExportedImplementation (Sym);  /* May be an exported hidden type  */
      M2Quads_PushTFtok (Sym, name, tokno);  /* May be an exported hidden type  */
      M2Quads_Annotate ((const char *) "%1s(%1d)|%2n|%3d||type|type name|token no", 41);
    }
}


/*
   StartBuildFormalParameters - Initialises the quadruple stack for
                                Formal Parameters.

                                The Stack:

                                Entry                Exit

                                                                    <- Ptr
                                                     +------------+
                                Empty                | 0          |
                                                     |------------|
*/

extern "C" void P2SymBuild_StartBuildFormalParameters (void)
{
  M2Quads_PushT (static_cast<unsigned int> (0));
}


/*
   EndBuildFormalParameters - Resets the quadruple stack after building
                              Formal Parameters.

                              The Stack:

                              Entry                    Exit

                       Ptr ->
                              +------------+
                              | NoOfParam  |                          <- Ptr
                              |------------|           +------------+
                              | ProcSym    |           | ProcSym    |
                              |------------|           |------------|
*/

extern "C" void P2SymBuild_EndBuildFormalParameters (void)
{
  NameKey_Name n;
  unsigned int NoOfPar;
  unsigned int ProcSym;

  M2Quads_PopT (&NoOfPar);
  M2Quads_PopT (&ProcSym);
  M2Quads_PushT (ProcSym);
  M2Debug_Assert (SymbolTable_IsProcedure (ProcSym));
  if ((SymbolTable_NoOfParam (ProcSym)) != NoOfPar)
    {
      n = SymbolTable_GetSymName (ProcSym);
      if (M2Comp_CompilingDefinitionModule ())
        {
          M2Error_WriteFormat1 ((const char *) "procedure (%a) was declared with fewer parameters in the DEFINITION MODULE", 74, (const unsigned char *) &n, (sizeof (n)-1));
        }
      else
        {
          M2Error_WriteFormat1 ((const char *) "procedure (%a) was declared with more parameters in the DEFINITION MODULE", 73, (const unsigned char *) &n, (sizeof (n)-1));
        }
    }
  M2Debug_Assert (SymbolTable_IsProcedure (M2Quads_OperandT (1)));
}


/*
   BuildProcedureHeading - Builds a procedure heading for the definition
                           module procedures.

                           Operation only performed if compiling a
                           definition module.

                           The Stack:

                           Entry                       Exit

                    Ptr ->
                           +------------+
                           | ProcSym    |
                           |------------|
                           | NameStart  |
                           |------------|
                                                       Empty

*/

extern "C" void P2SymBuild_BuildProcedureHeading (void)
{
  unsigned int ProcSym;
  NameKey_Name NameStart;

  if (M2Comp_CompilingDefinitionModule ())
    {
      M2Quads_PopT (&ProcSym);
      M2Debug_Assert (SymbolTable_IsProcedure (ProcSym));
      M2Quads_PopT (&NameStart);
      SymbolTable_EndScope ();
    }
}


/*
   BuildFunction - Builds a procedures return type.
                   Procedure becomes a function.

                    The Stack:

                    Entry                 Exit

             Ptr ->
                    +------------+
                    | TypeSym    |                       <- Ptr
                    |------------|        +------------+
                    | ProcSym    |        | ProcSym    |
                    |------------|        |------------|
*/

extern "C" void P2SymBuild_BuildFunction (void)
{
  unsigned int PrevSym;
  unsigned int TypeSym;
  unsigned int ProcSym;

  M2Quads_PopT (&TypeSym);
  M2Quads_PopT (&ProcSym);
  if ((SymbolTable_IsProcedure (ProcSym)) && (SymbolTable_AreProcedureParametersDefined (ProcSym)))
    {
      PrevSym = SymbolTable_GetType (ProcSym);
      if ((PrevSym != SymbolTable_NulSym) && (PrevSym != TypeSym))
        {
          /* avoid gcc warning by using compound statement even if not strictly necessary.  */
          if (M2Comp_CompilingDefinitionModule ())
            {
              M2MetaError_MetaErrorsT2 (SymbolTable_GetDeclaredDef (ProcSym), (const char *) "the return type for procedure {%1a} is defined differently in the definition module as {%1tad} and the implementation module as {%2ad}", 134, (const char *) "the return type for procedure {%1a} is defined differently in the definition module as {%1tad} and the implementation module as {%2ad}", 134, ProcSym, TypeSym);
            }
          else
            {
              M2MetaError_MetaErrorsT2 (SymbolTable_GetDeclaredMod (ProcSym), (const char *) "the return type for procedure {%1a} is defined differently in the definition module as {%2ad} and the implementation module as {%1tad}", 134, (const char *) "the return type for procedure {%1a} is defined differently in the definition module as {%2ad} and the implementation module as {%1tad}", 134, ProcSym, TypeSym);
            }
        }
    }
  SymbolTable_PutFunction (ProcSym, TypeSym);
  /* 
   WriteString('Procedure ') ; WriteKey(GetSymName(ProcSym)) ;
   WriteString(' has a return argument ') ;
   WriteKey(GetSymName(TypeSym)) ;
   WriteString(' checking ') ; WriteKey(GetSymName(GetType(ProcSym))) ;
   WriteLn ;
  */
  M2Quads_PushT (ProcSym);
}


/*
   BuildOptFunction - Builds a procedures optional return type.
                      Procedure becomes a function and the user
                      can either call it as a function or a procedure.

                      The Stack:

                      Entry                 Exit

               Ptr ->
                      +------------+
                      | TypeSym    |                       <- Ptr
                      |------------|        +------------+
                      | ProcSym    |        | ProcSym    |
                      |------------|        |------------|
*/

extern "C" void P2SymBuild_BuildOptFunction (void)
{
  unsigned int TypeSym;
  unsigned int ProcSym;

  M2Quads_PopT (&TypeSym);
  M2Quads_PopT (&ProcSym);
  SymbolTable_PutOptFunction (ProcSym, TypeSym);
  /* 
   WriteString('Procedure ') ; WriteKey(GetSymName(ProcSym)) ;
   WriteString(' has a return argument ') ;
   WriteKey(GetSymName(TypeSym)) ;
   WriteString(' checking ') ; WriteKey(GetSymName(GetType(ProcSym))) ;
   WriteLn ;
  */
  M2Quads_PushT (ProcSym);
}


/*
   BuildFPSection - Builds a Formal Parameter in a procedure.

                    The Stack:

                    Entry                 Exit

             Ptr ->
                    +------------+
                    | ParamTotal |
                    |------------|
                    | TypeSym    |
                    |------------|
                    | Array/Nul  |
                    |------------|
                    | NoOfIds    |
                    |------------|
                    | Id 1       |
                    |------------|
                    .            .
                    .            .
                    .            .
                    |------------|
                    | Id n       |                       <- Ptr
                    |------------|        +------------+
                    | Var / Nul  |        | ParamTotal |
                    |------------|        |------------|
                    | ProcSym    |        | ProcSym    |
                    |------------|        |------------|
*/

extern "C" void P2SymBuild_BuildFPSection (void)
{
  NameKey_Name n;
  unsigned int ProcSym;
  unsigned int ParamTotal;

  M2Quads_PopT (&ParamTotal);
  ProcSym = (unsigned int ) (M2Quads_OperandT ((3+((unsigned int ) (M2Quads_OperandT (3))))+2));
  M2Quads_PushT (ParamTotal);
  M2Debug_Assert (SymbolTable_IsProcedure (ProcSym));
  if (M2Comp_CompilingDefinitionModule ())
    {
      /* avoid dangling else.  */
      if ((SymbolTable_AreParametersDefinedInDefinition (ProcSym)) && (ParamTotal == 0))
        {
          n = SymbolTable_GetSymName (ProcSym);
          M2Error_WriteFormat1 ((const char *) "cannot declare procedure %a twice in the definition module", 58, (const unsigned char *) &n, (sizeof (n)-1));
        }
      else if (SymbolTable_AreParametersDefinedInImplementation (ProcSym))
        {
          /* avoid dangling else.  */
          CheckFormalParameterSection ();
        }
      else
        {
          /* avoid dangling else.  */
          BuildFormalParameterSection ();
          if (ParamTotal == 0)
            {
              SymbolTable_ParametersDefinedInDefinition (ProcSym);
              SymbolTable_ProcedureParametersDefined (ProcSym);
            }
        }
    }
  else if (M2Comp_CompilingImplementationModule ())
    {
      /* avoid dangling else.  */
      if ((SymbolTable_AreParametersDefinedInImplementation (ProcSym)) && (ParamTotal == 0))
        {
          n = SymbolTable_GetSymName (ProcSym);
          M2Error_WriteFormat1 ((const char *) "cannot declare procedure %a twice in the implementation module", 62, (const unsigned char *) &n, (sizeof (n)-1));
        }
      else if (SymbolTable_AreParametersDefinedInDefinition (ProcSym))
        {
          /* avoid dangling else.  */
          CheckFormalParameterSection ();
        }
      else
        {
          /* avoid dangling else.  */
          BuildFormalParameterSection ();
          if (ParamTotal == 0)
            {
              SymbolTable_ParametersDefinedInImplementation (ProcSym);
              SymbolTable_ProcedureParametersDefined (ProcSym);
            }
        }
    }
  else if (M2Comp_CompilingProgramModule ())
    {
      /* avoid dangling else.  */
      if ((SymbolTable_AreProcedureParametersDefined (ProcSym)) && (ParamTotal == 0))
        {
          n = SymbolTable_GetSymName (ProcSym);
          M2Error_WriteFormat1 ((const char *) "procedure %a parameters already declared in program module", 58, (const unsigned char *) &n, (sizeof (n)-1));
        }
      else
        {
          BuildFormalParameterSection ();
          if (ParamTotal == 0)
            {
              SymbolTable_ProcedureParametersDefined (ProcSym);
            }
        }
    }
  else
    {
      /* avoid dangling else.  */
      M2Error_InternalError ((const char *) "should never reach this point", 29);
    }
  M2Debug_Assert (SymbolTable_IsProcedure (M2Quads_OperandT (2)));
}


/*
   BuildVarArgs - indicates that the ProcSym takes varargs
                  after ParamTotal.
                                                         <- Ptr
                    +------------+        +------------+
                    | ParamTotal |        | ParamTotal |
                    |------------|        |------------|
                    | ProcSym    |        | ProcSym    |
                    |------------|        |------------|

*/

extern "C" void P2SymBuild_BuildVarArgs (void)
{
  unsigned int ProcSym;
  unsigned int ParamTotal;

  M2Quads_PopT (&ParamTotal);
  M2Quads_PopT (&ProcSym);
  if (SymbolTable_UsesOptArg (ProcSym))
    {
      M2Error_WriteFormat0 ((const char *) "procedure can use either a single optional argument or a single vararg section ... at the end of the formal parameter list", 122);
    }
  if (SymbolTable_UsesVarArgs (ProcSym))
    {
      M2Error_WriteFormat0 ((const char *) "procedure can only have one vararg section ... at the end of the formal parameter list", 86);
    }
  SymbolTable_PutUseVarArgs (ProcSym);
  if (SymbolTable_IsDefImp (SymbolTable_GetCurrentModule ()))
    {
      /* avoid dangling else.  */
      if (! (SymbolTable_IsDefinitionForC (SymbolTable_GetCurrentModule ())))
        {
          M2Error_WriteFormat0 ((const char *) "the definition module must be declared as DEFINITION MODULE FOR \"C\" if varargs are to be used", 93);
        }
    }
  else
    {
      M2Error_WriteFormat0 ((const char *) "varargs can only be used in the module declared as DEFINITION MODULE FOR \"C\"", 76);
    }
  M2Quads_PushT (ProcSym);
  M2Quads_PushT (ParamTotal);
}


/*
   BuildFormalVarArgs - indicates that the procedure type takes varargs.

                                                             <- Ptr
                        +------------+        +------------+
                        | ProcSym    |        | ProcSym    |
                        |------------|        |------------|

*/

extern "C" void P2SymBuild_BuildFormalVarArgs (void)
{
  unsigned int ProcSym;

  M2Quads_PopT (&ProcSym);
  if (SymbolTable_UsesVarArgs (ProcSym))
    {
      M2Error_WriteFormat0 ((const char *) "procedure type can only have one vararg section ... at the end of the formal parameter list", 91);
    }
  SymbolTable_PutUseVarArgs (ProcSym);
  if (SymbolTable_IsDefImp (SymbolTable_GetCurrentModule ()))
    {
      /* avoid dangling else.  */
      if (! (SymbolTable_IsDefinitionForC (SymbolTable_GetCurrentModule ())))
        {
          M2Error_WriteFormat0 ((const char *) "the definition module must be declared as DEFINITION MODULE FOR \"C\" if varargs are to be used", 93);
        }
    }
  else
    {
      M2Error_WriteFormat0 ((const char *) "varargs can only be used in the module declared as DEFINITION MODULE FOR \"C\"", 76);
    }
  M2Quads_PushT (ProcSym);
}


/*
   BuildOptArg - indicates that the ProcSym takes a single optarg
                 after ParamTotal.

                                                         <- Ptr
                 +------------+        +------------+
                 | ParamTotal |        | ParamTotal |
                 |------------|        |------------|
                 | ProcSym    |        | ProcSym    |
                 |------------|        |------------|
*/

extern "C" void P2SymBuild_BuildOptArg (void)
{
  unsigned int ProcSym;
  unsigned int ParamTotal;

  M2Quads_PopT (&ParamTotal);
  M2Quads_PopT (&ProcSym);
  if (SymbolTable_UsesVarArgs (ProcSym))
    {
      M2Error_WriteFormat0 ((const char *) "procedure can not use an optional argument after a vararg ...", 61);
    }
  SymbolTable_PutUseOptArg (ProcSym);
  M2Quads_PushT (ProcSym);
  M2Quads_PushT (ParamTotal);
}


/*
   StartBuildProcedure - Builds a Procedure.

                         The Stack:

                         Entry                 Exit

                                                              <- Ptr
                                               +------------+
                  Ptr ->                       | ProcSym    |
                         +------------+        |------------|
                         | Name       |        | Name       |
                         |------------|        |------------|
*/

extern "C" void P2SymBuild_StartBuildProcedure (void)
{
  NameKey_Name name;
  unsigned int ProcSym;
  unsigned int tokno;

  M2Quads_PopTtok (&name, &tokno);
  M2Quads_PushTtok (name, tokno);  /* name saved for the EndBuildProcedure name check  */
  ProcSym = SymbolTable_GetDeclareSym (tokno, name);  /* name saved for the EndBuildProcedure name check  */
  if (SymbolTable_IsUnknown (ProcSym))
    {
      /* 
         May have been compiled in the definition or implementation module,
         remember that implementation maybe compiled before corresponding
         definition module.
         - no definition should always be compilied before implementation modules.
  */
      ProcSym = SymbolTable_MakeProcedure (tokno, name);
    }
  else if (SymbolTable_IsProcedure (ProcSym))
    {
      /* avoid dangling else.  */
      SymbolTable_PutDeclared (tokno, ProcSym);
    }
  else
    {
      /* avoid dangling else.  */
      M2Error_ErrorStringAt2 (FormatStrings_Sprintf1 (DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "procedure name (%a) has been declared as another object elsewhere", 65)), (const unsigned char *) &name, (sizeof (name)-1)), tokno, SymbolTable_GetDeclaredMod (ProcSym));
    }
  if (M2Comp_CompilingDefinitionModule ())
    {
      SymbolTable_PutExportUnImplemented (tokno, ProcSym);  /* Defined but not yet implemented  */
    }
  else
    {
      SymbolTable_CheckForExportedImplementation (ProcSym);  /* May be exported procedure  */
    }
  M2Quads_PushTtok (ProcSym, tokno);
  M2Quads_Annotate ((const char *) "%1s(%1d)||procedure start symbol", 32);
  SymbolTable_StartScope (ProcSym);
  M2Error_EnterProcedureScope (name);
}


/*
   EndBuildProcedure - Ends building a Procedure.
                       It checks the start procedure name matches the end
                       procedure name.

                       The Stack:

                       (Procedure Not Defined in definition module)

                       Entry                 Exit

                Ptr ->
                       +------------+
                       | NameEnd    |
                       |------------|
                       | ProcSym    |
                       |------------|
                       | NameStart  |
                       |------------|
                                             Empty
*/

extern "C" void P2SymBuild_EndBuildProcedure (void)
{
  NameKey_Name NameEnd;
  NameKey_Name NameStart;
  unsigned int ProcSym;

  M2Quads_PopT (&NameEnd);
  M2Quads_PopT (&ProcSym);
  M2Debug_Assert (SymbolTable_IsProcedure (ProcSym));
  M2Quads_PopT (&NameStart);
  if (NameEnd != NameStart)
    {
      M2Error_WriteFormat2 ((const char *) "end procedure name does not match beginning %a name %a", 54, (const unsigned char *) &NameStart, (sizeof (NameStart)-1), (const unsigned char *) &NameEnd, (sizeof (NameEnd)-1));
    }
  SymbolTable_EndScope ();
  M2Error_LeaveErrorScope ();
}


/*
   BuildNoReturnAttribute - provide an interface to the symbol table module.
*/

extern "C" void P2SymBuild_BuildNoReturnAttribute (unsigned int procedureSym)
{
  M2Debug_Assert (SymbolTable_IsProcedure (procedureSym));
  SymbolTable_PutProcedureNoReturn (procedureSym, true);
}


/*
   BuildPointerType - builds a pointer type.
                      The Stack:

                      Entry                       Exit
                      =====                       ====


               Ptr ->                                             <- Ptr
                      +------------+              +-------------+
                      | Type       |              | PointerType |
                      |------------|              |-------------|
                      | Name       |              | Name        |
                      |------------|              |-------------|
*/

extern "C" void P2SymBuild_BuildPointerType (void)
{
  unsigned int tok;
  NameKey_Name name;
  unsigned int Type;
  unsigned int PtrToType;

  M2Quads_PopTtok (&Type, &tok);
  M2Quads_PopT (&name);
  name = SymbolTable_CheckAnonymous (name);
  PtrToType = SymbolTable_MakePointer (tok, name);
  SymbolTable_PutPointer (PtrToType, Type);
  SymbolTable_CheckForExportedImplementation (PtrToType);  /* May be an exported hidden type  */
  M2Quads_PushTtok (name, tok);  /* May be an exported hidden type  */
  M2Quads_Annotate ((const char *) "%1n|%3d||pointer type name", 26);
  M2Quads_PushTtok (PtrToType, tok);
  M2Quads_Annotate ((const char *) "%1s(%1d)|%3d||pointer type", 26);
}


/*
   BuildSetType - builds a set type.
                  The Stack:

                  Entry                       Exit
                  =====                       ====


           Ptr ->                                             <- Ptr
                  +------------+              +-------------+
                  | Type       |              | SetType     |
                  |------------|              |-------------|
                  | Name       |              | Name        |
                  |------------|              |-------------|
*/

extern "C" void P2SymBuild_BuildSetType (bool ispacked)
{
  unsigned int tok;
  NameKey_Name name;
  unsigned int Type;
  unsigned int SetType;

  M2Quads_PopTtok (&Type, &tok);
  M2Quads_PopT (&name);
  SetType = SymbolTable_MakeSet (tok, name);
  SymbolTable_CheckForExportedImplementation (SetType);  /* May be an exported hidden type  */
  SymbolTable_PutSet (SetType, Type, ispacked);  /* May be an exported hidden type  */
  M2Quads_PushT (name);
  M2Quads_Annotate ((const char *) "%1n||set type name", 18);
  M2Quads_PushTtok (SetType, tok);
  M2Quads_Annotate ((const char *) "%1s(%1d)|%3d||set type|token no", 31);
}


/*
   BuildRecord - Builds a record type.
                 The Stack:

                 Entry                              Exit
                 =====                              ====


                                                                  <- Ptr
                                                    +-----------+
          Ptr ->                                    | RecordSym |
                 +------------------+               |-----------|
                 | Name             |               | Name      |
                 |------------------|               |-----------|
*/

extern "C" void P2SymBuild_BuildRecord (void)
{
  unsigned int tokno;
  NameKey_Name name;
  unsigned int RecordType;

  name = static_cast<NameKey_Name> (M2Quads_OperandT (1));
  name = SymbolTable_CheckAnonymous (name);
  tokno = static_cast<unsigned int> (M2Quads_OperandTok (1));
  RecordType = SymbolTable_MakeRecord (tokno, name);
  SymbolTable_CheckForExportedImplementation (RecordType);  /* May be an exported hidden type  */
  M2Quads_PushT (RecordType);
  /* ; WriteKey(name) ; WriteString(' RECORD made') ; WriteLn  */
  M2Quads_Annotate ((const char *) "%1s(%1d)||record type", 21);
}


/*
   BuildFieldRecord - Builds a field into a record sym.
                      The Stack:


                      Entry                     Exit
                      =====                     ====

               Ptr ->
                      +-------------+
                      | NoOfPragmas |
                      |-------------|
                      | Const1      |
                      |-------------|
                      | PragmaName1 |
                      |-------------|
                      | Type | Name |
                      |-------------|
                      | n           |
                      |-------------|
                      | Id 1        |
                      |-------------|
                      .             .
                      .             .
                      .             .
                      |-------------|
                      | Id n        |                           <- Ptr
                      |-------------|           +-------------+
                      | RecordSym   |           | RecordSym   |
                      |-------------|           |-------------|
                      | RecordName  |           | RecordName  |
                      |-------------|           |-------------|
*/

extern "C" void P2SymBuild_BuildFieldRecord (void)
{
  NameKey_Name n1;
  unsigned int tok;
  unsigned int fsym;
  unsigned int Field;
  unsigned int Varient;
  unsigned int Parent;
  unsigned int Type;
  unsigned int NoOfPragmas;
  unsigned int NoOfFields;
  unsigned int Record;
  unsigned int i;

  M2Quads_PopT (&NoOfPragmas);
  Type = static_cast<unsigned int> (M2Quads_OperandT ((NoOfPragmas*2)+1));
  /* name := OperandF(NoOfPragmas*2+1) ;  */
  NoOfFields = static_cast<unsigned int> (M2Quads_OperandT ((NoOfPragmas*2)+2));
  Record = static_cast<unsigned int> (M2Quads_OperandT (((NoOfPragmas*2)+NoOfFields)+3));
  if (SymbolTable_IsRecord (Record))
    {
      Parent = Record;
      Varient = SymbolTable_NulSym;
    }
  else
    {
      /* Record maybe FieldVarient  */
      Parent = SymbolTable_GetRecord (SymbolTable_GetParent (Record));
      M2Debug_Assert (SymbolTable_IsFieldVarient (Record));
      Varient = static_cast<unsigned int> (M2Quads_OperandT (((NoOfPragmas*2)+NoOfFields)+4));
      M2Debug_Assert (SymbolTable_IsVarient (Varient));
      SymbolTable_PutFieldVarient (Record, Varient);
      if (Debugging)
        {
          n1 = SymbolTable_GetSymName (Record);
          StrIO_WriteString ((const char *) "Record ", 7);
          NameKey_WriteKey (n1);
          StrIO_WriteString ((const char *) " has varient ", 13);
          n1 = SymbolTable_GetSymName (Varient);
          NameKey_WriteKey (n1);
          StrIO_WriteLn ();
        }
    }
  Field = SymbolTable_NulSym;
  i = 1;
  while (i <= NoOfFields)
    {
      if (Debugging)
        {
          n1 = SymbolTable_GetSymName (Record);
          StrIO_WriteString ((const char *) "Record ", 7);
          NameKey_WriteKey (n1);
          StrIO_WriteString ((const char *) "  ", 2);
          NameKey_WriteKey (M2Quads_OperandT ((((NoOfPragmas*2)+NoOfFields)+3)-i));
          StrIO_WriteString ((const char *) " is a Field with type ", 22);
          NameKey_WriteKey (SymbolTable_GetSymName (Type));
          StrIO_WriteLn ();
        }
      fsym = SymbolTable_GetLocalSym (Parent, M2Quads_OperandT ((((NoOfPragmas*2)+NoOfFields)+3)-i));
      if (fsym == SymbolTable_NulSym)
        {
          Field = SymbolTable_PutFieldRecord (Record, M2Quads_OperandT ((((NoOfPragmas*2)+NoOfFields)+3)-i), Type, Varient);
          HandleRecordFieldPragmas (Record, Field, NoOfPragmas);
        }
      else
        {
          M2MetaError_MetaErrors2 ((const char *) "record field {%1ad} has already been declared inside a {%2Dd} {%2a}", 67, (const char *) "attempting to declare a duplicate record field", 46, fsym, Parent);
        }
      /* adjust the location of declaration to the one on the stack (rather than GetTokenNo).  */
      tok = static_cast<unsigned int> (M2Quads_OperandTok ((((NoOfPragmas*2)+NoOfFields)+3)-i));
      if ((tok != M2LexBuf_UnknownTokenNo) && (Field != SymbolTable_NulSym))
        {
          SymbolTable_PutDeclared (tok, Field);
        }
      i += 1;
    }
  M2Quads_PopN (((NoOfPragmas*2)+NoOfFields)+3);
  M2Quads_PushT (Record);
  if (SymbolTable_IsRecord (Record))
    {
      M2Quads_Annotate ((const char *) "%1s(%1d)||record type", 21);
    }
  else
    {
      M2Debug_Assert (SymbolTable_IsFieldVarient (Record));
      M2Quads_Annotate ((const char *) "%1s(%1d)||varient field type", 28);
    }
}


/*
   StartBuildVarient - Builds a varient symbol on top of a record sym.
                       The Stack:


                       Entry                     Exit
                       =====                     ====

                                                                 <- Ptr
                                                 +-------------+
                Ptr ->                           | VarientSym  |
                       +-------------+           |-------------|
                       | RecordSym   |           | RecordSym   |
                       |-------------|           |-------------|
                       | RecordName  |           | RecordName  |
                       |-------------|           |-------------|
*/

extern "C" void P2SymBuild_StartBuildVarient (void)
{
  unsigned int tokno;
  unsigned int RecordSym;
  unsigned int Sym;

  RecordSym = static_cast<unsigned int> (M2Quads_OperandT (1));
  tokno = static_cast<unsigned int> (M2Quads_OperandTok (1));
  Sym = SymbolTable_MakeVarient (tokno, RecordSym);
  M2Quads_PushT (Sym);
  M2Quads_Annotate ((const char *) "%1s(%1d)||varient type", 22);
}


/*
   EndBuildVarient - Removes the varient symbol from the stack.
                     The Stack:

                     Entry                     Exit
                     =====                     ====

              Ptr ->
                     +-------------+
                     | VarientSym  |                           <- Ptr
                     |-------------|           +-------------+
                     | RecordSym   |           | RecordSym   |
                     |-------------|           |-------------|
                     | RecordName  |           | RecordName  |
                     |-------------|           |-------------|
*/

extern "C" void P2SymBuild_EndBuildVarient (void)
{
  unsigned int Sym;

  M2Quads_PopT (&Sym);
}


/*
   BuildVarientSelector - Builds a field into a record sym.
                          The Stack:


                          Entry                     Exit
                          =====                     ====

                   Ptr ->
                          +-------------+
                          | Type        |
                          |-------------|
                          | Tag         |                           <- Ptr
                          |-------------|           +-------------+
                          | RecordSym   |           | RecordSym   |
                          |-------------|           |-------------|
*/

extern "C" void P2SymBuild_BuildVarientSelector (void)
{
  unsigned int tagtok;
  NameKey_Name tag;
  unsigned int Field;
  unsigned int Type;
  unsigned int Varient;
  unsigned int VarField;
  unsigned int Record;

  M2Quads_PopT (&Type);
  M2Quads_PopTtok (&tag, &tagtok);
  Record = static_cast<unsigned int> (M2Quads_OperandT (1));
  if (SymbolTable_IsRecord (Record))
    {
      Varient = SymbolTable_NulSym;
      M2Error_InternalError ((const char *) "not expecting a record symbol", 29);
    }
  else if (SymbolTable_IsVarient (Record))
    {
      /* avoid dangling else.  */
      Varient = Record;
      VarField = SymbolTable_GetParent (Varient);
      if ((Type == SymbolTable_NulSym) && (tag == NameKey_NulName))
        {
          M2MetaError_MetaError1 ((const char *) "expecting a tag field in the declaration of a varient record {%1Ua}", 67, Record);
        }
      else if (Type == SymbolTable_NulSym)
        {
          /* avoid dangling else.  */
          SymbolTable_PutVarientTag (Varient, SymbolTable_RequestSym (tagtok, tag));
        }
      else
        {
          /* avoid dangling else.  */
          Field = SymbolTable_PutFieldRecord (VarField, tag, Type, Varient);
          SymbolTable_PutVarientTag (Varient, Field);
          if (Debugging)
            {
              StrIO_WriteString ((const char *) "varient field ", 14);
              NameKey_WriteKey (SymbolTable_GetSymName (VarField));
              StrIO_WriteString ((const char *) "varient ", 8);
              NameKey_WriteKey (SymbolTable_GetSymName (Varient));
              StrIO_WriteLn ();
            }
        }
    }
  else
    {
      /* avoid dangling else.  */
      /* Record maybe FieldVarient  */
      M2Debug_Assert (SymbolTable_IsFieldVarient (Record));
      Varient = static_cast<unsigned int> (M2Quads_OperandT (1+2));
      M2Debug_Assert (SymbolTable_IsVarient (Varient));
      SymbolTable_PutFieldVarient (Record, Varient);
      if (Debugging)
        {
          StrIO_WriteString ((const char *) "record ", 7);
          NameKey_WriteKey (SymbolTable_GetSymName (Record));
          StrIO_WriteString ((const char *) "varient ", 8);
          NameKey_WriteKey (SymbolTable_GetSymName (Varient));
          StrIO_WriteLn ();
        }
      if ((Type == SymbolTable_NulSym) && (tag == NameKey_NulName))
        {
          M2MetaError_MetaError1 ((const char *) "expecting a tag field in the declaration of a varient record {%1Ua}", 67, Record);
        }
      else if (Type == SymbolTable_NulSym)
        {
          /* avoid dangling else.  */
          SymbolTable_PutVarientTag (Varient, SymbolTable_RequestSym (tagtok, tag));
        }
      else
        {
          /* avoid dangling else.  */
          Field = SymbolTable_PutFieldRecord (Record, tag, Type, Varient);
          SymbolTable_PutVarientTag (Varient, Field);
          if (Debugging)
            {
              StrIO_WriteString ((const char *) "record ", 7);
              NameKey_WriteKey (SymbolTable_GetSymName (Record));
              StrIO_WriteString ((const char *) "varient ", 8);
              NameKey_WriteKey (SymbolTable_GetSymName (Varient));
              StrIO_WriteLn ();
            }
        }
    }
}


/*
   StartBuildVarientFieldRecord - Builds a varient field into a varient sym.
                                  The Stack:


                                  Entry                     Exit
                                  =====                     ====

                                                                       <- Ptr
                                                       +-------------+
                      Ptr ->                           | VarientField|
                             +-------------+           |-------------|
                             | VarientSym  |           | VarientSym  |
                             |-------------|           |-------------|
*/

extern "C" void P2SymBuild_StartBuildVarientFieldRecord (void)
{
  unsigned int VarientSym;
  unsigned int FieldSym;

  VarientSym = static_cast<unsigned int> (M2Quads_OperandT (1));
  FieldSym = SymbolTable_MakeFieldVarient (SymbolTable_CheckAnonymous (NameKey_NulName), VarientSym);
  M2Quads_Annotate ((const char *) "%1s(%1d)||varient sym", 21);
  M2Quads_PushT (FieldSym);
  M2Quads_Annotate ((const char *) "%1s(%1d)||varient field type", 28);
  M2Debug_Assert (SymbolTable_IsFieldVarient (FieldSym));
  SymbolTable_PutFieldVarient (FieldSym, VarientSym);
  M2Quads_AddVarientFieldToList (FieldSym);
}


/*
   EndBuildVarientFieldRecord - Removes a varient field from the stack.
                                The Stack:


                                Entry                     Exit
                                =====                     ====

                         Ptr ->
                                +-------------+
                                | VarientField|                           <- Ptr
                                |-------------|           +-------------+
                                | VarientSym  |           | VarientSym  |
                                |-------------|           |-------------|
*/

extern "C" void P2SymBuild_EndBuildVarientFieldRecord (void)
{
  unsigned int FieldSym;

  M2Quads_PopT (&FieldSym);
}


/*
   BuildNulName - Pushes a NulName onto the top of the stack.
                  The Stack:


                  Entry                    Exit

                                                          <- Ptr
                  Empty                    +------------+
                                           | NulName   |
                                           |------------|
*/

extern "C" void P2SymBuild_BuildNulName (void)
{
  M2Quads_PushTtok (static_cast<unsigned int> (NameKey_NulName), M2LexBuf_GetTokenNo ());
  M2Quads_Annotate ((const char *) "%1n|%3d||NulName|token no", 25);
}


/*
   BuildTypeEnd - Pops the type Type and Name.
                  The Stack:


                  Entry                    Exit


           Ptr ->
                  +-------------+
                  | Type | Name |          Empty
                  |-------------|
*/

extern "C" void P2SymBuild_BuildTypeEnd (void)
{
  unsigned int Type;
  NameKey_Name name;

  M2Quads_PopTF (&Type, &name);
}


/*
   StartBuildArray - Builds an array type.
                     The Stack:

                     Entry                        Exit
                     =====                        ====

                                                                <- Ptr
                                                  +-----------+
              Ptr ->                              | ArraySym  |
                     +------------+               |-----------|
                     | Name       |               | Name      |
                     |------------|               |-----------|
*/

extern "C" void P2SymBuild_StartBuildArray (void)
{
  unsigned int tok;
  NameKey_Name name;
  unsigned int ArrayType;

  name = static_cast<NameKey_Name> (M2Quads_OperandT (1));
  tok = static_cast<unsigned int> (M2Quads_OperandTok (1));
  ArrayType = SymbolTable_MakeArray (tok, name);
  SymbolTable_CheckForExportedImplementation (ArrayType);  /* May be an exported hidden type  */
  M2Quads_PushTtok (ArrayType, tok);  /* May be an exported hidden type  */
  /* ; WriteKey(Name) ; WriteString(' ARRAY made') ; WriteLn  */
  M2Quads_Annotate ((const char *) "%1s(%1d)|%3d||array type|token no", 33);
}


/*
   EndBuildArray - Builds an array type.
                   The Stack:

                   Entry                        Exit
                   =====                        ====

            Ptr ->
                   +------------+
                   | TypeSym    |                              <- Ptr
                   |------------|               +------------+
                   | ArraySym   |               | ArraySym   |
                   |------------|               |------------|
                   | Name       |               | Name       |
                   |------------|               |------------|
*/

extern "C" void P2SymBuild_EndBuildArray (void)
{
  unsigned int TypeSym;
  unsigned int ArraySym;

  M2Quads_PopT (&TypeSym);
  M2Quads_PopT (&ArraySym);
  M2Debug_Assert (SymbolTable_IsArray (ArraySym));
  SymbolTable_PutArray (ArraySym, TypeSym);
  M2Quads_PushT (ArraySym);
  M2Quads_Annotate ((const char *) "%1s(%1d)||array type", 20);
}


/*
   BuildFieldArray - Builds a field into an array sym.
                     The Stack:


                     Entry                     Exit
                     =====                     ====

              Ptr ->
                     +-------------+
                     | Type | Name |                           <- Ptr
                     |-------------|           +-------------+
                     | ArraySym    |           | ArraySym    |
                     |-------------|           |-------------|
                     | ArrayName   |           | ArrayName   |
                     |-------------|           |-------------|
*/

extern "C" void P2SymBuild_BuildFieldArray (void)
{
  unsigned int Subscript;
  unsigned int Type;
  unsigned int Array;
  NameKey_Name name;

  M2Quads_PopTF (&Type, &name);
  M2Quads_PopT (&Array);
  M2Debug_Assert (SymbolTable_IsArray (Array));
  Subscript = SymbolTable_MakeSubscript ();
  /* 
      We cannot Assert(IsSubrange(Type)) as the subrange type might be
      declared later on in the file.
      We also note it could be an ordinal type or enumerated type.
      Therefore we must save this information and deal with the
      different cases in M2GCCDeclare.mod and M2GenGCC.mod.
      However this works to our advantage as it preserves the
      actual declaration as specified by the source file.
  */
  SymbolTable_PutSubscript (Subscript, Type);
  SymbolTable_PutArraySubscript (Array, Subscript);
  M2Quads_PushT (Array);
  /* ; WriteString('Field Placed in Array') ; WriteLn  */
  M2Quads_Annotate ((const char *) "%1s(%1d)||array type", 20);
}


/*
   BuildArrayComma - converts ARRAY [..], [..] OF into ARRAY [..] OF ARRAY [..]


              Ptr ->                                           <- Ptr
                     +-------------+           +-------------+
                     | ArraySym1   |           | ArraySym2   |
                     |-------------|           |-------------|
                     | ArrayName   |           | ArrayName   |
                     |-------------|           |-------------|
*/

extern "C" void P2SymBuild_BuildArrayComma (void)
{
  unsigned int Nothing;
  unsigned int ArraySym1;
  unsigned int ArraySym2;

  M2Quads_PushT (static_cast<unsigned int> (NameKey_NulName));
  P2SymBuild_StartBuildArray ();
  M2Quads_PopT (&ArraySym2);
  M2Quads_PopT (&Nothing);
  M2Quads_PushT (ArraySym2);
  P2SymBuild_EndBuildArray ();
  M2Quads_PopT (&ArraySym1);
  M2Quads_PushT (ArraySym2);
  M2Quads_Annotate ((const char *) "%1s(%1d)||array type comma", 26);
}


/*
   BuildProcedureType - builds a procedure type symbol.
                        The Stack:


                                                               <- Ptr
                                               +-------------+
                 Ptr ->                        | ProcTypeSym |
                        +-------------+        |-------------|
                        | Name        |        | Name        |
                        |-------------|        |-------------|
*/

extern "C" void P2SymBuild_BuildProcedureType (void)
{
  unsigned int tok;
  NameKey_Name name;
  unsigned int ProcTypeSym;

  name = static_cast<NameKey_Name> (M2Quads_OperandT (1));
  tok = static_cast<unsigned int> (M2Quads_OperandTok (1));
  ProcTypeSym = SymbolTable_MakeProcType (tok, name);
  SymbolTable_CheckForExportedImplementation (ProcTypeSym);  /* May be an exported hidden type  */
  M2Quads_Annotate ((const char *) "%1n||procedure type name", 24);  /* May be an exported hidden type  */
  M2Quads_PushTtok (ProcTypeSym, tok);
  M2Quads_Annotate ((const char *) "%1s(%1d)|%3d||proc type|token no", 32);
}


/*
   BuildFormalType - Builds a Formal Parameter in a procedure type.

                     The Stack:

                     Entry                 Exit

              Ptr ->
                     +------------+
                     | TypeSym    |
                     |------------|
                     | Array/Nul  |
                     |------------|
                     | Var / Nul  |                         <- Ptr
                     |------------|        +--------------+
                     | ProcTypeSym|        | ProcTypeSym  |
                     |------------|        |--------------|
*/

extern "C" void P2SymBuild_BuildFormalType (void)
{
  unsigned int tok;
  NameKey_Name Array;
  NameKey_Name Var;
  unsigned int TypeSym;
  unsigned int UnboundedSym;
  unsigned int ProcTypeSym;

  M2Quads_PopT (&TypeSym);
  M2Quads_PopT (&Array);
  M2Quads_PopT (&Var);
  M2Quads_PopT (&ProcTypeSym);
  tok = M2LexBuf_GetTokenNo ();
  M2Debug_Assert ((Array == M2Reserved_ArrayTok) || (Array == M2Reserved_NulTok));
  M2Debug_Assert (SymbolTable_IsProcType (ProcTypeSym));
  M2Debug_Assert ((Var == M2Reserved_VarTok) || (Var == M2Reserved_NulTok));
  if (Array == M2Reserved_ArrayTok)
    {
      UnboundedSym = SymbolTable_MakeUnbounded (tok, TypeSym, 1);
      TypeSym = UnboundedSym;
    }
  if (Var == M2Reserved_VarTok)
    {
      /* VAR parameter  */
      SymbolTable_PutProcTypeVarParam (ProcTypeSym, TypeSym, SymbolTable_IsUnbounded (TypeSym));
    }
  else
    {
      /* Non VAR parameter  */
      SymbolTable_PutProcTypeParam (ProcTypeSym, TypeSym, SymbolTable_IsUnbounded (TypeSym));
    }
  M2Quads_PushT (ProcTypeSym);
  M2Quads_Annotate ((const char *) "%1s(%1d)||proc type", 19);
}


/*
   SeenUnknown - sets the operand type to unknown.
*/

extern "C" void P2SymBuild_SeenUnknown (void)
{
  type = M2Const_unknown;
}


/*
   SeenCast - sets the operand type to cast.
*/

extern "C" void P2SymBuild_SeenCast (unsigned int sym)
{
  type = M2Const_cast;
  castType = sym;
  M2Debug_Assert (SymbolTable_IsAModula2Type (sym));
}


/*
   SeenSet - sets the operand type to set.
*/

extern "C" void P2SymBuild_SeenSet (void)
{
  SetTypeTo (M2Const_set);
  SaveRememberedConstructor ();
}


/*
   SeenConstructor - sets the operand type to constructor.
*/

extern "C" void P2SymBuild_SeenConstructor (void)
{
  SetTypeTo (M2Const_constructor);
  SaveRememberedConstructor ();
}


/*
   SeenArray - sets the operand type to array.
*/

extern "C" void P2SymBuild_SeenArray (void)
{
  SetTypeTo (M2Const_array);
}


/*
   SeenString - sets the operand type to string.
*/

extern "C" void P2SymBuild_SeenString (void)
{
  SetTypeTo (M2Const_str);
}


/*
   SeenBoolean - sets the operand type to a BOOLEAN.
*/

extern "C" void P2SymBuild_SeenBoolean (void)
{
  type = M2Const_boolean;
}


/*
   SeenZType - sets the operand type to a Z type.
*/

extern "C" void P2SymBuild_SeenZType (void)
{
  type = M2Const_ztype;
}


/*
   SeenRType - sets the operand type to a R type.
*/

extern "C" void P2SymBuild_SeenRType (void)
{
  type = M2Const_rtype;
}


/*
   SeenCType - sets the operand type to a C type.
*/

extern "C" void P2SymBuild_SeenCType (void)
{
  type = M2Const_ctype;
}


/*
   DetermineType - assigns the top of stack symbol with the type of
                   constant expression, if known.
*/

extern "C" void P2SymBuild_DetermineType (void)
{
  unsigned int Sym;

  Sym = static_cast<unsigned int> (M2Quads_OperandT (1));
  switch (type)
    {
      case M2Const_set:
        SymbolTable_PutConstSet (Sym);
        break;

      case M2Const_str:
        SymbolTable_PutConstString (M2LexBuf_GetTokenNo (), Sym, NameKey_MakeKey ((const char *) "", 0));
        break;

      case M2Const_array:
      case M2Const_constructor:
        SymbolTable_PutConstructor (Sym);
        break;

      case M2Const_cast:
        SymbolTable_PutConst (Sym, castType);
        break;

      case M2Const_unknown:
        break;


      default:
        break;
    }
}


/*
   PushType -
*/

extern "C" void P2SymBuild_PushType (void)
{
  M2StackWord_PushWord (TypeStack, static_cast<unsigned int> (type));
}


/*
   PopType -
*/

extern "C" void P2SymBuild_PopType (void)
{
  type = static_cast<M2Const_constType> (M2StackWord_PopWord (TypeStack));
}


/*
   PushRememberConstant -
*/

extern "C" void P2SymBuild_PushRememberConstant (void)
{
  M2StackWord_PushWord (RememberStack, RememberedConstant);
  P2SymBuild_RememberConstant (SymbolTable_NulSym);
}


/*
   PopRememberConstant -
*/

extern "C" void P2SymBuild_PopRememberConstant (void)
{
  RememberedConstant = static_cast<unsigned int> (M2StackWord_PopWord (RememberStack));
}


/*
   RememberConstant -
*/

extern "C" void P2SymBuild_RememberConstant (unsigned int sym)
{
  RememberedConstant = sym;
}

extern "C" void _M2_P2SymBuild_init (__attribute__((unused)) int argc,__attribute__((unused)) char *argv[],__attribute__((unused)) char *envp[])
{
  alignTypeNo = 0;
  TypeStack = M2StackWord_InitStackWord ();
  RememberStack = M2StackWord_InitStackWord ();
  BlockStack = M2StackWord_InitStackWord ();
  castType = SymbolTable_NulSym;
}

extern "C" void _M2_P2SymBuild_fini (__attribute__((unused)) int argc,__attribute__((unused)) char *argv[],__attribute__((unused)) char *envp[])
{
}
