/* do not edit automatically generated by mc from m2builtins.  */
/* m2builtins.def definition module for m2builtins.cc.

Copyright (C) 2003-2023 Free Software Foundation, Inc.
Contributed by Gaius Mulley <gaius.mulley@southwales.ac.uk>.

This file is part of GNU Modula-2.

GNU Modula-2 is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 3, or (at your option)
any later version.

GNU Modula-2 is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with GNU Modula-2; see the file COPYING3.  If not see
<http://www.gnu.org/licenses/>.  */


#if !defined (_m2builtins_H)
#   define _m2builtins_H

#include "config.h"
#include "system.h"
#   ifdef __cplusplus
extern "C" {
#   endif
#include <stdbool.h>
#   if !defined (PROC_D)
#      define PROC_D
       typedef void (*PROC_t) (void);
       typedef struct { PROC_t proc; } PROC;
#   endif

#   include "GSYSTEM.h"
#   include "Gm2tree.h"
#   include "Gm2linemap.h"

#   if defined (_m2builtins_C)
#      define EXTERN
#   else
#      define EXTERN extern
#   endif


/*
   GetBuiltinConst - returns the gcc tree of a built in constant, name.
                     NIL is returned if the constant is unknown.
*/

EXTERN m2tree_Tree m2builtins_GetBuiltinConst (void * name);

/*
   GetBuiltinConstType - returns the type of a builtin constant, name.

                         0 = unknown constant name
                         1 = integer
                         2 = real
*/

EXTERN unsigned int m2builtins_GetBuiltinConstType (void * name);

/*
   GetBuiltinTypeInfoType - returns value:
                            0    is ident is unknown.
                            1    if ident is IEC559, LIA1, ISO, IEEE, rounds, underflow,
                                             exception, extend.
                            2    if ident is radix, places, exponentmin, exponentmax,
                                             noofmodes.
                            3    if ident is large, small.
*/

EXTERN unsigned int m2builtins_GetBuiltinTypeInfoType (void * ident);

/*
   GetBuiltinTypeInfo - returns a Tree value:

                        NULL_TREE        if ident is unknown.
                        boolean Tree     if ident is IEC559, LIA1, ISO, IEEE, rounds, underflow,
                                         exception, extend.
                        ZType Tree       if ident is radix, places, exponentmin, exponentmax,
                                         noofmodes.
                        RType Tree       if ident is large, small.
*/

EXTERN m2tree_Tree m2builtins_GetBuiltinTypeInfo (m2linemap_location_t location, m2tree_Tree type, void * ident);

/*
   BuiltinExists - returns TRUE if the builtin function, name, exists
                   for this target architecture.
*/

EXTERN bool m2builtins_BuiltinExists (void * name);

/*
   BuildBuiltinTree - returns a Tree containing the builtin function, name.
*/

EXTERN m2tree_Tree m2builtins_BuildBuiltinTree (m2linemap_location_t location, void * name);
EXTERN m2tree_Tree m2builtins_BuiltInMemCopy (m2linemap_location_t location, m2tree_Tree dest, m2tree_Tree src, m2tree_Tree n);

/*
   BuiltInAlloca - given an expression, n, allocate, n, bytes on the stack for the life
                   of the current function.
*/

EXTERN m2tree_Tree m2builtins_BuiltInAlloca (m2linemap_location_t location, m2tree_Tree n);

/*
   BuiltInIsfinite - given an expression, e, return an integer Tree of 1 if the
                     value is finite.  Return an integer Tree 0 if the value is
                     not finite.
*/

EXTERN m2tree_Tree m2builtins_BuiltInIsfinite (m2linemap_location_t location, m2tree_Tree e);
#   ifdef __cplusplus
}
#   endif

#   undef EXTERN
#endif
