/* do not edit automatically generated by mc from m2statement.  */
/* m2statement.def definition module for m2statement.cc.

Copyright (C) 2011-2023 Free Software Foundation, Inc.
Contributed by Gaius Mulley <gaius.mulley@southwales.ac.uk>.

This file is part of GNU Modula-2.

GNU Modula-2 is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 3, or (at your option)
any later version.

GNU Modula-2 is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with GNU Modula-2; see the file COPYING3.  If not see
<http://www.gnu.org/licenses/>.  */


#if !defined (_m2statement_H)
#   define _m2statement_H

#include "config.h"
#include "system.h"
#   ifdef __cplusplus
extern "C" {
#   endif
#include <stdbool.h>
#   if !defined (PROC_D)
#      define PROC_D
       typedef void (*PROC_t) (void);
       typedef struct { PROC_t proc; } PROC;
#   endif

#   include "GSYSTEM.h"
#   include "Gm2tree.h"
#   include "Gm2linemap.h"
#   include "Gm2expr.h"

#   if defined (_m2statement_C)
#      define EXTERN
#   else
#      define EXTERN extern
#   endif


/*
   DoJump - jump to the appropriate label depending whether
            result of the expression is TRUE or FALSE.
*/

EXTERN void m2statement_DoJump (m2linemap_location_t location, m2tree_Tree exp, void * falselabel, void * truelabel);

/*
   BuildStartFunctionCode - generate function entry code.
*/

EXTERN void m2statement_BuildStartFunctionCode (m2linemap_location_t location, m2tree_Tree fndecl, bool isexported, bool isinline);

/*
   BuildEndFunctionCode - generates the function epilogue.
*/

EXTERN void m2statement_BuildEndFunctionCode (m2linemap_location_t location, m2tree_Tree fndecl, bool nested);

/*
   BuildReturnValueCode - generates the code associated with: RETURN( value )
*/

EXTERN void m2statement_BuildReturnValueCode (m2linemap_location_t location, m2tree_Tree fndecl, m2tree_Tree value);

/*
   BuildPushFunctionContext - pushes the current function context.
                              Maps onto push_function_context in ../function.c
*/

EXTERN void m2statement_BuildPushFunctionContext (void);

/*
   BuildPopFunctionContext - pops the current function context.
                             Maps onto pop_function_context in ../function.c
*/

EXTERN void m2statement_BuildPopFunctionContext (void);

/*
   BuildAssignmentTree - builds the assignment of, des, and, expr.
                         It returns, des.
*/

EXTERN m2tree_Tree m2statement_BuildAssignmentTree (m2linemap_location_t location, m2tree_Tree des, m2tree_Tree expr);

/*
   BuildAssignmentStatement builds the assignment of, des, and, expr.
*/

EXTERN void m2statement_BuildAssignmentStatement (m2linemap_location_t location, m2tree_Tree des, m2tree_Tree expr);

/*
   BuildGoto - builds a goto operation.
*/

EXTERN void m2statement_BuildGoto (m2linemap_location_t location, void * name);

/*
   DeclareLabel - create a label, name.
*/

EXTERN void m2statement_DeclareLabel (m2linemap_location_t location, void * name);

/*
   BuildIfThenDoEnd - returns a tree which will only execute
                      statement, s, if, condition, is true.
*/

EXTERN m2tree_Tree m2statement_BuildIfThenDoEnd (m2tree_Tree condition, m2tree_Tree then_block);

/*
   BuildIfThenElseEnd - returns a tree which will execute
                        then_block or else_block depending upon,
                        condition.
*/

EXTERN m2tree_Tree m2statement_BuildIfThenElseEnd (m2tree_Tree condition, m2tree_Tree then_block, m2tree_Tree else_block);

/*
   BuildParam - build a list of parameters, ready for a subsequent procedure call.
*/

EXTERN void m2statement_BuildParam (m2linemap_location_t location, m2tree_Tree param);

/*
   BuildFunctionCallTree - creates a procedure function call from
                           a procedure and parameter list and the
                           return type, rettype.  No tree is returned
                           as the tree is held in the last_function
                           global variable.  It is expected the
                           BuildFunctValue is to be called after
                           a call to BuildFunctionCallTree.
*/

EXTERN void m2statement_BuildFunctionCallTree (m2linemap_location_t location, m2tree_Tree procedure, m2tree_Tree rettype);

/*
   BuildProcedureCallTree - creates a procedure call from a procedure and
                            parameter list and the return type, rettype.
*/

EXTERN m2tree_Tree m2statement_BuildProcedureCallTree (m2linemap_location_t location, m2tree_Tree procedure, m2tree_Tree rettype);

/*
   BuildIndirectProcedureCallTree - creates a procedure call from a procedure and
                                    parameter list and the return type, rettype.
*/

EXTERN m2tree_Tree m2statement_BuildIndirectProcedureCallTree (m2linemap_location_t location, m2tree_Tree procedure, m2tree_Tree rettype);

/*
   BuildFunctValue - generates code for value := last_function(foobar);
*/

EXTERN m2tree_Tree m2statement_BuildFunctValue (m2linemap_location_t location, m2tree_Tree value);

/*
   BuildCall2 - builds a tree representing:  function(arg1, arg2).
*/

EXTERN m2tree_Tree m2statement_BuildCall2 (m2linemap_location_t location, m2tree_Tree function, m2tree_Tree rettype, m2tree_Tree arg1, m2tree_Tree arg2);

/*
   BuildCall3 - builds a tree representing:  function(arg1, arg2, arg3).
*/

EXTERN m2tree_Tree m2statement_BuildCall3 (m2linemap_location_t location, m2tree_Tree function, m2tree_Tree rettype, m2tree_Tree arg1, m2tree_Tree arg2, m2tree_Tree arg3);

/*
   SetLastFunction - set the last_function to, t.
*/

EXTERN void m2statement_SetLastFunction (m2tree_Tree t);

/*
   GetLastFunction - returns, last_function.
*/

EXTERN m2tree_Tree m2statement_GetLastFunction (void);

/*
   GetParamTree - return parameter, i.
*/

EXTERN m2tree_Tree m2statement_GetParamTree (m2tree_Tree call, unsigned int i);

/*
   BuildTryFinally - returns a TRY_FINALL_EXPR with the call and cleanups
                     attached.
*/

EXTERN m2tree_Tree m2statement_BuildTryFinally (m2linemap_location_t location, m2tree_Tree call, m2tree_Tree cleanups);

/*
   BuildCleanUp - return a CLEANUP_POINT_EXPR which will clobber, param.
*/

EXTERN m2tree_Tree m2statement_BuildCleanUp (m2tree_Tree param);

/*
    BuildAsm - generates an inline assembler instruction.
*/

EXTERN void m2statement_BuildAsm (m2linemap_location_t location, m2tree_Tree instr, bool isVolatile, bool isSimple, m2tree_Tree inputs, m2tree_Tree outputs, m2tree_Tree trash, m2tree_Tree labels);

/*
    BuildUnaryForeachWordDo - provides the large set operators.
                              Each word (or less) of the set can be
                              calculated by unop.
                              This procedure iterates over each word
                              of the large set invoking the unop.
*/

EXTERN void m2statement_BuildUnaryForeachWordDo (m2linemap_location_t location, m2tree_Tree type, m2tree_Tree op1, m2tree_Tree op2, m2expr_BuildUnarySetFunction_C unop, bool is_op1lvalue, bool is_op2lvalue, bool is_op1const, bool is_op2const);

/*
    BuildExcludeVarConst - builds the EXCL(op1, 1<<op2) operation for a small sets. Large
                           sets call this routine to exclude the bit in the particular word.
                           op2 is a constant.
*/

EXTERN void m2statement_BuildExcludeVarConst (m2linemap_location_t location, m2tree_Tree type, m2tree_Tree op1, m2tree_Tree op2, bool is_lvalue, int fieldno);

/*
    BuildExcludeVarVar - builds the EXCL(varset, 1<<varel) operation for a small and large sets.
                         varel is a variable.
*/

EXTERN void m2statement_BuildExcludeVarVar (m2linemap_location_t location, m2tree_Tree type, m2tree_Tree varset, m2tree_Tree varel, bool is_lvalue, m2tree_Tree low);

/*
    BuildIncludeVarConst - builds the INCL(op1, 1<<op2) operation for a small sets. Large
                           sets call this routine to include the bit in the particular word.
                           op2 is a constant.
*/

EXTERN void m2statement_BuildIncludeVarConst (m2linemap_location_t location, m2tree_Tree type, m2tree_Tree op1, m2tree_Tree op2, bool is_lvalue, int fieldno);

/*
    BuildIncludeVarVar - builds the INCL(varset, 1<<varel) operation for a small and large sets.
                         op2 is a variable.
*/

EXTERN void m2statement_BuildIncludeVarVar (m2linemap_location_t location, m2tree_Tree type, m2tree_Tree varset, m2tree_Tree varel, bool is_lvalue, m2tree_Tree low);

/*
    BuildStart - creates a module initialization function. We make
                 this function public if it is not an inner module.
                 The linker will create a call list for all linked
                 modules which determines the initialization
                 sequence for all modules.
*/

EXTERN m2tree_Tree m2statement_BuildStart (m2linemap_location_t location, void * name, bool inner_module);

/*
    BuildEnd - complete the initialisation function for this module.
*/

EXTERN void m2statement_BuildEnd (m2linemap_location_t location, m2tree_Tree fndecl, bool nested);

/*
    BuildCallInner - call the inner module function.  It has no parameters and no return value.
*/

EXTERN void m2statement_BuildCallInner (m2linemap_location_t location, m2tree_Tree fndecl);

/*
   SetBeginLocation - sets the begin location for the function to obtain good debugging info.
*/

EXTERN void m2statement_SetBeginLocation (m2linemap_location_t location);

/*
   SetEndLocation - sets the end location for the function to obtain good debugging info.
*/

EXTERN void m2statement_SetEndLocation (m2linemap_location_t location);
#   ifdef __cplusplus
}
#   endif

#   undef EXTERN
#endif
