/* do not edit automatically generated by mc from P3Build.  */
/* output from m2-3.bnf, automatically generated do not edit if these
   are the top two lines in the file.

Copyright (C) 2001-2023 Free Software Foundation, Inc.
Contributed by Gaius Mulley <gaius.mulley@southwales.ac.uk>.

This file is part of GNU Modula-2.

GNU Modula-2 is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 3, or (at your option)
any later version.

GNU Modula-2 is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with GNU Modula-2; see the file COPYING.  If not,
see <https://www.gnu.org/licenses/>.  */

#include "config.h"
#include "system.h"
#include <stdbool.h>
#   if !defined (PROC_D)
#      define PROC_D
       typedef void (*PROC_t) (void);
       typedef struct { PROC_t proc; } PROC;
#   endif

#   if !defined (TRUE)
#      define TRUE (1==1)
#   endif

#   if !defined (FALSE)
#      define FALSE (1==0)
#   endif

#define _P3Build_H
#define _P3Build_C

#   include "GM2LexBuf.h"
#   include "GM2Error.h"
#   include "GNameKey.h"
#   include "GDynamicStrings.h"
#   include "GM2Printf.h"
#   include "GM2Debug.h"
#   include "GP2SymBuild.h"
#   include "GM2MetaError.h"
#   include "GM2Reserved.h"
#   include "GM2Quads.h"
#   include "GP3SymBuild.h"
#   include "GSymbolTable.h"
#   include "GM2Batch.h"
#   include "GM2CaseList.h"

#   define Debugging false
#   define Pass1 false
#   define Pass2 false
#   define Pass3 true
#   define DebugAsm false
typedef unsigned int P3Build_stop0;

typedef unsigned int P3Build_SetOfStop0;

typedef unsigned int P3Build_stop1;

typedef unsigned int P3Build_SetOfStop1;

typedef unsigned int P3Build_stop2;

typedef unsigned int P3Build_SetOfStop2;

static bool WasNoError;

/*
   CompilationUnit - returns TRUE if the input was correct enough to parse
                     in future passes.
*/

extern "C" bool P3Build_CompilationUnit (void);
static void ErrorString (DynamicStrings_String s);
static void ErrorArray (const char *a_, unsigned int _a_high);

/*
   DescribeStop - issues a message explaining what tokens were expected
*/

static DynamicStrings_String DescribeStop (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   DescribeError - issues a message explaining what tokens were expected
*/

static void DescribeError (void);

/*
   SyntaxError - after a syntax error we skip all tokens up until we reach
                 a stop symbol.
*/

static void SyntaxError (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   SyntaxCheck -
*/

static void SyntaxCheck (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   WarnMissingToken - generates a warning message about a missing token, t.
*/

static void WarnMissingToken (M2Reserved_toktype t);

/*
   MissingToken - generates a warning message about a missing token, t.
*/

static void MissingToken (M2Reserved_toktype t);

/*
   CheckAndInsert -
*/

static bool CheckAndInsert (M2Reserved_toktype t, P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   InStopSet
*/

static bool InStopSet (M2Reserved_toktype t, P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   PeepToken - peep token checks to see whether the stopset is satisfied by currenttoken
               If it is not then it will insert a token providing the token
               is one of ; ] ) } . OF END ,

               if the stopset contains <identtok> then we do not insert a token
*/

static void PeepToken (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   Expect -
*/

static void Expect (M2Reserved_toktype t, P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   Ident - error checking varient of Ident
*/

static void Ident (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   string -
*/

static void string (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   Integer -
*/

static void Integer (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   Real -
*/

static void Real (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   FileUnit := 
               % PushAutoOff  %
               ( DefinitionModule  | 
                 ImplementationOrProgramModule  ) 
               % PopAuto  %
               

   first  symbols:implementationtok, moduletok, definitiontok
   
   cannot reachend
*/

static void FileUnit (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   ProgramModule := 
                    % VAR modulet, endt: CARDINAL ;  %
                    
                    % modulet := GetTokenNo ()  %
                    'MODULE' 
                    % M2Error.DefaultProgramModule  %
                    
                    % PushAutoOn  %
                    Ident 
                    % P3StartBuildProgModule  %
                    
                    % StartBuildModFile (modulet)  %
                    
                    % BuildModuleStart (modulet)  %
                    
                    % PushAutoOff  %
                    [ Priority  ] ';' 
                    % BuildScaffold (modulet,
                                     GetCurrentModule ())  %
                    { Import  } Block 
                    % PushAutoOn  %
                    
                    % endt := GetTokenNo () -1  %
                    Ident 
                    % EndBuildFile (endt)  %
                    
                    % P3EndBuildProgModule  %
                    '.' 
                    % PopAuto ; PopAuto  %
                    

   first  symbols:moduletok
   
   cannot reachend
*/

static void ProgramModule (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   ImplementationModule := 
                           % VAR modulet, endt: CARDINAL ;  %
                           
                           % modulet := GetTokenNo ()  %
                           'IMPLEMENTATION' 
                           % M2Error.DefaultImplementationModule  %
                           'MODULE' 
                           % PushAutoOn  %
                           Ident 
                           % StartBuildModFile (modulet)  %
                           
                           % P3StartBuildImpModule  %
                           
                           % BuildModuleStart (modulet)  %
                           
                           % PushAutoOff  %
                           [ Priority  ] ';' 
                           % BuildScaffold (modulet,
                                            GetCurrentModule ())  %
                           { Import  } Block 
                           % PushAutoOn  %
                           
                           % endt := GetTokenNo () -1  %
                           Ident 
                           % EndBuildFile (endt)  %
                           
                           % P3EndBuildImpModule  %
                           '.' 
                           % PopAuto ; PopAuto ; PopAuto  %
                           

   first  symbols:implementationtok
   
   cannot reachend
*/

static void ImplementationModule (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   ImplementationOrProgramModule := 
                                    % PushAutoOff  %
                                    ( ImplementationModule  | 
                                      ProgramModule  ) 
                                    
                                    % PopAuto  %
                                    

   first  symbols:moduletok, implementationtok
   
   cannot reachend
*/

static void ImplementationOrProgramModule (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   Number := Integer  | Real 

   first  symbols:realtok, integertok
   
   cannot reachend
*/

static void Number (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   Qualident := 
                % VAR name          : Name ;
                      init, ip1,
                      tokstart, tok : CARDINAL ;  %
                Ident 
                % IF IsAutoPushOn()
                  THEN
                     PopTtok(name, tokstart) ;
                  										tok := tokstart ;
                     init := RequestSym (tok, name) ;
                     WHILE IsDefImp (init) OR IsModule (init) DO
                        Expect (periodtok, stopset0, stopset1, stopset2 + SetOfStop2{identtok}) ;
                        StartScope (init) ;
                        Ident (stopset0, stopset1, stopset2) ;
                        PopTtok (name, tok) ;
                        ip1 := RequestSym (tok, name) ;
                        PutIncluded(ip1) ;
                        EndScope ;
                        CheckCanBeImported(init, ip1) ;
                        init := ip1
                     END ;
                  										IF tok#tokstart
                  										THEN
                  										   tok := MakeVirtualTok (tokstart, tokstart, tok)
                  										END ;
                     IF IsProcedure(init) OR IsProcType(init)
                     THEN
                        PushTtok(init, tok)
                     ELSE
                        PushTFtok(init, GetType(init), tok) ;
                     END
                  ELSE  %
                { '.' Ident  } 
                % END  %
                

   first  symbols:identtok
   
   cannot reachend
*/

static void Qualident (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   ConstantDeclaration := 
                          % VAR tokno: CARDINAL ;  %
                          
                          % PushAutoOn  %
                          ( Ident '=' 
                            % tokno := GetTokenNo () -1  %
                            
                            % BuildConst  %
                            ConstExpression  ) 
                          % BuildAssignConstant (tokno)  %
                          
                          % PopAuto  %
                          

   first  symbols:identtok
   
   cannot reachend
*/

static void ConstantDeclaration (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   ConstExpression := 
                      % VAR tokpos: CARDINAL ;  %
                      
                      % PushAutoOn  %
                      SimpleConstExpr [ Relation 
                                        % tokpos := GetTokenNo ()-1  %
                                        SimpleConstExpr 
                                        
                                        % BuildRelOp (tokpos)  %
                                         ] 
                      % PopAuto  %
                      

   first  symbols:attributetok, identtok, lcbratok, stringtok, nottok, lparatok, integertok, realtok, minustok, plustok
   
   cannot reachend
*/

static void ConstExpression (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   Relation := '=' 
               % PushTtok(EqualTok, GetTokenNo() -1)  %
                | '#' 
               % PushTtok(HashTok, GetTokenNo() -1)  %
                | '<>' 
               % PushTtok(LessGreaterTok, GetTokenNo() -1)  %
                | '<' 
               % PushTtok(LessTok, GetTokenNo() -1)  %
                | '<=' 
               % PushTtok(LessEqualTok, GetTokenNo() -1)  %
                | '>' 
               % PushTtok(GreaterTok, GetTokenNo() -1)  %
                | '>=' 
               % PushTtok(GreaterEqualTok, GetTokenNo() -1)  %
                | 'IN' 
               % PushTtok(InTok, GetTokenNo() -1)  %
               

   first  symbols:intok, greaterequaltok, greatertok, lessequaltok, lesstok, lessgreatertok, hashtok, equaltok
   
   cannot reachend
*/

static void Relation (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   SimpleConstExpr := UnaryOrConstTerm { AddOperator 
                                         ConstTerm 
                                         
                                         % BuildBinaryOp  %
                                          } 

   first  symbols:stringtok, lcbratok, identtok, attributetok, realtok, integertok, lparatok, nottok, plustok, minustok
   
   cannot reachend
*/

static void SimpleConstExpr (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   UnaryOrConstTerm := '+' 
                       % PushTtok(PlusTok, GetTokenNo() -1)  %
                       ConstTerm 
                       % BuildUnaryOp  %
                        | '-' 
                       % PushTtok(MinusTok, GetTokenNo() -1)  %
                       ConstTerm 
                       % BuildUnaryOp  %
                        | ConstTerm 

   first  symbols:attributetok, identtok, lcbratok, stringtok, nottok, lparatok, integertok, realtok, minustok, plustok
   
   cannot reachend
*/

static void UnaryOrConstTerm (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   AddOperator := '+' 
                  % PushTtok(PlusTok, GetTokenNo() -1) ;
                    RecordOp  %
                   | '-' 
                  % PushTtok(MinusTok, GetTokenNo() -1) ;
                    RecordOp  %
                   | 'OR' 
                  % PushTtok(OrTok, GetTokenNo() -1) ;
                    RecordOp  %
                  

   first  symbols:ortok, minustok, plustok
   
   cannot reachend
*/

static void AddOperator (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   ConstTerm := ConstFactor { MulOperator ConstFactor 
                              
                              % BuildBinaryOp  %
                               } 

   first  symbols:stringtok, lcbratok, identtok, attributetok, realtok, integertok, lparatok, nottok
   
   cannot reachend
*/

static void ConstTerm (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   MulOperator := '*' 
                  % PushTtok(TimesTok, GetTokenNo() -1) ;
                    RecordOp  %
                   | '/' 
                  % PushTtok(DivideTok, GetTokenNo() -1) ;
                    RecordOp  %
                   | 'DIV' 
                  % PushTtok(DivTok, GetTokenNo() -1) ;
                    RecordOp  %
                   | 'MOD' 
                  % PushTtok(ModTok, GetTokenNo() -1) ;
                    RecordOp  %
                   | 'REM' 
                  % PushTtok(RemTok, GetTokenNo() -1) ;
                    RecordOp  %
                   | 'AND' 
                  % PushTtok(AndTok, GetTokenNo() -1) ;
                    RecordOp  %
                   | '&' 
                  % PushTtok(AmbersandTok, GetTokenNo() -1) ;
                    RecordOp  %
                  

   first  symbols:ambersandtok, andtok, remtok, modtok, divtok, dividetok, timestok
   
   cannot reachend
*/

static void MulOperator (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   ConstFactor := 
                  % VAR tokpos: CARDINAL ;  %
                  Number  | ConstString  | 
                  ConstSetOrQualidentOrFunction  | 
                  '(' ConstExpression ')'  | 
                  'NOT' 
                  % tokpos := GetTokenNo() -1  %
                  ConstFactor 
                  % BuildNot (tokpos)  %
                   | ConstAttribute 

   first  symbols:attributetok, identtok, lcbratok, stringtok, nottok, lparatok, integertok, realtok
   
   cannot reachend
*/

static void ConstFactor (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   ConstString := string 

   first  symbols:stringtok
   
   cannot reachend
*/

static void ConstString (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   ComponentElement := ConstExpression ( '..' ConstExpression 
                                         
                                         % PushTtok(PeriodPeriodTok, GetTokenNo() -1)  %
                                          | 
                                         
                                         % PushT(NulTok)  %
                                          ) 

   first  symbols:stringtok, lcbratok, identtok, attributetok, realtok, integertok, lparatok, nottok, plustok, minustok
   
   cannot reachend
*/

static void ComponentElement (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   ComponentValue := ComponentElement ( 'BY' ConstExpression 
                                        
                                        % PushTtok(ByTok, GetTokenNo() -1)  %
                                         | 
                                        
                                        % PushT(NulTok)  %
                                         ) 

   first  symbols:attributetok, identtok, lcbratok, stringtok, nottok, lparatok, integertok, realtok, minustok, plustok
   
   cannot reachend
*/

static void ComponentValue (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   ArraySetRecordValue := ComponentValue 
                          % BuildComponentValue  %
                          { ',' 
                            % NextConstructorField  %
                            ComponentValue 
                            % BuildComponentValue  %
                             } 

   first  symbols:stringtok, lcbratok, identtok, attributetok, realtok, integertok, lparatok, nottok, plustok, minustok
   
   cannot reachend
*/

static void ArraySetRecordValue (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   Constructor := 
                  % DisplayStack  %
                  '{' 
                  % BuildConstructorStart (GetTokenNo() -1)  %
                  [ ArraySetRecordValue  ] 
                  % BuildConstructorEnd (GetTokenNo())   %
                  '}' 

   first  symbols:lcbratok
   
   cannot reachend
*/

static void Constructor (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   ConstSetOrQualidentOrFunction := Qualident [ Constructor  | 
                                                ConstActualParameters 
                                                
                                                % BuildConstFunctionCall  %
                                                 ]  | 
                                    
                                    % BuildTypeForConstructor  %
                                    Constructor 

   first  symbols:lcbratok, identtok
   
   cannot reachend
*/

static void ConstSetOrQualidentOrFunction (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   ConstActualParameters := 
                            % PushInConstExpression  %
                            ActualParameters 
                            % PopInConstExpression  %
                            

   first  symbols:lparatok
   
   cannot reachend
*/

static void ConstActualParameters (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   ConstAttribute := '__ATTRIBUTE__' '__BUILTIN__' 
                     '(' '(' 
                     % PushAutoOn  %
                     ConstAttributeExpression 
                     % PopAuto  %
                     ')' ')' 

   first  symbols:attributetok
   
   cannot reachend
*/

static void ConstAttribute (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   ConstAttributeExpression := Ident 
                               % BuildBuiltinConst  %
                                | '<' Qualident ',' 
                               Ident 
                               % BuildBuiltinTypeInfo  %
                               '>' 

   first  symbols:lesstok, identtok
   
   cannot reachend
*/

static void ConstAttributeExpression (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   ByteAlignment := '' 
                    % PopAuto  %
                    

   first  symbols:ldirectivetok
   
   cannot reachend
*/

static void ByteAlignment (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   Alignment := [ ByteAlignment  ] 

   first  symbols:ldirectivetok
   
   reachend
*/

static void Alignment (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   TypeDeclaration := Ident '=' Type Alignment 

   first  symbols:identtok
   
   cannot reachend
*/

static void TypeDeclaration (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   Type := 
           % PushAutoOff  %
           ( SimpleType  | ArrayType  | RecordType  | 
             SetType  | PointerType  | 
             ProcedureType  ) 
           % PopAuto  %
           

   first  symbols:lparatok, lsbratok, proceduretok, pointertok, settok, packedsettok, oftok, recordtok, arraytok, identtok
   
   cannot reachend
*/

static void Type (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   SimpleType := Qualident [ SubrangeType  ]  | 
                 Enumeration  | SubrangeType 

   first  symbols:lsbratok, lparatok, identtok
   
   cannot reachend
*/

static void SimpleType (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   Enumeration := '(' ( IdentList  ) ')' 

   first  symbols:lparatok
   
   cannot reachend
*/

static void Enumeration (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   IdentList := Ident 
                % VAR
                                                                                                  on: BOOLEAN ;
                                                                                                  n : CARDINAL ;  %
                
                % on := IsAutoPushOn() ;
                  IF on
                  THEN
                     n := 1
                  END  %
                { ',' Ident 
                  % IF on
                    THEN
                       INC(n)
                    END  %
                   } 
                % IF on
                  THEN
                     PushT(n)
                  END  %
                

   first  symbols:identtok
   
   cannot reachend
*/

static void IdentList (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   SubrangeType := '[' ConstExpression '..' ConstExpression 
                   ']' 
                   % BuildSubrange ;  %
                   

   first  symbols:lsbratok
   
   cannot reachend
*/

static void SubrangeType (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   ArrayType := 'ARRAY' SimpleType { ',' SimpleType  } 
                'OF' Type 

   first  symbols:arraytok
   
   cannot reachend
*/

static void ArrayType (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   RecordType := 'RECORD' [ DefaultRecordAttributes  ] 
                 FieldListSequence 'END' 

   first  symbols:recordtok
   
   cannot reachend
*/

static void RecordType (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   DefaultRecordAttributes := '' 

   first  symbols:ldirectivetok
   
   cannot reachend
*/

static void DefaultRecordAttributes (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   RecordFieldPragma := [ ''  ] 

   first  symbols:ldirectivetok
   
   reachend
*/

static void RecordFieldPragma (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   FieldPragmaExpression := 
                            % PushAutoOn  %
                            Ident PragmaConstExpression 
                            
                            % BuildPragmaField  %
                            
                            % PopAuto  %
                            

   first  symbols:identtok
   
   cannot reachend
*/

static void FieldPragmaExpression (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   PragmaConstExpression := ( '(' ConstExpression ')'  | 
                              
                              % PushT(NulSym)  %
                              
                              % Annotate('NulSym||no pragma const')  %
                               ) 

   first  symbols:lparatok
   
   reachend
*/

static void PragmaConstExpression (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   AttributeExpression := Ident '(' ConstExpression 
                          ')' 

   first  symbols:identtok
   
   cannot reachend
*/

static void AttributeExpression (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   FieldListSequence := FieldListStatement { ';' FieldListStatement  } 

   first  symbols:casetok, identtok, semicolontok
   
   reachend
*/

static void FieldListSequence (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   FieldListStatement := [ FieldList  ] 

   first  symbols:identtok, casetok
   
   reachend
*/

static void FieldListStatement (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   FieldList := IdentList ':' Type RecordFieldPragma  | 
                'CASE' 
                % BeginVarient  %
                CaseTag 'OF' Varient { '|' Varient  } 
                [ 'ELSE' 
                  % ElseVarient  %
                  FieldListSequence  ] 'END' 
                % EndVarient  %
                

   first  symbols:casetok, identtok
   
   cannot reachend
*/

static void FieldList (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   TagIdent := [ Ident  ] 

   first  symbols:identtok
   
   reachend
*/

static void TagIdent (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   CaseTag := TagIdent [ ':' Qualident  ] 

   first  symbols:colontok, identtok
   
   reachend
*/

static void CaseTag (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   Varient := [ 
                % BeginVarientList  %
                VarientCaseLabelList ':' FieldListSequence 
                
                % EndVarientList  %
                 ] 

   first  symbols:stringtok, lcbratok, identtok, attributetok, realtok, integertok, lparatok, nottok, plustok, minustok
   
   reachend
*/

static void Varient (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   VarientCaseLabelList := VarientCaseLabels { ',' 
                                               VarientCaseLabels  } 

   first  symbols:attributetok, identtok, lcbratok, stringtok, nottok, lparatok, integertok, realtok, minustok, plustok
   
   cannot reachend
*/

static void VarientCaseLabelList (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   VarientCaseLabels := ConstExpression ( '..' ConstExpression 
                                          
                                          % AddVarientRange  %
                                           | 
                                          
                                          % AddVarientEquality ;  epsilon   %
                                           ) 

   first  symbols:stringtok, lcbratok, identtok, attributetok, realtok, integertok, lparatok, nottok, plustok, minustok
   
   cannot reachend
*/

static void VarientCaseLabels (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   SilentConstExpression := 
                            % PushAutoOff  %
                            SilentSimpleConstExpr [ 
   SilentRelation SilentSimpleConstExpr  ] 
                            % PopAuto  %
                            

   first  symbols:attributetok, lcbratok, identtok, stringtok, nottok, lparatok, integertok, realtok, minustok, plustok
   
   cannot reachend
*/

static void SilentConstExpression (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   SilentRelation := '='  | '#'  | '<>'  | '<'  | 
                     '<='  | '>'  | '>='  | 'IN' 

   first  symbols:intok, greaterequaltok, greatertok, lessequaltok, lesstok, lessgreatertok, hashtok, equaltok
   
   cannot reachend
*/

static void SilentRelation (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   SilentSimpleConstExpr := SilentUnaryOrConstTerm 
                            { SilentAddOperator SilentConstTerm  } 

   first  symbols:stringtok, identtok, lcbratok, attributetok, realtok, integertok, lparatok, nottok, plustok, minustok
   
   cannot reachend
*/

static void SilentSimpleConstExpr (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   SilentUnaryOrConstTerm := '+' SilentConstTerm  | 
                             '-' SilentConstTerm  | 
                             SilentConstTerm 

   first  symbols:attributetok, lcbratok, identtok, stringtok, nottok, lparatok, integertok, realtok, minustok, plustok
   
   cannot reachend
*/

static void SilentUnaryOrConstTerm (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   SilentAddOperator := '+'  | '-'  | 'OR' 

   first  symbols:ortok, minustok, plustok
   
   cannot reachend
*/

static void SilentAddOperator (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   SilentConstTerm := SilentConstFactor { SilentMulOperator 
                                          SilentConstFactor  } 

   first  symbols:stringtok, identtok, lcbratok, attributetok, realtok, integertok, lparatok, nottok
   
   cannot reachend
*/

static void SilentConstTerm (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   SilentMulOperator := '*'  | '/'  | 'DIV'  | 
                        'MOD'  | 'REM'  | 'AND'  | 
                        '&' 

   first  symbols:ambersandtok, andtok, remtok, modtok, divtok, dividetok, timestok
   
   cannot reachend
*/

static void SilentMulOperator (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   SilentConstFactor := Number  | SilentConstString  | 
                        SilentConstSetOrQualidentOrFunction  | 
                        '(' SilentConstExpression ')'  | 
                        'NOT' SilentConstFactor  | 
                        SilentConstAttribute 

   first  symbols:attributetok, lcbratok, identtok, stringtok, nottok, lparatok, integertok, realtok
   
   cannot reachend
*/

static void SilentConstFactor (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   SilentConstString := string 

   first  symbols:stringtok
   
   cannot reachend
*/

static void SilentConstString (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   SilentConstAttribute := '__ATTRIBUTE__' '__BUILTIN__' 
                           '(' '(' SilentConstAttributeExpression 
                           ')' ')' 

   first  symbols:attributetok
   
   cannot reachend
*/

static void SilentConstAttribute (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   SilentConstAttributeExpression := Ident  | 
                                     '<' Ident ',' 
                                     SilentConstString 
                                     '>' 

   first  symbols:lesstok, identtok
   
   cannot reachend
*/

static void SilentConstAttributeExpression (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   SilentComponentElement := SilentConstExpression 
                             [ '..' SilentConstExpression  ] 

   first  symbols:stringtok, identtok, lcbratok, attributetok, realtok, integertok, lparatok, nottok, plustok, minustok
   
   cannot reachend
*/

static void SilentComponentElement (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   SilentComponentValue := SilentComponentElement [ 
   'BY' SilentConstExpression  ] 

   first  symbols:attributetok, lcbratok, identtok, stringtok, nottok, lparatok, integertok, realtok, minustok, plustok
   
   cannot reachend
*/

static void SilentComponentValue (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   SilentArraySetRecordValue := SilentComponentValue 
                                { ',' SilentComponentValue  } 

   first  symbols:stringtok, identtok, lcbratok, attributetok, realtok, integertok, lparatok, nottok, plustok, minustok
   
   cannot reachend
*/

static void SilentArraySetRecordValue (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   SilentConstructor := '{' 
                        % SilentBuildConstructorStart  %
                        [ SilentArraySetRecordValue  ] 
                        '}' 

   first  symbols:lcbratok
   
   cannot reachend
*/

static void SilentConstructor (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   SilentConstSetOrQualidentOrFunction := SilentConstructor  | 
                                          Qualident 
                                          [ SilentConstructor  | 
                                            SilentActualParameters  ] 

   first  symbols:identtok, lcbratok
   
   cannot reachend
*/

static void SilentConstSetOrQualidentOrFunction (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   SilentActualParameters := '(' [ SilentExpList  ] 
                             ')' 

   first  symbols:lparatok
   
   cannot reachend
*/

static void SilentActualParameters (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   SilentExpList := SilentConstExpression { ',' SilentConstExpression  } 

   first  symbols:stringtok, identtok, lcbratok, attributetok, realtok, integertok, lparatok, nottok, plustok, minustok
   
   cannot reachend
*/

static void SilentExpList (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   SetType := ( 'SET'  | 'PACKEDSET'  ) 'OF' SimpleType 

   first  symbols:oftok, packedsettok, settok
   
   cannot reachend
*/

static void SetType (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   PointerType := 'POINTER' 'TO' Type 

   first  symbols:pointertok
   
   cannot reachend
*/

static void PointerType (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   ProcedureType := 'PROCEDURE' [ FormalTypeList  ] 

   first  symbols:proceduretok
   
   cannot reachend
*/

static void ProcedureType (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   FormalTypeList := '(' ( ')' FormalReturn  | 
                           ProcedureParameters ')' 
                           FormalReturn  ) 

   first  symbols:lparatok
   
   cannot reachend
*/

static void FormalTypeList (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   FormalReturn := [ ':' OptReturnType  ] 

   first  symbols:colontok
   
   reachend
*/

static void FormalReturn (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   OptReturnType := '[' Qualident ']'  | 
                    Qualident 

   first  symbols:identtok, lsbratok
   
   cannot reachend
*/

static void OptReturnType (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   ProcedureParameters := ProcedureParameter { ',' 
                                               ProcedureParameter  } 

   first  symbols:identtok, arraytok, periodperiodperiodtok, vartok
   
   cannot reachend
*/

static void ProcedureParameters (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   ProcedureParameter := '...'  | 'VAR' FormalType  | 
                         FormalType 

   first  symbols:arraytok, identtok, vartok, periodperiodperiodtok
   
   cannot reachend
*/

static void ProcedureParameter (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   VarIdent := 
               % VAR
                                                                                                 Sym, Type: CARDINAL ;
                                                                                                 on: BOOLEAN ;  %
               
               % on := IsAutoPushOn()  %
               
               % IF NOT on
                 THEN
                    PushAutoOn
                 END  %
               Ident 
               % IF on
                 THEN
                    PopTF(Sym, Type) ;
                    PushTF(Sym, Type) ;
                    PushTF(Sym, Type)
                 END  %
               [ '[' ConstExpression 
                 % BuildVarAtAddress  %
                 ']'  ] 
               % PopNothing ;
                 PopAuto  %
               

   first  symbols:identtok
   
   cannot reachend
*/

static void VarIdent (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   VarIdentList := VarIdent 
                   % VAR
                                                                                                     on: BOOLEAN ;
                                                                                                     n : CARDINAL ;  %
                   
                   % on := IsAutoPushOn() ;
                     IF on
                     THEN
                        n := 1
                     END  %
                   { ',' VarIdent 
                     % IF on
                       THEN
                          INC(n)
                       END  %
                      } 
                   % IF on
                     THEN
                        PushT(n)
                     END  %
                   

   first  symbols:identtok
   
   cannot reachend
*/

static void VarIdentList (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   VariableDeclaration := VarIdentList ':' Type Alignment 

   first  symbols:identtok
   
   cannot reachend
*/

static void VariableDeclaration (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   Designator := Qualident 
                 % CheckWithReference  %
                 { SubDesignator  } 

   first  symbols:identtok
   
   cannot reachend
*/

static void Designator (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   SubDesignator := '.' 
                    % VAR Sym, Type, tok,
                          dotpostok     : CARDINAL ;
                          name, n1      : Name ;  %
                    
                    % dotpostok := GetTokenNo () -1 ;
                      PopTFtok (Sym, Type, tok) ;
                      Type := SkipType(Type) ;
                      PushTFtok(Sym, Type, tok) ;
                      IF Type=NulSym
                      THEN
                         n1 := GetSymName(Sym) ;
                         IF IsModuleKnown(GetSymName(Sym))
                         THEN
                            WriteFormat2('%a looks like a module which has not been globally imported (eg. suggest that you IMPORT %a ;)',
                            n1, n1)
                         ELSE
                            WriteFormat1('%a is not a record variable', n1)
                         END
                      ELSIF NOT IsRecord(Type)
                      THEN
                         n1 := GetSymName(Type) ;
                         WriteFormat1('%a is not a record type', n1)
                      END ;
                      StartScope(Type)  %
                    Ident 
                    % PopTtok (name, tok) ;
                      Sym := GetLocalSym(Type, name) ;
                      IF Sym=NulSym
                      THEN
                         n1 := GetSymName(Type) ;
                         WriteFormat2('field %a does not exist within record %a', name, n1)
                      END ;
                      Type := GetType(Sym) ;
                      PushTFtok (Sym, Type, tok) ;
                      EndScope ;
                      PushT(1) ;
                      BuildDesignatorRecord (dotpostok)  %
                     | '[' ArrayExpList ']'  | 
                    '^' 
                    % BuildDesignatorPointer (GetTokenNo () -1)  %
                    

   first  symbols:uparrowtok, lsbratok, periodtok
   
   cannot reachend
*/

static void SubDesignator (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   ArrayExpList := Expression 
                   % BuildBooleanVariable  %
                   
                   % BuildDesignatorArray  %
                   { ',' Expression 
                     % BuildBooleanVariable  %
                     
                     % BuildDesignatorArray  %
                      } 

   first  symbols:lcbratok, identtok, realtok, integertok, stringtok, lparatok, nottok, plustok, minustok
   
   cannot reachend
*/

static void ArrayExpList (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   ExpList := 
              % VAR n: CARDINAL ;  %
              Expression 
              % BuildBooleanVariable  %
              
              % n := 1  %
              { ',' Expression 
                % BuildBooleanVariable  %
                
                % INC(n)  %
                 } 
              % PushT(n)  %
              

   first  symbols:lcbratok, identtok, realtok, integertok, stringtok, lparatok, nottok, plustok, minustok
   
   cannot reachend
*/

static void ExpList (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   Expression := 
                 % VAR tokpos: CARDINAL ;  %
                 
                 % PushAutoOn  %
                 SimpleExpression [ Relation 
                                    % tokpos := GetTokenNo ()-1  %
                                    SimpleExpression 
                                    
                                    % BuildRelOp (tokpos)  %
                                     ] 
                 % PopAuto  %
                 

   first  symbols:identtok, lcbratok, nottok, lparatok, stringtok, integertok, realtok, minustok, plustok
   
   cannot reachend
*/

static void Expression (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   SimpleExpression := UnaryOrTerm { AddOperator Term 
                                     
                                     % BuildBinaryOp  %
                                      } 

   first  symbols:lcbratok, identtok, realtok, integertok, stringtok, lparatok, nottok, plustok, minustok
   
   cannot reachend
*/

static void SimpleExpression (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   UnaryOrTerm := '+' 
                  % PushTtok(PlusTok, GetTokenNo() -1)  %
                  Term 
                  % BuildUnaryOp  %
                   | '-' 
                  % PushTtok(MinusTok, GetTokenNo() -1)  %
                  Term 
                  % BuildUnaryOp  %
                   | Term 

   first  symbols:identtok, lcbratok, nottok, lparatok, stringtok, integertok, realtok, minustok, plustok
   
   cannot reachend
*/

static void UnaryOrTerm (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   Term := Factor { MulOperator Factor 
                    % BuildBinaryOp  %
                     } 

   first  symbols:lcbratok, identtok, realtok, integertok, stringtok, lparatok, nottok
   
   cannot reachend
*/

static void Term (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   Factor := 
             % VAR tokpos: CARDINAL ;  %
             Number  | string  | SetOrDesignatorOrFunction  | 
             '(' Expression ')'  | 
             'NOT' 
             % tokpos := GetTokenNo ()-1  %
             ( Factor 
               % BuildNot (tokpos)  %
                | ConstAttribute  ) 

   first  symbols:identtok, lcbratok, nottok, lparatok, stringtok, integertok, realtok
   
   cannot reachend
*/

static void Factor (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   SetOrDesignatorOrFunction := Qualident 
                                % Assert (OperandTok(1) # UnknownTokenNo)  %
                                
                                % CheckWithReference  %
                                
                                % Assert (OperandTok(1) # UnknownTokenNo)  %
                                [ Constructor  | 
                                  SimpleDes 
                                  %  Assert (OperandTok(1) # UnknownTokenNo)   %
                                  [ ActualParameters 
                                    
                                    % IF IsInConstExpression()
                                      THEN
                                         BuildConstFunctionCall
                                      ELSE
                                         BuildFunctionCall
                                      END  %
                                     ]  ]  | 
                                
                                % BuildTypeForConstructor  %
                                Constructor 

   first  symbols:lcbratok, identtok
   
   cannot reachend
*/

static void SetOrDesignatorOrFunction (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   SimpleDes := { SubDesignator  } 

   first  symbols:periodtok, lsbratok, uparrowtok
   
   reachend
*/

static void SimpleDes (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   ActualParameters := '(' 
                       % BuildSizeCheckStart  %
                       ( ExpList  | 
                         % BuildNulParam  %
                          ) ')' 

   first  symbols:lparatok
   
   cannot reachend
*/

static void ActualParameters (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   ExitStatement := 'EXIT' 
                    % BuildExit  %
                    

   first  symbols:exittok
   
   cannot reachend
*/

static void ExitStatement (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   ReturnStatement := 'RETURN' 
                      % VAR tokno: CARDINAL ;  %
                      
                      % tokno := GetTokenNo () -1  %
                      ( Expression  | 
                        % BuildNulExpression  in epsilon   %
                         ) 
                      % BuildReturn (tokno)  %
                      

   first  symbols:returntok
   
   cannot reachend
*/

static void ReturnStatement (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   Statement := 
                % BuildStmtNote (0)  %
                
                % PushAutoOn ; DisplayStack  %
                [ AssignmentOrProcedureCall  | 
                  IfStatement  | CaseStatement  | 
                  WhileStatement  | 
                  RepeatStatement  | 
                  LoopStatement  | ForStatement  | 
                  WithStatement  | AsmStatement  | 
                  ExitStatement  | ReturnStatement  | 
                  RetryStatement  ] 
                % PopAuto ;  %
                

   first  symbols:retrytok, asmtok, withtok, fortok, looptok, repeattok, whiletok, casetok, iftok, identtok, returntok, exittok
   
   reachend
*/

static void Statement (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   RetryStatement := 'RETRY' 
                     % BuildRetry (GetTokenNo () -1)  %
                     

   first  symbols:retrytok
   
   cannot reachend
*/

static void RetryStatement (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   AssignmentOrProcedureCall := 
                                % VAR isFunc: BOOLEAN ;
                                      tokno : CARDINAL ;  %
                                
                                % DisplayStack  %
                                Designator 
                                % tokno := GetTokenNo ()  %
                                ( ':=' 
                                  %  PrintTokenNo (tokno)   %
                                  Expression 
                                  % BuildAssignment (tokno)  %
                                   | 
                                  
                                  % isFunc := CheckBuildFunction()  %
                                  ( ActualParameters  | 
                                    
                                    % BuildNulParam  in epsilon   %
                                     ) 
                                  % IF isFunc
                                    THEN
                                       BuildFunctionCall ;
                                       BuildAssignment (tokno)
                                    ELSE
                                       BuildProcedureCall (tokno - 1)
                                    END  %
                                   ) 
                                % DisplayStack  %
                                

   first  symbols:identtok
   
   cannot reachend
*/

static void AssignmentOrProcedureCall (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   StatementSequence := Statement { ';' Statement  } 

   first  symbols:identtok, iftok, casetok, whiletok, repeattok, looptok, fortok, withtok, asmtok, retrytok, semicolontok, exittok, returntok
   
   reachend
*/

static void StatementSequence (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   IfStatement := 'IF' Expression 'THEN' 
                  % BuildThenIf  %
                  
                  % BuildStmtNote (-1)  %
                  StatementSequence { 'ELSIF' 
                                      % BuildElsif1  %
                                      
                                      % BuildStmtNote (-1)  %
                                      Expression 'THEN' 
                                      
                                      % BuildThenIf  %
                                      
                                      % BuildStmtNote (-1)  %
                                      StatementSequence 
                                      
                                      % BuildElsif2  %
                                       } [ 'ELSE' 
                                           % BuildElse  %
                                           
                                           % BuildStmtNote (-1)  %
                                           StatementSequence  ] 
                  'END' 
                  % BuildEndIf  %
                  
                  % BuildStmtNote (-1)  %
                  

   first  symbols:iftok
   
   cannot reachend
*/

static void IfStatement (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   CaseStatement := 'CASE' Expression 
                    % BuildCaseStart  %
                    'OF' Case { '|' Case  } CaseEndStatement 

   first  symbols:casetok
   
   cannot reachend
*/

static void CaseStatement (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   CaseEndStatement := 'END' 
                       % BuildStmtNote (-1)  %
                       
                       % BuildCaseElse  %
                       
                       % BuildCaseCheck  %
                       
                       % BuildCaseEnd  %
                        | 'ELSE' 
                       % BuildStmtNote (-1)  %
                       
                       % BuildCaseElse  %
                       StatementSequence 
                       % BuildStmtNote (0)  %
                       'END' 
                       % BuildCaseEnd  %
                       

   first  symbols:elsetok, endtok
   
   cannot reachend
*/

static void CaseEndStatement (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   Case := [ 
             % BuildStmtNote (-1)  %
             CaseLabelList 
             % BuildCaseStartStatementSequence  %
             ':' StatementSequence 
             % BuildCaseEndStatementSequence  %
             
             % EndCaseList  %
              ] 

   first  symbols:stringtok, lcbratok, identtok, attributetok, realtok, integertok, lparatok, nottok, plustok, minustok
   
   reachend
*/

static void Case (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   CaseLabelList := 
                    % BeginCaseList(NulSym)  %
                    CaseLabels { ',' 
                                 % BuildCaseOr  %
                                 CaseLabels  } 

   first  symbols:attributetok, identtok, lcbratok, stringtok, nottok, lparatok, integertok, realtok, minustok, plustok
   
   cannot reachend
*/

static void CaseLabelList (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   CaseLabels := ConstExpression ( '..' ConstExpression 
                                   
                                   % BuildCaseRange ;
                                     BuildCaseList  %
                                    | 
                                   
                                   % BuildCaseEquality ;   epsilon 
                                     BuildCaseList  %
                                    ) 

   first  symbols:stringtok, lcbratok, identtok, attributetok, realtok, integertok, lparatok, nottok, plustok, minustok
   
   cannot reachend
*/

static void CaseLabels (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   WhileStatement := 'WHILE' 
                     % BuildWhile  %
                     
                     % BuildStmtNote (0)  %
                     Expression 
                     % BuildStmtNote (0)  %
                     'DO' 
                     % BuildDoWhile  %
                     StatementSequence 
                     % BuildStmtNote (0)  %
                     'END' 
                     % DisplayStack ; BuildEndWhile  %
                     

   first  symbols:whiletok
   
   cannot reachend
*/

static void WhileStatement (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   RepeatStatement := 'REPEAT' 
                      % BuildRepeat  %
                      StatementSequence 
                      % BuildStmtNote (0)  %
                      'UNTIL' Expression 
                      % BuildUntil  %
                      

   first  symbols:repeattok
   
   cannot reachend
*/

static void RepeatStatement (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   ForStatement := 
                   % VAR endpostok: CARDINAL ;  %
                   
                   % PushLineNo  %
                   'FOR' Ident ':=' Expression 'TO' 
                   Expression ( 'BY' ConstExpression  | 
                                
                                % BuildPseudoBy  epsilon   %
                                 ) 
                   % PushLineNo  %
                   
                   % BuildStmtNote (0)  %
                   'DO' 
                   % BuildForToByDo  %
                   StatementSequence 
                   % BuildStmtNote (0)  %
                   
                   % endpostok := GetTokenNo ()  %
                   'END' 
                   % BuildEndFor (endpostok)  %
                   

   first  symbols:fortok
   
   cannot reachend
*/

static void ForStatement (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   LoopStatement := 'LOOP' 
                    % BuildLoop  %
                    StatementSequence 
                    % BuildStmtNote (0)  %
                    'END' 
                    % BuildEndLoop  %
                    

   first  symbols:looptok
   
   cannot reachend
*/

static void LoopStatement (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   WithStatement := 
                    % VAR
                                                                                                      tok: CARDINAL ;  %
                    'WITH' 
                    % tok := GetTokenNo () -1  %
                    Designator 
                    % StartBuildWith (tok)  %
                    
                    % BuildStmtNote (0)  %
                    'DO' StatementSequence 
                    % BuildStmtNote (0)  %
                    'END' 
                    % EndBuildWith  %
                    

   first  symbols:withtok
   
   cannot reachend
*/

static void WithStatement (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   ProcedureDeclaration := ProcedureHeading ';' ProcedureBlock 
                           
                           % BuildProcedureEnd ;
                             PushAutoOn  %
                           Ident 
                           % EndBuildProcedure ;
                             PopAuto  %
                           

   first  symbols:proceduretok
   
   cannot reachend
*/

static void ProcedureDeclaration (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   DefineBuiltinProcedure := [ '__ATTRIBUTE__' '__BUILTIN__' 
                               '(' '(' 
                               % PushAutoOff  %
                               Ident 
                               % PopAuto  %
                               ')' ')'  | 
                               '__INLINE__'  ] 

   first  symbols:inlinetok, attributetok
   
   reachend
*/

static void DefineBuiltinProcedure (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   ProcedureHeading := 'PROCEDURE' 
                       % M2Error.DefaultProcedure  %
                       
                       % PushAutoOn  %
                       DefineBuiltinProcedure ( Ident 
                                                
                                                % StartBuildProcedure ;
                                                  PushAutoOff  %
                                                [ FormalParameters  ] 
                                                AttributeNoReturn 
                                                
                                                % BuildProcedureHeading ;
                                                  PopAuto  %
                                                 ) 
                       
                       % PopAuto  %
                       

   first  symbols:proceduretok
   
   cannot reachend
*/

static void ProcedureHeading (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   Builtin := [ '__BUILTIN__'  | '__INLINE__'  ] 

   first  symbols:inlinetok, builtintok
   
   reachend
*/

static void Builtin (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   DefProcedureHeading := 'PROCEDURE' 
                          % M2Error.DefaultProcedure  %
                          
                          % PushAutoOn  %
                          Builtin ( Ident 
                                    % StartBuildProcedure ;
                                      PushAutoOff  %
                                    [ DefFormalParameters  ] 
                                    AttributeNoReturn 
                                    
                                    % BuildProcedureHeading ;
                                      PopAuto  %
                                     ) 
                          % PopAuto  %
                          
                          % M2Error.LeaveErrorScope  %
                          

   first  symbols:proceduretok
   
   cannot reachend
*/

static void DefProcedureHeading (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   AttributeNoReturn := [ ''  ] 

   first  symbols:ldirectivetok
   
   reachend
*/

static void AttributeNoReturn (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   AttributeUnused := [ ''  ] 

   first  symbols:ldirectivetok
   
   reachend
*/

static void AttributeUnused (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   ProcedureBlock := 
                     % BuildProcedureStart  %
                     { Declaration  } 
                     % BuildProcedureBegin  %
                     [ 'BEGIN' 
                       % BuildStmtNote (-1)  %
                       ProcedureBlockBody  ] 
                     % BuildStmtNote (0)  %
                     'END' 

   first  symbols:proceduretok, moduletok, consttok, typetok, vartok, endtok, begintok
   
   cannot reachend
*/

static void ProcedureBlock (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   Block := { Declaration  } 
            % StartBuildInit (GetTokenNo ())  %
            InitialBlock 
            % EndBuildInit (GetTokenNo ()) ;
              StartBuildFinally (GetTokenNo ())  %
            FinalBlock 
            % EndBuildFinally (GetTokenNo ())  %
            'END' 

   first  symbols:proceduretok, moduletok, finallytok, begintok, consttok, typetok, vartok, endtok
   
   cannot reachend
*/

static void Block (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   InitialBlock := [ 'BEGIN' 
                     % BuildStmtNote (-1)  %
                     InitialBlockBody  ] 

   first  symbols:begintok
   
   reachend
*/

static void InitialBlock (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   FinalBlock := [ 'FINALLY' 
                   % BuildStmtNote (-1)  %
                   FinalBlockBody  ] 

   first  symbols:finallytok
   
   reachend
*/

static void FinalBlock (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   InitialBlockBody := NormalPart [ 'EXCEPT' 
                                    % BuildStmtNote (-1)  %
                                    
                                    % BuildExceptInitial (GetTokenNo() -1)  %
                                    ExceptionalPart  ] 

   first  symbols:identtok, iftok, casetok, whiletok, repeattok, looptok, fortok, withtok, asmtok, retrytok, semicolontok, exittok, returntok, excepttok
   
   reachend
*/

static void InitialBlockBody (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   FinalBlockBody := NormalPart [ 'EXCEPT' 
                                  % BuildStmtNote (-1)  %
                                  
                                  % BuildExceptFinally (GetTokenNo() -1)  %
                                  ExceptionalPart  ] 

   first  symbols:identtok, iftok, casetok, whiletok, repeattok, looptok, fortok, withtok, asmtok, retrytok, semicolontok, exittok, returntok, excepttok
   
   reachend
*/

static void FinalBlockBody (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   ProcedureBlockBody := NormalPart [ 'EXCEPT' 
                                      % BuildStmtNote (-1)  %
                                      
                                      % BuildExceptProcedure (GetTokenNo() -1)  %
                                      ExceptionalPart  ] 

   first  symbols:identtok, iftok, casetok, whiletok, repeattok, looptok, fortok, withtok, asmtok, retrytok, semicolontok, exittok, returntok, excepttok
   
   reachend
*/

static void ProcedureBlockBody (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   NormalPart := StatementSequence 

   first  symbols:retrytok, asmtok, withtok, fortok, looptok, repeattok, whiletok, casetok, iftok, identtok, returntok, exittok, semicolontok
   
   reachend
*/

static void NormalPart (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   ExceptionalPart := StatementSequence 
                      % BuildReThrow (GetTokenNo())  %
                      

   first  symbols:retrytok, asmtok, withtok, fortok, looptok, repeattok, whiletok, casetok, iftok, identtok, returntok, exittok, semicolontok
   
   reachend
*/

static void ExceptionalPart (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   Declaration := 'CONST' { ConstantDeclaration ';'  }  | 
                  'TYPE' { TypeDeclaration ';'  }  | 
                  'VAR' { VariableDeclaration ';'  }  | 
                  ProcedureDeclaration ';'  | 
                  ModuleDeclaration ';' 

   first  symbols:moduletok, proceduretok, vartok, typetok, consttok
   
   cannot reachend
*/

static void Declaration (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   DefFormalParameters := '(' [ DefMultiFPSection  ] 
                          ')' FormalReturn 

   first  symbols:lparatok
   
   cannot reachend
*/

static void DefFormalParameters (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   DefMultiFPSection := DefExtendedFP  | 
                        FPSection [ ';' DefMultiFPSection  ] 

   first  symbols:identtok, vartok, lsbratok, periodperiodperiodtok
   
   cannot reachend
*/

static void DefMultiFPSection (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   FormalParameters := '(' [ MultiFPSection  ] ')' 
                       FormalReturn 

   first  symbols:lparatok
   
   cannot reachend
*/

static void FormalParameters (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   MultiFPSection := ExtendedFP  | FPSection [ ';' 
                                               MultiFPSection  ] 

   first  symbols:identtok, vartok, lsbratok, periodperiodperiodtok
   
   cannot reachend
*/

static void MultiFPSection (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   FPSection := NonVarFPSection  | 
                VarFPSection 

   first  symbols:vartok, identtok
   
   cannot reachend
*/

static void FPSection (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   DefExtendedFP := DefOptArg  | '...' 

   first  symbols:lsbratok, periodperiodperiodtok
   
   cannot reachend
*/

static void DefExtendedFP (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   ExtendedFP := OptArg  | '...' 

   first  symbols:lsbratok, periodperiodperiodtok
   
   cannot reachend
*/

static void ExtendedFP (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   VarFPSection := 'VAR' IdentList ':' FormalType [ 
   AttributeUnused  ] 

   first  symbols:vartok
   
   cannot reachend
*/

static void VarFPSection (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   NonVarFPSection := IdentList ':' FormalType [ AttributeUnused  ] 

   first  symbols:identtok
   
   cannot reachend
*/

static void NonVarFPSection (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   OptArg := '[' Ident ':' FormalType [ '=' ConstExpression 
                                        
                                        % BuildOptArgInitializer  %
                                         ] ']' 

   first  symbols:lsbratok
   
   cannot reachend
*/

static void OptArg (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   DefOptArg := '[' Ident ':' FormalType '=' ConstExpression 
                
                % BuildOptArgInitializer  %
                ']' 

   first  symbols:lsbratok
   
   cannot reachend
*/

static void DefOptArg (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   FormalType := { 'ARRAY' 'OF'  } Qualident 

   first  symbols:identtok, arraytok
   
   cannot reachend
*/

static void FormalType (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   ModuleDeclaration := 
                        % VAR modulet: CARDINAL ;  %
                        
                        % modulet := GetTokenNo ()  %
                        'MODULE' 
                        % M2Error.DefaultInnerModule  %
                        
                        % PushAutoOn  %
                        Ident 
                        % StartBuildInnerModule  %
                        
                        % BuildModuleStart (modulet) ;
                          PushAutoOff  %
                        [ Priority  ] ';' { Import  } 
                        [ Export  ] Block 
                        % PushAutoOn  %
                        Ident 
                        % EndBuildInnerModule  %
                        
                        % PopAuto ; PopAuto ; PopAuto  %
                        

   first  symbols:moduletok
   
   cannot reachend
*/

static void ModuleDeclaration (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   Priority := '[' 
               % PushAutoOn  %
               ConstExpression 
               % BuildModulePriority ;
                 PopAuto  %
               ']' 

   first  symbols:lsbratok
   
   cannot reachend
*/

static void Priority (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   Export := 'EXPORT' ( 'QUALIFIED' IdentList  | 
                        'UNQUALIFIED' IdentList  | 
                        IdentList  ) ';' 

   first  symbols:exporttok
   
   cannot reachend
*/

static void Export (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   FromImport := 
                 % PushAutoOn  %
                 'FROM' Ident 'IMPORT' IdentList ';' 
                 
                 % CheckImportListOuterModule  %
                 
                 % PopAuto  %
                 

   first  symbols:fromtok
   
   cannot reachend
*/

static void FromImport (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   WithoutFromImport := 
                        % PushAutoOff  %
                        'IMPORT' IdentList ';' 
                        % PopAuto  %
                        

   first  symbols:importtok
   
   cannot reachend
*/

static void WithoutFromImport (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   Import := FromImport  | WithoutFromImport 

   first  symbols:importtok, fromtok
   
   cannot reachend
*/

static void Import (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   DefinitionModule := 
                       % VAR deft, endt: CARDINAL ;  %
                       
                       % deft := GetTokenNo ()  %
                       'DEFINITION' 
                       % M2Error.DefaultDefinitionModule  %
                       'MODULE' 
                       % PushAutoOn  %
                       [ 'FOR' string  ] Ident 
                       % StartBuildDefFile (deft) ;
                         P3StartBuildDefModule ;
                         PushAutoOff  %
                       ';' { Import  } [ Export  ] 
                       { Definition  } 
                       % endt := GetTokenNo ()  %
                       'END' 
                       % PushAutoOn  %
                       Ident 
                       % EndBuildFile (endt) ;
                         P3EndBuildDefModule  %
                       '.' 
                       % PopAuto ; PopAuto ; PopAuto  %
                       

   first  symbols:definitiontok
   
   cannot reachend
*/

static void DefinitionModule (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   Definition := 'CONST' { ConstantDeclaration ';'  }  | 
                 'TYPE' { Ident ( ';'  | '=' Type Alignment 
                                  ';'  )  }  | 
                 'VAR' { VariableDeclaration ';'  }  | 
                 DefProcedureHeading ';' 

   first  symbols:proceduretok, vartok, typetok, consttok
   
   cannot reachend
*/

static void Definition (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   AsmStatement := 
                   % VAR CurrentAsm: CARDINAL ;  %
                   'ASM' 
                   % IF Pass3
                     THEN
                        PushAutoOn ;
                        PushT(0) ;   operand count 
                        PushT(MakeGnuAsm())
                     END
                      %
                   [ 'VOLATILE' 
                     % IF Pass3
                       THEN
                          PopT(CurrentAsm) ;
                          PutGnuAsmVolatile(CurrentAsm) ;
                          PushT(CurrentAsm)
                       END
                        %
                      ] '(' AsmOperands 
                   % IF Pass3
                     THEN
                        PopNothing ;   throw away interface sym 
                        BuildInline ;
                        PopNothing ;   throw away count 
                        PopAuto
                     END
                      %
                   ')' 

   first  symbols:asmtok
   
   cannot reachend
*/

static void AsmStatement (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   AsmOperands := 
                  % VAR CurrentAsm, count: CARDINAL ;
                        str: CARDINAL ;
                     %
                  string 
                  % IF Pass3
                    THEN
                       PopT(str) ;
                       PopT(CurrentAsm) ;
                       Assert(IsGnuAsm(CurrentAsm) OR IsGnuAsmVolatile(CurrentAsm)) ;
                       PopT(count) ;
                       IF DebugAsm
                       THEN
                          printf1('1: count of asm operands: %d
', count)
                       END ;
                       PushT(count) ;
                        adds the name/instruction for this asm 
                       PutGnuAsm(CurrentAsm, str) ;
                       PushT(CurrentAsm) ;
                       PushT(NulSym)     the InterfaceSym 
                    END
                     %
                  ( AsmOperandSpec  | 
                    
                    %  epsilon 
                      IF Pass3
                      THEN
                         PutGnuAsmSimple(CurrentAsm)
                      END
                       %
                     ) 

   first  symbols:stringtok
   
   cannot reachend
*/

static void AsmOperands (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   AsmOperandSpec := 
                     % VAR CurrentAsm, outputs, inputs, trash, count: CARDINAL ;
                        %
                     [ ':' AsmList 
                       % IF Pass3
                         THEN
                            PopT(outputs) ;
                            PopT(CurrentAsm) ;
                            Assert(IsGnuAsm(CurrentAsm) OR IsGnuAsmVolatile(CurrentAsm)) ;
                            PopT(count) ;
                            IF DebugAsm
                            THEN
                               printf1('2: output count of asm operands: %d
', count)
                            END ;
                            PutGnuAsmOutput(CurrentAsm, outputs) ;
                            PushT(0) ;   reset count 
                            PushT(CurrentAsm) ;
                            PushT(NulSym)     the InterfaceSym 
                         END
                          %
                       [ ':' AsmList 
                         % IF Pass3
                           THEN
                              PopT(inputs) ;
                              PopT(CurrentAsm) ;
                              Assert(IsGnuAsm(CurrentAsm) OR IsGnuAsmVolatile(CurrentAsm)) ;
                              PopT(count) ;
                              IF DebugAsm
                              THEN
                                 printf1('3: input count of asm operands: %d
', count)
                              END ;
                              PutGnuAsmInput(CurrentAsm, inputs) ;
                              PushT(0) ;   reset count 
                              PushT(CurrentAsm) ;
                              PushT(NulSym)     the InterfaceSym 
                           END
                            %
                         [ ':' TrashList 
                           % IF Pass3
                             THEN
                                PopT(trash) ;
                                PopT(CurrentAsm) ;
                                Assert(IsGnuAsm(CurrentAsm) OR IsGnuAsmVolatile(CurrentAsm)) ;
                                PopT(count) ;
                                IF DebugAsm
                                THEN
                                   printf1('4: trash count of asm operands: %d
', count)
                                END ;
                                PutGnuAsmTrash(CurrentAsm, trash) ;
                                PushT(0) ;   reset count 
                                PushT(CurrentAsm) ;
                                PushT(NulSym)     the InterfaceSym 
                             END
                              %
                            ]  ]  ] 

   first  symbols:colontok
   
   reachend
*/

static void AsmOperandSpec (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   AsmList := 
              % VAR count, CurrentAsm, CurrentInterface: CARDINAL ;  %
              
              % IF Pass3
                THEN
                   PopT(CurrentInterface) ;
                   PopT(CurrentAsm) ;
                   PopT(count) ;
                   Assert(IsGnuAsm(CurrentAsm) OR IsGnuAsmVolatile(CurrentAsm)) ;
                   PushT(count) ;
                   PushT(CurrentAsm) ;
                   PushT(CurrentInterface) ;
                   IF DebugAsm
                   THEN
                      printf1('8: AsmList has a count of asm operands: %d
', count)
                   END
                END
                 %
              [ AsmElement  ] { ',' AsmElement  } 

   first  symbols:lsbratok, stringtok, commatok
   
   reachend
*/

static void AsmList (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   NamedOperand := '[' Ident ']' 

   first  symbols:lsbratok
   
   cannot reachend
*/

static void NamedOperand (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   AsmOperandName := ( NamedOperand  | 
                       
                       % IF IsAutoPushOn()
                         THEN
                            PushTF(NulName, identtok)
                         END
                          %
                        ) 

   first  symbols:lsbratok
   
   reachend
*/

static void AsmOperandName (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   AsmElement := 
                 % VAR n, str, expr,
                       CurrentInterface,
                       CurrentAsm, name: CARDINAL ;  %
                 AsmOperandName string '(' Expression 
                 
                 % IF Pass3
                   THEN
                      PopT(expr) ;
                      PopT(str) ;
                      PopT(name) ;
                      PopT(CurrentInterface) ;
                      PopT(CurrentAsm) ;
                      Assert(IsGnuAsm(CurrentAsm) OR IsGnuAsmVolatile(CurrentAsm)) ;
                      PopT(n) ;
                      INC(n) ;
                      IF CurrentInterface=NulSym
                      THEN
                         CurrentInterface := MakeRegInterface()
                      END ;
                      IF DebugAsm
                      THEN
                         printf1('5: count of asm operands: %d
', n)
                      END ;
                      PutRegInterface(CurrentInterface, n, name, str, expr) ;
                      PushT(n) ;
                      PushT(CurrentAsm) ;
                      PushT(CurrentInterface)
                   END
                    %
                 ')' 

   first  symbols:stringtok, lsbratok
   
   cannot reachend
*/

static void AsmElement (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

/*
   TrashList := 
                % VAR CurrentInterface,
                      CurrentAsm,
                      n, str          : CARDINAL ;  %
                [ string 
                  % IF Pass3
                    THEN
                       PopT(str) ;
                       PopT(CurrentInterface) ;
                       PopT(CurrentAsm) ;
                       PopT(n) ;
                       INC(n) ;
                       Assert(IsGnuAsm(CurrentAsm) OR IsGnuAsmVolatile(CurrentAsm)) ;
                       IF DebugAsm
                       THEN
                          printf1('6: count of asm trash operands: %d
', n)
                       END ;
                       IF CurrentInterface=NulSym
                       THEN
                          CurrentInterface := MakeRegInterface()
                       END ;
                       PutRegInterface(CurrentInterface, n, NulName, str, NulSym) ;
                       PushT(n) ;
                       PushT(CurrentAsm) ;
                       PushT(CurrentInterface)
                    END
                     %
                   ] { ',' string 
                       % IF Pass3
                         THEN
                            PopT(str) ;
                            PopT(CurrentInterface) ;
                            PopT(CurrentAsm) ;
                            PopT(n) ;
                            INC(n) ;
                            Assert(IsGnuAsm(CurrentAsm) OR IsGnuAsmVolatile(CurrentAsm)) ;
                            IF DebugAsm
                            THEN
                               printf1('7: count of asm trash operands: %d
', n)
                            END ;
                            IF CurrentInterface=NulSym
                            THEN
                               CurrentInterface := MakeRegInterface()
                            END ;
                            PutRegInterface(CurrentInterface, n, NulName, str, NulSym) ;
                            PushT(n) ;
                            PushT(CurrentAsm) ;
                            PushT(CurrentInterface)
                         END
                          %
                        } 

   first  symbols:commatok, stringtok
   
   reachend
*/

static void TrashList (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2);

static void ErrorString (DynamicStrings_String s)
{
  M2Error_ErrorStringAt (s, M2LexBuf_GetTokenNo ());  /* permanently disabled for the time being  */
  WasNoError = false;
}

static void ErrorArray (const char *a_, unsigned int _a_high)
{
  char a[_a_high+1];

  /* make a local copy of each unbounded array.  */
  memcpy (a, a_, _a_high+1);

  ErrorString (DynamicStrings_InitString ((const char *) a, _a_high));
}


/*
   DescribeStop - issues a message explaining what tokens were expected
*/

static DynamicStrings_String DescribeStop (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  unsigned int n;
  DynamicStrings_String str;
  DynamicStrings_String message;

  n = 0;
  message = DynamicStrings_InitString ((const char *) "", 0);
  if ((((1 << (M2Reserved_stringtok-M2Reserved_recordtok)) & (stopset2)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%Kstring}", 10)));
      n += 1;
    }
  if ((((1 << (M2Reserved_realtok-M2Reserved_recordtok)) & (stopset2)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%Kreal number}", 15)));
      n += 1;
    }
  if ((((1 << (M2Reserved_identtok-M2Reserved_recordtok)) & (stopset2)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%Kidentifier}", 14)));
      n += 1;
    }
  if ((((1 << (M2Reserved_integertok-M2Reserved_recordtok)) & (stopset2)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%Kinteger number}", 18)));
      n += 1;
    }
  if ((((1 << (M2Reserved_inlinetok-M2Reserved_recordtok)) & (stopset2)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%K__INLINE__}", 14)));
      n += 1;
    }
  if ((((1 << (M2Reserved_builtintok-M2Reserved_recordtok)) & (stopset2)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%K__BUILTIN__}", 15)));
      n += 1;
    }
  if ((((1 << (M2Reserved_attributetok-M2Reserved_recordtok)) & (stopset2)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%K__ATTRIBUTE__}", 17)));
      n += 1;
    }
  if ((((1 << (M2Reserved_filetok-M2Reserved_recordtok)) & (stopset2)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%K__FILE__}", 12)));
      n += 1;
    }
  if ((((1 << (M2Reserved_linetok-M2Reserved_recordtok)) & (stopset2)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%K__LINE__}", 12)));
      n += 1;
    }
  if ((((1 << (M2Reserved_datetok-M2Reserved_recordtok)) & (stopset2)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%K__DATE__}", 12)));
      n += 1;
    }
  if ((((1 << (M2Reserved_periodperiodperiodtok-M2Reserved_recordtok)) & (stopset2)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%K...}", 7)));
      n += 1;
    }
  if ((((1 << (M2Reserved_volatiletok-M2Reserved_recordtok)) & (stopset2)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KVOLATILE}", 12)));
      n += 1;
    }
  if ((((1 << (M2Reserved_asmtok-M2Reserved_recordtok)) & (stopset2)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KASM}", 7)));
      n += 1;
    }
  if ((((1 << (M2Reserved_withtok-M2Reserved_recordtok)) & (stopset2)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KWITH}", 8)));
      n += 1;
    }
  if ((((1 << (M2Reserved_whiletok-M2Reserved_recordtok)) & (stopset2)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KWHILE}", 9)));
      n += 1;
    }
  if ((((1 << (M2Reserved_vartok-M2Reserved_recordtok)) & (stopset2)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KVAR}", 7)));
      n += 1;
    }
  if ((((1 << (M2Reserved_untiltok-M2Reserved_recordtok)) & (stopset2)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KUNTIL}", 9)));
      n += 1;
    }
  if ((((1 << (M2Reserved_typetok-M2Reserved_recordtok)) & (stopset2)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KTYPE}", 8)));
      n += 1;
    }
  if ((((1 << (M2Reserved_totok-M2Reserved_recordtok)) & (stopset2)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KTO}", 6)));
      n += 1;
    }
  if ((((1 << (M2Reserved_thentok-M2Reserved_recordtok)) & (stopset2)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KTHEN}", 8)));
      n += 1;
    }
  if ((((1 << (M2Reserved_settok-M2Reserved_recordtok)) & (stopset2)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KSET}", 7)));
      n += 1;
    }
  if ((((1 << (M2Reserved_returntok-M2Reserved_recordtok)) & (stopset2)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KRETURN}", 10)));
      n += 1;
    }
  if ((((1 << (M2Reserved_retrytok-M2Reserved_recordtok)) & (stopset2)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KRETRY}", 9)));
      n += 1;
    }
  if ((((1 << (M2Reserved_repeattok-M2Reserved_recordtok)) & (stopset2)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KREPEAT}", 10)));
      n += 1;
    }
  if ((((1 << (M2Reserved_remtok-M2Reserved_recordtok)) & (stopset2)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KREM}", 7)));
      n += 1;
    }
  if ((((1 << (M2Reserved_recordtok-M2Reserved_recordtok)) & (stopset2)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KRECORD}", 10)));
      n += 1;
    }
  if ((((1 << (M2Reserved_unqualifiedtok-M2Reserved_arraytok)) & (stopset1)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KUNQUALIFIED}", 15)));
      n += 1;
    }
  if ((((1 << (M2Reserved_qualifiedtok-M2Reserved_arraytok)) & (stopset1)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KQUALIFIED}", 13)));
      n += 1;
    }
  if ((((1 << (M2Reserved_proceduretok-M2Reserved_arraytok)) & (stopset1)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KPROCEDURE}", 13)));
      n += 1;
    }
  if ((((1 << (M2Reserved_pointertok-M2Reserved_arraytok)) & (stopset1)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KPOINTER}", 11)));
      n += 1;
    }
  if ((((1 << (M2Reserved_packedsettok-M2Reserved_arraytok)) & (stopset1)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KPACKEDSET}", 13)));
      n += 1;
    }
  if ((((1 << (M2Reserved_ortok-M2Reserved_arraytok)) & (stopset1)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KOR}", 6)));
      n += 1;
    }
  if ((((1 << (M2Reserved_oftok-M2Reserved_arraytok)) & (stopset1)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KOF}", 6)));
      n += 1;
    }
  if ((((1 << (M2Reserved_nottok-M2Reserved_arraytok)) & (stopset1)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KNOT}", 7)));
      n += 1;
    }
  if ((((1 << (M2Reserved_moduletok-M2Reserved_arraytok)) & (stopset1)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KMODULE}", 10)));
      n += 1;
    }
  if ((((1 << (M2Reserved_modtok-M2Reserved_arraytok)) & (stopset1)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KMOD}", 7)));
      n += 1;
    }
  if ((((1 << (M2Reserved_looptok-M2Reserved_arraytok)) & (stopset1)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KLOOP}", 8)));
      n += 1;
    }
  if ((((1 << (M2Reserved_intok-M2Reserved_arraytok)) & (stopset1)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KIN}", 6)));
      n += 1;
    }
  if ((((1 << (M2Reserved_importtok-M2Reserved_arraytok)) & (stopset1)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KIMPORT}", 10)));
      n += 1;
    }
  if ((((1 << (M2Reserved_implementationtok-M2Reserved_arraytok)) & (stopset1)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KIMPLEMENTATION}", 18)));
      n += 1;
    }
  if ((((1 << (M2Reserved_iftok-M2Reserved_arraytok)) & (stopset1)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KIF}", 6)));
      n += 1;
    }
  if ((((1 << (M2Reserved_fromtok-M2Reserved_arraytok)) & (stopset1)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KFROM}", 8)));
      n += 1;
    }
  if ((((1 << (M2Reserved_fortok-M2Reserved_arraytok)) & (stopset1)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KFOR}", 7)));
      n += 1;
    }
  if ((((1 << (M2Reserved_finallytok-M2Reserved_arraytok)) & (stopset1)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KFINALLY}", 11)));
      n += 1;
    }
  if ((((1 << (M2Reserved_exporttok-M2Reserved_arraytok)) & (stopset1)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KEXPORT}", 10)));
      n += 1;
    }
  if ((((1 << (M2Reserved_exittok-M2Reserved_arraytok)) & (stopset1)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KEXIT}", 8)));
      n += 1;
    }
  if ((((1 << (M2Reserved_excepttok-M2Reserved_arraytok)) & (stopset1)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KEXCEPT}", 10)));
      n += 1;
    }
  if ((((1 << (M2Reserved_endtok-M2Reserved_arraytok)) & (stopset1)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KEND}", 7)));
      n += 1;
    }
  if ((((1 << (M2Reserved_elsiftok-M2Reserved_arraytok)) & (stopset1)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KELSIF}", 9)));
      n += 1;
    }
  if ((((1 << (M2Reserved_elsetok-M2Reserved_arraytok)) & (stopset1)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KELSE}", 8)));
      n += 1;
    }
  if ((((1 << (M2Reserved_dotok-M2Reserved_arraytok)) & (stopset1)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KDO}", 6)));
      n += 1;
    }
  if ((((1 << (M2Reserved_divtok-M2Reserved_arraytok)) & (stopset1)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KDIV}", 7)));
      n += 1;
    }
  if ((((1 << (M2Reserved_definitiontok-M2Reserved_arraytok)) & (stopset1)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KDEFINITION}", 14)));
      n += 1;
    }
  if ((((1 << (M2Reserved_consttok-M2Reserved_arraytok)) & (stopset1)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KCONST}", 9)));
      n += 1;
    }
  if ((((1 << (M2Reserved_casetok-M2Reserved_arraytok)) & (stopset1)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KCASE}", 8)));
      n += 1;
    }
  if ((((1 << (M2Reserved_bytok-M2Reserved_arraytok)) & (stopset1)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KBY}", 6)));
      n += 1;
    }
  if ((((1 << (M2Reserved_begintok-M2Reserved_arraytok)) & (stopset1)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KBEGIN}", 9)));
      n += 1;
    }
  if ((((1 << (M2Reserved_arraytok-M2Reserved_arraytok)) & (stopset1)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KARRAY}", 9)));
      n += 1;
    }
  if ((((1 << (M2Reserved_andtok-M2Reserved_eoftok)) & (stopset0)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%KAND}", 7)));
      n += 1;
    }
  if ((((1 << (M2Reserved_colontok-M2Reserved_eoftok)) & (stopset0)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%K:}", 5)));
      n += 1;
    }
  if ((((1 << (M2Reserved_periodperiodtok-M2Reserved_eoftok)) & (stopset0)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%K..}", 6)));
      n += 1;
    }
  if ((((1 << (M2Reserved_rdirectivetok-M2Reserved_eoftok)) & (stopset0)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%K*>}", 6)));
      n += 1;
    }
  if ((((1 << (M2Reserved_ldirectivetok-M2Reserved_eoftok)) & (stopset0)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%K<*}", 6)));
      n += 1;
    }
  if ((((1 << (M2Reserved_greaterequaltok-M2Reserved_eoftok)) & (stopset0)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%K>=}", 6)));
      n += 1;
    }
  if ((((1 << (M2Reserved_lessequaltok-M2Reserved_eoftok)) & (stopset0)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%K<=}", 6)));
      n += 1;
    }
  if ((((1 << (M2Reserved_lessgreatertok-M2Reserved_eoftok)) & (stopset0)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%K<>}", 6)));
      n += 1;
    }
  if ((((1 << (M2Reserved_hashtok-M2Reserved_eoftok)) & (stopset0)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%K#}", 5)));
      n += 1;
    }
  if ((((1 << (M2Reserved_equaltok-M2Reserved_eoftok)) & (stopset0)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%K=}", 5)));
      n += 1;
    }
  if ((((1 << (M2Reserved_uparrowtok-M2Reserved_eoftok)) & (stopset0)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%K^}", 5)));
      n += 1;
    }
  if ((((1 << (M2Reserved_semicolontok-M2Reserved_eoftok)) & (stopset0)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%K;}", 5)));
      n += 1;
    }
  if ((((1 << (M2Reserved_commatok-M2Reserved_eoftok)) & (stopset0)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%K,}", 5)));
      n += 1;
    }
  if ((((1 << (M2Reserved_periodtok-M2Reserved_eoftok)) & (stopset0)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%K.}", 5)));
      n += 1;
    }
  if ((((1 << (M2Reserved_ambersandtok-M2Reserved_eoftok)) & (stopset0)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%K&}", 5)));
      n += 1;
    }
  if ((((1 << (M2Reserved_dividetok-M2Reserved_eoftok)) & (stopset0)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%K/}", 5)));
      n += 1;
    }
  if ((((1 << (M2Reserved_timestok-M2Reserved_eoftok)) & (stopset0)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%K*}", 5)));
      n += 1;
    }
  if ((((1 << (M2Reserved_minustok-M2Reserved_eoftok)) & (stopset0)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%K-}", 5)));
      n += 1;
    }
  if ((((1 << (M2Reserved_plustok-M2Reserved_eoftok)) & (stopset0)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%K+}", 5)));
      n += 1;
    }
  if ((((1 << (M2Reserved_doublequotestok-M2Reserved_eoftok)) & (stopset0)) != 0))
    {
      message = DynamicStrings_ConCatChar (DynamicStrings_ConCatChar (DynamicStrings_ConCatChar (DynamicStrings_ConCatChar (DynamicStrings_ConCatChar (message, ' '), '`'), '"'), '\''), ',');
      n += 1;
    }
  if ((((1 << (M2Reserved_singlequotetok-M2Reserved_eoftok)) & (stopset0)) != 0))
    {
      message = DynamicStrings_ConCatChar (DynamicStrings_ConCatChar (DynamicStrings_ConCatChar (DynamicStrings_ConCatChar (DynamicStrings_ConCatChar (message, ' '), '"'), '\''), '"'), ',');
      n += 1;
    }
  if ((((1 << (M2Reserved_greatertok-M2Reserved_eoftok)) & (stopset0)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%K>}", 5)));
      n += 1;
    }
  if ((((1 << (M2Reserved_lesstok-M2Reserved_eoftok)) & (stopset0)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%K<}", 5)));
      n += 1;
    }
  if ((((1 << (M2Reserved_rparatok-M2Reserved_eoftok)) & (stopset0)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%K)}", 5)));
      n += 1;
    }
  if ((((1 << (M2Reserved_lparatok-M2Reserved_eoftok)) & (stopset0)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%K(}", 5)));
      n += 1;
    }
  if ((((1 << (M2Reserved_rcbratok-M2Reserved_eoftok)) & (stopset0)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%K%}}", 6)));
      n += 1;
    }
  if ((((1 << (M2Reserved_lcbratok-M2Reserved_eoftok)) & (stopset0)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%K%{}", 6)));
      n += 1;
    }
  if ((((1 << (M2Reserved_rsbratok-M2Reserved_eoftok)) & (stopset0)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%K]}", 5)));
      n += 1;
    }
  if ((((1 << (M2Reserved_lsbratok-M2Reserved_eoftok)) & (stopset0)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%K[}", 5)));
      n += 1;
    }
  if ((((1 << (M2Reserved_bartok-M2Reserved_eoftok)) & (stopset0)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%K|}", 5)));
      n += 1;
    }
  if ((((1 << (M2Reserved_becomestok-M2Reserved_eoftok)) & (stopset0)) != 0))
    {
      message = DynamicStrings_ConCat (DynamicStrings_ConCatChar (message, ' '), DynamicStrings_Mark (DynamicStrings_InitString ((const char *) "{%K:=}", 6)));
      n += 1;
    }
  if ((((1 << (M2Reserved_eoftok-M2Reserved_eoftok)) & (stopset0)) != 0))
    {}  /* empty.  */
  /* eoftok has no token name (needed to generate error messages)  */
  if (n == 0)
    {
      str = DynamicStrings_InitString ((const char *) " syntax error", 13);
      message = DynamicStrings_KillString (message);
    }
  else if (n == 1)
    {
      /* avoid dangling else.  */
      str = DynamicStrings_ConCat (message, DynamicStrings_Mark (DynamicStrings_InitString ((const char *) " missing ", 9)));
    }
  else
    {
      /* avoid dangling else.  */
      str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) " expecting one of", 17), message);
      message = DynamicStrings_KillString (message);
    }
  return str;
  /* static analysis guarentees a RETURN statement will be used before here.  */
  __builtin_unreachable ();
}


/*
   DescribeError - issues a message explaining what tokens were expected
*/

static void DescribeError (void)
{
  DynamicStrings_String str;

  str = DynamicStrings_InitString ((const char *) "", 0);
  switch (M2LexBuf_currenttoken)
    {
      case M2Reserved_stringtok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%Kstring}", 30), DynamicStrings_Mark (str));
        break;

      case M2Reserved_realtok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%Kreal number}", 35), DynamicStrings_Mark (str));
        break;

      case M2Reserved_identtok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%Kidentifier}", 34), DynamicStrings_Mark (str));
        break;

      case M2Reserved_integertok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%Kinteger number}", 38), DynamicStrings_Mark (str));
        break;

      case M2Reserved_inlinetok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%K__INLINE__}", 34), DynamicStrings_Mark (str));
        break;

      case M2Reserved_builtintok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%K__BUILTIN__}", 35), DynamicStrings_Mark (str));
        break;

      case M2Reserved_attributetok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%K__ATTRIBUTE__}", 37), DynamicStrings_Mark (str));
        break;

      case M2Reserved_filetok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%K__FILE__}", 32), DynamicStrings_Mark (str));
        break;

      case M2Reserved_linetok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%K__LINE__}", 32), DynamicStrings_Mark (str));
        break;

      case M2Reserved_datetok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%K__DATE__}", 32), DynamicStrings_Mark (str));
        break;

      case M2Reserved_periodperiodperiodtok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%K...}", 27), DynamicStrings_Mark (str));
        break;

      case M2Reserved_volatiletok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KVOLATILE}", 32), DynamicStrings_Mark (str));
        break;

      case M2Reserved_asmtok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KASM}", 27), DynamicStrings_Mark (str));
        break;

      case M2Reserved_withtok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KWITH}", 28), DynamicStrings_Mark (str));
        break;

      case M2Reserved_whiletok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KWHILE}", 29), DynamicStrings_Mark (str));
        break;

      case M2Reserved_vartok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KVAR}", 27), DynamicStrings_Mark (str));
        break;

      case M2Reserved_untiltok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KUNTIL}", 29), DynamicStrings_Mark (str));
        break;

      case M2Reserved_typetok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KTYPE}", 28), DynamicStrings_Mark (str));
        break;

      case M2Reserved_totok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KTO}", 26), DynamicStrings_Mark (str));
        break;

      case M2Reserved_thentok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KTHEN}", 28), DynamicStrings_Mark (str));
        break;

      case M2Reserved_settok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KSET}", 27), DynamicStrings_Mark (str));
        break;

      case M2Reserved_returntok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KRETURN}", 30), DynamicStrings_Mark (str));
        break;

      case M2Reserved_retrytok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KRETRY}", 29), DynamicStrings_Mark (str));
        break;

      case M2Reserved_repeattok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KREPEAT}", 30), DynamicStrings_Mark (str));
        break;

      case M2Reserved_remtok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KREM}", 27), DynamicStrings_Mark (str));
        break;

      case M2Reserved_recordtok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KRECORD}", 30), DynamicStrings_Mark (str));
        break;

      case M2Reserved_unqualifiedtok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KUNQUALIFIED}", 35), DynamicStrings_Mark (str));
        break;

      case M2Reserved_qualifiedtok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KQUALIFIED}", 33), DynamicStrings_Mark (str));
        break;

      case M2Reserved_proceduretok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KPROCEDURE}", 33), DynamicStrings_Mark (str));
        break;

      case M2Reserved_pointertok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KPOINTER}", 31), DynamicStrings_Mark (str));
        break;

      case M2Reserved_packedsettok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KPACKEDSET}", 33), DynamicStrings_Mark (str));
        break;

      case M2Reserved_ortok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KOR}", 26), DynamicStrings_Mark (str));
        break;

      case M2Reserved_oftok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KOF}", 26), DynamicStrings_Mark (str));
        break;

      case M2Reserved_nottok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KNOT}", 27), DynamicStrings_Mark (str));
        break;

      case M2Reserved_moduletok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KMODULE}", 30), DynamicStrings_Mark (str));
        break;

      case M2Reserved_modtok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KMOD}", 27), DynamicStrings_Mark (str));
        break;

      case M2Reserved_looptok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KLOOP}", 28), DynamicStrings_Mark (str));
        break;

      case M2Reserved_intok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KIN}", 26), DynamicStrings_Mark (str));
        break;

      case M2Reserved_importtok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KIMPORT}", 30), DynamicStrings_Mark (str));
        break;

      case M2Reserved_implementationtok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KIMPLEMENTATION}", 38), DynamicStrings_Mark (str));
        break;

      case M2Reserved_iftok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KIF}", 26), DynamicStrings_Mark (str));
        break;

      case M2Reserved_fromtok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KFROM}", 28), DynamicStrings_Mark (str));
        break;

      case M2Reserved_fortok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KFOR}", 27), DynamicStrings_Mark (str));
        break;

      case M2Reserved_finallytok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KFINALLY}", 31), DynamicStrings_Mark (str));
        break;

      case M2Reserved_exporttok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KEXPORT}", 30), DynamicStrings_Mark (str));
        break;

      case M2Reserved_exittok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KEXIT}", 28), DynamicStrings_Mark (str));
        break;

      case M2Reserved_excepttok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KEXCEPT}", 30), DynamicStrings_Mark (str));
        break;

      case M2Reserved_endtok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KEND}", 27), DynamicStrings_Mark (str));
        break;

      case M2Reserved_elsiftok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KELSIF}", 29), DynamicStrings_Mark (str));
        break;

      case M2Reserved_elsetok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KELSE}", 28), DynamicStrings_Mark (str));
        break;

      case M2Reserved_dotok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KDO}", 26), DynamicStrings_Mark (str));
        break;

      case M2Reserved_divtok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KDIV}", 27), DynamicStrings_Mark (str));
        break;

      case M2Reserved_definitiontok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KDEFINITION}", 34), DynamicStrings_Mark (str));
        break;

      case M2Reserved_consttok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KCONST}", 29), DynamicStrings_Mark (str));
        break;

      case M2Reserved_casetok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KCASE}", 28), DynamicStrings_Mark (str));
        break;

      case M2Reserved_bytok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KBY}", 26), DynamicStrings_Mark (str));
        break;

      case M2Reserved_begintok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KBEGIN}", 29), DynamicStrings_Mark (str));
        break;

      case M2Reserved_arraytok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KARRAY}", 29), DynamicStrings_Mark (str));
        break;

      case M2Reserved_andtok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%KAND}", 27), DynamicStrings_Mark (str));
        break;

      case M2Reserved_colontok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%K:}", 25), DynamicStrings_Mark (str));
        break;

      case M2Reserved_periodperiodtok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%K..}", 26), DynamicStrings_Mark (str));
        break;

      case M2Reserved_rdirectivetok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%K*>}", 26), DynamicStrings_Mark (str));
        break;

      case M2Reserved_ldirectivetok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%K<*}", 26), DynamicStrings_Mark (str));
        break;

      case M2Reserved_greaterequaltok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%K>=}", 26), DynamicStrings_Mark (str));
        break;

      case M2Reserved_lessequaltok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%K<=}", 26), DynamicStrings_Mark (str));
        break;

      case M2Reserved_lessgreatertok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%K<>}", 26), DynamicStrings_Mark (str));
        break;

      case M2Reserved_hashtok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%K#}", 25), DynamicStrings_Mark (str));
        break;

      case M2Reserved_equaltok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%K=}", 25), DynamicStrings_Mark (str));
        break;

      case M2Reserved_uparrowtok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%K^}", 25), DynamicStrings_Mark (str));
        break;

      case M2Reserved_semicolontok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%K;}", 25), DynamicStrings_Mark (str));
        break;

      case M2Reserved_commatok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%K,}", 25), DynamicStrings_Mark (str));
        break;

      case M2Reserved_periodtok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%K.}", 25), DynamicStrings_Mark (str));
        break;

      case M2Reserved_ambersandtok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%K&}", 25), DynamicStrings_Mark (str));
        break;

      case M2Reserved_dividetok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%K/}", 25), DynamicStrings_Mark (str));
        break;

      case M2Reserved_timestok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%K*}", 25), DynamicStrings_Mark (str));
        break;

      case M2Reserved_minustok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%K-}", 25), DynamicStrings_Mark (str));
        break;

      case M2Reserved_plustok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%K+}", 25), DynamicStrings_Mark (str));
        break;

      case M2Reserved_doublequotestok:
        str = DynamicStrings_ConCat (DynamicStrings_ConCatChar (DynamicStrings_ConCatChar (DynamicStrings_InitString ((const char *) "syntax error, found '", 21), '"'), '\''), DynamicStrings_Mark (str));
        break;

      case M2Reserved_singlequotetok:
        str = DynamicStrings_ConCat (DynamicStrings_ConCatChar (DynamicStrings_ConCatChar (DynamicStrings_InitString ((const char *) "syntax error, found \"", 21), '\''), '"'), DynamicStrings_Mark (str));
        break;

      case M2Reserved_greatertok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%K>}", 25), DynamicStrings_Mark (str));
        break;

      case M2Reserved_lesstok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%K<}", 25), DynamicStrings_Mark (str));
        break;

      case M2Reserved_rparatok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%K)}", 25), DynamicStrings_Mark (str));
        break;

      case M2Reserved_lparatok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%K(}", 25), DynamicStrings_Mark (str));
        break;

      case M2Reserved_rcbratok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%K%}}", 26), DynamicStrings_Mark (str));
        break;

      case M2Reserved_lcbratok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%K%{}", 26), DynamicStrings_Mark (str));
        break;

      case M2Reserved_rsbratok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%K]}", 25), DynamicStrings_Mark (str));
        break;

      case M2Reserved_lsbratok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%K[}", 25), DynamicStrings_Mark (str));
        break;

      case M2Reserved_bartok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%K|}", 25), DynamicStrings_Mark (str));
        break;

      case M2Reserved_becomestok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%K:=}", 26), DynamicStrings_Mark (str));
        break;

      case M2Reserved_eoftok:
        str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error, found {%K}", 24), DynamicStrings_Mark (str));
        break;


      default:
        break;
    }
  ErrorString (str);
}


/*
   SyntaxError - after a syntax error we skip all tokens up until we reach
                 a stop symbol.
*/

static void SyntaxError (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  DescribeError ();
  if (Debugging)
    {
      M2Printf_printf0 ((const char *) "\\nskipping token *** ", 21);
    }
  /* --fixme-- this assumes a 32 bit word size.  */
  while (! (((( ((unsigned int) (M2LexBuf_currenttoken)) < 32) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_eoftok)) & (stopset0)) != 0))) || ((( ((unsigned int) (M2LexBuf_currenttoken)) >= 32) && ( ((unsigned int) (M2LexBuf_currenttoken)) < 64)) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_arraytok)) & (stopset1)) != 0)))) || (( ((unsigned int) (M2LexBuf_currenttoken)) >= 64) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_recordtok)) & (stopset2)) != 0)))))
    {
      M2LexBuf_GetToken ();
    }
  if (Debugging)
    {
      M2Printf_printf0 ((const char *) " ***\\n", 6);
    }
}


/*
   SyntaxCheck -
*/

static void SyntaxCheck (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  /* --fixme-- this assumes a 32 bit word size.  */
  if (! (((( ((unsigned int) (M2LexBuf_currenttoken)) < 32) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_eoftok)) & (stopset0)) != 0))) || ((( ((unsigned int) (M2LexBuf_currenttoken)) >= 32) && ( ((unsigned int) (M2LexBuf_currenttoken)) < 64)) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_arraytok)) & (stopset1)) != 0)))) || (( ((unsigned int) (M2LexBuf_currenttoken)) >= 64) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_recordtok)) & (stopset2)) != 0)))))
    {
      SyntaxError (stopset0, stopset1, stopset2);
    }
}


/*
   WarnMissingToken - generates a warning message about a missing token, t.
*/

static void WarnMissingToken (M2Reserved_toktype t)
{
  P3Build_SetOfStop0 s0;
  P3Build_SetOfStop1 s1;
  P3Build_SetOfStop2 s2;
  DynamicStrings_String str;

  s0 = (P3Build_SetOfStop0) 0;
  s1 = (P3Build_SetOfStop1) 0;
  s2 = (P3Build_SetOfStop2) 0;
  if ( ((unsigned int) (t)) < 32)
    {
      s0 = (P3Build_SetOfStop0) ((1 << (t-M2Reserved_eoftok)));
    }
  else if ( ((unsigned int) (t)) < 64)
    {
      /* avoid dangling else.  */
      s1 = (P3Build_SetOfStop1) ((1 << (t-M2Reserved_arraytok)));
    }
  else
    {
      /* avoid dangling else.  */
      s2 = (P3Build_SetOfStop2) ((1 << (t-M2Reserved_recordtok)));
    }
  str = DescribeStop (s0, s1, s2);
  str = DynamicStrings_ConCat (DynamicStrings_InitString ((const char *) "syntax error,", 13), DynamicStrings_Mark (str));
  M2Error_ErrorStringAt (str, M2LexBuf_GetTokenNo ());
}


/*
   MissingToken - generates a warning message about a missing token, t.
*/

static void MissingToken (M2Reserved_toktype t)
{
  WarnMissingToken (t);
  if ((((t != M2Reserved_identtok) && (t != M2Reserved_integertok)) && (t != M2Reserved_realtok)) && (t != M2Reserved_stringtok))
    {
      if (Debugging)
        {
          M2Printf_printf0 ((const char *) "inserting token\\n", 17);
        }
      M2LexBuf_InsertToken (t);
    }
}


/*
   CheckAndInsert -
*/

static bool CheckAndInsert (M2Reserved_toktype t, P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  if (((( ((unsigned int) (t)) < 32) && ((((1 << (t-M2Reserved_eoftok)) & (stopset0)) != 0))) || ((( ((unsigned int) (t)) >= 32) && ( ((unsigned int) (t)) < 64)) && ((((1 << (t-M2Reserved_arraytok)) & (stopset1)) != 0)))) || (( ((unsigned int) (t)) >= 64) && ((((1 << (t-M2Reserved_recordtok)) & (stopset2)) != 0))))
    {
      WarnMissingToken (t);
      M2LexBuf_InsertTokenAndRewind (t);
      return true;
    }
  else
    {
      return false;
    }
  /* static analysis guarentees a RETURN statement will be used before here.  */
  __builtin_unreachable ();
}


/*
   InStopSet
*/

static bool InStopSet (M2Reserved_toktype t, P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  if (((( ((unsigned int) (t)) < 32) && ((((1 << (t-M2Reserved_eoftok)) & (stopset0)) != 0))) || ((( ((unsigned int) (t)) >= 32) && ( ((unsigned int) (t)) < 64)) && ((((1 << (t-M2Reserved_arraytok)) & (stopset1)) != 0)))) || (( ((unsigned int) (t)) >= 64) && ((((1 << (t-M2Reserved_recordtok)) & (stopset2)) != 0))))
    {
      return true;
    }
  else
    {
      return false;
    }
  /* static analysis guarentees a RETURN statement will be used before here.  */
  __builtin_unreachable ();
}


/*
   PeepToken - peep token checks to see whether the stopset is satisfied by currenttoken
               If it is not then it will insert a token providing the token
               is one of ; ] ) } . OF END ,

               if the stopset contains <identtok> then we do not insert a token
*/

static void PeepToken (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  /* and again (see above re: ORD)
  */
  if ((! (((( ((unsigned int) (M2LexBuf_currenttoken)) < 32) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_eoftok)) & (stopset0)) != 0))) || ((( ((unsigned int) (M2LexBuf_currenttoken)) >= 32) && ( ((unsigned int) (M2LexBuf_currenttoken)) < 64)) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_arraytok)) & (stopset1)) != 0)))) || (( ((unsigned int) (M2LexBuf_currenttoken)) >= 64) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_recordtok)) & (stopset2)) != 0))))) && (! (InStopSet (M2Reserved_identtok, stopset0, stopset1, stopset2))))
    {
      /* SyntaxCheck would fail since currentoken is not part of the stopset
         we check to see whether any of currenttoken might be a commonly omitted token  */
      if ((((((((CheckAndInsert (M2Reserved_semicolontok, stopset0, stopset1, stopset2)) || (CheckAndInsert (M2Reserved_rsbratok, stopset0, stopset1, stopset2))) || (CheckAndInsert (M2Reserved_rparatok, stopset0, stopset1, stopset2))) || (CheckAndInsert (M2Reserved_rcbratok, stopset0, stopset1, stopset2))) || (CheckAndInsert (M2Reserved_periodtok, stopset0, stopset1, stopset2))) || (CheckAndInsert (M2Reserved_oftok, stopset0, stopset1, stopset2))) || (CheckAndInsert (M2Reserved_endtok, stopset0, stopset1, stopset2))) || (CheckAndInsert (M2Reserved_commatok, stopset0, stopset1, stopset2)))
        {}  /* empty.  */
    }
}


/*
   Expect -
*/

static void Expect (M2Reserved_toktype t, P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  if (M2LexBuf_currenttoken == t)
    {
      /* avoid dangling else.  */
      M2LexBuf_GetToken ();
      if (Pass1)
        {
          PeepToken (stopset0, stopset1, stopset2);
        }
    }
  else
    {
      MissingToken (t);
    }
  SyntaxCheck (stopset0, stopset1, stopset2);
}


/*
   Ident - error checking varient of Ident
*/

static void Ident (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  if (M2Quads_IsAutoPushOn ())
    {
      /* ; MetaErrorT0 (GetTokenNo(), "{%W}an ident")  */
      M2Quads_PushTFtok (NameKey_makekey (M2LexBuf_currentstring), static_cast<unsigned int> (M2Reserved_identtok), M2LexBuf_GetTokenNo ());
    }
  Expect (M2Reserved_identtok, stopset0, stopset1, stopset2);
}


/*
   string -
*/

static void string (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  if (M2Quads_IsAutoPushOn ())
    {
      M2Quads_PushTFtok (NameKey_makekey (M2LexBuf_currentstring), static_cast<unsigned int> (M2Reserved_stringtok), M2LexBuf_GetTokenNo ());
      P2SymBuild_BuildString ();
    }
  Expect (M2Reserved_stringtok, stopset0, stopset1, stopset2);
}


/*
   Integer -
*/

static void Integer (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  if (M2Quads_IsAutoPushOn ())
    {
      M2Quads_PushTFtok (NameKey_makekey (M2LexBuf_currentstring), static_cast<unsigned int> (M2Reserved_integertok), M2LexBuf_GetTokenNo ());
      P2SymBuild_BuildNumber ();
    }
  Expect (M2Reserved_integertok, stopset0, stopset1, stopset2);
}


/*
   Real -
*/

static void Real (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  if (M2Quads_IsAutoPushOn ())
    {
      M2Quads_PushTFtok (NameKey_makekey (M2LexBuf_currentstring), static_cast<unsigned int> (M2Reserved_realtok), M2LexBuf_GetTokenNo ());
      P2SymBuild_BuildNumber ();
    }
  Expect (M2Reserved_realtok, stopset0, stopset1, stopset2);
}


/*
   FileUnit := 
               % PushAutoOff  %
               ( DefinitionModule  | 
                 ImplementationOrProgramModule  ) 
               % PopAuto  %
               

   first  symbols:implementationtok, moduletok, definitiontok
   
   cannot reachend
*/

static void FileUnit (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  M2Quads_PushAutoOff ();
  if (M2LexBuf_currenttoken == M2Reserved_definitiontok)
    {
      DefinitionModule (stopset0, stopset1, stopset2);
    }
  else if (((M2LexBuf_currenttoken >= M2Reserved_arraytok) && (M2LexBuf_currenttoken < M2Reserved_recordtok)) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_arraytok)) & ((P3Build_SetOfStop1) ((1 << (M2Reserved_implementationtok-M2Reserved_arraytok)) | (1 << (M2Reserved_moduletok-M2Reserved_arraytok))))) != 0)))
    {
      /* avoid dangling else.  */
      ImplementationOrProgramModule (stopset0, stopset1, stopset2);
    }
  else
    {
      /* avoid dangling else.  */
      ErrorArray ((const char *) "expecting one of: {%KIMPLEMENTATION} {%KMODULE} {%KDEFINITION}", 62);
    }
  M2Quads_PopAuto ();
}


/*
   ProgramModule := 
                    % VAR modulet, endt: CARDINAL ;  %
                    
                    % modulet := GetTokenNo ()  %
                    'MODULE' 
                    % M2Error.DefaultProgramModule  %
                    
                    % PushAutoOn  %
                    Ident 
                    % P3StartBuildProgModule  %
                    
                    % StartBuildModFile (modulet)  %
                    
                    % BuildModuleStart (modulet)  %
                    
                    % PushAutoOff  %
                    [ Priority  ] ';' 
                    % BuildScaffold (modulet,
                                     GetCurrentModule ())  %
                    { Import  } Block 
                    % PushAutoOn  %
                    
                    % endt := GetTokenNo () -1  %
                    Ident 
                    % EndBuildFile (endt)  %
                    
                    % P3EndBuildProgModule  %
                    '.' 
                    % PopAuto ; PopAuto  %
                    

   first  symbols:moduletok
   
   cannot reachend
*/

static void ProgramModule (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  unsigned int modulet;
  unsigned int endt;

  modulet = M2LexBuf_GetTokenNo ();
  Expect (M2Reserved_moduletok, stopset0, stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  M2Error_DefaultProgramModule ();
  M2Quads_PushAutoOn ();
  Ident (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok)) | (1 << (M2Reserved_lsbratok-M2Reserved_eoftok))), stopset1, stopset2);
  P3SymBuild_P3StartBuildProgModule ();
  M2Quads_StartBuildModFile (modulet);
  M2Quads_BuildModuleStart (modulet);
  M2Quads_PushAutoOff ();
  if (M2LexBuf_currenttoken == M2Reserved_lsbratok)
    {
      Priority (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1, stopset2);
    }
  Expect (M2Reserved_semicolontok, stopset0, stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_importtok-M2Reserved_arraytok)) | (1 << (M2Reserved_fromtok-M2Reserved_arraytok)) | (1 << (M2Reserved_endtok-M2Reserved_arraytok)) | (1 << (M2Reserved_finallytok-M2Reserved_arraytok)) | (1 << (M2Reserved_begintok-M2Reserved_arraytok)) | (1 << (M2Reserved_consttok-M2Reserved_arraytok)) | (1 << (M2Reserved_proceduretok-M2Reserved_arraytok)) | (1 << (M2Reserved_moduletok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_typetok-M2Reserved_recordtok)) | (1 << (M2Reserved_vartok-M2Reserved_recordtok))));
  M2Quads_BuildScaffold (modulet, SymbolTable_GetCurrentModule ());
  while (((M2LexBuf_currenttoken >= M2Reserved_arraytok) && (M2LexBuf_currenttoken < M2Reserved_recordtok)) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_arraytok)) & ((P3Build_SetOfStop1) ((1 << (M2Reserved_fromtok-M2Reserved_arraytok)) | (1 << (M2Reserved_importtok-M2Reserved_arraytok))))) != 0)))
    {
      Import (stopset0, stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_endtok-M2Reserved_arraytok)) | (1 << (M2Reserved_fromtok-M2Reserved_arraytok)) | (1 << (M2Reserved_importtok-M2Reserved_arraytok)) | (1 << (M2Reserved_consttok-M2Reserved_arraytok)) | (1 << (M2Reserved_begintok-M2Reserved_arraytok)) | (1 << (M2Reserved_finallytok-M2Reserved_arraytok)) | (1 << (M2Reserved_moduletok-M2Reserved_arraytok)) | (1 << (M2Reserved_proceduretok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_vartok-M2Reserved_recordtok)) | (1 << (M2Reserved_typetok-M2Reserved_recordtok))));
    }
   /* while  */
  Block (stopset0, stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  M2Quads_PushAutoOn ();
  endt = (M2LexBuf_GetTokenNo ())-1;
  Ident (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_periodtok-M2Reserved_eoftok))), stopset1, stopset2);
  M2Quads_EndBuildFile (endt);
  P3SymBuild_P3EndBuildProgModule ();
  Expect (M2Reserved_periodtok, stopset0, stopset1, stopset2);
  M2Quads_PopAuto ();
  M2Quads_PopAuto ();
}


/*
   ImplementationModule := 
                           % VAR modulet, endt: CARDINAL ;  %
                           
                           % modulet := GetTokenNo ()  %
                           'IMPLEMENTATION' 
                           % M2Error.DefaultImplementationModule  %
                           'MODULE' 
                           % PushAutoOn  %
                           Ident 
                           % StartBuildModFile (modulet)  %
                           
                           % P3StartBuildImpModule  %
                           
                           % BuildModuleStart (modulet)  %
                           
                           % PushAutoOff  %
                           [ Priority  ] ';' 
                           % BuildScaffold (modulet,
                                            GetCurrentModule ())  %
                           { Import  } Block 
                           % PushAutoOn  %
                           
                           % endt := GetTokenNo () -1  %
                           Ident 
                           % EndBuildFile (endt)  %
                           
                           % P3EndBuildImpModule  %
                           '.' 
                           % PopAuto ; PopAuto ; PopAuto  %
                           

   first  symbols:implementationtok
   
   cannot reachend
*/

static void ImplementationModule (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  unsigned int modulet;
  unsigned int endt;

  modulet = M2LexBuf_GetTokenNo ();
  Expect (M2Reserved_implementationtok, stopset0, stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_moduletok-M2Reserved_arraytok))), stopset2);
  M2Error_DefaultImplementationModule ();
  Expect (M2Reserved_moduletok, stopset0, stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  M2Quads_PushAutoOn ();
  Ident (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok)) | (1 << (M2Reserved_lsbratok-M2Reserved_eoftok))), stopset1, stopset2);
  M2Quads_StartBuildModFile (modulet);
  P3SymBuild_P3StartBuildImpModule ();
  M2Quads_BuildModuleStart (modulet);
  M2Quads_PushAutoOff ();
  if (M2LexBuf_currenttoken == M2Reserved_lsbratok)
    {
      Priority (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1, stopset2);
    }
  Expect (M2Reserved_semicolontok, stopset0, stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_importtok-M2Reserved_arraytok)) | (1 << (M2Reserved_fromtok-M2Reserved_arraytok)) | (1 << (M2Reserved_endtok-M2Reserved_arraytok)) | (1 << (M2Reserved_finallytok-M2Reserved_arraytok)) | (1 << (M2Reserved_begintok-M2Reserved_arraytok)) | (1 << (M2Reserved_consttok-M2Reserved_arraytok)) | (1 << (M2Reserved_proceduretok-M2Reserved_arraytok)) | (1 << (M2Reserved_moduletok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_typetok-M2Reserved_recordtok)) | (1 << (M2Reserved_vartok-M2Reserved_recordtok))));
  M2Quads_BuildScaffold (modulet, SymbolTable_GetCurrentModule ());
  while (((M2LexBuf_currenttoken >= M2Reserved_arraytok) && (M2LexBuf_currenttoken < M2Reserved_recordtok)) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_arraytok)) & ((P3Build_SetOfStop1) ((1 << (M2Reserved_fromtok-M2Reserved_arraytok)) | (1 << (M2Reserved_importtok-M2Reserved_arraytok))))) != 0)))
    {
      Import (stopset0, stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_endtok-M2Reserved_arraytok)) | (1 << (M2Reserved_fromtok-M2Reserved_arraytok)) | (1 << (M2Reserved_importtok-M2Reserved_arraytok)) | (1 << (M2Reserved_consttok-M2Reserved_arraytok)) | (1 << (M2Reserved_begintok-M2Reserved_arraytok)) | (1 << (M2Reserved_finallytok-M2Reserved_arraytok)) | (1 << (M2Reserved_moduletok-M2Reserved_arraytok)) | (1 << (M2Reserved_proceduretok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_vartok-M2Reserved_recordtok)) | (1 << (M2Reserved_typetok-M2Reserved_recordtok))));
    }
   /* while  */
  Block (stopset0, stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  M2Quads_PushAutoOn ();
  endt = (M2LexBuf_GetTokenNo ())-1;
  Ident (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_periodtok-M2Reserved_eoftok))), stopset1, stopset2);
  M2Quads_EndBuildFile (endt);
  P3SymBuild_P3EndBuildImpModule ();
  Expect (M2Reserved_periodtok, stopset0, stopset1, stopset2);
  M2Quads_PopAuto ();
  M2Quads_PopAuto ();
  M2Quads_PopAuto ();
}


/*
   ImplementationOrProgramModule := 
                                    % PushAutoOff  %
                                    ( ImplementationModule  | 
                                      ProgramModule  ) 
                                    
                                    % PopAuto  %
                                    

   first  symbols:moduletok, implementationtok
   
   cannot reachend
*/

static void ImplementationOrProgramModule (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  M2Quads_PushAutoOff ();
  if (M2LexBuf_currenttoken == M2Reserved_implementationtok)
    {
      ImplementationModule (stopset0, stopset1, stopset2);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_moduletok)
    {
      /* avoid dangling else.  */
      ProgramModule (stopset0, stopset1, stopset2);
    }
  else
    {
      /* avoid dangling else.  */
      ErrorArray ((const char *) "expecting one of: {%KMODULE} {%KIMPLEMENTATION}", 47);
    }
  M2Quads_PopAuto ();
}


/*
   Number := Integer  | Real 

   first  symbols:realtok, integertok
   
   cannot reachend
*/

static void Number (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  if (M2LexBuf_currenttoken == M2Reserved_integertok)
    {
      Integer (stopset0, stopset1, stopset2);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_realtok)
    {
      /* avoid dangling else.  */
      Real (stopset0, stopset1, stopset2);
    }
  else
    {
      /* avoid dangling else.  */
      ErrorArray ((const char *) "expecting one of: {%Kreal number} {%Kinteger number}", 52);
    }
}


/*
   Qualident := 
                % VAR name          : Name ;
                      init, ip1,
                      tokstart, tok : CARDINAL ;  %
                Ident 
                % IF IsAutoPushOn()
                  THEN
                     PopTtok(name, tokstart) ;
                  										tok := tokstart ;
                     init := RequestSym (tok, name) ;
                     WHILE IsDefImp (init) OR IsModule (init) DO
                        Expect (periodtok, stopset0, stopset1, stopset2 + SetOfStop2{identtok}) ;
                        StartScope (init) ;
                        Ident (stopset0, stopset1, stopset2) ;
                        PopTtok (name, tok) ;
                        ip1 := RequestSym (tok, name) ;
                        PutIncluded(ip1) ;
                        EndScope ;
                        CheckCanBeImported(init, ip1) ;
                        init := ip1
                     END ;
                  										IF tok#tokstart
                  										THEN
                  										   tok := MakeVirtualTok (tokstart, tokstart, tok)
                  										END ;
                     IF IsProcedure(init) OR IsProcType(init)
                     THEN
                        PushTtok(init, tok)
                     ELSE
                        PushTFtok(init, GetType(init), tok) ;
                     END
                  ELSE  %
                { '.' Ident  } 
                % END  %
                

   first  symbols:identtok
   
   cannot reachend
*/

static void Qualident (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  NameKey_Name name;
  unsigned int init;
  unsigned int ip1;
  unsigned int tokstart;
  unsigned int tok;

  Ident (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_periodtok-M2Reserved_eoftok))), stopset1, stopset2);
  if (M2Quads_IsAutoPushOn ())
    {
      M2Quads_PopTtok (&name, &tokstart);
      tok = tokstart;
      init = SymbolTable_RequestSym (tok, name);
      while ((SymbolTable_IsDefImp (init)) || (SymbolTable_IsModule (init)))
        {
          Expect (M2Reserved_periodtok, stopset0, stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
          SymbolTable_StartScope (init);
          Ident (stopset0, stopset1, stopset2);
          M2Quads_PopTtok (&name, &tok);
          ip1 = SymbolTable_RequestSym (tok, name);
          SymbolTable_PutIncluded (ip1);
          SymbolTable_EndScope ();
          P3SymBuild_CheckCanBeImported (init, ip1);
          init = ip1;
        }
      if (tok != tokstart)
        {
          tok = M2LexBuf_MakeVirtualTok (tokstart, tokstart, tok);
        }
      if ((SymbolTable_IsProcedure (init)) || (SymbolTable_IsProcType (init)))
        {
          M2Quads_PushTtok (init, tok);
        }
      else
        {
          M2Quads_PushTFtok (init, SymbolTable_GetType (init), tok);
        }
    }
  else
    {
      while (M2LexBuf_currenttoken == M2Reserved_periodtok)
        {
          Expect (M2Reserved_periodtok, stopset0, stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
          Ident (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_periodtok-M2Reserved_eoftok))), stopset1, stopset2);
        }
       /* while  */
    }
}


/*
   ConstantDeclaration := 
                          % VAR tokno: CARDINAL ;  %
                          
                          % PushAutoOn  %
                          ( Ident '=' 
                            % tokno := GetTokenNo () -1  %
                            
                            % BuildConst  %
                            ConstExpression  ) 
                          % BuildAssignConstant (tokno)  %
                          
                          % PopAuto  %
                          

   first  symbols:identtok
   
   cannot reachend
*/

static void ConstantDeclaration (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  unsigned int tokno;

  M2Quads_PushAutoOn ();
  Ident (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_equaltok-M2Reserved_eoftok))), stopset1, stopset2);
  Expect (M2Reserved_equaltok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok))));
  tokno = (M2LexBuf_GetTokenNo ())-1;
  P3SymBuild_BuildConst ();
  ConstExpression (stopset0, stopset1, stopset2);
  M2Quads_BuildAssignConstant (tokno);
  M2Quads_PopAuto ();
}


/*
   ConstExpression := 
                      % VAR tokpos: CARDINAL ;  %
                      
                      % PushAutoOn  %
                      SimpleConstExpr [ Relation 
                                        % tokpos := GetTokenNo ()-1  %
                                        SimpleConstExpr 
                                        
                                        % BuildRelOp (tokpos)  %
                                         ] 
                      % PopAuto  %
                      

   first  symbols:attributetok, identtok, lcbratok, stringtok, nottok, lparatok, integertok, realtok, minustok, plustok
   
   cannot reachend
*/

static void ConstExpression (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  unsigned int tokpos;

  M2Quads_PushAutoOn ();
  SimpleConstExpr (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_greaterequaltok-M2Reserved_eoftok)) | (1 << (M2Reserved_greatertok-M2Reserved_eoftok)) | (1 << (M2Reserved_lessequaltok-M2Reserved_eoftok)) | (1 << (M2Reserved_lesstok-M2Reserved_eoftok)) | (1 << (M2Reserved_lessgreatertok-M2Reserved_eoftok)) | (1 << (M2Reserved_hashtok-M2Reserved_eoftok)) | (1 << (M2Reserved_equaltok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_intok-M2Reserved_arraytok))), stopset2);
  if (((M2LexBuf_currenttoken < M2Reserved_arraytok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_eoftok)) & ((P3Build_SetOfStop0) ((1 << (M2Reserved_equaltok-M2Reserved_eoftok)) | (1 << (M2Reserved_hashtok-M2Reserved_eoftok)) | (1 << (M2Reserved_lessgreatertok-M2Reserved_eoftok)) | (1 << (M2Reserved_lesstok-M2Reserved_eoftok)) | (1 << (M2Reserved_lessequaltok-M2Reserved_eoftok)) | (1 << (M2Reserved_greatertok-M2Reserved_eoftok)) | (1 << (M2Reserved_greaterequaltok-M2Reserved_eoftok))))) != 0))) || (M2LexBuf_currenttoken == M2Reserved_intok))
    {
      Relation (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok))));
      tokpos = (M2LexBuf_GetTokenNo ())-1;
      SimpleConstExpr (stopset0, stopset1, stopset2);
      M2Quads_BuildRelOp (tokpos);
    }
  M2Quads_PopAuto ();
}


/*
   Relation := '=' 
               % PushTtok(EqualTok, GetTokenNo() -1)  %
                | '#' 
               % PushTtok(HashTok, GetTokenNo() -1)  %
                | '<>' 
               % PushTtok(LessGreaterTok, GetTokenNo() -1)  %
                | '<' 
               % PushTtok(LessTok, GetTokenNo() -1)  %
                | '<=' 
               % PushTtok(LessEqualTok, GetTokenNo() -1)  %
                | '>' 
               % PushTtok(GreaterTok, GetTokenNo() -1)  %
                | '>=' 
               % PushTtok(GreaterEqualTok, GetTokenNo() -1)  %
                | 'IN' 
               % PushTtok(InTok, GetTokenNo() -1)  %
               

   first  symbols:intok, greaterequaltok, greatertok, lessequaltok, lesstok, lessgreatertok, hashtok, equaltok
   
   cannot reachend
*/

static void Relation (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  if (M2LexBuf_currenttoken == M2Reserved_equaltok)
    {
      Expect (M2Reserved_equaltok, stopset0, stopset1, stopset2);
      M2Quads_PushTtok (M2Reserved_EqualTok, (M2LexBuf_GetTokenNo ())-1);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_hashtok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_hashtok, stopset0, stopset1, stopset2);
      M2Quads_PushTtok (M2Reserved_HashTok, (M2LexBuf_GetTokenNo ())-1);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_lessgreatertok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_lessgreatertok, stopset0, stopset1, stopset2);
      M2Quads_PushTtok (M2Reserved_LessGreaterTok, (M2LexBuf_GetTokenNo ())-1);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_lesstok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_lesstok, stopset0, stopset1, stopset2);
      M2Quads_PushTtok (M2Reserved_LessTok, (M2LexBuf_GetTokenNo ())-1);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_lessequaltok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_lessequaltok, stopset0, stopset1, stopset2);
      M2Quads_PushTtok (M2Reserved_LessEqualTok, (M2LexBuf_GetTokenNo ())-1);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_greatertok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_greatertok, stopset0, stopset1, stopset2);
      M2Quads_PushTtok (M2Reserved_GreaterTok, (M2LexBuf_GetTokenNo ())-1);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_greaterequaltok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_greaterequaltok, stopset0, stopset1, stopset2);
      M2Quads_PushTtok (M2Reserved_GreaterEqualTok, (M2LexBuf_GetTokenNo ())-1);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_intok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_intok, stopset0, stopset1, stopset2);
      M2Quads_PushTtok (M2Reserved_InTok, (M2LexBuf_GetTokenNo ())-1);
    }
  else
    {
      /* avoid dangling else.  */
      ErrorArray ((const char *) "expecting one of: {%KIN} {%K>=} {%K>} {%K<=} {%K<} {%K<>} {%K#} {%K=}", 69);
    }
}


/*
   SimpleConstExpr := UnaryOrConstTerm { AddOperator 
                                         ConstTerm 
                                         
                                         % BuildBinaryOp  %
                                          } 

   first  symbols:stringtok, lcbratok, identtok, attributetok, realtok, integertok, lparatok, nottok, plustok, minustok
   
   cannot reachend
*/

static void SimpleConstExpr (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  UnaryOrConstTerm (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_ortok-M2Reserved_arraytok))), stopset2);
  while (((M2LexBuf_currenttoken < M2Reserved_arraytok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_eoftok)) & ((P3Build_SetOfStop0) ((1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_minustok-M2Reserved_eoftok))))) != 0))) || (M2LexBuf_currenttoken == M2Reserved_ortok))
    {
      AddOperator (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok))));
      ConstTerm (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_minustok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_ortok-M2Reserved_arraytok))), stopset2);
      M2Quads_BuildBinaryOp ();
    }
   /* while  */
}


/*
   UnaryOrConstTerm := '+' 
                       % PushTtok(PlusTok, GetTokenNo() -1)  %
                       ConstTerm 
                       % BuildUnaryOp  %
                        | '-' 
                       % PushTtok(MinusTok, GetTokenNo() -1)  %
                       ConstTerm 
                       % BuildUnaryOp  %
                        | ConstTerm 

   first  symbols:attributetok, identtok, lcbratok, stringtok, nottok, lparatok, integertok, realtok, minustok, plustok
   
   cannot reachend
*/

static void UnaryOrConstTerm (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  if (M2LexBuf_currenttoken == M2Reserved_plustok)
    {
      Expect (M2Reserved_plustok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok))));
      M2Quads_PushTtok (M2Reserved_PlusTok, (M2LexBuf_GetTokenNo ())-1);
      ConstTerm (stopset0, stopset1, stopset2);
      M2Quads_BuildUnaryOp ();
    }
  else if (M2LexBuf_currenttoken == M2Reserved_minustok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_minustok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok))));
      M2Quads_PushTtok (M2Reserved_MinusTok, (M2LexBuf_GetTokenNo ())-1);
      ConstTerm (stopset0, stopset1, stopset2);
      M2Quads_BuildUnaryOp ();
    }
  else if ((((M2LexBuf_currenttoken < M2Reserved_arraytok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_eoftok)) & ((P3Build_SetOfStop0) ((1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))))) != 0))) || (M2LexBuf_currenttoken == M2Reserved_nottok)) || ((M2LexBuf_currenttoken >= M2Reserved_recordtok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_recordtok)) & ((P3Build_SetOfStop2) ((1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok))))) != 0))))
    {
      /* avoid dangling else.  */
      ConstTerm (stopset0, stopset1, stopset2);
    }
  else
    {
      /* avoid dangling else.  */
      ErrorArray ((const char *) "expecting one of: {%KNOT} {%K(} {%Kinteger number} {%Kreal number} {%K__ATTRIBUTE__} {%Kidentifier} {%K%{} {%Kstring} {%K-} {%K+}", 129);
    }
}


/*
   AddOperator := '+' 
                  % PushTtok(PlusTok, GetTokenNo() -1) ;
                    RecordOp  %
                   | '-' 
                  % PushTtok(MinusTok, GetTokenNo() -1) ;
                    RecordOp  %
                   | 'OR' 
                  % PushTtok(OrTok, GetTokenNo() -1) ;
                    RecordOp  %
                  

   first  symbols:ortok, minustok, plustok
   
   cannot reachend
*/

static void AddOperator (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  if (M2LexBuf_currenttoken == M2Reserved_plustok)
    {
      Expect (M2Reserved_plustok, stopset0, stopset1, stopset2);
      M2Quads_PushTtok (M2Reserved_PlusTok, (M2LexBuf_GetTokenNo ())-1);
      M2Quads_RecordOp ();
    }
  else if (M2LexBuf_currenttoken == M2Reserved_minustok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_minustok, stopset0, stopset1, stopset2);
      M2Quads_PushTtok (M2Reserved_MinusTok, (M2LexBuf_GetTokenNo ())-1);
      M2Quads_RecordOp ();
    }
  else if (M2LexBuf_currenttoken == M2Reserved_ortok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_ortok, stopset0, stopset1, stopset2);
      M2Quads_PushTtok (M2Reserved_OrTok, (M2LexBuf_GetTokenNo ())-1);
      M2Quads_RecordOp ();
    }
  else
    {
      /* avoid dangling else.  */
      ErrorArray ((const char *) "expecting one of: {%KOR} {%K-} {%K+}", 36);
    }
}


/*
   ConstTerm := ConstFactor { MulOperator ConstFactor 
                              
                              % BuildBinaryOp  %
                               } 

   first  symbols:stringtok, lcbratok, identtok, attributetok, realtok, integertok, lparatok, nottok
   
   cannot reachend
*/

static void ConstTerm (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  ConstFactor (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_ambersandtok-M2Reserved_eoftok)) | (1 << (M2Reserved_andtok-M2Reserved_eoftok)) | (1 << (M2Reserved_dividetok-M2Reserved_eoftok)) | (1 << (M2Reserved_timestok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_modtok-M2Reserved_arraytok)) | (1 << (M2Reserved_divtok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_remtok-M2Reserved_recordtok))));
  while ((((M2LexBuf_currenttoken < M2Reserved_arraytok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_eoftok)) & ((P3Build_SetOfStop0) ((1 << (M2Reserved_timestok-M2Reserved_eoftok)) | (1 << (M2Reserved_dividetok-M2Reserved_eoftok)) | (1 << (M2Reserved_andtok-M2Reserved_eoftok)) | (1 << (M2Reserved_ambersandtok-M2Reserved_eoftok))))) != 0))) || (((M2LexBuf_currenttoken >= M2Reserved_arraytok) && (M2LexBuf_currenttoken < M2Reserved_recordtok)) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_arraytok)) & ((P3Build_SetOfStop1) ((1 << (M2Reserved_divtok-M2Reserved_arraytok)) | (1 << (M2Reserved_modtok-M2Reserved_arraytok))))) != 0)))) || (M2LexBuf_currenttoken == M2Reserved_remtok))
    {
      MulOperator (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok))));
      ConstFactor (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_timestok-M2Reserved_eoftok)) | (1 << (M2Reserved_dividetok-M2Reserved_eoftok)) | (1 << (M2Reserved_andtok-M2Reserved_eoftok)) | (1 << (M2Reserved_ambersandtok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_divtok-M2Reserved_arraytok)) | (1 << (M2Reserved_modtok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_remtok-M2Reserved_recordtok))));
      M2Quads_BuildBinaryOp ();
    }
   /* while  */
}


/*
   MulOperator := '*' 
                  % PushTtok(TimesTok, GetTokenNo() -1) ;
                    RecordOp  %
                   | '/' 
                  % PushTtok(DivideTok, GetTokenNo() -1) ;
                    RecordOp  %
                   | 'DIV' 
                  % PushTtok(DivTok, GetTokenNo() -1) ;
                    RecordOp  %
                   | 'MOD' 
                  % PushTtok(ModTok, GetTokenNo() -1) ;
                    RecordOp  %
                   | 'REM' 
                  % PushTtok(RemTok, GetTokenNo() -1) ;
                    RecordOp  %
                   | 'AND' 
                  % PushTtok(AndTok, GetTokenNo() -1) ;
                    RecordOp  %
                   | '&' 
                  % PushTtok(AmbersandTok, GetTokenNo() -1) ;
                    RecordOp  %
                  

   first  symbols:ambersandtok, andtok, remtok, modtok, divtok, dividetok, timestok
   
   cannot reachend
*/

static void MulOperator (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  if (M2LexBuf_currenttoken == M2Reserved_timestok)
    {
      Expect (M2Reserved_timestok, stopset0, stopset1, stopset2);
      M2Quads_PushTtok (M2Reserved_TimesTok, (M2LexBuf_GetTokenNo ())-1);
      M2Quads_RecordOp ();
    }
  else if (M2LexBuf_currenttoken == M2Reserved_dividetok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_dividetok, stopset0, stopset1, stopset2);
      M2Quads_PushTtok (M2Reserved_DivideTok, (M2LexBuf_GetTokenNo ())-1);
      M2Quads_RecordOp ();
    }
  else if (M2LexBuf_currenttoken == M2Reserved_divtok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_divtok, stopset0, stopset1, stopset2);
      M2Quads_PushTtok (M2Reserved_DivTok, (M2LexBuf_GetTokenNo ())-1);
      M2Quads_RecordOp ();
    }
  else if (M2LexBuf_currenttoken == M2Reserved_modtok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_modtok, stopset0, stopset1, stopset2);
      M2Quads_PushTtok (M2Reserved_ModTok, (M2LexBuf_GetTokenNo ())-1);
      M2Quads_RecordOp ();
    }
  else if (M2LexBuf_currenttoken == M2Reserved_remtok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_remtok, stopset0, stopset1, stopset2);
      M2Quads_PushTtok (M2Reserved_RemTok, (M2LexBuf_GetTokenNo ())-1);
      M2Quads_RecordOp ();
    }
  else if (M2LexBuf_currenttoken == M2Reserved_andtok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_andtok, stopset0, stopset1, stopset2);
      M2Quads_PushTtok (M2Reserved_AndTok, (M2LexBuf_GetTokenNo ())-1);
      M2Quads_RecordOp ();
    }
  else if (M2LexBuf_currenttoken == M2Reserved_ambersandtok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_ambersandtok, stopset0, stopset1, stopset2);
      M2Quads_PushTtok (M2Reserved_AmbersandTok, (M2LexBuf_GetTokenNo ())-1);
      M2Quads_RecordOp ();
    }
  else
    {
      /* avoid dangling else.  */
      ErrorArray ((const char *) "expecting one of: {%K&} {%KAND} {%KREM} {%KMOD} {%KDIV} {%K/} {%K*}", 67);
    }
}


/*
   ConstFactor := 
                  % VAR tokpos: CARDINAL ;  %
                  Number  | ConstString  | 
                  ConstSetOrQualidentOrFunction  | 
                  '(' ConstExpression ')'  | 
                  'NOT' 
                  % tokpos := GetTokenNo() -1  %
                  ConstFactor 
                  % BuildNot (tokpos)  %
                   | ConstAttribute 

   first  symbols:attributetok, identtok, lcbratok, stringtok, nottok, lparatok, integertok, realtok
   
   cannot reachend
*/

static void ConstFactor (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  unsigned int tokpos;

  if ((M2LexBuf_currenttoken >= M2Reserved_recordtok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_recordtok)) & ((P3Build_SetOfStop2) ((1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok))))) != 0)))
    {
      Number (stopset0, stopset1, stopset2);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_stringtok)
    {
      /* avoid dangling else.  */
      ConstString (stopset0, stopset1, stopset2);
    }
  else if ((M2LexBuf_currenttoken == M2Reserved_lcbratok) || (M2LexBuf_currenttoken == M2Reserved_identtok))
    {
      /* avoid dangling else.  */
      ConstSetOrQualidentOrFunction (stopset0, stopset1, stopset2);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_lparatok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_lparatok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok))));
      ConstExpression (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_rparatok-M2Reserved_eoftok))), stopset1, stopset2);
      Expect (M2Reserved_rparatok, stopset0, stopset1, stopset2);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_nottok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_nottok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok))));
      tokpos = (M2LexBuf_GetTokenNo ())-1;
      ConstFactor (stopset0, stopset1, stopset2);
      M2Quads_BuildNot (tokpos);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_attributetok)
    {
      /* avoid dangling else.  */
      ConstAttribute (stopset0, stopset1, stopset2);
    }
  else
    {
      /* avoid dangling else.  */
      ErrorArray ((const char *) "expecting one of: {%K__ATTRIBUTE__} {%KNOT} {%K(} {%Kidentifier} {%K%{} {%Kstring} {%Kinteger number} {%Kreal number}", 117);
    }
}


/*
   ConstString := string 

   first  symbols:stringtok
   
   cannot reachend
*/

static void ConstString (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  string (stopset0, stopset1, stopset2);
}


/*
   ComponentElement := ConstExpression ( '..' ConstExpression 
                                         
                                         % PushTtok(PeriodPeriodTok, GetTokenNo() -1)  %
                                          | 
                                         
                                         % PushT(NulTok)  %
                                          ) 

   first  symbols:stringtok, lcbratok, identtok, attributetok, realtok, integertok, lparatok, nottok, plustok, minustok
   
   cannot reachend
*/

static void ComponentElement (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  ConstExpression (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_periodperiodtok-M2Reserved_eoftok))), stopset1, stopset2);
  if (M2LexBuf_currenttoken == M2Reserved_periodperiodtok)
    {
      Expect (M2Reserved_periodperiodtok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok))));
      ConstExpression (stopset0, stopset1, stopset2);
      M2Quads_PushTtok (M2Reserved_PeriodPeriodTok, (M2LexBuf_GetTokenNo ())-1);
    }
  else
    {
      M2Quads_PushT (M2Reserved_NulTok);
    }
}


/*
   ComponentValue := ComponentElement ( 'BY' ConstExpression 
                                        
                                        % PushTtok(ByTok, GetTokenNo() -1)  %
                                         | 
                                        
                                        % PushT(NulTok)  %
                                         ) 

   first  symbols:attributetok, identtok, lcbratok, stringtok, nottok, lparatok, integertok, realtok, minustok, plustok
   
   cannot reachend
*/

static void ComponentValue (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  ComponentElement (stopset0, stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_bytok-M2Reserved_arraytok))), stopset2);
  if (M2LexBuf_currenttoken == M2Reserved_bytok)
    {
      Expect (M2Reserved_bytok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok))));
      ConstExpression (stopset0, stopset1, stopset2);
      M2Quads_PushTtok (M2Reserved_ByTok, (M2LexBuf_GetTokenNo ())-1);
    }
  else
    {
      M2Quads_PushT (M2Reserved_NulTok);
    }
}


/*
   ArraySetRecordValue := ComponentValue 
                          % BuildComponentValue  %
                          { ',' 
                            % NextConstructorField  %
                            ComponentValue 
                            % BuildComponentValue  %
                             } 

   first  symbols:stringtok, lcbratok, identtok, attributetok, realtok, integertok, lparatok, nottok, plustok, minustok
   
   cannot reachend
*/

static void ArraySetRecordValue (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  ComponentValue (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_commatok-M2Reserved_eoftok))), stopset1, stopset2);
  M2Quads_BuildComponentValue ();
  while (M2LexBuf_currenttoken == M2Reserved_commatok)
    {
      Expect (M2Reserved_commatok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok))));
      M2Quads_NextConstructorField ();
      ComponentValue (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_commatok-M2Reserved_eoftok))), stopset1, stopset2);
      M2Quads_BuildComponentValue ();
    }
   /* while  */
}


/*
   Constructor := 
                  % DisplayStack  %
                  '{' 
                  % BuildConstructorStart (GetTokenNo() -1)  %
                  [ ArraySetRecordValue  ] 
                  % BuildConstructorEnd (GetTokenNo())   %
                  '}' 

   first  symbols:lcbratok
   
   cannot reachend
*/

static void Constructor (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  M2Quads_DisplayStack ();
  Expect (M2Reserved_lcbratok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_rcbratok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok))));
  M2Quads_BuildConstructorStart ((M2LexBuf_GetTokenNo ())-1);
  if ((((M2LexBuf_currenttoken < M2Reserved_arraytok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_eoftok)) & ((P3Build_SetOfStop0) ((1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))))) != 0))) || (M2LexBuf_currenttoken == M2Reserved_nottok)) || ((M2LexBuf_currenttoken >= M2Reserved_recordtok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_recordtok)) & ((P3Build_SetOfStop2) ((1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok))))) != 0))))
    {
      ArraySetRecordValue (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_rcbratok-M2Reserved_eoftok))), stopset1, stopset2);
    }
  M2Quads_BuildConstructorEnd (M2LexBuf_GetTokenNo ());
  Expect (M2Reserved_rcbratok, stopset0, stopset1, stopset2);
}


/*
   ConstSetOrQualidentOrFunction := Qualident [ Constructor  | 
                                                ConstActualParameters 
                                                
                                                % BuildConstFunctionCall  %
                                                 ]  | 
                                    
                                    % BuildTypeForConstructor  %
                                    Constructor 

   first  symbols:lcbratok, identtok
   
   cannot reachend
*/

static void ConstSetOrQualidentOrFunction (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  if (M2LexBuf_currenttoken == M2Reserved_identtok)
    {
      /* avoid dangling else.  */
      Qualident (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_lcbratok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok))), stopset1, stopset2);
      if ((M2LexBuf_currenttoken < M2Reserved_arraytok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_eoftok)) & ((P3Build_SetOfStop0) ((1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))))) != 0)))
        {
          /* avoid gcc warning by using compound statement even if not strictly necessary.  */
          /* seen optional [ | ] expression  */
          if (M2LexBuf_currenttoken == M2Reserved_lcbratok)
            {
              Constructor (stopset0, stopset1, stopset2);
            }
          else if (M2LexBuf_currenttoken == M2Reserved_lparatok)
            {
              /* avoid dangling else.  */
              ConstActualParameters (stopset0, stopset1, stopset2);
              M2Quads_BuildConstFunctionCall ();
            }
          else
            {
              /* avoid dangling else.  */
              ErrorArray ((const char *) "expecting one of: {%K(} {%K%{}", 30);
            }
        }
      /* end of optional [ | ] expression  */
    }
  else
    {
      M2Quads_BuildTypeForConstructor ();
      Constructor (stopset0, stopset1, stopset2);
    }
}


/*
   ConstActualParameters := 
                            % PushInConstExpression  %
                            ActualParameters 
                            % PopInConstExpression  %
                            

   first  symbols:lparatok
   
   cannot reachend
*/

static void ConstActualParameters (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  M2Quads_PushInConstExpression ();
  ActualParameters (stopset0, stopset1, stopset2);
  M2Quads_PopInConstExpression ();
}


/*
   ConstAttribute := '__ATTRIBUTE__' '__BUILTIN__' 
                     '(' '(' 
                     % PushAutoOn  %
                     ConstAttributeExpression 
                     % PopAuto  %
                     ')' ')' 

   first  symbols:attributetok
   
   cannot reachend
*/

static void ConstAttribute (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  Expect (M2Reserved_attributetok, stopset0, stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_builtintok-M2Reserved_recordtok))));
  Expect (M2Reserved_builtintok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_lparatok-M2Reserved_eoftok))), stopset1, stopset2);
  Expect (M2Reserved_lparatok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_lparatok-M2Reserved_eoftok))), stopset1, stopset2);
  Expect (M2Reserved_lparatok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_lesstok-M2Reserved_eoftok))), stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  M2Quads_PushAutoOn ();
  ConstAttributeExpression (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_rparatok-M2Reserved_eoftok))), stopset1, stopset2);
  M2Quads_PopAuto ();
  Expect (M2Reserved_rparatok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_rparatok-M2Reserved_eoftok))), stopset1, stopset2);
  Expect (M2Reserved_rparatok, stopset0, stopset1, stopset2);
}


/*
   ConstAttributeExpression := Ident 
                               % BuildBuiltinConst  %
                                | '<' Qualident ',' 
                               Ident 
                               % BuildBuiltinTypeInfo  %
                               '>' 

   first  symbols:lesstok, identtok
   
   cannot reachend
*/

static void ConstAttributeExpression (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  if (M2LexBuf_currenttoken == M2Reserved_identtok)
    {
      Ident (stopset0, stopset1, stopset2);
      M2Quads_BuildBuiltinConst ();
    }
  else if (M2LexBuf_currenttoken == M2Reserved_lesstok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_lesstok, stopset0, stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      Qualident (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_commatok-M2Reserved_eoftok))), stopset1, stopset2);
      Expect (M2Reserved_commatok, stopset0, stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      Ident (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_greatertok-M2Reserved_eoftok))), stopset1, stopset2);
      M2Quads_BuildBuiltinTypeInfo ();
      Expect (M2Reserved_greatertok, stopset0, stopset1, stopset2);
    }
  else
    {
      /* avoid dangling else.  */
      ErrorArray ((const char *) "expecting one of: {%K<} {%Kidentifier}", 38);
    }
}


/*
   ByteAlignment := '' 
                    % PopAuto  %
                    

   first  symbols:ldirectivetok
   
   cannot reachend
*/

static void ByteAlignment (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  Expect (M2Reserved_ldirectivetok, stopset0, stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  M2Quads_PushAutoOn ();
  AttributeExpression (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_rdirectivetok-M2Reserved_eoftok))), stopset1, stopset2);
  M2Quads_BuildAlignment ();
  Expect (M2Reserved_rdirectivetok, stopset0, stopset1, stopset2);
  M2Quads_PopAuto ();
}


/*
   Alignment := [ ByteAlignment  ] 

   first  symbols:ldirectivetok
   
   reachend
*/

static void Alignment (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  if (M2LexBuf_currenttoken == M2Reserved_ldirectivetok)
    {
      ByteAlignment (stopset0, stopset1, stopset2);
    }
}


/*
   TypeDeclaration := Ident '=' Type Alignment 

   first  symbols:identtok
   
   cannot reachend
*/

static void TypeDeclaration (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  Ident (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_equaltok-M2Reserved_eoftok))), stopset1, stopset2);
  Expect (M2Reserved_equaltok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lsbratok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_proceduretok-M2Reserved_arraytok)) | (1 << (M2Reserved_pointertok-M2Reserved_arraytok)) | (1 << (M2Reserved_packedsettok-M2Reserved_arraytok)) | (1 << (M2Reserved_oftok-M2Reserved_arraytok)) | (1 << (M2Reserved_arraytok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_settok-M2Reserved_recordtok)) | (1 << (M2Reserved_recordtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  Type (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_ldirectivetok-M2Reserved_eoftok))), stopset1, stopset2);
  Alignment (stopset0, stopset1, stopset2);
}


/*
   Type := 
           % PushAutoOff  %
           ( SimpleType  | ArrayType  | RecordType  | 
             SetType  | PointerType  | 
             ProcedureType  ) 
           % PopAuto  %
           

   first  symbols:lparatok, lsbratok, proceduretok, pointertok, settok, packedsettok, oftok, recordtok, arraytok, identtok
   
   cannot reachend
*/

static void Type (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  M2Quads_PushAutoOff ();
  if (((M2LexBuf_currenttoken < M2Reserved_arraytok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_eoftok)) & ((P3Build_SetOfStop0) ((1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lsbratok-M2Reserved_eoftok))))) != 0))) || (M2LexBuf_currenttoken == M2Reserved_identtok))
    {
      SimpleType (stopset0, stopset1, stopset2);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_arraytok)
    {
      /* avoid dangling else.  */
      ArrayType (stopset0, stopset1, stopset2);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_recordtok)
    {
      /* avoid dangling else.  */
      RecordType (stopset0, stopset1, stopset2);
    }
  else if ((((M2LexBuf_currenttoken >= M2Reserved_arraytok) && (M2LexBuf_currenttoken < M2Reserved_recordtok)) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_arraytok)) & ((P3Build_SetOfStop1) ((1 << (M2Reserved_packedsettok-M2Reserved_arraytok)) | (1 << (M2Reserved_oftok-M2Reserved_arraytok))))) != 0))) || (M2LexBuf_currenttoken == M2Reserved_settok))
    {
      /* avoid dangling else.  */
      SetType (stopset0, stopset1, stopset2);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_pointertok)
    {
      /* avoid dangling else.  */
      PointerType (stopset0, stopset1, stopset2);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_proceduretok)
    {
      /* avoid dangling else.  */
      ProcedureType (stopset0, stopset1, stopset2);
    }
  else
    {
      /* avoid dangling else.  */
      ErrorArray ((const char *) "expecting one of: {%KPROCEDURE} {%KPOINTER} {%KSET} {%KPACKEDSET} {%KOF} {%KRECORD} {%KARRAY} {%Kidentifier} {%K(} {%K[}", 120);
    }
  M2Quads_PopAuto ();
}


/*
   SimpleType := Qualident [ SubrangeType  ]  | 
                 Enumeration  | SubrangeType 

   first  symbols:lsbratok, lparatok, identtok
   
   cannot reachend
*/

static void SimpleType (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  if (M2LexBuf_currenttoken == M2Reserved_identtok)
    {
      /* avoid dangling else.  */
      Qualident (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_lsbratok-M2Reserved_eoftok))), stopset1, stopset2);
      if (M2LexBuf_currenttoken == M2Reserved_lsbratok)
        {
          SubrangeType (stopset0, stopset1, stopset2);
        }
    }
  else if (M2LexBuf_currenttoken == M2Reserved_lparatok)
    {
      /* avoid dangling else.  */
      Enumeration (stopset0, stopset1, stopset2);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_lsbratok)
    {
      /* avoid dangling else.  */
      SubrangeType (stopset0, stopset1, stopset2);
    }
  else
    {
      /* avoid dangling else.  */
      ErrorArray ((const char *) "expecting one of: {%K[} {%K(} {%Kidentifier}", 44);
    }
}


/*
   Enumeration := '(' ( IdentList  ) ')' 

   first  symbols:lparatok
   
   cannot reachend
*/

static void Enumeration (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  Expect (M2Reserved_lparatok, stopset0, stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  IdentList (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_rparatok-M2Reserved_eoftok))), stopset1, stopset2);
  Expect (M2Reserved_rparatok, stopset0, stopset1, stopset2);
}


/*
   IdentList := Ident 
                % VAR
                                                                                                  on: BOOLEAN ;
                                                                                                  n : CARDINAL ;  %
                
                % on := IsAutoPushOn() ;
                  IF on
                  THEN
                     n := 1
                  END  %
                { ',' Ident 
                  % IF on
                    THEN
                       INC(n)
                    END  %
                   } 
                % IF on
                  THEN
                     PushT(n)
                  END  %
                

   first  symbols:identtok
   
   cannot reachend
*/

static void IdentList (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  bool on;
  unsigned int n;

  Ident (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_commatok-M2Reserved_eoftok))), stopset1, stopset2);
  on = M2Quads_IsAutoPushOn ();
  if (on)
    {
      n = 1;
    }
  while (M2LexBuf_currenttoken == M2Reserved_commatok)
    {
      Expect (M2Reserved_commatok, stopset0, stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      Ident (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_commatok-M2Reserved_eoftok))), stopset1, stopset2);
      if (on)
        {
          n += 1;
        }
    }
   /* while  */
  if (on)
    {
      M2Quads_PushT (n);
    }
}


/*
   SubrangeType := '[' ConstExpression '..' ConstExpression 
                   ']' 
                   % BuildSubrange ;  %
                   

   first  symbols:lsbratok
   
   cannot reachend
*/

static void SubrangeType (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  Expect (M2Reserved_lsbratok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok))));
  ConstExpression (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_periodperiodtok-M2Reserved_eoftok))), stopset1, stopset2);
  Expect (M2Reserved_periodperiodtok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok))));
  ConstExpression (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_rsbratok-M2Reserved_eoftok))), stopset1, stopset2);
  Expect (M2Reserved_rsbratok, stopset0, stopset1, stopset2);
  P3SymBuild_BuildSubrange ();
}


/*
   ArrayType := 'ARRAY' SimpleType { ',' SimpleType  } 
                'OF' Type 

   first  symbols:arraytok
   
   cannot reachend
*/

static void ArrayType (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  Expect (M2Reserved_arraytok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_lsbratok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok))), stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  SimpleType (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_commatok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_oftok-M2Reserved_arraytok))), stopset2);
  while (M2LexBuf_currenttoken == M2Reserved_commatok)
    {
      Expect (M2Reserved_commatok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_lsbratok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok))), stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      SimpleType (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_commatok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_oftok-M2Reserved_arraytok))), stopset2);
    }
   /* while  */
  Expect (M2Reserved_oftok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lsbratok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_proceduretok-M2Reserved_arraytok)) | (1 << (M2Reserved_pointertok-M2Reserved_arraytok)) | (1 << (M2Reserved_packedsettok-M2Reserved_arraytok)) | (1 << (M2Reserved_oftok-M2Reserved_arraytok)) | (1 << (M2Reserved_arraytok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_settok-M2Reserved_recordtok)) | (1 << (M2Reserved_recordtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  Type (stopset0, stopset1, stopset2);
}


/*
   RecordType := 'RECORD' [ DefaultRecordAttributes  ] 
                 FieldListSequence 'END' 

   first  symbols:recordtok
   
   cannot reachend
*/

static void RecordType (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  Expect (M2Reserved_recordtok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_ldirectivetok-M2Reserved_eoftok)) | (1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_endtok-M2Reserved_arraytok)) | (1 << (M2Reserved_casetok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  if (M2LexBuf_currenttoken == M2Reserved_ldirectivetok)
    {
      DefaultRecordAttributes (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_endtok-M2Reserved_arraytok)) | (1 << (M2Reserved_casetok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
    }
  FieldListSequence (stopset0, stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_endtok-M2Reserved_arraytok))), stopset2);
  Expect (M2Reserved_endtok, stopset0, stopset1, stopset2);
}


/*
   DefaultRecordAttributes := '' 

   first  symbols:ldirectivetok
   
   cannot reachend
*/

static void DefaultRecordAttributes (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  Expect (M2Reserved_ldirectivetok, stopset0, stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  M2Quads_PushAutoOn ();
  AttributeExpression (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_rdirectivetok-M2Reserved_eoftok))), stopset1, stopset2);
  M2Quads_BuildDefaultFieldAlignment ();
  M2Quads_PopAuto ();
  Expect (M2Reserved_rdirectivetok, stopset0, stopset1, stopset2);
}


/*
   RecordFieldPragma := [ ''  ] 

   first  symbols:ldirectivetok
   
   reachend
*/

static void RecordFieldPragma (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  if (M2LexBuf_currenttoken == M2Reserved_ldirectivetok)
    {
      Expect (M2Reserved_ldirectivetok, stopset0, stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      FieldPragmaExpression (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_commatok-M2Reserved_eoftok)) | (1 << (M2Reserved_rdirectivetok-M2Reserved_eoftok))), stopset1, stopset2);
      while (M2LexBuf_currenttoken == M2Reserved_commatok)
        {
          Expect (M2Reserved_commatok, stopset0, stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
          FieldPragmaExpression (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_rdirectivetok-M2Reserved_eoftok)) | (1 << (M2Reserved_commatok-M2Reserved_eoftok))), stopset1, stopset2);
        }
       /* while  */
      Expect (M2Reserved_rdirectivetok, stopset0, stopset1, stopset2);
    }
}


/*
   FieldPragmaExpression := 
                            % PushAutoOn  %
                            Ident PragmaConstExpression 
                            
                            % BuildPragmaField  %
                            
                            % PopAuto  %
                            

   first  symbols:identtok
   
   cannot reachend
*/

static void FieldPragmaExpression (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  M2Quads_PushAutoOn ();
  Ident (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_lparatok-M2Reserved_eoftok))), stopset1, stopset2);
  PragmaConstExpression (stopset0, stopset1, stopset2);
  M2Quads_BuildPragmaField ();
  M2Quads_PopAuto ();
}


/*
   PragmaConstExpression := ( '(' ConstExpression ')'  | 
                              
                              % PushT(NulSym)  %
                              
                              % Annotate('NulSym||no pragma const')  %
                               ) 

   first  symbols:lparatok
   
   reachend
*/

static void PragmaConstExpression (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  if (M2LexBuf_currenttoken == M2Reserved_lparatok)
    {
      Expect (M2Reserved_lparatok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok))));
      ConstExpression (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_rparatok-M2Reserved_eoftok))), stopset1, stopset2);
      Expect (M2Reserved_rparatok, stopset0, stopset1, stopset2);
    }
  else
    {
      M2Quads_PushT (static_cast<unsigned int> (SymbolTable_NulSym));
      M2Quads_Annotate ((const char *) "NulSym||no pragma const", 23);
    }
}


/*
   AttributeExpression := Ident '(' ConstExpression 
                          ')' 

   first  symbols:identtok
   
   cannot reachend
*/

static void AttributeExpression (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  Ident (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_lparatok-M2Reserved_eoftok))), stopset1, stopset2);
  Expect (M2Reserved_lparatok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok))));
  ConstExpression (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_rparatok-M2Reserved_eoftok))), stopset1, stopset2);
  Expect (M2Reserved_rparatok, stopset0, stopset1, stopset2);
}


/*
   FieldListSequence := FieldListStatement { ';' FieldListStatement  } 

   first  symbols:casetok, identtok, semicolontok
   
   reachend
*/

static void FieldListSequence (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  FieldListStatement (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1, stopset2);
  while (M2LexBuf_currenttoken == M2Reserved_semicolontok)
    {
      Expect (M2Reserved_semicolontok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_casetok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      FieldListStatement (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1, stopset2);
    }
   /* while  */
}


/*
   FieldListStatement := [ FieldList  ] 

   first  symbols:identtok, casetok
   
   reachend
*/

static void FieldListStatement (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  if ((M2LexBuf_currenttoken == M2Reserved_casetok) || (M2LexBuf_currenttoken == M2Reserved_identtok))
    {
      FieldList (stopset0, stopset1, stopset2);
    }
}


/*
   FieldList := IdentList ':' Type RecordFieldPragma  | 
                'CASE' 
                % BeginVarient  %
                CaseTag 'OF' Varient { '|' Varient  } 
                [ 'ELSE' 
                  % ElseVarient  %
                  FieldListSequence  ] 'END' 
                % EndVarient  %
                

   first  symbols:casetok, identtok
   
   cannot reachend
*/

static void FieldList (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  if (M2LexBuf_currenttoken == M2Reserved_identtok)
    {
      IdentList (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_colontok-M2Reserved_eoftok))), stopset1, stopset2);
      Expect (M2Reserved_colontok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lsbratok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_proceduretok-M2Reserved_arraytok)) | (1 << (M2Reserved_pointertok-M2Reserved_arraytok)) | (1 << (M2Reserved_packedsettok-M2Reserved_arraytok)) | (1 << (M2Reserved_oftok-M2Reserved_arraytok)) | (1 << (M2Reserved_arraytok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_settok-M2Reserved_recordtok)) | (1 << (M2Reserved_recordtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      Type (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_ldirectivetok-M2Reserved_eoftok))), stopset1, stopset2);
      RecordFieldPragma (stopset0, stopset1, stopset2);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_casetok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_casetok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_colontok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_oftok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      M2Quads_BeginVarient ();
      CaseTag (stopset0, stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_oftok-M2Reserved_arraytok))), stopset2);
      Expect (M2Reserved_oftok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_bartok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_elsetok-M2Reserved_arraytok)) | (1 << (M2Reserved_endtok-M2Reserved_arraytok)) | (1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok))));
      Varient (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_bartok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_elsetok-M2Reserved_arraytok)) | (1 << (M2Reserved_endtok-M2Reserved_arraytok))), stopset2);
      while (M2LexBuf_currenttoken == M2Reserved_bartok)
        {
          Expect (M2Reserved_bartok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_bartok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_endtok-M2Reserved_arraytok)) | (1 << (M2Reserved_elsetok-M2Reserved_arraytok)) | (1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok))));
          Varient (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_bartok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_endtok-M2Reserved_arraytok)) | (1 << (M2Reserved_elsetok-M2Reserved_arraytok))), stopset2);
        }
       /* while  */
      if (M2LexBuf_currenttoken == M2Reserved_elsetok)
        {
          Expect (M2Reserved_elsetok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_endtok-M2Reserved_arraytok)) | (1 << (M2Reserved_casetok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
          M2Quads_ElseVarient ();
          FieldListSequence (stopset0, stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_endtok-M2Reserved_arraytok))), stopset2);
        }
      Expect (M2Reserved_endtok, stopset0, stopset1, stopset2);
      M2Quads_EndVarient ();
    }
  else
    {
      /* avoid dangling else.  */
      ErrorArray ((const char *) "expecting one of: {%KCASE} {%Kidentifier}", 41);
    }
}


/*
   TagIdent := [ Ident  ] 

   first  symbols:identtok
   
   reachend
*/

static void TagIdent (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  if (M2LexBuf_currenttoken == M2Reserved_identtok)
    {
      Ident (stopset0, stopset1, stopset2);
    }
}


/*
   CaseTag := TagIdent [ ':' Qualident  ] 

   first  symbols:colontok, identtok
   
   reachend
*/

static void CaseTag (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  TagIdent (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_colontok-M2Reserved_eoftok))), stopset1, stopset2);
  if (M2LexBuf_currenttoken == M2Reserved_colontok)
    {
      Expect (M2Reserved_colontok, stopset0, stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      Qualident (stopset0, stopset1, stopset2);
    }
}


/*
   Varient := [ 
                % BeginVarientList  %
                VarientCaseLabelList ':' FieldListSequence 
                
                % EndVarientList  %
                 ] 

   first  symbols:stringtok, lcbratok, identtok, attributetok, realtok, integertok, lparatok, nottok, plustok, minustok
   
   reachend
*/

static void Varient (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  if ((((M2LexBuf_currenttoken < M2Reserved_arraytok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_eoftok)) & ((P3Build_SetOfStop0) ((1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))))) != 0))) || (M2LexBuf_currenttoken == M2Reserved_nottok)) || ((M2LexBuf_currenttoken >= M2Reserved_recordtok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_recordtok)) & ((P3Build_SetOfStop2) ((1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok))))) != 0))))
    {
      M2Quads_BeginVarientList ();
      VarientCaseLabelList (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_colontok-M2Reserved_eoftok))), stopset1, stopset2);
      Expect (M2Reserved_colontok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_casetok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      FieldListSequence (stopset0, stopset1, stopset2);
      M2Quads_EndVarientList ();
    }
}


/*
   VarientCaseLabelList := VarientCaseLabels { ',' 
                                               VarientCaseLabels  } 

   first  symbols:attributetok, identtok, lcbratok, stringtok, nottok, lparatok, integertok, realtok, minustok, plustok
   
   cannot reachend
*/

static void VarientCaseLabelList (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  VarientCaseLabels (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_commatok-M2Reserved_eoftok))), stopset1, stopset2);
  while (M2LexBuf_currenttoken == M2Reserved_commatok)
    {
      Expect (M2Reserved_commatok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok))));
      VarientCaseLabels (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_commatok-M2Reserved_eoftok))), stopset1, stopset2);
    }
   /* while  */
}


/*
   VarientCaseLabels := ConstExpression ( '..' ConstExpression 
                                          
                                          % AddVarientRange  %
                                           | 
                                          
                                          % AddVarientEquality ;  epsilon   %
                                           ) 

   first  symbols:stringtok, lcbratok, identtok, attributetok, realtok, integertok, lparatok, nottok, plustok, minustok
   
   cannot reachend
*/

static void VarientCaseLabels (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  ConstExpression (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_periodperiodtok-M2Reserved_eoftok))), stopset1, stopset2);
  if (M2LexBuf_currenttoken == M2Reserved_periodperiodtok)
    {
      Expect (M2Reserved_periodperiodtok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok))));
      ConstExpression (stopset0, stopset1, stopset2);
      M2Quads_AddVarientRange ();
    }
  else
    {
      M2Quads_AddVarientEquality ();  /* epsilon  */
    }
   /* epsilon  */
}


/*
   SilentConstExpression := 
                            % PushAutoOff  %
                            SilentSimpleConstExpr [ 
   SilentRelation SilentSimpleConstExpr  ] 
                            % PopAuto  %
                            

   first  symbols:attributetok, lcbratok, identtok, stringtok, nottok, lparatok, integertok, realtok, minustok, plustok
   
   cannot reachend
*/

static void SilentConstExpression (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  M2Quads_PushAutoOff ();
  SilentSimpleConstExpr (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_greaterequaltok-M2Reserved_eoftok)) | (1 << (M2Reserved_greatertok-M2Reserved_eoftok)) | (1 << (M2Reserved_lessequaltok-M2Reserved_eoftok)) | (1 << (M2Reserved_lesstok-M2Reserved_eoftok)) | (1 << (M2Reserved_lessgreatertok-M2Reserved_eoftok)) | (1 << (M2Reserved_hashtok-M2Reserved_eoftok)) | (1 << (M2Reserved_equaltok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_intok-M2Reserved_arraytok))), stopset2);
  if (((M2LexBuf_currenttoken < M2Reserved_arraytok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_eoftok)) & ((P3Build_SetOfStop0) ((1 << (M2Reserved_equaltok-M2Reserved_eoftok)) | (1 << (M2Reserved_hashtok-M2Reserved_eoftok)) | (1 << (M2Reserved_lessgreatertok-M2Reserved_eoftok)) | (1 << (M2Reserved_lesstok-M2Reserved_eoftok)) | (1 << (M2Reserved_lessequaltok-M2Reserved_eoftok)) | (1 << (M2Reserved_greatertok-M2Reserved_eoftok)) | (1 << (M2Reserved_greaterequaltok-M2Reserved_eoftok))))) != 0))) || (M2LexBuf_currenttoken == M2Reserved_intok))
    {
      SilentRelation (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok))));
      SilentSimpleConstExpr (stopset0, stopset1, stopset2);
    }
  M2Quads_PopAuto ();
}


/*
   SilentRelation := '='  | '#'  | '<>'  | '<'  | 
                     '<='  | '>'  | '>='  | 'IN' 

   first  symbols:intok, greaterequaltok, greatertok, lessequaltok, lesstok, lessgreatertok, hashtok, equaltok
   
   cannot reachend
*/

static void SilentRelation (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  if (M2LexBuf_currenttoken == M2Reserved_equaltok)
    {
      Expect (M2Reserved_equaltok, stopset0, stopset1, stopset2);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_hashtok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_hashtok, stopset0, stopset1, stopset2);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_lessgreatertok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_lessgreatertok, stopset0, stopset1, stopset2);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_lesstok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_lesstok, stopset0, stopset1, stopset2);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_lessequaltok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_lessequaltok, stopset0, stopset1, stopset2);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_greatertok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_greatertok, stopset0, stopset1, stopset2);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_greaterequaltok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_greaterequaltok, stopset0, stopset1, stopset2);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_intok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_intok, stopset0, stopset1, stopset2);
    }
  else
    {
      /* avoid dangling else.  */
      ErrorArray ((const char *) "expecting one of: {%KIN} {%K>=} {%K>} {%K<=} {%K<} {%K<>} {%K#} {%K=}", 69);
    }
}


/*
   SilentSimpleConstExpr := SilentUnaryOrConstTerm 
                            { SilentAddOperator SilentConstTerm  } 

   first  symbols:stringtok, identtok, lcbratok, attributetok, realtok, integertok, lparatok, nottok, plustok, minustok
   
   cannot reachend
*/

static void SilentSimpleConstExpr (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  SilentUnaryOrConstTerm (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_ortok-M2Reserved_arraytok))), stopset2);
  while (((M2LexBuf_currenttoken < M2Reserved_arraytok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_eoftok)) & ((P3Build_SetOfStop0) ((1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_minustok-M2Reserved_eoftok))))) != 0))) || (M2LexBuf_currenttoken == M2Reserved_ortok))
    {
      SilentAddOperator (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok))));
      SilentConstTerm (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_minustok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_ortok-M2Reserved_arraytok))), stopset2);
    }
   /* while  */
}


/*
   SilentUnaryOrConstTerm := '+' SilentConstTerm  | 
                             '-' SilentConstTerm  | 
                             SilentConstTerm 

   first  symbols:attributetok, lcbratok, identtok, stringtok, nottok, lparatok, integertok, realtok, minustok, plustok
   
   cannot reachend
*/

static void SilentUnaryOrConstTerm (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  if (M2LexBuf_currenttoken == M2Reserved_plustok)
    {
      Expect (M2Reserved_plustok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok))));
      SilentConstTerm (stopset0, stopset1, stopset2);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_minustok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_minustok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok))));
      SilentConstTerm (stopset0, stopset1, stopset2);
    }
  else if ((((M2LexBuf_currenttoken < M2Reserved_arraytok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_eoftok)) & ((P3Build_SetOfStop0) ((1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))))) != 0))) || (M2LexBuf_currenttoken == M2Reserved_nottok)) || ((M2LexBuf_currenttoken >= M2Reserved_recordtok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_recordtok)) & ((P3Build_SetOfStop2) ((1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok))))) != 0))))
    {
      /* avoid dangling else.  */
      SilentConstTerm (stopset0, stopset1, stopset2);
    }
  else
    {
      /* avoid dangling else.  */
      ErrorArray ((const char *) "expecting one of: {%KNOT} {%K(} {%Kinteger number} {%Kreal number} {%K__ATTRIBUTE__} {%K%{} {%Kidentifier} {%Kstring} {%K-} {%K+}", 129);
    }
}


/*
   SilentAddOperator := '+'  | '-'  | 'OR' 

   first  symbols:ortok, minustok, plustok
   
   cannot reachend
*/

static void SilentAddOperator (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  if (M2LexBuf_currenttoken == M2Reserved_plustok)
    {
      Expect (M2Reserved_plustok, stopset0, stopset1, stopset2);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_minustok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_minustok, stopset0, stopset1, stopset2);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_ortok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_ortok, stopset0, stopset1, stopset2);
    }
  else
    {
      /* avoid dangling else.  */
      ErrorArray ((const char *) "expecting one of: {%KOR} {%K-} {%K+}", 36);
    }
}


/*
   SilentConstTerm := SilentConstFactor { SilentMulOperator 
                                          SilentConstFactor  } 

   first  symbols:stringtok, identtok, lcbratok, attributetok, realtok, integertok, lparatok, nottok
   
   cannot reachend
*/

static void SilentConstTerm (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  SilentConstFactor (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_ambersandtok-M2Reserved_eoftok)) | (1 << (M2Reserved_andtok-M2Reserved_eoftok)) | (1 << (M2Reserved_dividetok-M2Reserved_eoftok)) | (1 << (M2Reserved_timestok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_modtok-M2Reserved_arraytok)) | (1 << (M2Reserved_divtok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_remtok-M2Reserved_recordtok))));
  while ((((M2LexBuf_currenttoken < M2Reserved_arraytok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_eoftok)) & ((P3Build_SetOfStop0) ((1 << (M2Reserved_timestok-M2Reserved_eoftok)) | (1 << (M2Reserved_dividetok-M2Reserved_eoftok)) | (1 << (M2Reserved_andtok-M2Reserved_eoftok)) | (1 << (M2Reserved_ambersandtok-M2Reserved_eoftok))))) != 0))) || (((M2LexBuf_currenttoken >= M2Reserved_arraytok) && (M2LexBuf_currenttoken < M2Reserved_recordtok)) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_arraytok)) & ((P3Build_SetOfStop1) ((1 << (M2Reserved_divtok-M2Reserved_arraytok)) | (1 << (M2Reserved_modtok-M2Reserved_arraytok))))) != 0)))) || (M2LexBuf_currenttoken == M2Reserved_remtok))
    {
      SilentMulOperator (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok))));
      SilentConstFactor (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_timestok-M2Reserved_eoftok)) | (1 << (M2Reserved_dividetok-M2Reserved_eoftok)) | (1 << (M2Reserved_andtok-M2Reserved_eoftok)) | (1 << (M2Reserved_ambersandtok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_divtok-M2Reserved_arraytok)) | (1 << (M2Reserved_modtok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_remtok-M2Reserved_recordtok))));
    }
   /* while  */
}


/*
   SilentMulOperator := '*'  | '/'  | 'DIV'  | 
                        'MOD'  | 'REM'  | 'AND'  | 
                        '&' 

   first  symbols:ambersandtok, andtok, remtok, modtok, divtok, dividetok, timestok
   
   cannot reachend
*/

static void SilentMulOperator (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  if (M2LexBuf_currenttoken == M2Reserved_timestok)
    {
      Expect (M2Reserved_timestok, stopset0, stopset1, stopset2);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_dividetok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_dividetok, stopset0, stopset1, stopset2);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_divtok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_divtok, stopset0, stopset1, stopset2);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_modtok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_modtok, stopset0, stopset1, stopset2);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_remtok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_remtok, stopset0, stopset1, stopset2);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_andtok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_andtok, stopset0, stopset1, stopset2);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_ambersandtok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_ambersandtok, stopset0, stopset1, stopset2);
    }
  else
    {
      /* avoid dangling else.  */
      ErrorArray ((const char *) "expecting one of: {%K&} {%KAND} {%KREM} {%KMOD} {%KDIV} {%K/} {%K*}", 67);
    }
}


/*
   SilentConstFactor := Number  | SilentConstString  | 
                        SilentConstSetOrQualidentOrFunction  | 
                        '(' SilentConstExpression ')'  | 
                        'NOT' SilentConstFactor  | 
                        SilentConstAttribute 

   first  symbols:attributetok, lcbratok, identtok, stringtok, nottok, lparatok, integertok, realtok
   
   cannot reachend
*/

static void SilentConstFactor (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  if ((M2LexBuf_currenttoken >= M2Reserved_recordtok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_recordtok)) & ((P3Build_SetOfStop2) ((1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok))))) != 0)))
    {
      Number (stopset0, stopset1, stopset2);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_stringtok)
    {
      /* avoid dangling else.  */
      SilentConstString (stopset0, stopset1, stopset2);
    }
  else if ((M2LexBuf_currenttoken == M2Reserved_lcbratok) || (M2LexBuf_currenttoken == M2Reserved_identtok))
    {
      /* avoid dangling else.  */
      SilentConstSetOrQualidentOrFunction (stopset0, stopset1, stopset2);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_lparatok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_lparatok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok))));
      SilentConstExpression (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_rparatok-M2Reserved_eoftok))), stopset1, stopset2);
      Expect (M2Reserved_rparatok, stopset0, stopset1, stopset2);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_nottok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_nottok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok))));
      SilentConstFactor (stopset0, stopset1, stopset2);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_attributetok)
    {
      /* avoid dangling else.  */
      SilentConstAttribute (stopset0, stopset1, stopset2);
    }
  else
    {
      /* avoid dangling else.  */
      ErrorArray ((const char *) "expecting one of: {%K__ATTRIBUTE__} {%KNOT} {%K(} {%K%{} {%Kidentifier} {%Kstring} {%Kinteger number} {%Kreal number}", 117);
    }
}


/*
   SilentConstString := string 

   first  symbols:stringtok
   
   cannot reachend
*/

static void SilentConstString (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  string (stopset0, stopset1, stopset2);
}


/*
   SilentConstAttribute := '__ATTRIBUTE__' '__BUILTIN__' 
                           '(' '(' SilentConstAttributeExpression 
                           ')' ')' 

   first  symbols:attributetok
   
   cannot reachend
*/

static void SilentConstAttribute (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  Expect (M2Reserved_attributetok, stopset0, stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_builtintok-M2Reserved_recordtok))));
  Expect (M2Reserved_builtintok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_lparatok-M2Reserved_eoftok))), stopset1, stopset2);
  Expect (M2Reserved_lparatok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_lparatok-M2Reserved_eoftok))), stopset1, stopset2);
  Expect (M2Reserved_lparatok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_lesstok-M2Reserved_eoftok))), stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  SilentConstAttributeExpression (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_rparatok-M2Reserved_eoftok))), stopset1, stopset2);
  Expect (M2Reserved_rparatok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_rparatok-M2Reserved_eoftok))), stopset1, stopset2);
  Expect (M2Reserved_rparatok, stopset0, stopset1, stopset2);
}


/*
   SilentConstAttributeExpression := Ident  | 
                                     '<' Ident ',' 
                                     SilentConstString 
                                     '>' 

   first  symbols:lesstok, identtok
   
   cannot reachend
*/

static void SilentConstAttributeExpression (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  if (M2LexBuf_currenttoken == M2Reserved_identtok)
    {
      Ident (stopset0, stopset1, stopset2);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_lesstok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_lesstok, stopset0, stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      Ident (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_commatok-M2Reserved_eoftok))), stopset1, stopset2);
      Expect (M2Reserved_commatok, stopset0, stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_stringtok-M2Reserved_recordtok))));
      SilentConstString (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_greatertok-M2Reserved_eoftok))), stopset1, stopset2);
      Expect (M2Reserved_greatertok, stopset0, stopset1, stopset2);
    }
  else
    {
      /* avoid dangling else.  */
      ErrorArray ((const char *) "expecting one of: {%K<} {%Kidentifier}", 38);
    }
}


/*
   SilentComponentElement := SilentConstExpression 
                             [ '..' SilentConstExpression  ] 

   first  symbols:stringtok, identtok, lcbratok, attributetok, realtok, integertok, lparatok, nottok, plustok, minustok
   
   cannot reachend
*/

static void SilentComponentElement (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  SilentConstExpression (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_periodperiodtok-M2Reserved_eoftok))), stopset1, stopset2);
  if (M2LexBuf_currenttoken == M2Reserved_periodperiodtok)
    {
      Expect (M2Reserved_periodperiodtok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok))));
      SilentConstExpression (stopset0, stopset1, stopset2);
    }
}


/*
   SilentComponentValue := SilentComponentElement [ 
   'BY' SilentConstExpression  ] 

   first  symbols:attributetok, lcbratok, identtok, stringtok, nottok, lparatok, integertok, realtok, minustok, plustok
   
   cannot reachend
*/

static void SilentComponentValue (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  SilentComponentElement (stopset0, stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_bytok-M2Reserved_arraytok))), stopset2);
  if (M2LexBuf_currenttoken == M2Reserved_bytok)
    {
      Expect (M2Reserved_bytok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok))));
      SilentConstExpression (stopset0, stopset1, stopset2);
    }
}


/*
   SilentArraySetRecordValue := SilentComponentValue 
                                { ',' SilentComponentValue  } 

   first  symbols:stringtok, identtok, lcbratok, attributetok, realtok, integertok, lparatok, nottok, plustok, minustok
   
   cannot reachend
*/

static void SilentArraySetRecordValue (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  SilentComponentValue (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_commatok-M2Reserved_eoftok))), stopset1, stopset2);
  while (M2LexBuf_currenttoken == M2Reserved_commatok)
    {
      Expect (M2Reserved_commatok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok))));
      SilentComponentValue (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_commatok-M2Reserved_eoftok))), stopset1, stopset2);
    }
   /* while  */
}


/*
   SilentConstructor := '{' 
                        % SilentBuildConstructorStart  %
                        [ SilentArraySetRecordValue  ] 
                        '}' 

   first  symbols:lcbratok
   
   cannot reachend
*/

static void SilentConstructor (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  Expect (M2Reserved_lcbratok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_rcbratok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok))));
  M2Quads_SilentBuildConstructorStart ();
  if ((((M2LexBuf_currenttoken < M2Reserved_arraytok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_eoftok)) & ((P3Build_SetOfStop0) ((1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))))) != 0))) || (M2LexBuf_currenttoken == M2Reserved_nottok)) || ((M2LexBuf_currenttoken >= M2Reserved_recordtok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_recordtok)) & ((P3Build_SetOfStop2) ((1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok))))) != 0))))
    {
      SilentArraySetRecordValue (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_rcbratok-M2Reserved_eoftok))), stopset1, stopset2);
    }
  Expect (M2Reserved_rcbratok, stopset0, stopset1, stopset2);
}


/*
   SilentConstSetOrQualidentOrFunction := SilentConstructor  | 
                                          Qualident 
                                          [ SilentConstructor  | 
                                            SilentActualParameters  ] 

   first  symbols:identtok, lcbratok
   
   cannot reachend
*/

static void SilentConstSetOrQualidentOrFunction (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  if (M2LexBuf_currenttoken == M2Reserved_lcbratok)
    {
      SilentConstructor (stopset0, stopset1, stopset2);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_identtok)
    {
      /* avoid dangling else.  */
      Qualident (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_lcbratok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok))), stopset1, stopset2);
      if ((M2LexBuf_currenttoken < M2Reserved_arraytok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_eoftok)) & ((P3Build_SetOfStop0) ((1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))))) != 0)))
        {
          /* avoid gcc warning by using compound statement even if not strictly necessary.  */
          /* seen optional [ | ] expression  */
          if (M2LexBuf_currenttoken == M2Reserved_lcbratok)
            {
              SilentConstructor (stopset0, stopset1, stopset2);
            }
          else if (M2LexBuf_currenttoken == M2Reserved_lparatok)
            {
              /* avoid dangling else.  */
              SilentActualParameters (stopset0, stopset1, stopset2);
            }
          else
            {
              /* avoid dangling else.  */
              ErrorArray ((const char *) "expecting one of: {%K(} {%K%{}", 30);
            }
        }
      /* end of optional [ | ] expression  */
    }
  else
    {
      /* avoid dangling else.  */
      ErrorArray ((const char *) "expecting one of: {%Kidentifier} {%K%{}", 39);
    }
}


/*
   SilentActualParameters := '(' [ SilentExpList  ] 
                             ')' 

   first  symbols:lparatok
   
   cannot reachend
*/

static void SilentActualParameters (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  Expect (M2Reserved_lparatok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_rparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok))));
  if ((((M2LexBuf_currenttoken < M2Reserved_arraytok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_eoftok)) & ((P3Build_SetOfStop0) ((1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))))) != 0))) || (M2LexBuf_currenttoken == M2Reserved_nottok)) || ((M2LexBuf_currenttoken >= M2Reserved_recordtok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_recordtok)) & ((P3Build_SetOfStop2) ((1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok))))) != 0))))
    {
      SilentExpList (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_rparatok-M2Reserved_eoftok))), stopset1, stopset2);
    }
  Expect (M2Reserved_rparatok, stopset0, stopset1, stopset2);
}


/*
   SilentExpList := SilentConstExpression { ',' SilentConstExpression  } 

   first  symbols:stringtok, identtok, lcbratok, attributetok, realtok, integertok, lparatok, nottok, plustok, minustok
   
   cannot reachend
*/

static void SilentExpList (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  SilentConstExpression (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_commatok-M2Reserved_eoftok))), stopset1, stopset2);
  while (M2LexBuf_currenttoken == M2Reserved_commatok)
    {
      Expect (M2Reserved_commatok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok))));
      SilentConstExpression (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_commatok-M2Reserved_eoftok))), stopset1, stopset2);
    }
   /* while  */
}


/*
   SetType := ( 'SET'  | 'PACKEDSET'  ) 'OF' SimpleType 

   first  symbols:oftok, packedsettok, settok
   
   cannot reachend
*/

static void SetType (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  if (M2LexBuf_currenttoken == M2Reserved_settok)
    {
      Expect (M2Reserved_settok, stopset0, stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_oftok-M2Reserved_arraytok))), stopset2);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_packedsettok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_packedsettok, stopset0, stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_oftok-M2Reserved_arraytok))), stopset2);
    }
  else
    {
      /* avoid dangling else.  */
      ErrorArray ((const char *) "expecting one of: {%KPACKEDSET} {%KSET}", 39);
    }
  Expect (M2Reserved_oftok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_lsbratok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok))), stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  SimpleType (stopset0, stopset1, stopset2);
}


/*
   PointerType := 'POINTER' 'TO' Type 

   first  symbols:pointertok
   
   cannot reachend
*/

static void PointerType (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  Expect (M2Reserved_pointertok, stopset0, stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_totok-M2Reserved_recordtok))));
  Expect (M2Reserved_totok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lsbratok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_proceduretok-M2Reserved_arraytok)) | (1 << (M2Reserved_pointertok-M2Reserved_arraytok)) | (1 << (M2Reserved_packedsettok-M2Reserved_arraytok)) | (1 << (M2Reserved_oftok-M2Reserved_arraytok)) | (1 << (M2Reserved_arraytok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_settok-M2Reserved_recordtok)) | (1 << (M2Reserved_recordtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  Type (stopset0, stopset1, stopset2);
}


/*
   ProcedureType := 'PROCEDURE' [ FormalTypeList  ] 

   first  symbols:proceduretok
   
   cannot reachend
*/

static void ProcedureType (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  Expect (M2Reserved_proceduretok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_lparatok-M2Reserved_eoftok))), stopset1, stopset2);
  if (M2LexBuf_currenttoken == M2Reserved_lparatok)
    {
      FormalTypeList (stopset0, stopset1, stopset2);
    }
}


/*
   FormalTypeList := '(' ( ')' FormalReturn  | 
                           ProcedureParameters ')' 
                           FormalReturn  ) 

   first  symbols:lparatok
   
   cannot reachend
*/

static void FormalTypeList (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  Expect (M2Reserved_lparatok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_rparatok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_arraytok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_periodperiodperiodtok-M2Reserved_recordtok)) | (1 << (M2Reserved_vartok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  if (M2LexBuf_currenttoken == M2Reserved_rparatok)
    {
      Expect (M2Reserved_rparatok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_colontok-M2Reserved_eoftok))), stopset1, stopset2);
      FormalReturn (stopset0, stopset1, stopset2);
    }
  else if ((M2LexBuf_currenttoken == M2Reserved_arraytok) || ((M2LexBuf_currenttoken >= M2Reserved_recordtok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_recordtok)) & ((P3Build_SetOfStop2) ((1 << (M2Reserved_vartok-M2Reserved_recordtok)) | (1 << (M2Reserved_periodperiodperiodtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))))) != 0))))
    {
      /* avoid dangling else.  */
      ProcedureParameters (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_rparatok-M2Reserved_eoftok))), stopset1, stopset2);
      Expect (M2Reserved_rparatok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_colontok-M2Reserved_eoftok))), stopset1, stopset2);
      FormalReturn (stopset0, stopset1, stopset2);
    }
  else
    {
      /* avoid dangling else.  */
      ErrorArray ((const char *) "expecting one of: {%KVAR} {%K...} {%KARRAY} {%Kidentifier} {%K)}", 64);
    }
}


/*
   FormalReturn := [ ':' OptReturnType  ] 

   first  symbols:colontok
   
   reachend
*/

static void FormalReturn (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  if (M2LexBuf_currenttoken == M2Reserved_colontok)
    {
      Expect (M2Reserved_colontok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_lsbratok-M2Reserved_eoftok))), stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      OptReturnType (stopset0, stopset1, stopset2);
    }
}


/*
   OptReturnType := '[' Qualident ']'  | 
                    Qualident 

   first  symbols:identtok, lsbratok
   
   cannot reachend
*/

static void OptReturnType (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  if (M2LexBuf_currenttoken == M2Reserved_lsbratok)
    {
      Expect (M2Reserved_lsbratok, stopset0, stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      Qualident (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_rsbratok-M2Reserved_eoftok))), stopset1, stopset2);
      Expect (M2Reserved_rsbratok, stopset0, stopset1, stopset2);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_identtok)
    {
      /* avoid dangling else.  */
      Qualident (stopset0, stopset1, stopset2);
    }
  else
    {
      /* avoid dangling else.  */
      ErrorArray ((const char *) "expecting one of: {%Kidentifier} {%K[}", 38);
    }
}


/*
   ProcedureParameters := ProcedureParameter { ',' 
                                               ProcedureParameter  } 

   first  symbols:identtok, arraytok, periodperiodperiodtok, vartok
   
   cannot reachend
*/

static void ProcedureParameters (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  ProcedureParameter (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_commatok-M2Reserved_eoftok))), stopset1, stopset2);
  while (M2LexBuf_currenttoken == M2Reserved_commatok)
    {
      Expect (M2Reserved_commatok, stopset0, stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_arraytok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_vartok-M2Reserved_recordtok)) | (1 << (M2Reserved_periodperiodperiodtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      ProcedureParameter (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_commatok-M2Reserved_eoftok))), stopset1, stopset2);
    }
   /* while  */
}


/*
   ProcedureParameter := '...'  | 'VAR' FormalType  | 
                         FormalType 

   first  symbols:arraytok, identtok, vartok, periodperiodperiodtok
   
   cannot reachend
*/

static void ProcedureParameter (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  if (M2LexBuf_currenttoken == M2Reserved_periodperiodperiodtok)
    {
      Expect (M2Reserved_periodperiodperiodtok, stopset0, stopset1, stopset2);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_vartok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_vartok, stopset0, stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_arraytok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      FormalType (stopset0, stopset1, stopset2);
    }
  else if ((M2LexBuf_currenttoken == M2Reserved_arraytok) || (M2LexBuf_currenttoken == M2Reserved_identtok))
    {
      /* avoid dangling else.  */
      FormalType (stopset0, stopset1, stopset2);
    }
  else
    {
      /* avoid dangling else.  */
      ErrorArray ((const char *) "expecting one of: {%KARRAY} {%Kidentifier} {%KVAR} {%K...}", 58);
    }
}


/*
   VarIdent := 
               % VAR
                                                                                                 Sym, Type: CARDINAL ;
                                                                                                 on: BOOLEAN ;  %
               
               % on := IsAutoPushOn()  %
               
               % IF NOT on
                 THEN
                    PushAutoOn
                 END  %
               Ident 
               % IF on
                 THEN
                    PopTF(Sym, Type) ;
                    PushTF(Sym, Type) ;
                    PushTF(Sym, Type)
                 END  %
               [ '[' ConstExpression 
                 % BuildVarAtAddress  %
                 ']'  ] 
               % PopNothing ;
                 PopAuto  %
               

   first  symbols:identtok
   
   cannot reachend
*/

static void VarIdent (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  unsigned int Sym;
  unsigned int Type;
  bool on;

  on = M2Quads_IsAutoPushOn ();
  if (! on)
    {
      M2Quads_PushAutoOn ();
    }
  Ident (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_lsbratok-M2Reserved_eoftok))), stopset1, stopset2);
  if (on)
    {
      M2Quads_PopTF (&Sym, &Type);
      M2Quads_PushTF (Sym, Type);
      M2Quads_PushTF (Sym, Type);
    }
  if (M2LexBuf_currenttoken == M2Reserved_lsbratok)
    {
      Expect (M2Reserved_lsbratok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok))));
      ConstExpression (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_rsbratok-M2Reserved_eoftok))), stopset1, stopset2);
      P3SymBuild_BuildVarAtAddress ();
      Expect (M2Reserved_rsbratok, stopset0, stopset1, stopset2);
    }
  M2Quads_PopNothing ();
  M2Quads_PopAuto ();
}


/*
   VarIdentList := VarIdent 
                   % VAR
                                                                                                     on: BOOLEAN ;
                                                                                                     n : CARDINAL ;  %
                   
                   % on := IsAutoPushOn() ;
                     IF on
                     THEN
                        n := 1
                     END  %
                   { ',' VarIdent 
                     % IF on
                       THEN
                          INC(n)
                       END  %
                      } 
                   % IF on
                     THEN
                        PushT(n)
                     END  %
                   

   first  symbols:identtok
   
   cannot reachend
*/

static void VarIdentList (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  bool on;
  unsigned int n;

  VarIdent (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_commatok-M2Reserved_eoftok))), stopset1, stopset2);
  on = M2Quads_IsAutoPushOn ();
  if (on)
    {
      n = 1;
    }
  while (M2LexBuf_currenttoken == M2Reserved_commatok)
    {
      Expect (M2Reserved_commatok, stopset0, stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      VarIdent (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_commatok-M2Reserved_eoftok))), stopset1, stopset2);
      if (on)
        {
          n += 1;
        }
    }
   /* while  */
  if (on)
    {
      M2Quads_PushT (n);
    }
}


/*
   VariableDeclaration := VarIdentList ':' Type Alignment 

   first  symbols:identtok
   
   cannot reachend
*/

static void VariableDeclaration (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  VarIdentList (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_colontok-M2Reserved_eoftok))), stopset1, stopset2);
  Expect (M2Reserved_colontok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lsbratok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_proceduretok-M2Reserved_arraytok)) | (1 << (M2Reserved_pointertok-M2Reserved_arraytok)) | (1 << (M2Reserved_packedsettok-M2Reserved_arraytok)) | (1 << (M2Reserved_oftok-M2Reserved_arraytok)) | (1 << (M2Reserved_arraytok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_settok-M2Reserved_recordtok)) | (1 << (M2Reserved_recordtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  Type (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_ldirectivetok-M2Reserved_eoftok))), stopset1, stopset2);
  Alignment (stopset0, stopset1, stopset2);
}


/*
   Designator := Qualident 
                 % CheckWithReference  %
                 { SubDesignator  } 

   first  symbols:identtok
   
   cannot reachend
*/

static void Designator (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  Qualident (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_uparrowtok-M2Reserved_eoftok)) | (1 << (M2Reserved_lsbratok-M2Reserved_eoftok)) | (1 << (M2Reserved_periodtok-M2Reserved_eoftok))), stopset1, stopset2);
  M2Quads_CheckWithReference ();
  while ((M2LexBuf_currenttoken < M2Reserved_arraytok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_eoftok)) & ((P3Build_SetOfStop0) ((1 << (M2Reserved_periodtok-M2Reserved_eoftok)) | (1 << (M2Reserved_lsbratok-M2Reserved_eoftok)) | (1 << (M2Reserved_uparrowtok-M2Reserved_eoftok))))) != 0)))
    {
      SubDesignator (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_periodtok-M2Reserved_eoftok)) | (1 << (M2Reserved_lsbratok-M2Reserved_eoftok)) | (1 << (M2Reserved_uparrowtok-M2Reserved_eoftok))), stopset1, stopset2);
    }
   /* while  */
}


/*
   SubDesignator := '.' 
                    % VAR Sym, Type, tok,
                          dotpostok     : CARDINAL ;
                          name, n1      : Name ;  %
                    
                    % dotpostok := GetTokenNo () -1 ;
                      PopTFtok (Sym, Type, tok) ;
                      Type := SkipType(Type) ;
                      PushTFtok(Sym, Type, tok) ;
                      IF Type=NulSym
                      THEN
                         n1 := GetSymName(Sym) ;
                         IF IsModuleKnown(GetSymName(Sym))
                         THEN
                            WriteFormat2('%a looks like a module which has not been globally imported (eg. suggest that you IMPORT %a ;)',
                            n1, n1)
                         ELSE
                            WriteFormat1('%a is not a record variable', n1)
                         END
                      ELSIF NOT IsRecord(Type)
                      THEN
                         n1 := GetSymName(Type) ;
                         WriteFormat1('%a is not a record type', n1)
                      END ;
                      StartScope(Type)  %
                    Ident 
                    % PopTtok (name, tok) ;
                      Sym := GetLocalSym(Type, name) ;
                      IF Sym=NulSym
                      THEN
                         n1 := GetSymName(Type) ;
                         WriteFormat2('field %a does not exist within record %a', name, n1)
                      END ;
                      Type := GetType(Sym) ;
                      PushTFtok (Sym, Type, tok) ;
                      EndScope ;
                      PushT(1) ;
                      BuildDesignatorRecord (dotpostok)  %
                     | '[' ArrayExpList ']'  | 
                    '^' 
                    % BuildDesignatorPointer (GetTokenNo () -1)  %
                    

   first  symbols:uparrowtok, lsbratok, periodtok
   
   cannot reachend
*/

static void SubDesignator (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  unsigned int Sym;
  unsigned int Type;
  unsigned int tok;
  unsigned int dotpostok;
  NameKey_Name name;
  NameKey_Name n1;

  if (M2LexBuf_currenttoken == M2Reserved_periodtok)
    {
      Expect (M2Reserved_periodtok, stopset0, stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      dotpostok = (M2LexBuf_GetTokenNo ())-1;
      M2Quads_PopTFtok (&Sym, &Type, &tok);
      Type = SymbolTable_SkipType (Type);
      M2Quads_PushTFtok (Sym, Type, tok);
      if (Type == SymbolTable_NulSym)
        {
          n1 = SymbolTable_GetSymName (Sym);
          if (M2Batch_IsModuleKnown (SymbolTable_GetSymName (Sym)))
            {
              M2Error_WriteFormat2 ((const char *) "%a looks like a module which has not been globally imported (eg. suggest that you IMPORT %a ;)", 94, (const unsigned char *) &n1, (sizeof (n1)-1), (const unsigned char *) &n1, (sizeof (n1)-1));
            }
          else
            {
              M2Error_WriteFormat1 ((const char *) "%a is not a record variable", 27, (const unsigned char *) &n1, (sizeof (n1)-1));
            }
        }
      else if (! (SymbolTable_IsRecord (Type)))
        {
          /* avoid dangling else.  */
          n1 = SymbolTable_GetSymName (Type);
          M2Error_WriteFormat1 ((const char *) "%a is not a record type", 23, (const unsigned char *) &n1, (sizeof (n1)-1));
        }
      SymbolTable_StartScope (Type);
      Ident (stopset0, stopset1, stopset2);
      M2Quads_PopTtok (&name, &tok);
      Sym = SymbolTable_GetLocalSym (Type, name);
      if (Sym == SymbolTable_NulSym)
        {
          n1 = SymbolTable_GetSymName (Type);
          M2Error_WriteFormat2 ((const char *) "field %a does not exist within record %a", 40, (const unsigned char *) &name, (sizeof (name)-1), (const unsigned char *) &n1, (sizeof (n1)-1));
        }
      Type = SymbolTable_GetType (Sym);
      M2Quads_PushTFtok (Sym, Type, tok);
      SymbolTable_EndScope ();
      M2Quads_PushT (static_cast<unsigned int> (1));
      M2Quads_BuildDesignatorRecord (dotpostok);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_lsbratok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_lsbratok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      ArrayExpList (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_rsbratok-M2Reserved_eoftok))), stopset1, stopset2);
      Expect (M2Reserved_rsbratok, stopset0, stopset1, stopset2);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_uparrowtok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_uparrowtok, stopset0, stopset1, stopset2);
      M2Quads_BuildDesignatorPointer ((M2LexBuf_GetTokenNo ())-1);
    }
  else
    {
      /* avoid dangling else.  */
      ErrorArray ((const char *) "expecting one of: {%K^} {%K[} {%K.}", 35);
    }
}


/*
   ArrayExpList := Expression 
                   % BuildBooleanVariable  %
                   
                   % BuildDesignatorArray  %
                   { ',' Expression 
                     % BuildBooleanVariable  %
                     
                     % BuildDesignatorArray  %
                      } 

   first  symbols:lcbratok, identtok, realtok, integertok, stringtok, lparatok, nottok, plustok, minustok
   
   cannot reachend
*/

static void ArrayExpList (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  Expression (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_commatok-M2Reserved_eoftok))), stopset1, stopset2);
  M2Quads_BuildBooleanVariable ();
  M2Quads_BuildDesignatorArray ();
  while (M2LexBuf_currenttoken == M2Reserved_commatok)
    {
      Expect (M2Reserved_commatok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      Expression (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_commatok-M2Reserved_eoftok))), stopset1, stopset2);
      M2Quads_BuildBooleanVariable ();
      M2Quads_BuildDesignatorArray ();
    }
   /* while  */
}


/*
   ExpList := 
              % VAR n: CARDINAL ;  %
              Expression 
              % BuildBooleanVariable  %
              
              % n := 1  %
              { ',' Expression 
                % BuildBooleanVariable  %
                
                % INC(n)  %
                 } 
              % PushT(n)  %
              

   first  symbols:lcbratok, identtok, realtok, integertok, stringtok, lparatok, nottok, plustok, minustok
   
   cannot reachend
*/

static void ExpList (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  unsigned int n;

  Expression (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_commatok-M2Reserved_eoftok))), stopset1, stopset2);
  M2Quads_BuildBooleanVariable ();
  n = 1;
  while (M2LexBuf_currenttoken == M2Reserved_commatok)
    {
      Expect (M2Reserved_commatok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      Expression (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_commatok-M2Reserved_eoftok))), stopset1, stopset2);
      M2Quads_BuildBooleanVariable ();
      n += 1;
    }
   /* while  */
  M2Quads_PushT (n);
}


/*
   Expression := 
                 % VAR tokpos: CARDINAL ;  %
                 
                 % PushAutoOn  %
                 SimpleExpression [ Relation 
                                    % tokpos := GetTokenNo ()-1  %
                                    SimpleExpression 
                                    
                                    % BuildRelOp (tokpos)  %
                                     ] 
                 % PopAuto  %
                 

   first  symbols:identtok, lcbratok, nottok, lparatok, stringtok, integertok, realtok, minustok, plustok
   
   cannot reachend
*/

static void Expression (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  unsigned int tokpos;

  M2Quads_PushAutoOn ();
  SimpleExpression (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_greaterequaltok-M2Reserved_eoftok)) | (1 << (M2Reserved_greatertok-M2Reserved_eoftok)) | (1 << (M2Reserved_lessequaltok-M2Reserved_eoftok)) | (1 << (M2Reserved_lesstok-M2Reserved_eoftok)) | (1 << (M2Reserved_lessgreatertok-M2Reserved_eoftok)) | (1 << (M2Reserved_hashtok-M2Reserved_eoftok)) | (1 << (M2Reserved_equaltok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_intok-M2Reserved_arraytok))), stopset2);
  if (((M2LexBuf_currenttoken < M2Reserved_arraytok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_eoftok)) & ((P3Build_SetOfStop0) ((1 << (M2Reserved_equaltok-M2Reserved_eoftok)) | (1 << (M2Reserved_hashtok-M2Reserved_eoftok)) | (1 << (M2Reserved_lessgreatertok-M2Reserved_eoftok)) | (1 << (M2Reserved_lesstok-M2Reserved_eoftok)) | (1 << (M2Reserved_lessequaltok-M2Reserved_eoftok)) | (1 << (M2Reserved_greatertok-M2Reserved_eoftok)) | (1 << (M2Reserved_greaterequaltok-M2Reserved_eoftok))))) != 0))) || (M2LexBuf_currenttoken == M2Reserved_intok))
    {
      Relation (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      tokpos = (M2LexBuf_GetTokenNo ())-1;
      SimpleExpression (stopset0, stopset1, stopset2);
      M2Quads_BuildRelOp (tokpos);
    }
  M2Quads_PopAuto ();
}


/*
   SimpleExpression := UnaryOrTerm { AddOperator Term 
                                     
                                     % BuildBinaryOp  %
                                      } 

   first  symbols:lcbratok, identtok, realtok, integertok, stringtok, lparatok, nottok, plustok, minustok
   
   cannot reachend
*/

static void SimpleExpression (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  UnaryOrTerm (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_ortok-M2Reserved_arraytok))), stopset2);
  while (((M2LexBuf_currenttoken < M2Reserved_arraytok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_eoftok)) & ((P3Build_SetOfStop0) ((1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_minustok-M2Reserved_eoftok))))) != 0))) || (M2LexBuf_currenttoken == M2Reserved_ortok))
    {
      AddOperator (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      Term (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_minustok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_ortok-M2Reserved_arraytok))), stopset2);
      M2Quads_BuildBinaryOp ();
    }
   /* while  */
}


/*
   UnaryOrTerm := '+' 
                  % PushTtok(PlusTok, GetTokenNo() -1)  %
                  Term 
                  % BuildUnaryOp  %
                   | '-' 
                  % PushTtok(MinusTok, GetTokenNo() -1)  %
                  Term 
                  % BuildUnaryOp  %
                   | Term 

   first  symbols:identtok, lcbratok, nottok, lparatok, stringtok, integertok, realtok, minustok, plustok
   
   cannot reachend
*/

static void UnaryOrTerm (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  if (M2LexBuf_currenttoken == M2Reserved_plustok)
    {
      Expect (M2Reserved_plustok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      M2Quads_PushTtok (M2Reserved_PlusTok, (M2LexBuf_GetTokenNo ())-1);
      Term (stopset0, stopset1, stopset2);
      M2Quads_BuildUnaryOp ();
    }
  else if (M2LexBuf_currenttoken == M2Reserved_minustok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_minustok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      M2Quads_PushTtok (M2Reserved_MinusTok, (M2LexBuf_GetTokenNo ())-1);
      Term (stopset0, stopset1, stopset2);
      M2Quads_BuildUnaryOp ();
    }
  else if ((((M2LexBuf_currenttoken < M2Reserved_arraytok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_eoftok)) & ((P3Build_SetOfStop0) ((1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))))) != 0))) || (M2LexBuf_currenttoken == M2Reserved_nottok)) || ((M2LexBuf_currenttoken >= M2Reserved_recordtok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_recordtok)) & ((P3Build_SetOfStop2) ((1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))))) != 0))))
    {
      /* avoid dangling else.  */
      Term (stopset0, stopset1, stopset2);
    }
  else
    {
      /* avoid dangling else.  */
      ErrorArray ((const char *) "expecting one of: {%KNOT} {%K(} {%Kstring} {%Kinteger number} {%Kreal number} {%Kidentifier} {%K%{} {%K-} {%K+}", 111);
    }
}


/*
   Term := Factor { MulOperator Factor 
                    % BuildBinaryOp  %
                     } 

   first  symbols:lcbratok, identtok, realtok, integertok, stringtok, lparatok, nottok
   
   cannot reachend
*/

static void Term (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  Factor (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_ambersandtok-M2Reserved_eoftok)) | (1 << (M2Reserved_andtok-M2Reserved_eoftok)) | (1 << (M2Reserved_dividetok-M2Reserved_eoftok)) | (1 << (M2Reserved_timestok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_modtok-M2Reserved_arraytok)) | (1 << (M2Reserved_divtok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_remtok-M2Reserved_recordtok))));
  while ((((M2LexBuf_currenttoken < M2Reserved_arraytok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_eoftok)) & ((P3Build_SetOfStop0) ((1 << (M2Reserved_timestok-M2Reserved_eoftok)) | (1 << (M2Reserved_dividetok-M2Reserved_eoftok)) | (1 << (M2Reserved_andtok-M2Reserved_eoftok)) | (1 << (M2Reserved_ambersandtok-M2Reserved_eoftok))))) != 0))) || (((M2LexBuf_currenttoken >= M2Reserved_arraytok) && (M2LexBuf_currenttoken < M2Reserved_recordtok)) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_arraytok)) & ((P3Build_SetOfStop1) ((1 << (M2Reserved_divtok-M2Reserved_arraytok)) | (1 << (M2Reserved_modtok-M2Reserved_arraytok))))) != 0)))) || (M2LexBuf_currenttoken == M2Reserved_remtok))
    {
      MulOperator (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      Factor (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_timestok-M2Reserved_eoftok)) | (1 << (M2Reserved_dividetok-M2Reserved_eoftok)) | (1 << (M2Reserved_andtok-M2Reserved_eoftok)) | (1 << (M2Reserved_ambersandtok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_divtok-M2Reserved_arraytok)) | (1 << (M2Reserved_modtok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_remtok-M2Reserved_recordtok))));
      M2Quads_BuildBinaryOp ();
    }
   /* while  */
}


/*
   Factor := 
             % VAR tokpos: CARDINAL ;  %
             Number  | string  | SetOrDesignatorOrFunction  | 
             '(' Expression ')'  | 
             'NOT' 
             % tokpos := GetTokenNo ()-1  %
             ( Factor 
               % BuildNot (tokpos)  %
                | ConstAttribute  ) 

   first  symbols:identtok, lcbratok, nottok, lparatok, stringtok, integertok, realtok
   
   cannot reachend
*/

static void Factor (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  unsigned int tokpos;

  if ((M2LexBuf_currenttoken >= M2Reserved_recordtok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_recordtok)) & ((P3Build_SetOfStop2) ((1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok))))) != 0)))
    {
      Number (stopset0, stopset1, stopset2);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_stringtok)
    {
      /* avoid dangling else.  */
      string (stopset0, stopset1, stopset2);
    }
  else if ((M2LexBuf_currenttoken == M2Reserved_lcbratok) || (M2LexBuf_currenttoken == M2Reserved_identtok))
    {
      /* avoid dangling else.  */
      SetOrDesignatorOrFunction (stopset0, stopset1, stopset2);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_lparatok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_lparatok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      Expression (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_rparatok-M2Reserved_eoftok))), stopset1, stopset2);
      Expect (M2Reserved_rparatok, stopset0, stopset1, stopset2);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_nottok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_nottok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      tokpos = (M2LexBuf_GetTokenNo ())-1;
      if ((((M2LexBuf_currenttoken < M2Reserved_arraytok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_eoftok)) & ((P3Build_SetOfStop0) ((1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))))) != 0))) || (M2LexBuf_currenttoken == M2Reserved_nottok)) || ((M2LexBuf_currenttoken >= M2Reserved_recordtok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_recordtok)) & ((P3Build_SetOfStop2) ((1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))))) != 0))))
        {
          Factor (stopset0, stopset1, stopset2);
          M2Quads_BuildNot (tokpos);
        }
      else if (M2LexBuf_currenttoken == M2Reserved_attributetok)
        {
          /* avoid dangling else.  */
          ConstAttribute (stopset0, stopset1, stopset2);
        }
      else
        {
          /* avoid dangling else.  */
          ErrorArray ((const char *) "expecting one of: {%K__ATTRIBUTE__} {%Kreal number} {%Kinteger number} {%Kstring} {%K(} {%KNOT} {%K%{} {%Kidentifier}", 117);
        }
    }
  else
    {
      /* avoid dangling else.  */
      ErrorArray ((const char *) "expecting one of: {%KNOT} {%K(} {%Kidentifier} {%K%{} {%Kstring} {%Kinteger number} {%Kreal number}", 99);
    }
}


/*
   SetOrDesignatorOrFunction := Qualident 
                                % Assert (OperandTok(1) # UnknownTokenNo)  %
                                
                                % CheckWithReference  %
                                
                                % Assert (OperandTok(1) # UnknownTokenNo)  %
                                [ Constructor  | 
                                  SimpleDes 
                                  %  Assert (OperandTok(1) # UnknownTokenNo)   %
                                  [ ActualParameters 
                                    
                                    % IF IsInConstExpression()
                                      THEN
                                         BuildConstFunctionCall
                                      ELSE
                                         BuildFunctionCall
                                      END  %
                                     ]  ]  | 
                                
                                % BuildTypeForConstructor  %
                                Constructor 

   first  symbols:lcbratok, identtok
   
   cannot reachend
*/

static void SetOrDesignatorOrFunction (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  if (M2LexBuf_currenttoken == M2Reserved_identtok)
    {
      /* avoid dangling else.  */
      Qualident (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_lcbratok-M2Reserved_eoftok)) | (1 << (M2Reserved_periodtok-M2Reserved_eoftok)) | (1 << (M2Reserved_lsbratok-M2Reserved_eoftok)) | (1 << (M2Reserved_uparrowtok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok))), stopset1, stopset2);
      M2Debug_Assert ((M2Quads_OperandTok (1)) != M2LexBuf_UnknownTokenNo);
      M2Quads_CheckWithReference ();
      M2Debug_Assert ((M2Quads_OperandTok (1)) != M2LexBuf_UnknownTokenNo);
      if ((M2LexBuf_currenttoken < M2Reserved_arraytok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_eoftok)) & ((P3Build_SetOfStop0) ((1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_uparrowtok-M2Reserved_eoftok)) | (1 << (M2Reserved_lsbratok-M2Reserved_eoftok)) | (1 << (M2Reserved_periodtok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))))) != 0)))
        {
          /* avoid gcc warning by using compound statement even if not strictly necessary.  */
          /* seen optional [ | ] expression  */
          if (M2LexBuf_currenttoken == M2Reserved_lcbratok)
            {
              Constructor (stopset0, stopset1, stopset2);
            }
          else if ((M2LexBuf_currenttoken < M2Reserved_arraytok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_eoftok)) & ((P3Build_SetOfStop0) ((1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_uparrowtok-M2Reserved_eoftok)) | (1 << (M2Reserved_lsbratok-M2Reserved_eoftok)) | (1 << (M2Reserved_periodtok-M2Reserved_eoftok))))) != 0)))
            {
              /* avoid dangling else.  */
              SimpleDes (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_lparatok-M2Reserved_eoftok))), stopset1, stopset2);
              /* Assert (OperandTok(1) # UnknownTokenNo)  */
              if (M2LexBuf_currenttoken == M2Reserved_lparatok)
                {
                  ActualParameters (stopset0, stopset1, stopset2);
                  if (M2Quads_IsInConstExpression ())
                    {
                      M2Quads_BuildConstFunctionCall ();
                    }
                  else
                    {
                      M2Quads_BuildFunctionCall ();
                    }
                }
            }
          else
            {
              /* avoid dangling else.  */
              ErrorArray ((const char *) "expecting one of: {%K(} {%K^} {%K[} {%K.} {%K%{}", 48);
            }
        }
      /* end of optional [ | ] expression  */
    }
  else
    {
      M2Quads_BuildTypeForConstructor ();
      Constructor (stopset0, stopset1, stopset2);
    }
}


/*
   SimpleDes := { SubDesignator  } 

   first  symbols:periodtok, lsbratok, uparrowtok
   
   reachend
*/

static void SimpleDes (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  while ((M2LexBuf_currenttoken < M2Reserved_arraytok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_eoftok)) & ((P3Build_SetOfStop0) ((1 << (M2Reserved_periodtok-M2Reserved_eoftok)) | (1 << (M2Reserved_lsbratok-M2Reserved_eoftok)) | (1 << (M2Reserved_uparrowtok-M2Reserved_eoftok))))) != 0)))
    {
      SubDesignator (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_periodtok-M2Reserved_eoftok)) | (1 << (M2Reserved_lsbratok-M2Reserved_eoftok)) | (1 << (M2Reserved_uparrowtok-M2Reserved_eoftok))), stopset1, stopset2);
    }
   /* while  */
}


/*
   ActualParameters := '(' 
                       % BuildSizeCheckStart  %
                       ( ExpList  | 
                         % BuildNulParam  %
                          ) ')' 

   first  symbols:lparatok
   
   cannot reachend
*/

static void ActualParameters (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  Expect (M2Reserved_lparatok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_rparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  M2Quads_BuildSizeCheckStart ();
  if ((((M2LexBuf_currenttoken < M2Reserved_arraytok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_eoftok)) & ((P3Build_SetOfStop0) ((1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))))) != 0))) || (M2LexBuf_currenttoken == M2Reserved_nottok)) || ((M2LexBuf_currenttoken >= M2Reserved_recordtok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_recordtok)) & ((P3Build_SetOfStop2) ((1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))))) != 0))))
    {
      ExpList (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_rparatok-M2Reserved_eoftok))), stopset1, stopset2);
    }
  else
    {
      M2Quads_BuildNulParam ();
    }
  Expect (M2Reserved_rparatok, stopset0, stopset1, stopset2);
}


/*
   ExitStatement := 'EXIT' 
                    % BuildExit  %
                    

   first  symbols:exittok
   
   cannot reachend
*/

static void ExitStatement (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  Expect (M2Reserved_exittok, stopset0, stopset1, stopset2);
  M2Quads_BuildExit ();
}


/*
   ReturnStatement := 'RETURN' 
                      % VAR tokno: CARDINAL ;  %
                      
                      % tokno := GetTokenNo () -1  %
                      ( Expression  | 
                        % BuildNulExpression  in epsilon   %
                         ) 
                      % BuildReturn (tokno)  %
                      

   first  symbols:returntok
   
   cannot reachend
*/

static void ReturnStatement (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  unsigned int tokno;

  Expect (M2Reserved_returntok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  tokno = (M2LexBuf_GetTokenNo ())-1;
  if ((((M2LexBuf_currenttoken < M2Reserved_arraytok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_eoftok)) & ((P3Build_SetOfStop0) ((1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))))) != 0))) || (M2LexBuf_currenttoken == M2Reserved_nottok)) || ((M2LexBuf_currenttoken >= M2Reserved_recordtok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_recordtok)) & ((P3Build_SetOfStop2) ((1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))))) != 0))))
    {
      Expression (stopset0, stopset1, stopset2);
    }
  else
    {
      M2Quads_BuildNulExpression ();  /* in epsilon  */
    }
  M2Quads_BuildReturn (tokno);
}


/*
   Statement := 
                % BuildStmtNote (0)  %
                
                % PushAutoOn ; DisplayStack  %
                [ AssignmentOrProcedureCall  | 
                  IfStatement  | CaseStatement  | 
                  WhileStatement  | 
                  RepeatStatement  | 
                  LoopStatement  | ForStatement  | 
                  WithStatement  | AsmStatement  | 
                  ExitStatement  | ReturnStatement  | 
                  RetryStatement  ] 
                % PopAuto ;  %
                

   first  symbols:retrytok, asmtok, withtok, fortok, looptok, repeattok, whiletok, casetok, iftok, identtok, returntok, exittok
   
   reachend
*/

static void Statement (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  M2Quads_BuildStmtNote (0);
  M2Quads_PushAutoOn ();
  M2Quads_DisplayStack ();
  if ((((M2LexBuf_currenttoken >= M2Reserved_arraytok) && (M2LexBuf_currenttoken < M2Reserved_recordtok)) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_arraytok)) & ((P3Build_SetOfStop1) ((1 << (M2Reserved_exittok-M2Reserved_arraytok)) | (1 << (M2Reserved_fortok-M2Reserved_arraytok)) | (1 << (M2Reserved_looptok-M2Reserved_arraytok)) | (1 << (M2Reserved_casetok-M2Reserved_arraytok)) | (1 << (M2Reserved_iftok-M2Reserved_arraytok))))) != 0))) || ((M2LexBuf_currenttoken >= M2Reserved_recordtok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_recordtok)) & ((P3Build_SetOfStop2) ((1 << (M2Reserved_retrytok-M2Reserved_recordtok)) | (1 << (M2Reserved_returntok-M2Reserved_recordtok)) | (1 << (M2Reserved_asmtok-M2Reserved_recordtok)) | (1 << (M2Reserved_withtok-M2Reserved_recordtok)) | (1 << (M2Reserved_repeattok-M2Reserved_recordtok)) | (1 << (M2Reserved_whiletok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))))) != 0))))
    {
      /* avoid gcc warning by using compound statement even if not strictly necessary.  */
      /* seen optional [ | ] expression  */
      if (M2LexBuf_currenttoken == M2Reserved_identtok)
        {
          AssignmentOrProcedureCall (stopset0, stopset1, stopset2);
        }
      else if (M2LexBuf_currenttoken == M2Reserved_iftok)
        {
          /* avoid dangling else.  */
          IfStatement (stopset0, stopset1, stopset2);
        }
      else if (M2LexBuf_currenttoken == M2Reserved_casetok)
        {
          /* avoid dangling else.  */
          CaseStatement (stopset0, stopset1, stopset2);
        }
      else if (M2LexBuf_currenttoken == M2Reserved_whiletok)
        {
          /* avoid dangling else.  */
          WhileStatement (stopset0, stopset1, stopset2);
        }
      else if (M2LexBuf_currenttoken == M2Reserved_repeattok)
        {
          /* avoid dangling else.  */
          RepeatStatement (stopset0, stopset1, stopset2);
        }
      else if (M2LexBuf_currenttoken == M2Reserved_looptok)
        {
          /* avoid dangling else.  */
          LoopStatement (stopset0, stopset1, stopset2);
        }
      else if (M2LexBuf_currenttoken == M2Reserved_fortok)
        {
          /* avoid dangling else.  */
          ForStatement (stopset0, stopset1, stopset2);
        }
      else if (M2LexBuf_currenttoken == M2Reserved_withtok)
        {
          /* avoid dangling else.  */
          WithStatement (stopset0, stopset1, stopset2);
        }
      else if (M2LexBuf_currenttoken == M2Reserved_asmtok)
        {
          /* avoid dangling else.  */
          AsmStatement (stopset0, stopset1, stopset2);
        }
      else if (M2LexBuf_currenttoken == M2Reserved_exittok)
        {
          /* avoid dangling else.  */
          ExitStatement (stopset0, stopset1, stopset2);
        }
      else if (M2LexBuf_currenttoken == M2Reserved_returntok)
        {
          /* avoid dangling else.  */
          ReturnStatement (stopset0, stopset1, stopset2);
        }
      else if (M2LexBuf_currenttoken == M2Reserved_retrytok)
        {
          /* avoid dangling else.  */
          RetryStatement (stopset0, stopset1, stopset2);
        }
      else
        {
          /* avoid dangling else.  */
          ErrorArray ((const char *) "expecting one of: {%KRETRY} {%KRETURN} {%KEXIT} {%KASM} {%KWITH} {%KFOR} {%KLOOP} {%KREPEAT} {%KWHILE} {%KCASE} {%KIF} {%Kidentifier}", 133);
        }
    }
  /* end of optional [ | ] expression  */
  M2Quads_PopAuto ();
}


/*
   RetryStatement := 'RETRY' 
                     % BuildRetry (GetTokenNo () -1)  %
                     

   first  symbols:retrytok
   
   cannot reachend
*/

static void RetryStatement (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  Expect (M2Reserved_retrytok, stopset0, stopset1, stopset2);
  M2Quads_BuildRetry ((M2LexBuf_GetTokenNo ())-1);
}


/*
   AssignmentOrProcedureCall := 
                                % VAR isFunc: BOOLEAN ;
                                      tokno : CARDINAL ;  %
                                
                                % DisplayStack  %
                                Designator 
                                % tokno := GetTokenNo ()  %
                                ( ':=' 
                                  %  PrintTokenNo (tokno)   %
                                  Expression 
                                  % BuildAssignment (tokno)  %
                                   | 
                                  
                                  % isFunc := CheckBuildFunction()  %
                                  ( ActualParameters  | 
                                    
                                    % BuildNulParam  in epsilon   %
                                     ) 
                                  % IF isFunc
                                    THEN
                                       BuildFunctionCall ;
                                       BuildAssignment (tokno)
                                    ELSE
                                       BuildProcedureCall (tokno - 1)
                                    END  %
                                   ) 
                                % DisplayStack  %
                                

   first  symbols:identtok
   
   cannot reachend
*/

static void AssignmentOrProcedureCall (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  bool isFunc;
  unsigned int tokno;

  M2Quads_DisplayStack ();
  Designator (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_becomestok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok))), stopset1, stopset2);
  tokno = M2LexBuf_GetTokenNo ();
  if (M2LexBuf_currenttoken == M2Reserved_becomestok)
    {
      Expect (M2Reserved_becomestok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      /* PrintTokenNo (tokno)  */
      Expression (stopset0, stopset1, stopset2);
      M2Quads_BuildAssignment (tokno);
    }
  else
    {
      isFunc = M2Quads_CheckBuildFunction ();
      if (M2LexBuf_currenttoken == M2Reserved_lparatok)
        {
          ActualParameters (stopset0, stopset1, stopset2);
        }
      else
        {
          M2Quads_BuildNulParam ();  /* in epsilon  */
        }
      if (isFunc)
        {
          M2Quads_BuildFunctionCall ();
          M2Quads_BuildAssignment (tokno);
        }
      else
        {
          M2Quads_BuildProcedureCall (tokno-1);
        }
    }
  M2Quads_DisplayStack ();
}


/*
   StatementSequence := Statement { ';' Statement  } 

   first  symbols:identtok, iftok, casetok, whiletok, repeattok, looptok, fortok, withtok, asmtok, retrytok, semicolontok, exittok, returntok
   
   reachend
*/

static void StatementSequence (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  Statement (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1, stopset2);
  while (M2LexBuf_currenttoken == M2Reserved_semicolontok)
    {
      Expect (M2Reserved_semicolontok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_exittok-M2Reserved_arraytok)) | (1 << (M2Reserved_fortok-M2Reserved_arraytok)) | (1 << (M2Reserved_looptok-M2Reserved_arraytok)) | (1 << (M2Reserved_casetok-M2Reserved_arraytok)) | (1 << (M2Reserved_iftok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_returntok-M2Reserved_recordtok)) | (1 << (M2Reserved_retrytok-M2Reserved_recordtok)) | (1 << (M2Reserved_asmtok-M2Reserved_recordtok)) | (1 << (M2Reserved_withtok-M2Reserved_recordtok)) | (1 << (M2Reserved_repeattok-M2Reserved_recordtok)) | (1 << (M2Reserved_whiletok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      Statement (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1, stopset2);
    }
   /* while  */
}


/*
   IfStatement := 'IF' Expression 'THEN' 
                  % BuildThenIf  %
                  
                  % BuildStmtNote (-1)  %
                  StatementSequence { 'ELSIF' 
                                      % BuildElsif1  %
                                      
                                      % BuildStmtNote (-1)  %
                                      Expression 'THEN' 
                                      
                                      % BuildThenIf  %
                                      
                                      % BuildStmtNote (-1)  %
                                      StatementSequence 
                                      
                                      % BuildElsif2  %
                                       } [ 'ELSE' 
                                           % BuildElse  %
                                           
                                           % BuildStmtNote (-1)  %
                                           StatementSequence  ] 
                  'END' 
                  % BuildEndIf  %
                  
                  % BuildStmtNote (-1)  %
                  

   first  symbols:iftok
   
   cannot reachend
*/

static void IfStatement (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  Expect (M2Reserved_iftok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  Expression (stopset0, stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_thentok-M2Reserved_recordtok))));
  Expect (M2Reserved_thentok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_exittok-M2Reserved_arraytok)) | (1 << (M2Reserved_elsiftok-M2Reserved_arraytok)) | (1 << (M2Reserved_elsetok-M2Reserved_arraytok)) | (1 << (M2Reserved_endtok-M2Reserved_arraytok)) | (1 << (M2Reserved_iftok-M2Reserved_arraytok)) | (1 << (M2Reserved_casetok-M2Reserved_arraytok)) | (1 << (M2Reserved_looptok-M2Reserved_arraytok)) | (1 << (M2Reserved_fortok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_returntok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_whiletok-M2Reserved_recordtok)) | (1 << (M2Reserved_repeattok-M2Reserved_recordtok)) | (1 << (M2Reserved_withtok-M2Reserved_recordtok)) | (1 << (M2Reserved_asmtok-M2Reserved_recordtok)) | (1 << (M2Reserved_retrytok-M2Reserved_recordtok))));
  M2Quads_BuildThenIf ();
  M2Quads_BuildStmtNote (-1);
  StatementSequence (stopset0, stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_elsiftok-M2Reserved_arraytok)) | (1 << (M2Reserved_elsetok-M2Reserved_arraytok)) | (1 << (M2Reserved_endtok-M2Reserved_arraytok))), stopset2);
  while (M2LexBuf_currenttoken == M2Reserved_elsiftok)
    {
      Expect (M2Reserved_elsiftok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      M2Quads_BuildElsif1 ();
      M2Quads_BuildStmtNote (-1);
      Expression (stopset0, stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_thentok-M2Reserved_recordtok))));
      Expect (M2Reserved_thentok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_exittok-M2Reserved_arraytok)) | (1 << (M2Reserved_endtok-M2Reserved_arraytok)) | (1 << (M2Reserved_elsetok-M2Reserved_arraytok)) | (1 << (M2Reserved_elsiftok-M2Reserved_arraytok)) | (1 << (M2Reserved_iftok-M2Reserved_arraytok)) | (1 << (M2Reserved_casetok-M2Reserved_arraytok)) | (1 << (M2Reserved_looptok-M2Reserved_arraytok)) | (1 << (M2Reserved_fortok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_returntok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_whiletok-M2Reserved_recordtok)) | (1 << (M2Reserved_repeattok-M2Reserved_recordtok)) | (1 << (M2Reserved_withtok-M2Reserved_recordtok)) | (1 << (M2Reserved_asmtok-M2Reserved_recordtok)) | (1 << (M2Reserved_retrytok-M2Reserved_recordtok))));
      M2Quads_BuildThenIf ();
      M2Quads_BuildStmtNote (-1);
      StatementSequence (stopset0, stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_endtok-M2Reserved_arraytok)) | (1 << (M2Reserved_elsetok-M2Reserved_arraytok)) | (1 << (M2Reserved_elsiftok-M2Reserved_arraytok))), stopset2);
      M2Quads_BuildElsif2 ();
    }
   /* while  */
  if (M2LexBuf_currenttoken == M2Reserved_elsetok)
    {
      Expect (M2Reserved_elsetok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_exittok-M2Reserved_arraytok)) | (1 << (M2Reserved_endtok-M2Reserved_arraytok)) | (1 << (M2Reserved_iftok-M2Reserved_arraytok)) | (1 << (M2Reserved_casetok-M2Reserved_arraytok)) | (1 << (M2Reserved_looptok-M2Reserved_arraytok)) | (1 << (M2Reserved_fortok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_returntok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_whiletok-M2Reserved_recordtok)) | (1 << (M2Reserved_repeattok-M2Reserved_recordtok)) | (1 << (M2Reserved_withtok-M2Reserved_recordtok)) | (1 << (M2Reserved_asmtok-M2Reserved_recordtok)) | (1 << (M2Reserved_retrytok-M2Reserved_recordtok))));
      M2Quads_BuildElse ();
      M2Quads_BuildStmtNote (-1);
      StatementSequence (stopset0, stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_endtok-M2Reserved_arraytok))), stopset2);
    }
  Expect (M2Reserved_endtok, stopset0, stopset1, stopset2);
  M2Quads_BuildEndIf ();
  M2Quads_BuildStmtNote (-1);
}


/*
   CaseStatement := 'CASE' Expression 
                    % BuildCaseStart  %
                    'OF' Case { '|' Case  } CaseEndStatement 

   first  symbols:casetok
   
   cannot reachend
*/

static void CaseStatement (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  Expect (M2Reserved_casetok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  Expression (stopset0, stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_oftok-M2Reserved_arraytok))), stopset2);
  M2Quads_BuildCaseStart ();
  Expect (M2Reserved_oftok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_bartok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_elsetok-M2Reserved_arraytok)) | (1 << (M2Reserved_endtok-M2Reserved_arraytok)) | (1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok))));
  Case (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_bartok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_elsetok-M2Reserved_arraytok)) | (1 << (M2Reserved_endtok-M2Reserved_arraytok))), stopset2);
  while (M2LexBuf_currenttoken == M2Reserved_bartok)
    {
      Expect (M2Reserved_bartok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_bartok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_endtok-M2Reserved_arraytok)) | (1 << (M2Reserved_elsetok-M2Reserved_arraytok)) | (1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok))));
      Case (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_bartok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_endtok-M2Reserved_arraytok)) | (1 << (M2Reserved_elsetok-M2Reserved_arraytok))), stopset2);
    }
   /* while  */
  CaseEndStatement (stopset0, stopset1, stopset2);
}


/*
   CaseEndStatement := 'END' 
                       % BuildStmtNote (-1)  %
                       
                       % BuildCaseElse  %
                       
                       % BuildCaseCheck  %
                       
                       % BuildCaseEnd  %
                        | 'ELSE' 
                       % BuildStmtNote (-1)  %
                       
                       % BuildCaseElse  %
                       StatementSequence 
                       % BuildStmtNote (0)  %
                       'END' 
                       % BuildCaseEnd  %
                       

   first  symbols:elsetok, endtok
   
   cannot reachend
*/

static void CaseEndStatement (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  if (M2LexBuf_currenttoken == M2Reserved_endtok)
    {
      Expect (M2Reserved_endtok, stopset0, stopset1, stopset2);
      M2Quads_BuildStmtNote (-1);
      M2Quads_BuildCaseElse ();
      M2Quads_BuildCaseCheck ();
      M2Quads_BuildCaseEnd ();
    }
  else if (M2LexBuf_currenttoken == M2Reserved_elsetok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_elsetok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_exittok-M2Reserved_arraytok)) | (1 << (M2Reserved_endtok-M2Reserved_arraytok)) | (1 << (M2Reserved_iftok-M2Reserved_arraytok)) | (1 << (M2Reserved_casetok-M2Reserved_arraytok)) | (1 << (M2Reserved_looptok-M2Reserved_arraytok)) | (1 << (M2Reserved_fortok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_returntok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_whiletok-M2Reserved_recordtok)) | (1 << (M2Reserved_repeattok-M2Reserved_recordtok)) | (1 << (M2Reserved_withtok-M2Reserved_recordtok)) | (1 << (M2Reserved_asmtok-M2Reserved_recordtok)) | (1 << (M2Reserved_retrytok-M2Reserved_recordtok))));
      M2Quads_BuildStmtNote (-1);
      M2Quads_BuildCaseElse ();
      StatementSequence (stopset0, stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_endtok-M2Reserved_arraytok))), stopset2);
      M2Quads_BuildStmtNote (0);
      Expect (M2Reserved_endtok, stopset0, stopset1, stopset2);
      M2Quads_BuildCaseEnd ();
    }
  else
    {
      /* avoid dangling else.  */
      ErrorArray ((const char *) "expecting one of: {%KELSE} {%KEND}", 34);
    }
}


/*
   Case := [ 
             % BuildStmtNote (-1)  %
             CaseLabelList 
             % BuildCaseStartStatementSequence  %
             ':' StatementSequence 
             % BuildCaseEndStatementSequence  %
             
             % EndCaseList  %
              ] 

   first  symbols:stringtok, lcbratok, identtok, attributetok, realtok, integertok, lparatok, nottok, plustok, minustok
   
   reachend
*/

static void Case (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  if ((((M2LexBuf_currenttoken < M2Reserved_arraytok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_eoftok)) & ((P3Build_SetOfStop0) ((1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))))) != 0))) || (M2LexBuf_currenttoken == M2Reserved_nottok)) || ((M2LexBuf_currenttoken >= M2Reserved_recordtok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_recordtok)) & ((P3Build_SetOfStop2) ((1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok))))) != 0))))
    {
      M2Quads_BuildStmtNote (-1);
      CaseLabelList (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_colontok-M2Reserved_eoftok))), stopset1, stopset2);
      M2Quads_BuildCaseStartStatementSequence ();
      Expect (M2Reserved_colontok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_exittok-M2Reserved_arraytok)) | (1 << (M2Reserved_iftok-M2Reserved_arraytok)) | (1 << (M2Reserved_casetok-M2Reserved_arraytok)) | (1 << (M2Reserved_looptok-M2Reserved_arraytok)) | (1 << (M2Reserved_fortok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_returntok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_whiletok-M2Reserved_recordtok)) | (1 << (M2Reserved_repeattok-M2Reserved_recordtok)) | (1 << (M2Reserved_withtok-M2Reserved_recordtok)) | (1 << (M2Reserved_asmtok-M2Reserved_recordtok)) | (1 << (M2Reserved_retrytok-M2Reserved_recordtok))));
      StatementSequence (stopset0, stopset1, stopset2);
      M2Quads_BuildCaseEndStatementSequence ();
      M2CaseList_EndCaseList ();
    }
}


/*
   CaseLabelList := 
                    % BeginCaseList(NulSym)  %
                    CaseLabels { ',' 
                                 % BuildCaseOr  %
                                 CaseLabels  } 

   first  symbols:attributetok, identtok, lcbratok, stringtok, nottok, lparatok, integertok, realtok, minustok, plustok
   
   cannot reachend
*/

static void CaseLabelList (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  M2CaseList_BeginCaseList (SymbolTable_NulSym);
  CaseLabels (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_commatok-M2Reserved_eoftok))), stopset1, stopset2);
  while (M2LexBuf_currenttoken == M2Reserved_commatok)
    {
      Expect (M2Reserved_commatok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok))));
      M2Quads_BuildCaseOr ();
      CaseLabels (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_commatok-M2Reserved_eoftok))), stopset1, stopset2);
    }
   /* while  */
}


/*
   CaseLabels := ConstExpression ( '..' ConstExpression 
                                   
                                   % BuildCaseRange ;
                                     BuildCaseList  %
                                    | 
                                   
                                   % BuildCaseEquality ;   epsilon 
                                     BuildCaseList  %
                                    ) 

   first  symbols:stringtok, lcbratok, identtok, attributetok, realtok, integertok, lparatok, nottok, plustok, minustok
   
   cannot reachend
*/

static void CaseLabels (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  ConstExpression (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_periodperiodtok-M2Reserved_eoftok))), stopset1, stopset2);
  if (M2LexBuf_currenttoken == M2Reserved_periodperiodtok)
    {
      Expect (M2Reserved_periodperiodtok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok))));
      ConstExpression (stopset0, stopset1, stopset2);
      M2Quads_BuildCaseRange ();
      M2Quads_BuildCaseList ();
    }
  else
    {
      M2Quads_BuildCaseEquality ();  /* epsilon  */
      M2Quads_BuildCaseList ();  /* epsilon  */
    }
}


/*
   WhileStatement := 'WHILE' 
                     % BuildWhile  %
                     
                     % BuildStmtNote (0)  %
                     Expression 
                     % BuildStmtNote (0)  %
                     'DO' 
                     % BuildDoWhile  %
                     StatementSequence 
                     % BuildStmtNote (0)  %
                     'END' 
                     % DisplayStack ; BuildEndWhile  %
                     

   first  symbols:whiletok
   
   cannot reachend
*/

static void WhileStatement (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  Expect (M2Reserved_whiletok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  M2Quads_BuildWhile ();
  M2Quads_BuildStmtNote (0);
  Expression (stopset0, stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_dotok-M2Reserved_arraytok))), stopset2);
  M2Quads_BuildStmtNote (0);
  Expect (M2Reserved_dotok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_exittok-M2Reserved_arraytok)) | (1 << (M2Reserved_endtok-M2Reserved_arraytok)) | (1 << (M2Reserved_iftok-M2Reserved_arraytok)) | (1 << (M2Reserved_casetok-M2Reserved_arraytok)) | (1 << (M2Reserved_looptok-M2Reserved_arraytok)) | (1 << (M2Reserved_fortok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_returntok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_whiletok-M2Reserved_recordtok)) | (1 << (M2Reserved_repeattok-M2Reserved_recordtok)) | (1 << (M2Reserved_withtok-M2Reserved_recordtok)) | (1 << (M2Reserved_asmtok-M2Reserved_recordtok)) | (1 << (M2Reserved_retrytok-M2Reserved_recordtok))));
  M2Quads_BuildDoWhile ();
  StatementSequence (stopset0, stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_endtok-M2Reserved_arraytok))), stopset2);
  M2Quads_BuildStmtNote (0);
  Expect (M2Reserved_endtok, stopset0, stopset1, stopset2);
  M2Quads_DisplayStack ();
  M2Quads_BuildEndWhile ();
}


/*
   RepeatStatement := 'REPEAT' 
                      % BuildRepeat  %
                      StatementSequence 
                      % BuildStmtNote (0)  %
                      'UNTIL' Expression 
                      % BuildUntil  %
                      

   first  symbols:repeattok
   
   cannot reachend
*/

static void RepeatStatement (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  Expect (M2Reserved_repeattok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_exittok-M2Reserved_arraytok)) | (1 << (M2Reserved_iftok-M2Reserved_arraytok)) | (1 << (M2Reserved_casetok-M2Reserved_arraytok)) | (1 << (M2Reserved_looptok-M2Reserved_arraytok)) | (1 << (M2Reserved_fortok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_returntok-M2Reserved_recordtok)) | (1 << (M2Reserved_untiltok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_whiletok-M2Reserved_recordtok)) | (1 << (M2Reserved_repeattok-M2Reserved_recordtok)) | (1 << (M2Reserved_withtok-M2Reserved_recordtok)) | (1 << (M2Reserved_asmtok-M2Reserved_recordtok)) | (1 << (M2Reserved_retrytok-M2Reserved_recordtok))));
  M2Quads_BuildRepeat ();
  StatementSequence (stopset0, stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_untiltok-M2Reserved_recordtok))));
  M2Quads_BuildStmtNote (0);
  Expect (M2Reserved_untiltok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  Expression (stopset0, stopset1, stopset2);
  M2Quads_BuildUntil ();
}


/*
   ForStatement := 
                   % VAR endpostok: CARDINAL ;  %
                   
                   % PushLineNo  %
                   'FOR' Ident ':=' Expression 'TO' 
                   Expression ( 'BY' ConstExpression  | 
                                
                                % BuildPseudoBy  epsilon   %
                                 ) 
                   % PushLineNo  %
                   
                   % BuildStmtNote (0)  %
                   'DO' 
                   % BuildForToByDo  %
                   StatementSequence 
                   % BuildStmtNote (0)  %
                   
                   % endpostok := GetTokenNo ()  %
                   'END' 
                   % BuildEndFor (endpostok)  %
                   

   first  symbols:fortok
   
   cannot reachend
*/

static void ForStatement (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  unsigned int endpostok;

  M2Quads_PushLineNo ();
  Expect (M2Reserved_fortok, stopset0, stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  Ident (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_becomestok-M2Reserved_eoftok))), stopset1, stopset2);
  Expect (M2Reserved_becomestok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  Expression (stopset0, stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_totok-M2Reserved_recordtok))));
  Expect (M2Reserved_totok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  Expression (stopset0, stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_bytok-M2Reserved_arraytok)) | (1 << (M2Reserved_dotok-M2Reserved_arraytok))), stopset2);
  if (M2LexBuf_currenttoken == M2Reserved_bytok)
    {
      Expect (M2Reserved_bytok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok))));
      ConstExpression (stopset0, stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_dotok-M2Reserved_arraytok))), stopset2);
    }
  else
    {
      M2Quads_BuildPseudoBy ();  /* epsilon  */
    }
  M2Quads_PushLineNo ();
  M2Quads_BuildStmtNote (0);
  Expect (M2Reserved_dotok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_exittok-M2Reserved_arraytok)) | (1 << (M2Reserved_endtok-M2Reserved_arraytok)) | (1 << (M2Reserved_iftok-M2Reserved_arraytok)) | (1 << (M2Reserved_casetok-M2Reserved_arraytok)) | (1 << (M2Reserved_looptok-M2Reserved_arraytok)) | (1 << (M2Reserved_fortok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_returntok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_whiletok-M2Reserved_recordtok)) | (1 << (M2Reserved_repeattok-M2Reserved_recordtok)) | (1 << (M2Reserved_withtok-M2Reserved_recordtok)) | (1 << (M2Reserved_asmtok-M2Reserved_recordtok)) | (1 << (M2Reserved_retrytok-M2Reserved_recordtok))));
  M2Quads_BuildForToByDo ();
  StatementSequence (stopset0, stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_endtok-M2Reserved_arraytok))), stopset2);
  M2Quads_BuildStmtNote (0);
  endpostok = M2LexBuf_GetTokenNo ();
  Expect (M2Reserved_endtok, stopset0, stopset1, stopset2);
  M2Quads_BuildEndFor (endpostok);
}


/*
   LoopStatement := 'LOOP' 
                    % BuildLoop  %
                    StatementSequence 
                    % BuildStmtNote (0)  %
                    'END' 
                    % BuildEndLoop  %
                    

   first  symbols:looptok
   
   cannot reachend
*/

static void LoopStatement (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  Expect (M2Reserved_looptok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_exittok-M2Reserved_arraytok)) | (1 << (M2Reserved_endtok-M2Reserved_arraytok)) | (1 << (M2Reserved_iftok-M2Reserved_arraytok)) | (1 << (M2Reserved_casetok-M2Reserved_arraytok)) | (1 << (M2Reserved_looptok-M2Reserved_arraytok)) | (1 << (M2Reserved_fortok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_returntok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_whiletok-M2Reserved_recordtok)) | (1 << (M2Reserved_repeattok-M2Reserved_recordtok)) | (1 << (M2Reserved_withtok-M2Reserved_recordtok)) | (1 << (M2Reserved_asmtok-M2Reserved_recordtok)) | (1 << (M2Reserved_retrytok-M2Reserved_recordtok))));
  M2Quads_BuildLoop ();
  StatementSequence (stopset0, stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_endtok-M2Reserved_arraytok))), stopset2);
  M2Quads_BuildStmtNote (0);
  Expect (M2Reserved_endtok, stopset0, stopset1, stopset2);
  M2Quads_BuildEndLoop ();
}


/*
   WithStatement := 
                    % VAR
                                                                                                      tok: CARDINAL ;  %
                    'WITH' 
                    % tok := GetTokenNo () -1  %
                    Designator 
                    % StartBuildWith (tok)  %
                    
                    % BuildStmtNote (0)  %
                    'DO' StatementSequence 
                    % BuildStmtNote (0)  %
                    'END' 
                    % EndBuildWith  %
                    

   first  symbols:withtok
   
   cannot reachend
*/

static void WithStatement (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  unsigned int tok;

  Expect (M2Reserved_withtok, stopset0, stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  tok = (M2LexBuf_GetTokenNo ())-1;
  Designator (stopset0, stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_dotok-M2Reserved_arraytok))), stopset2);
  M2Quads_StartBuildWith (tok);
  M2Quads_BuildStmtNote (0);
  Expect (M2Reserved_dotok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_exittok-M2Reserved_arraytok)) | (1 << (M2Reserved_endtok-M2Reserved_arraytok)) | (1 << (M2Reserved_iftok-M2Reserved_arraytok)) | (1 << (M2Reserved_casetok-M2Reserved_arraytok)) | (1 << (M2Reserved_looptok-M2Reserved_arraytok)) | (1 << (M2Reserved_fortok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_returntok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_whiletok-M2Reserved_recordtok)) | (1 << (M2Reserved_repeattok-M2Reserved_recordtok)) | (1 << (M2Reserved_withtok-M2Reserved_recordtok)) | (1 << (M2Reserved_asmtok-M2Reserved_recordtok)) | (1 << (M2Reserved_retrytok-M2Reserved_recordtok))));
  StatementSequence (stopset0, stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_endtok-M2Reserved_arraytok))), stopset2);
  M2Quads_BuildStmtNote (0);
  Expect (M2Reserved_endtok, stopset0, stopset1, stopset2);
  M2Quads_EndBuildWith ();
}


/*
   ProcedureDeclaration := ProcedureHeading ';' ProcedureBlock 
                           
                           % BuildProcedureEnd ;
                             PushAutoOn  %
                           Ident 
                           % EndBuildProcedure ;
                             PopAuto  %
                           

   first  symbols:proceduretok
   
   cannot reachend
*/

static void ProcedureDeclaration (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  ProcedureHeading (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1, stopset2);
  Expect (M2Reserved_semicolontok, stopset0, stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_endtok-M2Reserved_arraytok)) | (1 << (M2Reserved_begintok-M2Reserved_arraytok)) | (1 << (M2Reserved_consttok-M2Reserved_arraytok)) | (1 << (M2Reserved_proceduretok-M2Reserved_arraytok)) | (1 << (M2Reserved_moduletok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_typetok-M2Reserved_recordtok)) | (1 << (M2Reserved_vartok-M2Reserved_recordtok))));
  ProcedureBlock (stopset0, stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  M2Quads_BuildProcedureEnd ();
  M2Quads_PushAutoOn ();
  Ident (stopset0, stopset1, stopset2);
  P3SymBuild_EndBuildProcedure ();
  M2Quads_PopAuto ();
}


/*
   DefineBuiltinProcedure := [ '__ATTRIBUTE__' '__BUILTIN__' 
                               '(' '(' 
                               % PushAutoOff  %
                               Ident 
                               % PopAuto  %
                               ')' ')'  | 
                               '__INLINE__'  ] 

   first  symbols:inlinetok, attributetok
   
   reachend
*/

static void DefineBuiltinProcedure (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  if ((M2LexBuf_currenttoken >= M2Reserved_recordtok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_recordtok)) & ((P3Build_SetOfStop2) ((1 << (M2Reserved_inlinetok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok))))) != 0)))
    {
      /* avoid gcc warning by using compound statement even if not strictly necessary.  */
      /* seen optional [ | ] expression  */
      if (M2LexBuf_currenttoken == M2Reserved_attributetok)
        {
          Expect (M2Reserved_attributetok, stopset0, stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_builtintok-M2Reserved_recordtok))));
          Expect (M2Reserved_builtintok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_lparatok-M2Reserved_eoftok))), stopset1, stopset2);
          Expect (M2Reserved_lparatok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_lparatok-M2Reserved_eoftok))), stopset1, stopset2);
          Expect (M2Reserved_lparatok, stopset0, stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
          M2Quads_PushAutoOff ();
          Ident (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_rparatok-M2Reserved_eoftok))), stopset1, stopset2);
          M2Quads_PopAuto ();
          Expect (M2Reserved_rparatok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_rparatok-M2Reserved_eoftok))), stopset1, stopset2);
          Expect (M2Reserved_rparatok, stopset0, stopset1, stopset2);
        }
      else if (M2LexBuf_currenttoken == M2Reserved_inlinetok)
        {
          /* avoid dangling else.  */
          Expect (M2Reserved_inlinetok, stopset0, stopset1, stopset2);
        }
      else
        {
          /* avoid dangling else.  */
          ErrorArray ((const char *) "expecting one of: {%K__INLINE__} {%K__ATTRIBUTE__}", 50);
        }
    }
  /* end of optional [ | ] expression  */
}


/*
   ProcedureHeading := 'PROCEDURE' 
                       % M2Error.DefaultProcedure  %
                       
                       % PushAutoOn  %
                       DefineBuiltinProcedure ( Ident 
                                                
                                                % StartBuildProcedure ;
                                                  PushAutoOff  %
                                                [ FormalParameters  ] 
                                                AttributeNoReturn 
                                                
                                                % BuildProcedureHeading ;
                                                  PopAuto  %
                                                 ) 
                       
                       % PopAuto  %
                       

   first  symbols:proceduretok
   
   cannot reachend
*/

static void ProcedureHeading (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  Expect (M2Reserved_proceduretok, stopset0, stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_inlinetok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  M2Error_DefaultProcedure ();
  M2Quads_PushAutoOn ();
  DefineBuiltinProcedure (stopset0, stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  Ident (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_ldirectivetok-M2Reserved_eoftok))), stopset1, stopset2);
  P3SymBuild_StartBuildProcedure ();
  M2Quads_PushAutoOff ();
  if (M2LexBuf_currenttoken == M2Reserved_lparatok)
    {
      FormalParameters (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_ldirectivetok-M2Reserved_eoftok))), stopset1, stopset2);
    }
  AttributeNoReturn (stopset0, stopset1, stopset2);
  P3SymBuild_BuildProcedureHeading ();
  M2Quads_PopAuto ();
  M2Quads_PopAuto ();
}


/*
   Builtin := [ '__BUILTIN__'  | '__INLINE__'  ] 

   first  symbols:inlinetok, builtintok
   
   reachend
*/

static void Builtin (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  if ((M2LexBuf_currenttoken >= M2Reserved_recordtok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_recordtok)) & ((P3Build_SetOfStop2) ((1 << (M2Reserved_inlinetok-M2Reserved_recordtok)) | (1 << (M2Reserved_builtintok-M2Reserved_recordtok))))) != 0)))
    {
      /* avoid gcc warning by using compound statement even if not strictly necessary.  */
      /* seen optional [ | ] expression  */
      if (M2LexBuf_currenttoken == M2Reserved_builtintok)
        {
          Expect (M2Reserved_builtintok, stopset0, stopset1, stopset2);
        }
      else if (M2LexBuf_currenttoken == M2Reserved_inlinetok)
        {
          /* avoid dangling else.  */
          Expect (M2Reserved_inlinetok, stopset0, stopset1, stopset2);
        }
      else
        {
          /* avoid dangling else.  */
          ErrorArray ((const char *) "expecting one of: {%K__INLINE__} {%K__BUILTIN__}", 48);
        }
    }
  /* end of optional [ | ] expression  */
}


/*
   DefProcedureHeading := 'PROCEDURE' 
                          % M2Error.DefaultProcedure  %
                          
                          % PushAutoOn  %
                          Builtin ( Ident 
                                    % StartBuildProcedure ;
                                      PushAutoOff  %
                                    [ DefFormalParameters  ] 
                                    AttributeNoReturn 
                                    
                                    % BuildProcedureHeading ;
                                      PopAuto  %
                                     ) 
                          % PopAuto  %
                          
                          % M2Error.LeaveErrorScope  %
                          

   first  symbols:proceduretok
   
   cannot reachend
*/

static void DefProcedureHeading (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  Expect (M2Reserved_proceduretok, stopset0, stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_inlinetok-M2Reserved_recordtok)) | (1 << (M2Reserved_builtintok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  M2Error_DefaultProcedure ();
  M2Quads_PushAutoOn ();
  Builtin (stopset0, stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  Ident (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_ldirectivetok-M2Reserved_eoftok))), stopset1, stopset2);
  P3SymBuild_StartBuildProcedure ();
  M2Quads_PushAutoOff ();
  if (M2LexBuf_currenttoken == M2Reserved_lparatok)
    {
      DefFormalParameters (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_ldirectivetok-M2Reserved_eoftok))), stopset1, stopset2);
    }
  AttributeNoReturn (stopset0, stopset1, stopset2);
  P3SymBuild_BuildProcedureHeading ();
  M2Quads_PopAuto ();
  M2Quads_PopAuto ();
  M2Error_LeaveErrorScope ();
}


/*
   AttributeNoReturn := [ ''  ] 

   first  symbols:ldirectivetok
   
   reachend
*/

static void AttributeNoReturn (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  if (M2LexBuf_currenttoken == M2Reserved_ldirectivetok)
    {
      Expect (M2Reserved_ldirectivetok, stopset0, stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      Ident (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_rdirectivetok-M2Reserved_eoftok))), stopset1, stopset2);
      Expect (M2Reserved_rdirectivetok, stopset0, stopset1, stopset2);
    }
}


/*
   AttributeUnused := [ ''  ] 

   first  symbols:ldirectivetok
   
   reachend
*/

static void AttributeUnused (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  if (M2LexBuf_currenttoken == M2Reserved_ldirectivetok)
    {
      Expect (M2Reserved_ldirectivetok, stopset0, stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      Ident (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_rdirectivetok-M2Reserved_eoftok))), stopset1, stopset2);
      Expect (M2Reserved_rdirectivetok, stopset0, stopset1, stopset2);
    }
}


/*
   ProcedureBlock := 
                     % BuildProcedureStart  %
                     { Declaration  } 
                     % BuildProcedureBegin  %
                     [ 'BEGIN' 
                       % BuildStmtNote (-1)  %
                       ProcedureBlockBody  ] 
                     % BuildStmtNote (0)  %
                     'END' 

   first  symbols:proceduretok, moduletok, consttok, typetok, vartok, endtok, begintok
   
   cannot reachend
*/

static void ProcedureBlock (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  M2Quads_BuildProcedureStart ();
  while ((((M2LexBuf_currenttoken >= M2Reserved_arraytok) && (M2LexBuf_currenttoken < M2Reserved_recordtok)) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_arraytok)) & ((P3Build_SetOfStop1) ((1 << (M2Reserved_consttok-M2Reserved_arraytok)) | (1 << (M2Reserved_proceduretok-M2Reserved_arraytok)) | (1 << (M2Reserved_moduletok-M2Reserved_arraytok))))) != 0))) || ((M2LexBuf_currenttoken >= M2Reserved_recordtok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_recordtok)) & ((P3Build_SetOfStop2) ((1 << (M2Reserved_typetok-M2Reserved_recordtok)) | (1 << (M2Reserved_vartok-M2Reserved_recordtok))))) != 0))))
    {
      Declaration (stopset0, stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_endtok-M2Reserved_arraytok)) | (1 << (M2Reserved_begintok-M2Reserved_arraytok)) | (1 << (M2Reserved_consttok-M2Reserved_arraytok)) | (1 << (M2Reserved_proceduretok-M2Reserved_arraytok)) | (1 << (M2Reserved_moduletok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_typetok-M2Reserved_recordtok)) | (1 << (M2Reserved_vartok-M2Reserved_recordtok))));
    }
   /* while  */
  M2Quads_BuildProcedureBegin ();
  if (M2LexBuf_currenttoken == M2Reserved_begintok)
    {
      Expect (M2Reserved_begintok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_endtok-M2Reserved_arraytok)) | (1 << (M2Reserved_excepttok-M2Reserved_arraytok)) | (1 << (M2Reserved_exittok-M2Reserved_arraytok)) | (1 << (M2Reserved_iftok-M2Reserved_arraytok)) | (1 << (M2Reserved_casetok-M2Reserved_arraytok)) | (1 << (M2Reserved_looptok-M2Reserved_arraytok)) | (1 << (M2Reserved_fortok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_returntok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_whiletok-M2Reserved_recordtok)) | (1 << (M2Reserved_repeattok-M2Reserved_recordtok)) | (1 << (M2Reserved_withtok-M2Reserved_recordtok)) | (1 << (M2Reserved_asmtok-M2Reserved_recordtok)) | (1 << (M2Reserved_retrytok-M2Reserved_recordtok))));
      M2Quads_BuildStmtNote (-1);
      ProcedureBlockBody (stopset0, stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_endtok-M2Reserved_arraytok))), stopset2);
    }
  M2Quads_BuildStmtNote (0);
  Expect (M2Reserved_endtok, stopset0, stopset1, stopset2);
}


/*
   Block := { Declaration  } 
            % StartBuildInit (GetTokenNo ())  %
            InitialBlock 
            % EndBuildInit (GetTokenNo ()) ;
              StartBuildFinally (GetTokenNo ())  %
            FinalBlock 
            % EndBuildFinally (GetTokenNo ())  %
            'END' 

   first  symbols:proceduretok, moduletok, finallytok, begintok, consttok, typetok, vartok, endtok
   
   cannot reachend
*/

static void Block (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  while ((((M2LexBuf_currenttoken >= M2Reserved_arraytok) && (M2LexBuf_currenttoken < M2Reserved_recordtok)) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_arraytok)) & ((P3Build_SetOfStop1) ((1 << (M2Reserved_consttok-M2Reserved_arraytok)) | (1 << (M2Reserved_proceduretok-M2Reserved_arraytok)) | (1 << (M2Reserved_moduletok-M2Reserved_arraytok))))) != 0))) || ((M2LexBuf_currenttoken >= M2Reserved_recordtok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_recordtok)) & ((P3Build_SetOfStop2) ((1 << (M2Reserved_typetok-M2Reserved_recordtok)) | (1 << (M2Reserved_vartok-M2Reserved_recordtok))))) != 0))))
    {
      Declaration (stopset0, stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_endtok-M2Reserved_arraytok)) | (1 << (M2Reserved_finallytok-M2Reserved_arraytok)) | (1 << (M2Reserved_begintok-M2Reserved_arraytok)) | (1 << (M2Reserved_consttok-M2Reserved_arraytok)) | (1 << (M2Reserved_proceduretok-M2Reserved_arraytok)) | (1 << (M2Reserved_moduletok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_typetok-M2Reserved_recordtok)) | (1 << (M2Reserved_vartok-M2Reserved_recordtok))));
    }
   /* while  */
  M2Quads_StartBuildInit (M2LexBuf_GetTokenNo ());
  InitialBlock (stopset0, stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_endtok-M2Reserved_arraytok)) | (1 << (M2Reserved_finallytok-M2Reserved_arraytok))), stopset2);
  M2Quads_EndBuildInit (M2LexBuf_GetTokenNo ());
  M2Quads_StartBuildFinally (M2LexBuf_GetTokenNo ());
  FinalBlock (stopset0, stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_endtok-M2Reserved_arraytok))), stopset2);
  M2Quads_EndBuildFinally (M2LexBuf_GetTokenNo ());
  Expect (M2Reserved_endtok, stopset0, stopset1, stopset2);
}


/*
   InitialBlock := [ 'BEGIN' 
                     % BuildStmtNote (-1)  %
                     InitialBlockBody  ] 

   first  symbols:begintok
   
   reachend
*/

static void InitialBlock (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  if (M2LexBuf_currenttoken == M2Reserved_begintok)
    {
      Expect (M2Reserved_begintok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_excepttok-M2Reserved_arraytok)) | (1 << (M2Reserved_exittok-M2Reserved_arraytok)) | (1 << (M2Reserved_iftok-M2Reserved_arraytok)) | (1 << (M2Reserved_casetok-M2Reserved_arraytok)) | (1 << (M2Reserved_looptok-M2Reserved_arraytok)) | (1 << (M2Reserved_fortok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_returntok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_whiletok-M2Reserved_recordtok)) | (1 << (M2Reserved_repeattok-M2Reserved_recordtok)) | (1 << (M2Reserved_withtok-M2Reserved_recordtok)) | (1 << (M2Reserved_asmtok-M2Reserved_recordtok)) | (1 << (M2Reserved_retrytok-M2Reserved_recordtok))));
      M2Quads_BuildStmtNote (-1);
      InitialBlockBody (stopset0, stopset1, stopset2);
    }
}


/*
   FinalBlock := [ 'FINALLY' 
                   % BuildStmtNote (-1)  %
                   FinalBlockBody  ] 

   first  symbols:finallytok
   
   reachend
*/

static void FinalBlock (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  if (M2LexBuf_currenttoken == M2Reserved_finallytok)
    {
      Expect (M2Reserved_finallytok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_excepttok-M2Reserved_arraytok)) | (1 << (M2Reserved_exittok-M2Reserved_arraytok)) | (1 << (M2Reserved_iftok-M2Reserved_arraytok)) | (1 << (M2Reserved_casetok-M2Reserved_arraytok)) | (1 << (M2Reserved_looptok-M2Reserved_arraytok)) | (1 << (M2Reserved_fortok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_returntok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_whiletok-M2Reserved_recordtok)) | (1 << (M2Reserved_repeattok-M2Reserved_recordtok)) | (1 << (M2Reserved_withtok-M2Reserved_recordtok)) | (1 << (M2Reserved_asmtok-M2Reserved_recordtok)) | (1 << (M2Reserved_retrytok-M2Reserved_recordtok))));
      M2Quads_BuildStmtNote (-1);
      FinalBlockBody (stopset0, stopset1, stopset2);
    }
}


/*
   InitialBlockBody := NormalPart [ 'EXCEPT' 
                                    % BuildStmtNote (-1)  %
                                    
                                    % BuildExceptInitial (GetTokenNo() -1)  %
                                    ExceptionalPart  ] 

   first  symbols:identtok, iftok, casetok, whiletok, repeattok, looptok, fortok, withtok, asmtok, retrytok, semicolontok, exittok, returntok, excepttok
   
   reachend
*/

static void InitialBlockBody (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  NormalPart (stopset0, stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_excepttok-M2Reserved_arraytok))), stopset2);
  if (M2LexBuf_currenttoken == M2Reserved_excepttok)
    {
      Expect (M2Reserved_excepttok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_exittok-M2Reserved_arraytok)) | (1 << (M2Reserved_fortok-M2Reserved_arraytok)) | (1 << (M2Reserved_looptok-M2Reserved_arraytok)) | (1 << (M2Reserved_casetok-M2Reserved_arraytok)) | (1 << (M2Reserved_iftok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_returntok-M2Reserved_recordtok)) | (1 << (M2Reserved_retrytok-M2Reserved_recordtok)) | (1 << (M2Reserved_asmtok-M2Reserved_recordtok)) | (1 << (M2Reserved_withtok-M2Reserved_recordtok)) | (1 << (M2Reserved_repeattok-M2Reserved_recordtok)) | (1 << (M2Reserved_whiletok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      M2Quads_BuildStmtNote (-1);
      M2Quads_BuildExceptInitial ((M2LexBuf_GetTokenNo ())-1);
      ExceptionalPart (stopset0, stopset1, stopset2);
    }
}


/*
   FinalBlockBody := NormalPart [ 'EXCEPT' 
                                  % BuildStmtNote (-1)  %
                                  
                                  % BuildExceptFinally (GetTokenNo() -1)  %
                                  ExceptionalPart  ] 

   first  symbols:identtok, iftok, casetok, whiletok, repeattok, looptok, fortok, withtok, asmtok, retrytok, semicolontok, exittok, returntok, excepttok
   
   reachend
*/

static void FinalBlockBody (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  NormalPart (stopset0, stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_excepttok-M2Reserved_arraytok))), stopset2);
  if (M2LexBuf_currenttoken == M2Reserved_excepttok)
    {
      Expect (M2Reserved_excepttok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_exittok-M2Reserved_arraytok)) | (1 << (M2Reserved_fortok-M2Reserved_arraytok)) | (1 << (M2Reserved_looptok-M2Reserved_arraytok)) | (1 << (M2Reserved_casetok-M2Reserved_arraytok)) | (1 << (M2Reserved_iftok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_returntok-M2Reserved_recordtok)) | (1 << (M2Reserved_retrytok-M2Reserved_recordtok)) | (1 << (M2Reserved_asmtok-M2Reserved_recordtok)) | (1 << (M2Reserved_withtok-M2Reserved_recordtok)) | (1 << (M2Reserved_repeattok-M2Reserved_recordtok)) | (1 << (M2Reserved_whiletok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      M2Quads_BuildStmtNote (-1);
      M2Quads_BuildExceptFinally ((M2LexBuf_GetTokenNo ())-1);
      ExceptionalPart (stopset0, stopset1, stopset2);
    }
}


/*
   ProcedureBlockBody := NormalPart [ 'EXCEPT' 
                                      % BuildStmtNote (-1)  %
                                      
                                      % BuildExceptProcedure (GetTokenNo() -1)  %
                                      ExceptionalPart  ] 

   first  symbols:identtok, iftok, casetok, whiletok, repeattok, looptok, fortok, withtok, asmtok, retrytok, semicolontok, exittok, returntok, excepttok
   
   reachend
*/

static void ProcedureBlockBody (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  NormalPart (stopset0, stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_excepttok-M2Reserved_arraytok))), stopset2);
  if (M2LexBuf_currenttoken == M2Reserved_excepttok)
    {
      Expect (M2Reserved_excepttok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_exittok-M2Reserved_arraytok)) | (1 << (M2Reserved_fortok-M2Reserved_arraytok)) | (1 << (M2Reserved_looptok-M2Reserved_arraytok)) | (1 << (M2Reserved_casetok-M2Reserved_arraytok)) | (1 << (M2Reserved_iftok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_returntok-M2Reserved_recordtok)) | (1 << (M2Reserved_retrytok-M2Reserved_recordtok)) | (1 << (M2Reserved_asmtok-M2Reserved_recordtok)) | (1 << (M2Reserved_withtok-M2Reserved_recordtok)) | (1 << (M2Reserved_repeattok-M2Reserved_recordtok)) | (1 << (M2Reserved_whiletok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      M2Quads_BuildStmtNote (-1);
      M2Quads_BuildExceptProcedure ((M2LexBuf_GetTokenNo ())-1);
      ExceptionalPart (stopset0, stopset1, stopset2);
    }
}


/*
   NormalPart := StatementSequence 

   first  symbols:retrytok, asmtok, withtok, fortok, looptok, repeattok, whiletok, casetok, iftok, identtok, returntok, exittok, semicolontok
   
   reachend
*/

static void NormalPart (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  StatementSequence (stopset0, stopset1, stopset2);
}


/*
   ExceptionalPart := StatementSequence 
                      % BuildReThrow (GetTokenNo())  %
                      

   first  symbols:retrytok, asmtok, withtok, fortok, looptok, repeattok, whiletok, casetok, iftok, identtok, returntok, exittok, semicolontok
   
   reachend
*/

static void ExceptionalPart (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  StatementSequence (stopset0, stopset1, stopset2);
  M2Quads_BuildReThrow (M2LexBuf_GetTokenNo ());
}


/*
   Declaration := 'CONST' { ConstantDeclaration ';'  }  | 
                  'TYPE' { TypeDeclaration ';'  }  | 
                  'VAR' { VariableDeclaration ';'  }  | 
                  ProcedureDeclaration ';'  | 
                  ModuleDeclaration ';' 

   first  symbols:moduletok, proceduretok, vartok, typetok, consttok
   
   cannot reachend
*/

static void Declaration (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  if (M2LexBuf_currenttoken == M2Reserved_consttok)
    {
      Expect (M2Reserved_consttok, stopset0, stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      while (M2LexBuf_currenttoken == M2Reserved_identtok)
        {
          ConstantDeclaration (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1, stopset2);
          Expect (M2Reserved_semicolontok, stopset0, stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
        }
       /* while  */
    }
  else if (M2LexBuf_currenttoken == M2Reserved_typetok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_typetok, stopset0, stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      while (M2LexBuf_currenttoken == M2Reserved_identtok)
        {
          TypeDeclaration (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1, stopset2);
          Expect (M2Reserved_semicolontok, stopset0, stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
        }
       /* while  */
    }
  else if (M2LexBuf_currenttoken == M2Reserved_vartok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_vartok, stopset0, stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      while (M2LexBuf_currenttoken == M2Reserved_identtok)
        {
          VariableDeclaration (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1, stopset2);
          Expect (M2Reserved_semicolontok, stopset0, stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
        }
       /* while  */
    }
  else if (M2LexBuf_currenttoken == M2Reserved_proceduretok)
    {
      /* avoid dangling else.  */
      ProcedureDeclaration (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1, stopset2);
      Expect (M2Reserved_semicolontok, stopset0, stopset1, stopset2);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_moduletok)
    {
      /* avoid dangling else.  */
      ModuleDeclaration (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1, stopset2);
      Expect (M2Reserved_semicolontok, stopset0, stopset1, stopset2);
    }
  else
    {
      /* avoid dangling else.  */
      ErrorArray ((const char *) "expecting one of: {%KMODULE} {%KPROCEDURE} {%KVAR} {%KTYPE} {%KCONST}", 69);
    }
}


/*
   DefFormalParameters := '(' [ DefMultiFPSection  ] 
                          ')' FormalReturn 

   first  symbols:lparatok
   
   cannot reachend
*/

static void DefFormalParameters (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  Expect (M2Reserved_lparatok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_rparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lsbratok-M2Reserved_eoftok))), stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_periodperiodperiodtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_vartok-M2Reserved_recordtok))));
  if ((M2LexBuf_currenttoken == M2Reserved_lsbratok) || ((M2LexBuf_currenttoken >= M2Reserved_recordtok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_recordtok)) & ((P3Build_SetOfStop2) ((1 << (M2Reserved_periodperiodperiodtok-M2Reserved_recordtok)) | (1 << (M2Reserved_vartok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))))) != 0))))
    {
      DefMultiFPSection (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_rparatok-M2Reserved_eoftok))), stopset1, stopset2);
    }
  Expect (M2Reserved_rparatok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_colontok-M2Reserved_eoftok))), stopset1, stopset2);
  FormalReturn (stopset0, stopset1, stopset2);
}


/*
   DefMultiFPSection := DefExtendedFP  | 
                        FPSection [ ';' DefMultiFPSection  ] 

   first  symbols:identtok, vartok, lsbratok, periodperiodperiodtok
   
   cannot reachend
*/

static void DefMultiFPSection (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  if ((M2LexBuf_currenttoken == M2Reserved_lsbratok) || (M2LexBuf_currenttoken == M2Reserved_periodperiodperiodtok))
    {
      DefExtendedFP (stopset0, stopset1, stopset2);
    }
  else if ((M2LexBuf_currenttoken >= M2Reserved_recordtok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_recordtok)) & ((P3Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_vartok-M2Reserved_recordtok))))) != 0)))
    {
      /* avoid dangling else.  */
      FPSection (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1, stopset2);
      if (M2LexBuf_currenttoken == M2Reserved_semicolontok)
        {
          Expect (M2Reserved_semicolontok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_lsbratok-M2Reserved_eoftok))), stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_periodperiodperiodtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_vartok-M2Reserved_recordtok))));
          DefMultiFPSection (stopset0, stopset1, stopset2);
        }
    }
  else
    {
      /* avoid dangling else.  */
      ErrorArray ((const char *) "expecting one of: {%Kidentifier} {%KVAR} {%K...} {%K[}", 54);
    }
}


/*
   FormalParameters := '(' [ MultiFPSection  ] ')' 
                       FormalReturn 

   first  symbols:lparatok
   
   cannot reachend
*/

static void FormalParameters (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  Expect (M2Reserved_lparatok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_rparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lsbratok-M2Reserved_eoftok))), stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_periodperiodperiodtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_vartok-M2Reserved_recordtok))));
  if ((M2LexBuf_currenttoken == M2Reserved_lsbratok) || ((M2LexBuf_currenttoken >= M2Reserved_recordtok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_recordtok)) & ((P3Build_SetOfStop2) ((1 << (M2Reserved_periodperiodperiodtok-M2Reserved_recordtok)) | (1 << (M2Reserved_vartok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))))) != 0))))
    {
      MultiFPSection (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_rparatok-M2Reserved_eoftok))), stopset1, stopset2);
    }
  Expect (M2Reserved_rparatok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_colontok-M2Reserved_eoftok))), stopset1, stopset2);
  FormalReturn (stopset0, stopset1, stopset2);
}


/*
   MultiFPSection := ExtendedFP  | FPSection [ ';' 
                                               MultiFPSection  ] 

   first  symbols:identtok, vartok, lsbratok, periodperiodperiodtok
   
   cannot reachend
*/

static void MultiFPSection (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  if ((M2LexBuf_currenttoken == M2Reserved_lsbratok) || (M2LexBuf_currenttoken == M2Reserved_periodperiodperiodtok))
    {
      ExtendedFP (stopset0, stopset1, stopset2);
    }
  else if ((M2LexBuf_currenttoken >= M2Reserved_recordtok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_recordtok)) & ((P3Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_vartok-M2Reserved_recordtok))))) != 0)))
    {
      /* avoid dangling else.  */
      FPSection (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1, stopset2);
      if (M2LexBuf_currenttoken == M2Reserved_semicolontok)
        {
          Expect (M2Reserved_semicolontok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_lsbratok-M2Reserved_eoftok))), stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_periodperiodperiodtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_vartok-M2Reserved_recordtok))));
          MultiFPSection (stopset0, stopset1, stopset2);
        }
    }
  else
    {
      /* avoid dangling else.  */
      ErrorArray ((const char *) "expecting one of: {%Kidentifier} {%KVAR} {%K...} {%K[}", 54);
    }
}


/*
   FPSection := NonVarFPSection  | 
                VarFPSection 

   first  symbols:vartok, identtok
   
   cannot reachend
*/

static void FPSection (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  if (M2LexBuf_currenttoken == M2Reserved_identtok)
    {
      NonVarFPSection (stopset0, stopset1, stopset2);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_vartok)
    {
      /* avoid dangling else.  */
      VarFPSection (stopset0, stopset1, stopset2);
    }
  else
    {
      /* avoid dangling else.  */
      ErrorArray ((const char *) "expecting one of: {%KVAR} {%Kidentifier}", 40);
    }
}


/*
   DefExtendedFP := DefOptArg  | '...' 

   first  symbols:lsbratok, periodperiodperiodtok
   
   cannot reachend
*/

static void DefExtendedFP (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  if (M2LexBuf_currenttoken == M2Reserved_lsbratok)
    {
      DefOptArg (stopset0, stopset1, stopset2);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_periodperiodperiodtok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_periodperiodperiodtok, stopset0, stopset1, stopset2);
    }
  else
    {
      /* avoid dangling else.  */
      ErrorArray ((const char *) "expecting one of: {%K...} {%K[}", 31);
    }
}


/*
   ExtendedFP := OptArg  | '...' 

   first  symbols:lsbratok, periodperiodperiodtok
   
   cannot reachend
*/

static void ExtendedFP (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  if (M2LexBuf_currenttoken == M2Reserved_lsbratok)
    {
      OptArg (stopset0, stopset1, stopset2);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_periodperiodperiodtok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_periodperiodperiodtok, stopset0, stopset1, stopset2);
    }
  else
    {
      /* avoid dangling else.  */
      ErrorArray ((const char *) "expecting one of: {%K...} {%K[}", 31);
    }
}


/*
   VarFPSection := 'VAR' IdentList ':' FormalType [ 
   AttributeUnused  ] 

   first  symbols:vartok
   
   cannot reachend
*/

static void VarFPSection (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  Expect (M2Reserved_vartok, stopset0, stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  IdentList (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_colontok-M2Reserved_eoftok))), stopset1, stopset2);
  Expect (M2Reserved_colontok, stopset0, stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_arraytok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  FormalType (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_ldirectivetok-M2Reserved_eoftok))), stopset1, stopset2);
  if (M2LexBuf_currenttoken == M2Reserved_ldirectivetok)
    {
      AttributeUnused (stopset0, stopset1, stopset2);
    }
}


/*
   NonVarFPSection := IdentList ':' FormalType [ AttributeUnused  ] 

   first  symbols:identtok
   
   cannot reachend
*/

static void NonVarFPSection (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  IdentList (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_colontok-M2Reserved_eoftok))), stopset1, stopset2);
  Expect (M2Reserved_colontok, stopset0, stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_arraytok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  FormalType (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_ldirectivetok-M2Reserved_eoftok))), stopset1, stopset2);
  if (M2LexBuf_currenttoken == M2Reserved_ldirectivetok)
    {
      AttributeUnused (stopset0, stopset1, stopset2);
    }
}


/*
   OptArg := '[' Ident ':' FormalType [ '=' ConstExpression 
                                        
                                        % BuildOptArgInitializer  %
                                         ] ']' 

   first  symbols:lsbratok
   
   cannot reachend
*/

static void OptArg (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  Expect (M2Reserved_lsbratok, stopset0, stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  Ident (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_colontok-M2Reserved_eoftok))), stopset1, stopset2);
  Expect (M2Reserved_colontok, stopset0, stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_arraytok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  FormalType (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_equaltok-M2Reserved_eoftok)) | (1 << (M2Reserved_rsbratok-M2Reserved_eoftok))), stopset1, stopset2);
  if (M2LexBuf_currenttoken == M2Reserved_equaltok)
    {
      Expect (M2Reserved_equaltok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok))));
      ConstExpression (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_rsbratok-M2Reserved_eoftok))), stopset1, stopset2);
      P3SymBuild_BuildOptArgInitializer ();
    }
  Expect (M2Reserved_rsbratok, stopset0, stopset1, stopset2);
}


/*
   DefOptArg := '[' Ident ':' FormalType '=' ConstExpression 
                
                % BuildOptArgInitializer  %
                ']' 

   first  symbols:lsbratok
   
   cannot reachend
*/

static void DefOptArg (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  Expect (M2Reserved_lsbratok, stopset0, stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  Ident (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_colontok-M2Reserved_eoftok))), stopset1, stopset2);
  Expect (M2Reserved_colontok, stopset0, stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_arraytok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  FormalType (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_equaltok-M2Reserved_eoftok))), stopset1, stopset2);
  Expect (M2Reserved_equaltok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok))));
  ConstExpression (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_rsbratok-M2Reserved_eoftok))), stopset1, stopset2);
  P3SymBuild_BuildOptArgInitializer ();
  Expect (M2Reserved_rsbratok, stopset0, stopset1, stopset2);
}


/*
   FormalType := { 'ARRAY' 'OF'  } Qualident 

   first  symbols:identtok, arraytok
   
   cannot reachend
*/

static void FormalType (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  while (M2LexBuf_currenttoken == M2Reserved_arraytok)
    {
      Expect (M2Reserved_arraytok, stopset0, stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_oftok-M2Reserved_arraytok))), stopset2);
      Expect (M2Reserved_oftok, stopset0, stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_arraytok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
    }
   /* while  */
  Qualident (stopset0, stopset1, stopset2);
}


/*
   ModuleDeclaration := 
                        % VAR modulet: CARDINAL ;  %
                        
                        % modulet := GetTokenNo ()  %
                        'MODULE' 
                        % M2Error.DefaultInnerModule  %
                        
                        % PushAutoOn  %
                        Ident 
                        % StartBuildInnerModule  %
                        
                        % BuildModuleStart (modulet) ;
                          PushAutoOff  %
                        [ Priority  ] ';' { Import  } 
                        [ Export  ] Block 
                        % PushAutoOn  %
                        Ident 
                        % EndBuildInnerModule  %
                        
                        % PopAuto ; PopAuto ; PopAuto  %
                        

   first  symbols:moduletok
   
   cannot reachend
*/

static void ModuleDeclaration (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  unsigned int modulet;

  modulet = M2LexBuf_GetTokenNo ();
  Expect (M2Reserved_moduletok, stopset0, stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  M2Error_DefaultInnerModule ();
  M2Quads_PushAutoOn ();
  Ident (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok)) | (1 << (M2Reserved_lsbratok-M2Reserved_eoftok))), stopset1, stopset2);
  P3SymBuild_StartBuildInnerModule ();
  M2Quads_BuildModuleStart (modulet);
  M2Quads_PushAutoOff ();
  if (M2LexBuf_currenttoken == M2Reserved_lsbratok)
    {
      Priority (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1, stopset2);
    }
  Expect (M2Reserved_semicolontok, stopset0, stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_endtok-M2Reserved_arraytok)) | (1 << (M2Reserved_importtok-M2Reserved_arraytok)) | (1 << (M2Reserved_fromtok-M2Reserved_arraytok)) | (1 << (M2Reserved_exporttok-M2Reserved_arraytok)) | (1 << (M2Reserved_finallytok-M2Reserved_arraytok)) | (1 << (M2Reserved_begintok-M2Reserved_arraytok)) | (1 << (M2Reserved_consttok-M2Reserved_arraytok)) | (1 << (M2Reserved_proceduretok-M2Reserved_arraytok)) | (1 << (M2Reserved_moduletok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_typetok-M2Reserved_recordtok)) | (1 << (M2Reserved_vartok-M2Reserved_recordtok))));
  while (((M2LexBuf_currenttoken >= M2Reserved_arraytok) && (M2LexBuf_currenttoken < M2Reserved_recordtok)) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_arraytok)) & ((P3Build_SetOfStop1) ((1 << (M2Reserved_fromtok-M2Reserved_arraytok)) | (1 << (M2Reserved_importtok-M2Reserved_arraytok))))) != 0)))
    {
      Import (stopset0, stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_endtok-M2Reserved_arraytok)) | (1 << (M2Reserved_consttok-M2Reserved_arraytok)) | (1 << (M2Reserved_begintok-M2Reserved_arraytok)) | (1 << (M2Reserved_finallytok-M2Reserved_arraytok)) | (1 << (M2Reserved_exporttok-M2Reserved_arraytok)) | (1 << (M2Reserved_fromtok-M2Reserved_arraytok)) | (1 << (M2Reserved_importtok-M2Reserved_arraytok)) | (1 << (M2Reserved_moduletok-M2Reserved_arraytok)) | (1 << (M2Reserved_proceduretok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_vartok-M2Reserved_recordtok)) | (1 << (M2Reserved_typetok-M2Reserved_recordtok))));
    }
   /* while  */
  if (M2LexBuf_currenttoken == M2Reserved_exporttok)
    {
      Export (stopset0, stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_endtok-M2Reserved_arraytok)) | (1 << (M2Reserved_consttok-M2Reserved_arraytok)) | (1 << (M2Reserved_begintok-M2Reserved_arraytok)) | (1 << (M2Reserved_finallytok-M2Reserved_arraytok)) | (1 << (M2Reserved_moduletok-M2Reserved_arraytok)) | (1 << (M2Reserved_proceduretok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_vartok-M2Reserved_recordtok)) | (1 << (M2Reserved_typetok-M2Reserved_recordtok))));
    }
  Block (stopset0, stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  M2Quads_PushAutoOn ();
  Ident (stopset0, stopset1, stopset2);
  P3SymBuild_EndBuildInnerModule ();
  M2Quads_PopAuto ();
  M2Quads_PopAuto ();
  M2Quads_PopAuto ();
}


/*
   Priority := '[' 
               % PushAutoOn  %
               ConstExpression 
               % BuildModulePriority ;
                 PopAuto  %
               ']' 

   first  symbols:lsbratok
   
   cannot reachend
*/

static void Priority (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  Expect (M2Reserved_lsbratok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_attributetok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok)) | (1 << (M2Reserved_stringtok-M2Reserved_recordtok))));
  M2Quads_PushAutoOn ();
  ConstExpression (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_rsbratok-M2Reserved_eoftok))), stopset1, stopset2);
  M2Quads_BuildModulePriority ();
  M2Quads_PopAuto ();
  Expect (M2Reserved_rsbratok, stopset0, stopset1, stopset2);
}


/*
   Export := 'EXPORT' ( 'QUALIFIED' IdentList  | 
                        'UNQUALIFIED' IdentList  | 
                        IdentList  ) ';' 

   first  symbols:exporttok
   
   cannot reachend
*/

static void Export (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  Expect (M2Reserved_exporttok, stopset0, stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_qualifiedtok-M2Reserved_arraytok)) | (1 << (M2Reserved_unqualifiedtok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  if (M2LexBuf_currenttoken == M2Reserved_qualifiedtok)
    {
      Expect (M2Reserved_qualifiedtok, stopset0, stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      IdentList (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1, stopset2);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_unqualifiedtok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_unqualifiedtok, stopset0, stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      IdentList (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1, stopset2);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_identtok)
    {
      /* avoid dangling else.  */
      IdentList (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1, stopset2);
    }
  else
    {
      /* avoid dangling else.  */
      ErrorArray ((const char *) "expecting one of: {%Kidentifier} {%KUNQUALIFIED} {%KQUALIFIED}", 62);
    }
  Expect (M2Reserved_semicolontok, stopset0, stopset1, stopset2);
}


/*
   FromImport := 
                 % PushAutoOn  %
                 'FROM' Ident 'IMPORT' IdentList ';' 
                 
                 % CheckImportListOuterModule  %
                 
                 % PopAuto  %
                 

   first  symbols:fromtok
   
   cannot reachend
*/

static void FromImport (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  M2Quads_PushAutoOn ();
  Expect (M2Reserved_fromtok, stopset0, stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  Ident (stopset0, stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_importtok-M2Reserved_arraytok))), stopset2);
  Expect (M2Reserved_importtok, stopset0, stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  IdentList (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1, stopset2);
  Expect (M2Reserved_semicolontok, stopset0, stopset1, stopset2);
  P3SymBuild_CheckImportListOuterModule ();
  M2Quads_PopAuto ();
}


/*
   WithoutFromImport := 
                        % PushAutoOff  %
                        'IMPORT' IdentList ';' 
                        % PopAuto  %
                        

   first  symbols:importtok
   
   cannot reachend
*/

static void WithoutFromImport (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  M2Quads_PushAutoOff ();
  Expect (M2Reserved_importtok, stopset0, stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  IdentList (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1, stopset2);
  Expect (M2Reserved_semicolontok, stopset0, stopset1, stopset2);
  M2Quads_PopAuto ();
}


/*
   Import := FromImport  | WithoutFromImport 

   first  symbols:importtok, fromtok
   
   cannot reachend
*/

static void Import (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  if (M2LexBuf_currenttoken == M2Reserved_fromtok)
    {
      FromImport (stopset0, stopset1, stopset2);
    }
  else if (M2LexBuf_currenttoken == M2Reserved_importtok)
    {
      /* avoid dangling else.  */
      WithoutFromImport (stopset0, stopset1, stopset2);
    }
  else
    {
      /* avoid dangling else.  */
      ErrorArray ((const char *) "expecting one of: {%KIMPORT} {%KFROM}", 37);
    }
}


/*
   DefinitionModule := 
                       % VAR deft, endt: CARDINAL ;  %
                       
                       % deft := GetTokenNo ()  %
                       'DEFINITION' 
                       % M2Error.DefaultDefinitionModule  %
                       'MODULE' 
                       % PushAutoOn  %
                       [ 'FOR' string  ] Ident 
                       % StartBuildDefFile (deft) ;
                         P3StartBuildDefModule ;
                         PushAutoOff  %
                       ';' { Import  } [ Export  ] 
                       { Definition  } 
                       % endt := GetTokenNo ()  %
                       'END' 
                       % PushAutoOn  %
                       Ident 
                       % EndBuildFile (endt) ;
                         P3EndBuildDefModule  %
                       '.' 
                       % PopAuto ; PopAuto ; PopAuto  %
                       

   first  symbols:definitiontok
   
   cannot reachend
*/

static void DefinitionModule (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  unsigned int deft;
  unsigned int endt;

  deft = M2LexBuf_GetTokenNo ();
  Expect (M2Reserved_definitiontok, stopset0, stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_moduletok-M2Reserved_arraytok))), stopset2);
  M2Error_DefaultDefinitionModule ();
  Expect (M2Reserved_moduletok, stopset0, stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_fortok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  M2Quads_PushAutoOn ();
  if (M2LexBuf_currenttoken == M2Reserved_fortok)
    {
      Expect (M2Reserved_fortok, stopset0, stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_stringtok-M2Reserved_recordtok))));
      string (stopset0, stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
    }
  Ident (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1, stopset2);
  M2Quads_StartBuildDefFile (deft);
  P3SymBuild_P3StartBuildDefModule ();
  M2Quads_PushAutoOff ();
  Expect (M2Reserved_semicolontok, stopset0, stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_importtok-M2Reserved_arraytok)) | (1 << (M2Reserved_fromtok-M2Reserved_arraytok)) | (1 << (M2Reserved_exporttok-M2Reserved_arraytok)) | (1 << (M2Reserved_endtok-M2Reserved_arraytok)) | (1 << (M2Reserved_proceduretok-M2Reserved_arraytok)) | (1 << (M2Reserved_consttok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_vartok-M2Reserved_recordtok)) | (1 << (M2Reserved_typetok-M2Reserved_recordtok))));
  while (((M2LexBuf_currenttoken >= M2Reserved_arraytok) && (M2LexBuf_currenttoken < M2Reserved_recordtok)) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_arraytok)) & ((P3Build_SetOfStop1) ((1 << (M2Reserved_fromtok-M2Reserved_arraytok)) | (1 << (M2Reserved_importtok-M2Reserved_arraytok))))) != 0)))
    {
      Import (stopset0, stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_endtok-M2Reserved_arraytok)) | (1 << (M2Reserved_exporttok-M2Reserved_arraytok)) | (1 << (M2Reserved_fromtok-M2Reserved_arraytok)) | (1 << (M2Reserved_importtok-M2Reserved_arraytok)) | (1 << (M2Reserved_consttok-M2Reserved_arraytok)) | (1 << (M2Reserved_proceduretok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_typetok-M2Reserved_recordtok)) | (1 << (M2Reserved_vartok-M2Reserved_recordtok))));
    }
   /* while  */
  if (M2LexBuf_currenttoken == M2Reserved_exporttok)
    {
      Export (stopset0, stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_endtok-M2Reserved_arraytok)) | (1 << (M2Reserved_consttok-M2Reserved_arraytok)) | (1 << (M2Reserved_proceduretok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_typetok-M2Reserved_recordtok)) | (1 << (M2Reserved_vartok-M2Reserved_recordtok))));
    }
  while ((((M2LexBuf_currenttoken >= M2Reserved_arraytok) && (M2LexBuf_currenttoken < M2Reserved_recordtok)) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_arraytok)) & ((P3Build_SetOfStop1) ((1 << (M2Reserved_consttok-M2Reserved_arraytok)) | (1 << (M2Reserved_proceduretok-M2Reserved_arraytok))))) != 0))) || ((M2LexBuf_currenttoken >= M2Reserved_recordtok) && ((((1 << (M2LexBuf_currenttoken-M2Reserved_recordtok)) & ((P3Build_SetOfStop2) ((1 << (M2Reserved_typetok-M2Reserved_recordtok)) | (1 << (M2Reserved_vartok-M2Reserved_recordtok))))) != 0))))
    {
      Definition (stopset0, stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_endtok-M2Reserved_arraytok)) | (1 << (M2Reserved_consttok-M2Reserved_arraytok)) | (1 << (M2Reserved_proceduretok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_typetok-M2Reserved_recordtok)) | (1 << (M2Reserved_vartok-M2Reserved_recordtok))));
    }
   /* while  */
  endt = M2LexBuf_GetTokenNo ();
  Expect (M2Reserved_endtok, stopset0, stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  M2Quads_PushAutoOn ();
  Ident (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_periodtok-M2Reserved_eoftok))), stopset1, stopset2);
  M2Quads_EndBuildFile (endt);
  P3SymBuild_P3EndBuildDefModule ();
  Expect (M2Reserved_periodtok, stopset0, stopset1, stopset2);
  M2Quads_PopAuto ();
  M2Quads_PopAuto ();
  M2Quads_PopAuto ();
}


/*
   Definition := 'CONST' { ConstantDeclaration ';'  }  | 
                 'TYPE' { Ident ( ';'  | '=' Type Alignment 
                                  ';'  )  }  | 
                 'VAR' { VariableDeclaration ';'  }  | 
                 DefProcedureHeading ';' 

   first  symbols:proceduretok, vartok, typetok, consttok
   
   cannot reachend
*/

static void Definition (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  if (M2LexBuf_currenttoken == M2Reserved_consttok)
    {
      Expect (M2Reserved_consttok, stopset0, stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      while (M2LexBuf_currenttoken == M2Reserved_identtok)
        {
          ConstantDeclaration (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1, stopset2);
          Expect (M2Reserved_semicolontok, stopset0, stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
        }
       /* while  */
    }
  else if (M2LexBuf_currenttoken == M2Reserved_typetok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_typetok, stopset0, stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      while (M2LexBuf_currenttoken == M2Reserved_identtok)
        {
          Ident (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok)) | (1 << (M2Reserved_equaltok-M2Reserved_eoftok))), stopset1, stopset2);
          if (M2LexBuf_currenttoken == M2Reserved_semicolontok)
            {
              Expect (M2Reserved_semicolontok, stopset0, stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
            }
          else if (M2LexBuf_currenttoken == M2Reserved_equaltok)
            {
              /* avoid dangling else.  */
              Expect (M2Reserved_equaltok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lsbratok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_proceduretok-M2Reserved_arraytok)) | (1 << (M2Reserved_pointertok-M2Reserved_arraytok)) | (1 << (M2Reserved_packedsettok-M2Reserved_arraytok)) | (1 << (M2Reserved_oftok-M2Reserved_arraytok)) | (1 << (M2Reserved_arraytok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_settok-M2Reserved_recordtok)) | (1 << (M2Reserved_recordtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))));
              Type (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_ldirectivetok-M2Reserved_eoftok)) | (1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1, stopset2);
              Alignment (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1, stopset2);
              Expect (M2Reserved_semicolontok, stopset0, stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
            }
          else
            {
              /* avoid dangling else.  */
              ErrorArray ((const char *) "expecting one of: {%K=} {%K;}", 29);
            }
        }
       /* while  */
    }
  else if (M2LexBuf_currenttoken == M2Reserved_vartok)
    {
      /* avoid dangling else.  */
      Expect (M2Reserved_vartok, stopset0, stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
      while (M2LexBuf_currenttoken == M2Reserved_identtok)
        {
          VariableDeclaration (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1, stopset2);
          Expect (M2Reserved_semicolontok, stopset0, stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
        }
       /* while  */
    }
  else if (M2LexBuf_currenttoken == M2Reserved_proceduretok)
    {
      /* avoid dangling else.  */
      DefProcedureHeading (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_semicolontok-M2Reserved_eoftok))), stopset1, stopset2);
      Expect (M2Reserved_semicolontok, stopset0, stopset1, stopset2);
    }
  else
    {
      /* avoid dangling else.  */
      ErrorArray ((const char *) "expecting one of: {%KPROCEDURE} {%KVAR} {%KTYPE} {%KCONST}", 58);
    }
}


/*
   AsmStatement := 
                   % VAR CurrentAsm: CARDINAL ;  %
                   'ASM' 
                   % IF Pass3
                     THEN
                        PushAutoOn ;
                        PushT(0) ;   operand count 
                        PushT(MakeGnuAsm())
                     END
                      %
                   [ 'VOLATILE' 
                     % IF Pass3
                       THEN
                          PopT(CurrentAsm) ;
                          PutGnuAsmVolatile(CurrentAsm) ;
                          PushT(CurrentAsm)
                       END
                        %
                      ] '(' AsmOperands 
                   % IF Pass3
                     THEN
                        PopNothing ;   throw away interface sym 
                        BuildInline ;
                        PopNothing ;   throw away count 
                        PopAuto
                     END
                      %
                   ')' 

   first  symbols:asmtok
   
   cannot reachend
*/

static void AsmStatement (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  unsigned int CurrentAsm;

  Expect (M2Reserved_asmtok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_lparatok-M2Reserved_eoftok))), stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_volatiletok-M2Reserved_recordtok))));
  if (Pass3)
    {
      M2Quads_PushAutoOn ();
      M2Quads_PushT (static_cast<unsigned int> (0));  /* operand count  */
      M2Quads_PushT (SymbolTable_MakeGnuAsm ());  /* operand count  */
    }
  if (M2LexBuf_currenttoken == M2Reserved_volatiletok)
    {
      Expect (M2Reserved_volatiletok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_lparatok-M2Reserved_eoftok))), stopset1, stopset2);
      if (Pass3)
        {
          M2Quads_PopT (&CurrentAsm);
          SymbolTable_PutGnuAsmVolatile (CurrentAsm);
          M2Quads_PushT (CurrentAsm);
        }
    }
  Expect (M2Reserved_lparatok, stopset0, stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_stringtok-M2Reserved_recordtok))));
  AsmOperands (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_rparatok-M2Reserved_eoftok))), stopset1, stopset2);
  if (Pass3)
    {
      M2Quads_PopNothing ();  /* throw away interface sym  */
      M2Quads_BuildInline ();  /* throw away interface sym  */
      M2Quads_PopNothing ();  /* throw away count  */
      M2Quads_PopAuto ();  /* throw away count  */
    }
  Expect (M2Reserved_rparatok, stopset0, stopset1, stopset2);
}


/*
   AsmOperands := 
                  % VAR CurrentAsm, count: CARDINAL ;
                        str: CARDINAL ;
                     %
                  string 
                  % IF Pass3
                    THEN
                       PopT(str) ;
                       PopT(CurrentAsm) ;
                       Assert(IsGnuAsm(CurrentAsm) OR IsGnuAsmVolatile(CurrentAsm)) ;
                       PopT(count) ;
                       IF DebugAsm
                       THEN
                          printf1('1: count of asm operands: %d
', count)
                       END ;
                       PushT(count) ;
                        adds the name/instruction for this asm 
                       PutGnuAsm(CurrentAsm, str) ;
                       PushT(CurrentAsm) ;
                       PushT(NulSym)     the InterfaceSym 
                    END
                     %
                  ( AsmOperandSpec  | 
                    
                    %  epsilon 
                      IF Pass3
                      THEN
                         PutGnuAsmSimple(CurrentAsm)
                      END
                       %
                     ) 

   first  symbols:stringtok
   
   cannot reachend
*/

static void AsmOperands (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  unsigned int CurrentAsm;
  unsigned int count;
  unsigned int str;

  string (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_colontok-M2Reserved_eoftok))), stopset1, stopset2);
  if (Pass3)
    {
      M2Quads_PopT (&str);
      M2Quads_PopT (&CurrentAsm);
      M2Debug_Assert ((SymbolTable_IsGnuAsm (CurrentAsm)) || (SymbolTable_IsGnuAsmVolatile (CurrentAsm)));
      M2Quads_PopT (&count);
      if (DebugAsm)
        {
          M2Printf_printf1 ((const char *) "1: count of asm operands: %d\\n", 30, (const unsigned char *) &count, (sizeof (count)-1));
        }
      M2Quads_PushT (count);
      /* adds the name/instruction for this asm  */
      SymbolTable_PutGnuAsm (CurrentAsm, str);
      M2Quads_PushT (CurrentAsm);
      M2Quads_PushT (static_cast<unsigned int> (SymbolTable_NulSym));  /* the InterfaceSym  */
    }
  if (M2LexBuf_currenttoken == M2Reserved_colontok)
    {
      AsmOperandSpec (stopset0, stopset1, stopset2);
    }
  else
    {
      /* epsilon  */
      if (Pass3)
        {
          SymbolTable_PutGnuAsmSimple (CurrentAsm);
        }
    }
}


/*
   AsmOperandSpec := 
                     % VAR CurrentAsm, outputs, inputs, trash, count: CARDINAL ;
                        %
                     [ ':' AsmList 
                       % IF Pass3
                         THEN
                            PopT(outputs) ;
                            PopT(CurrentAsm) ;
                            Assert(IsGnuAsm(CurrentAsm) OR IsGnuAsmVolatile(CurrentAsm)) ;
                            PopT(count) ;
                            IF DebugAsm
                            THEN
                               printf1('2: output count of asm operands: %d
', count)
                            END ;
                            PutGnuAsmOutput(CurrentAsm, outputs) ;
                            PushT(0) ;   reset count 
                            PushT(CurrentAsm) ;
                            PushT(NulSym)     the InterfaceSym 
                         END
                          %
                       [ ':' AsmList 
                         % IF Pass3
                           THEN
                              PopT(inputs) ;
                              PopT(CurrentAsm) ;
                              Assert(IsGnuAsm(CurrentAsm) OR IsGnuAsmVolatile(CurrentAsm)) ;
                              PopT(count) ;
                              IF DebugAsm
                              THEN
                                 printf1('3: input count of asm operands: %d
', count)
                              END ;
                              PutGnuAsmInput(CurrentAsm, inputs) ;
                              PushT(0) ;   reset count 
                              PushT(CurrentAsm) ;
                              PushT(NulSym)     the InterfaceSym 
                           END
                            %
                         [ ':' TrashList 
                           % IF Pass3
                             THEN
                                PopT(trash) ;
                                PopT(CurrentAsm) ;
                                Assert(IsGnuAsm(CurrentAsm) OR IsGnuAsmVolatile(CurrentAsm)) ;
                                PopT(count) ;
                                IF DebugAsm
                                THEN
                                   printf1('4: trash count of asm operands: %d
', count)
                                END ;
                                PutGnuAsmTrash(CurrentAsm, trash) ;
                                PushT(0) ;   reset count 
                                PushT(CurrentAsm) ;
                                PushT(NulSym)     the InterfaceSym 
                             END
                              %
                            ]  ]  ] 

   first  symbols:colontok
   
   reachend
*/

static void AsmOperandSpec (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  unsigned int CurrentAsm;
  unsigned int outputs;
  unsigned int inputs;
  unsigned int trash;
  unsigned int count;

  if (M2LexBuf_currenttoken == M2Reserved_colontok)
    {
      Expect (M2Reserved_colontok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_colontok-M2Reserved_eoftok)) | (1 << (M2Reserved_commatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lsbratok-M2Reserved_eoftok))), stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_stringtok-M2Reserved_recordtok))));
      AsmList (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_colontok-M2Reserved_eoftok))), stopset1, stopset2);
      if (Pass3)
        {
          M2Quads_PopT (&outputs);
          M2Quads_PopT (&CurrentAsm);
          M2Debug_Assert ((SymbolTable_IsGnuAsm (CurrentAsm)) || (SymbolTable_IsGnuAsmVolatile (CurrentAsm)));
          M2Quads_PopT (&count);
          if (DebugAsm)
            {
              M2Printf_printf1 ((const char *) "2: output count of asm operands: %d\\n", 37, (const unsigned char *) &count, (sizeof (count)-1));
            }
          SymbolTable_PutGnuAsmOutput (CurrentAsm, outputs);
          M2Quads_PushT (static_cast<unsigned int> (0));  /* reset count  */
          M2Quads_PushT (CurrentAsm);  /* reset count  */
          M2Quads_PushT (static_cast<unsigned int> (SymbolTable_NulSym));  /* the InterfaceSym  */
        }
      if (M2LexBuf_currenttoken == M2Reserved_colontok)
        {
          Expect (M2Reserved_colontok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_colontok-M2Reserved_eoftok)) | (1 << (M2Reserved_commatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lsbratok-M2Reserved_eoftok))), stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_stringtok-M2Reserved_recordtok))));
          AsmList (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_colontok-M2Reserved_eoftok))), stopset1, stopset2);
          if (Pass3)
            {
              M2Quads_PopT (&inputs);
              M2Quads_PopT (&CurrentAsm);
              M2Debug_Assert ((SymbolTable_IsGnuAsm (CurrentAsm)) || (SymbolTable_IsGnuAsmVolatile (CurrentAsm)));
              M2Quads_PopT (&count);
              if (DebugAsm)
                {
                  M2Printf_printf1 ((const char *) "3: input count of asm operands: %d\\n", 36, (const unsigned char *) &count, (sizeof (count)-1));
                }
              SymbolTable_PutGnuAsmInput (CurrentAsm, inputs);
              M2Quads_PushT (static_cast<unsigned int> (0));  /* reset count  */
              M2Quads_PushT (CurrentAsm);  /* reset count  */
              M2Quads_PushT (static_cast<unsigned int> (SymbolTable_NulSym));  /* the InterfaceSym  */
            }
          if (M2LexBuf_currenttoken == M2Reserved_colontok)
            {
              Expect (M2Reserved_colontok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_commatok-M2Reserved_eoftok))), stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_stringtok-M2Reserved_recordtok))));
              TrashList (stopset0, stopset1, stopset2);
              if (Pass3)
                {
                  M2Quads_PopT (&trash);
                  M2Quads_PopT (&CurrentAsm);
                  M2Debug_Assert ((SymbolTable_IsGnuAsm (CurrentAsm)) || (SymbolTable_IsGnuAsmVolatile (CurrentAsm)));
                  M2Quads_PopT (&count);
                  if (DebugAsm)
                    {
                      M2Printf_printf1 ((const char *) "4: trash count of asm operands: %d\\n", 36, (const unsigned char *) &count, (sizeof (count)-1));
                    }
                  SymbolTable_PutGnuAsmTrash (CurrentAsm, trash);
                  M2Quads_PushT (static_cast<unsigned int> (0));  /* reset count  */
                  M2Quads_PushT (CurrentAsm);  /* reset count  */
                  M2Quads_PushT (static_cast<unsigned int> (SymbolTable_NulSym));  /* the InterfaceSym  */
                }
            }
        }
    }
}


/*
   AsmList := 
              % VAR count, CurrentAsm, CurrentInterface: CARDINAL ;  %
              
              % IF Pass3
                THEN
                   PopT(CurrentInterface) ;
                   PopT(CurrentAsm) ;
                   PopT(count) ;
                   Assert(IsGnuAsm(CurrentAsm) OR IsGnuAsmVolatile(CurrentAsm)) ;
                   PushT(count) ;
                   PushT(CurrentAsm) ;
                   PushT(CurrentInterface) ;
                   IF DebugAsm
                   THEN
                      printf1('8: AsmList has a count of asm operands: %d
', count)
                   END
                END
                 %
              [ AsmElement  ] { ',' AsmElement  } 

   first  symbols:lsbratok, stringtok, commatok
   
   reachend
*/

static void AsmList (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  unsigned int count;
  unsigned int CurrentAsm;
  unsigned int CurrentInterface;

  if (Pass3)
    {
      M2Quads_PopT (&CurrentInterface);
      M2Quads_PopT (&CurrentAsm);
      M2Quads_PopT (&count);
      M2Debug_Assert ((SymbolTable_IsGnuAsm (CurrentAsm)) || (SymbolTable_IsGnuAsmVolatile (CurrentAsm)));
      M2Quads_PushT (count);
      M2Quads_PushT (CurrentAsm);
      M2Quads_PushT (CurrentInterface);
      if (DebugAsm)
        {
          M2Printf_printf1 ((const char *) "8: AsmList has a count of asm operands: %d\\n", 44, (const unsigned char *) &count, (sizeof (count)-1));
        }
    }
  if ((M2LexBuf_currenttoken == M2Reserved_lsbratok) || (M2LexBuf_currenttoken == M2Reserved_stringtok))
    {
      AsmElement (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_commatok-M2Reserved_eoftok))), stopset1, stopset2);
    }
  while (M2LexBuf_currenttoken == M2Reserved_commatok)
    {
      Expect (M2Reserved_commatok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_lsbratok-M2Reserved_eoftok))), stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_stringtok-M2Reserved_recordtok))));
      AsmElement (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_commatok-M2Reserved_eoftok))), stopset1, stopset2);
    }
   /* while  */
}


/*
   NamedOperand := '[' Ident ']' 

   first  symbols:lsbratok
   
   cannot reachend
*/

static void NamedOperand (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  Expect (M2Reserved_lsbratok, stopset0, stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  Ident (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_rsbratok-M2Reserved_eoftok))), stopset1, stopset2);
  Expect (M2Reserved_rsbratok, stopset0, stopset1, stopset2);
}


/*
   AsmOperandName := ( NamedOperand  | 
                       
                       % IF IsAutoPushOn()
                         THEN
                            PushTF(NulName, identtok)
                         END
                          %
                        ) 

   first  symbols:lsbratok
   
   reachend
*/

static void AsmOperandName (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  if (M2LexBuf_currenttoken == M2Reserved_lsbratok)
    {
      NamedOperand (stopset0, stopset1, stopset2);
    }
  else
    {
      if (M2Quads_IsAutoPushOn ())
        {
          M2Quads_PushTF (static_cast<unsigned int> (NameKey_NulName), static_cast<unsigned int> (M2Reserved_identtok));
        }
    }
}


/*
   AsmElement := 
                 % VAR n, str, expr,
                       CurrentInterface,
                       CurrentAsm, name: CARDINAL ;  %
                 AsmOperandName string '(' Expression 
                 
                 % IF Pass3
                   THEN
                      PopT(expr) ;
                      PopT(str) ;
                      PopT(name) ;
                      PopT(CurrentInterface) ;
                      PopT(CurrentAsm) ;
                      Assert(IsGnuAsm(CurrentAsm) OR IsGnuAsmVolatile(CurrentAsm)) ;
                      PopT(n) ;
                      INC(n) ;
                      IF CurrentInterface=NulSym
                      THEN
                         CurrentInterface := MakeRegInterface()
                      END ;
                      IF DebugAsm
                      THEN
                         printf1('5: count of asm operands: %d
', n)
                      END ;
                      PutRegInterface(CurrentInterface, n, name, str, expr) ;
                      PushT(n) ;
                      PushT(CurrentAsm) ;
                      PushT(CurrentInterface)
                   END
                    %
                 ')' 

   first  symbols:stringtok, lsbratok
   
   cannot reachend
*/

static void AsmElement (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  unsigned int n;
  unsigned int str;
  unsigned int expr;
  unsigned int CurrentInterface;
  unsigned int CurrentAsm;
  unsigned int name;

  AsmOperandName (stopset0, stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_stringtok-M2Reserved_recordtok))));
  string (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_lparatok-M2Reserved_eoftok))), stopset1, stopset2);
  Expect (M2Reserved_lparatok, stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_minustok-M2Reserved_eoftok)) | (1 << (M2Reserved_plustok-M2Reserved_eoftok)) | (1 << (M2Reserved_lparatok-M2Reserved_eoftok)) | (1 << (M2Reserved_lcbratok-M2Reserved_eoftok))), stopset1|(P3Build_SetOfStop1) ((1 << (M2Reserved_nottok-M2Reserved_arraytok))), stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_stringtok-M2Reserved_recordtok)) | (1 << (M2Reserved_integertok-M2Reserved_recordtok)) | (1 << (M2Reserved_realtok-M2Reserved_recordtok)) | (1 << (M2Reserved_identtok-M2Reserved_recordtok))));
  Expression (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_rparatok-M2Reserved_eoftok))), stopset1, stopset2);
  if (Pass3)
    {
      M2Quads_PopT (&expr);
      M2Quads_PopT (&str);
      M2Quads_PopT (&name);
      M2Quads_PopT (&CurrentInterface);
      M2Quads_PopT (&CurrentAsm);
      M2Debug_Assert ((SymbolTable_IsGnuAsm (CurrentAsm)) || (SymbolTable_IsGnuAsmVolatile (CurrentAsm)));
      M2Quads_PopT (&n);
      n += 1;
      if (CurrentInterface == SymbolTable_NulSym)
        {
          CurrentInterface = SymbolTable_MakeRegInterface ();
        }
      if (DebugAsm)
        {
          M2Printf_printf1 ((const char *) "5: count of asm operands: %d\\n", 30, (const unsigned char *) &n, (sizeof (n)-1));
        }
      SymbolTable_PutRegInterface (CurrentInterface, n, name, str, expr);
      M2Quads_PushT (n);
      M2Quads_PushT (CurrentAsm);
      M2Quads_PushT (CurrentInterface);
    }
  Expect (M2Reserved_rparatok, stopset0, stopset1, stopset2);
}


/*
   TrashList := 
                % VAR CurrentInterface,
                      CurrentAsm,
                      n, str          : CARDINAL ;  %
                [ string 
                  % IF Pass3
                    THEN
                       PopT(str) ;
                       PopT(CurrentInterface) ;
                       PopT(CurrentAsm) ;
                       PopT(n) ;
                       INC(n) ;
                       Assert(IsGnuAsm(CurrentAsm) OR IsGnuAsmVolatile(CurrentAsm)) ;
                       IF DebugAsm
                       THEN
                          printf1('6: count of asm trash operands: %d
', n)
                       END ;
                       IF CurrentInterface=NulSym
                       THEN
                          CurrentInterface := MakeRegInterface()
                       END ;
                       PutRegInterface(CurrentInterface, n, NulName, str, NulSym) ;
                       PushT(n) ;
                       PushT(CurrentAsm) ;
                       PushT(CurrentInterface)
                    END
                     %
                   ] { ',' string 
                       % IF Pass3
                         THEN
                            PopT(str) ;
                            PopT(CurrentInterface) ;
                            PopT(CurrentAsm) ;
                            PopT(n) ;
                            INC(n) ;
                            Assert(IsGnuAsm(CurrentAsm) OR IsGnuAsmVolatile(CurrentAsm)) ;
                            IF DebugAsm
                            THEN
                               printf1('7: count of asm trash operands: %d
', n)
                            END ;
                            IF CurrentInterface=NulSym
                            THEN
                               CurrentInterface := MakeRegInterface()
                            END ;
                            PutRegInterface(CurrentInterface, n, NulName, str, NulSym) ;
                            PushT(n) ;
                            PushT(CurrentAsm) ;
                            PushT(CurrentInterface)
                         END
                          %
                        } 

   first  symbols:commatok, stringtok
   
   reachend
*/

static void TrashList (P3Build_SetOfStop0 stopset0, P3Build_SetOfStop1 stopset1, P3Build_SetOfStop2 stopset2)
{
  unsigned int CurrentInterface;
  unsigned int CurrentAsm;
  unsigned int n;
  unsigned int str;

  if (M2LexBuf_currenttoken == M2Reserved_stringtok)
    {
      string (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_commatok-M2Reserved_eoftok))), stopset1, stopset2);
      if (Pass3)
        {
          M2Quads_PopT (&str);
          M2Quads_PopT (&CurrentInterface);
          M2Quads_PopT (&CurrentAsm);
          M2Quads_PopT (&n);
          n += 1;
          M2Debug_Assert ((SymbolTable_IsGnuAsm (CurrentAsm)) || (SymbolTable_IsGnuAsmVolatile (CurrentAsm)));
          if (DebugAsm)
            {
              M2Printf_printf1 ((const char *) "6: count of asm trash operands: %d\\n", 36, (const unsigned char *) &n, (sizeof (n)-1));
            }
          if (CurrentInterface == SymbolTable_NulSym)
            {
              CurrentInterface = SymbolTable_MakeRegInterface ();
            }
          SymbolTable_PutRegInterface (CurrentInterface, n, NameKey_NulName, str, SymbolTable_NulSym);
          M2Quads_PushT (n);
          M2Quads_PushT (CurrentAsm);
          M2Quads_PushT (CurrentInterface);
        }
    }
  while (M2LexBuf_currenttoken == M2Reserved_commatok)
    {
      Expect (M2Reserved_commatok, stopset0, stopset1, stopset2|(P3Build_SetOfStop2) ((1 << (M2Reserved_stringtok-M2Reserved_recordtok))));
      string (stopset0|(P3Build_SetOfStop0) ((1 << (M2Reserved_commatok-M2Reserved_eoftok))), stopset1, stopset2);
      if (Pass3)
        {
          M2Quads_PopT (&str);
          M2Quads_PopT (&CurrentInterface);
          M2Quads_PopT (&CurrentAsm);
          M2Quads_PopT (&n);
          n += 1;
          M2Debug_Assert ((SymbolTable_IsGnuAsm (CurrentAsm)) || (SymbolTable_IsGnuAsmVolatile (CurrentAsm)));
          if (DebugAsm)
            {
              M2Printf_printf1 ((const char *) "7: count of asm trash operands: %d\\n", 36, (const unsigned char *) &n, (sizeof (n)-1));
            }
          if (CurrentInterface == SymbolTable_NulSym)
            {
              CurrentInterface = SymbolTable_MakeRegInterface ();
            }
          SymbolTable_PutRegInterface (CurrentInterface, n, NameKey_NulName, str, SymbolTable_NulSym);
          M2Quads_PushT (n);
          M2Quads_PushT (CurrentAsm);
          M2Quads_PushT (CurrentInterface);
        }
    }
   /* while  */
}


/*
   CompilationUnit - returns TRUE if the input was correct enough to parse
                     in future passes.
*/

extern "C" bool P3Build_CompilationUnit (void)
{
  WasNoError = true;
  FileUnit ((P3Build_SetOfStop0) ((1 << (M2Reserved_eoftok-M2Reserved_eoftok))), (P3Build_SetOfStop1) 0, (P3Build_SetOfStop2) 0);
  return WasNoError;
  /* static analysis guarentees a RETURN statement will be used before here.  */
  __builtin_unreachable ();
}

extern "C" void _M2_P3Build_init (__attribute__((unused)) int argc,__attribute__((unused)) char *argv[],__attribute__((unused)) char *envp[])
{
}

extern "C" void _M2_P3Build_fini (__attribute__((unused)) int argc,__attribute__((unused)) char *argv[],__attribute__((unused)) char *envp[])
{
}
